package roboforge;

import roboforge.geometry.*;

import roboforge.ui.*;
import roboforge.ui.components.BUIResources;
//import roboforge.ui.components.BUIColorScheme;
//import roboforge.ui.events.*;
import roboforge.ui.modes.*;

import roboforge.animation.*;
//import roboforge.particles.*;
//import roboforge.particles.systems.*;
import roboforge.scalability.*;

import javax.vecmath.*;
import javax.media.j3d.*;
//import com.sun.j3d.utils.universe.*;
import javax.swing.tree.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import javax.media.j3d.Raster;
import javax.swing.*;
import java.util.*;
import java.awt.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import com.sun.image.codec.jpeg.*;
//import java.awt.image.*;
import java.io.*;
import com.sun.j3d.utils.geometry.*;
//import com.sun.j3d.utils.image.*;

import com.sun.j3d.utils.image.TextureLoader;


public final class BArenaCanvas
  extends
    BConsoleCanvas
  implements
    BMouseListenerCanvas,
    BSimulationCanvas
{

   /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
private BPickHighlightBehavior componentPick;
   private TransformGroup navigationTrans;
   //private TransformGroup noFloorTrans;
   private TransformGroup zoomGroup;
   private BranchGroup pickGroup;
   private BranchGroup sizeWrapper ;
   private TransformGroup sizeOrientGroup;

   // SJS [29/03/2000]: Collection of attached behaviors...
   protected Hashtable behaviorTable = new Hashtable(5);

   // SJS [09/03/2001]: Framerate metric...
   protected BFPSMetric metric;

   // SJS [21/03/2001]: Arena canvas animator.
   protected BCanvasAnimator animator;


   // Universe Appearance
   private Background bg;
   private BranchGroup bgGeometry = null;
   private Appearance backApp = null;

   //private Color3f ambientColor ;
   private AmbientLight AMB_LIGHT;


// Selected Appearance
   //private Appearance floorAppearance;
   private BComponent theFloor;

   //private boolean flashNextFrame = false;
   //private  boolean resetAmbLight = false;
   //private int flashCounter = 0;

   private ExponentialFog fog;

 // CONSTANTS
   private BoundingSphere bounds =new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000000000000.0);
   private static final float SIZEHEGHT = 1.0f;     // 20.0f

   private static final double HUMAN_FOV      = BPhysics.degToRad(75); // 0.5;  // Human Field Of View
   private static final double FRONTCLIPDIST  = 1.0;
   private static final double BACKCLIPDIST   = FRONTCLIPDIST * 2000;

// Cleanup Vectors
   private Vector objectList = new Vector();
   protected Vector shapeList = new Vector();

// parent
   //private JPanel parentPanel;
   private javax.media.j3d.Locale myLocale;
   private boolean addZones = false;
   private boolean addSensors = false;
   private boolean optimise = false;


   
// Filename
   private String savePictureName = null;
   BranchGroup zones;
   Behavior beh;
   BranchGroup behGroup;
   boolean showSize;

   DirectionalLight dirLight;
   DirectionalLight dirLight2;
   Color3f ambientColor3f;

   // boolean bPlayNextAnimationFrames = false;
   BMouseMultiBehavior mouseBehavior;

   // modes
   private int mode;

   BModeArenaCameraMove modeMouseMove;
   BModeArenaSphereCam modeSphereCam;
   BModeArenaBotCam modeBotCam;
   //BModeArenaFixedCamera modeFixedCam;
   BModeArenaAutoCam modeAutoCam;

   boolean useCameraMovement;
   private boolean transposePicks_ToChassis = true;
   private BComponent selectedComponent= null;
   private transient BArena arena;

   static double HUMAN_HEIGHT = BGlobal.HUMAN_HEIGHT ;

   private  BArenaObject aCache = null;
   private  BArenaObject bCache = null;






   // timer for testing
  public BArenaCanvas(BUIResources res, String key, JPanel parent)
  {
    this(parent);
    initializeUI(res, key);
  }


 public BArenaCanvas(JPanel parent)
 {            //false
   this(null, true, true, false, null, null, null, -1f, -1f, -1f,
                                              null, 0f, -1f, 0f,
                                              null, null, null, null,
                                              0, 0,  false, null, 0.0f , true, false, false, null);


 }


 public BArenaCanvas
 (
   JPanel parent, BArena a
 )
 {

    this(
      parent,  null,  a,
      false, //showSizeNew,
      true, //newAddZones,
      false, //optimiseForPlayer,
      true, //useCameraMovementnew,
      false, //allowPick,
      false //transposePicks_ToChassisnew
    )  ;

 }


 public BArenaCanvas
 (
   JPanel parent, Behavior b, BArena a,
   boolean showSizeNew,
   boolean newAddZones,
   boolean optimiseForPlayer,
   boolean useCameraMovementnew,
   boolean allowPick,
   boolean transposePicks_ToChassisnew
 )
 {
  this
  (
    parent, showSizeNew, newAddZones,  optimiseForPlayer, b,
    a.AmbientColor, a.directionalColor, a.dirX, a.dirY, a.dirZ,
    a.getDirectionalColor2(), a.getDirX2(), a.getDirY2(), a.getDirZ2(),
    a.backgroundFileName, a.floorObjectName, a.getfloorTexture(),
    a.getfloorColor(), a.getfloorShine(), a.getFloorColorDepth(),
    a.useFog, a.fogColor, a.fogDensity,
    useCameraMovementnew, allowPick, transposePicks_ToChassisnew, a
  );


 }

  public BArenaCanvas(JPanel parent, boolean showSizeNew, boolean newAddZones  , boolean optimiseForPlayer , Behavior behNew,
                        Color ambientLight,
                        Color directLightColor, float dirX, float dirY, float dirZ,
                        Color directLightColor2, float dirX2, float dirY2, float dirZ2,
                        String backFileName,
                        String floorObjectName , String floorTexture, Color floorColor, float floorShine, int floorDepth,
                        boolean useFog, Color fogColor, float fogDensity,
                        boolean useCameraMovementnew, boolean allowPick,
                        boolean transposePicks_ToChassisnew,
                        BArena a)
  {
        super(GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getBestConfiguration(new GraphicsConfigTemplate3D())
              , FRONTCLIPDIST, BACKCLIPDIST, HUMAN_FOV);

        arena = a;

        //parentPanel = parent;

        optimise =  optimiseForPlayer;
        addZones =  newAddZones;
        transposePicks_ToChassis = transposePicks_ToChassisnew;
        beh = behNew;
        showSize = showSizeNew;

        if (optimise || showSize)
          mouseBehavior = new BInputHandlerBehavior();
        else
          mouseBehavior = new BMouseListenerBehavior(this);


        useCameraMovement =  useCameraMovementnew ;

        constructUniverse(ambientLight, directLightColor, dirX, dirY, dirZ,
                                        directLightColor2, dirX2, dirY2, dirZ2,
                                        backFileName, floorObjectName ,  floorTexture,  floorColor,  floorShine,  floorDepth,  useFog,  fogColor,  fogDensity,  allowPick);


        // SJS [09/03/2001] - Framerate metric...
        metric = new BFPSMetric(getView());

        // SJS [21/03/2001] - Animator object, for misc. animations.
        animator = new BCanvasAnimator();
  }


  // -------------------------------------------------------------
  // STEVE'S UI MODIFICATIONS...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
      res.initComponent(this, key);

    currentFloor = null;

    setForeground(BGlobal.colors.getLightShade());
  }

  protected Color3f getBackground3f()
    { return BGlobal.colors.getExtraDarkShade3f(); }


  private BranchGroup currentFloor = null;

  public void setFloor(BranchGroup floor)
  {
    if (currentFloor == null)
      navigationTrans.addChild(floor);
    else
      if (currentFloor != floor)
      {
        currentFloor.detach();
        navigationTrans.addChild(floor);
      }
  }

  protected static final float GRID_SIZE_METERS = 60.0f;
  protected static final int   GRID_MAJOR_LINES = 12;
  protected static final int   GRID_MINOR_LINES = 5;

  public BranchGroup getGrid()
  {
    // Get canvas' UI foreground color...
    Color canvasFGColor = getForeground();
    float[] canvasFGComp = canvasFGColor.getColorComponents(null);
    Color3f fg = new Color3f(canvasFGComp);

    float gridSize =
      (GRID_SIZE_METERS * BGlobal.WORLD_TO_CANVAS_SCALE );

    BPlanarGrid3D grid = new BPlanarGrid3D
    (
      gridSize,
      GRID_MAJOR_LINES,
      GRID_MINOR_LINES,
      fg, fg
    );

    BranchGroup gridGroup = new BranchGroup();
    gridGroup.setCapability(BranchGroup.ALLOW_DETACH);
    gridGroup.addChild(grid);

    return gridGroup;
  }


    
  // -------------------------------------------------------------
  // END OF STEVE'S UI MODIFICATIONS.
  // -------------------------------------------------------------


  private void setupLights( BranchGroup attachGroup,
                            Color directLightColor,float dirX, float dirY, float dirZ,
                            Color directLightColor2,float dirX2, float dirY2, float dirZ2,
                            Color ambientLight)
  {
    Color3f ambientColor3f;

    if (BGlobal.USE_DIRLIGHT)
    {
      dirLight = createDirLight(directLightColor,attachGroup, optimise, dirX, dirY,dirZ );
      dirLight2 = createDirLight(directLightColor2,attachGroup, optimise, dirX2, dirY2,dirZ2 );

      if (ambientLight != null)
        ambientColor3f =  new Color3f((float)ambientLight.getRed() / 256f, (float)ambientLight.getGreen() / 256f, (float)ambientLight.getBlue() / 256f);
      else
        ambientColor3f = BGlobal.AMBIENTCOLOR;

    }
    else
      ambientColor3f = BGlobal.AMBIENT_NO_DIRLIGHT;



    AMB_LIGHT = new AmbientLight(ambientColor3f);
    AMB_LIGHT.setInfluencingBounds(bounds);
    AMB_LIGHT.setColor(ambientColor3f);

    if (!optimise)
    {
      AMB_LIGHT.setCapability(Light.ALLOW_COLOR_READ);
      AMB_LIGHT.setCapability(Light.ALLOW_COLOR_WRITE);

    }

    attachGroup.addChild(AMB_LIGHT);

  }

  private void setupFog(BranchGroup attachGroup, Color fogColor, float fogDensity)
  {


    if (BGlobal.USE_FOG || !optimise )
    {
      //BDebug.print ("SetupFog Called fogColor : " + fogColor + " fogDensity " + fogDensity );

      fog = new ExponentialFog(new Color3f(fogColor) );

      // fog off
      fog.setDensity(fogDensity);
      fog.setInfluencingBounds(new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000000000000.0));
      attachGroup.addChild(fog);

      if (!optimise)
      {
        fog.setCapability(Fog.ALLOW_COLOR_WRITE);
        fog.setCapability(Fog.ALLOW_COLOR_READ);
        fog.setCapability(ExponentialFog.ALLOW_DENSITY_WRITE);

      }

    }

  }


public void constructUniverse(  Color ambientLight,
                                Color directLightColor, float dirX, float dirY, float dirZ,
                                Color directLightColor2, float dirX2, float dirY2, float dirZ2,
                                String backFileName,
                                String floorObjectName , String floorTexture, Color floorColor, float floorShine, int floorDepth,
                                boolean useFog, Color fogColor, float fogDensity,
                                boolean allowPick)
{

  // Root
  BranchGroup sceneRootG = new BranchGroup();

  setupLights(sceneRootG, directLightColor,  dirX,  dirY,  dirZ, directLightColor2,  dirX2,  dirY2,  dirZ2, ambientLight) ;

  // player behaviour
  if (beh != null)
  {
    behGroup = new BranchGroup();
    behGroup.setCapability(BranchGroup.ALLOW_DETACH);
    behGroup.addChild(beh);
  }


  if (BGlobal.SHOW_BACKGROUND)
  {
    createBackGroupGeometry( backFileName, sceneRootG);

    if (!optimise)
        bg.setCapability(Background.ALLOW_GEOMETRY_WRITE);
  }
  //  Mouse Behaviour Transforms
  navigationTrans = new TransformGroup();
  navigationTrans.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);

  if (!optimise)
  {
    navigationTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
    navigationTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
    navigationTrans.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
  }
  sceneRootG.addChild(navigationTrans);


  if (useFog)
    setupFog(sceneRootG, fogColor, fogDensity);

  pickGroup = new BranchGroup();

  // PICK BEHAVIOUR
  if (allowPick)
  {

   componentPick = new BPickHighlightBehavior(this, pickGroup, new BoundingSphere(new Point3d(0.0,0.0,0.0), 10000.0), !optimise);

  }

  navigationTrans.addChild(pickGroup);


  // this group needs these capabilities to append arena Objects
  // maybe we can change it to append all arenaopbjects before we add this root to the universe
  pickGroup.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
  pickGroup.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
  pickGroup.setCapability(BranchGroup.ALLOW_DETACH);
  

   // Arena Size Display groups
  if ( (!optimise) &&  (showSize ) )
  {
        Transform3D sizeOrient = new Transform3D();
        //sizeOrient.rotX(java.lang.Math.PI /2);


        Transform3D sizeTranslate = new Transform3D();
        sizeTranslate.set(new Vector3f(0,SIZEHEGHT,0));
        sizeOrient.mul(sizeTranslate, sizeOrient);
        sizeOrientGroup = new TransformGroup(sizeOrient);
        navigationTrans.addChild(sizeOrientGroup);
        sizeOrientGroup.setCapability(Group.ALLOW_CHILDREN_EXTEND);
        sizeOrientGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);

        sizeWrapper = new BranchGroup();
        sizeWrapper.setCapability(BranchGroup.ALLOW_DETACH);
        sizeWrapper.addChild(this.getArenaSizeShape(100));
        sizeOrientGroup.addChild(sizeWrapper);

  }

   // Orienting the floor


  //camera.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
   // Set the universe Transform3D object.

  zoomGroup = universe.getViewingPlatform().getViewPlatformTransform();

  Transform3D transform = new Transform3D();
  transform.set( HUMAN_HEIGHT  );
  zoomGroup.setTransform(transform);


  float arenaSize = 50f;
  if (arena != null)
    arenaSize = arena.getSize();


  modeMouseMove = new BModeArenaCameraMove( zoomGroup, this, arena, HUMAN_HEIGHT * 1.5 , HUMAN_HEIGHT* 15f );
  modeSphereCam = new BModeArenaSphereCam( this, zoomGroup ,  arenaSize, HUMAN_HEIGHT) ;
  modeBotCam = new BModeArenaBotCam( zoomGroup, this , arenaSize / 2);
  modeAutoCam = new BModeArenaAutoCam( this, arenaSize / 2);

  /*if (arena != null)
    modeFixedCam = new BModeArenaFixedCamera(zoomGroup, new Vector3d(arena.getCameraX(),arena.getCameraY(),arena.getCameraZ()), this );
  else
    modeFixedCam = new BModeArenaFixedCamera(zoomGroup, new Vector3d(300,300,300), this );  */




  if (useCameraMovement)
   {
      this.addBehavior(mouseBehavior);
     //sceneRootG.addChild(mouseBehavior);


   }
  else
   {

      BMouseDrag mouseRotateBehaviour = new BMouseDrag(this, false, false, false);
      mouseRotateBehaviour.setTransformGroup(navigationTrans);
      navigationTrans.addChild(mouseRotateBehaviour);
      mouseRotateBehaviour.setSchedulingBounds(bounds);


      BCameraMouseMove mouseMoveBehaviour = new BCameraMouseMove(MouseTranslate.INVERT_INPUT,-Float.MAX_VALUE,Float.MAX_VALUE,    -Float.MAX_VALUE, Float.MAX_VALUE,    -Float.MAX_VALUE,Float.MAX_VALUE, false, this);
      mouseMoveBehaviour.setTransformGroup(zoomGroup);
      sceneRootG.addChild(mouseMoveBehaviour);
      mouseMoveBehaviour.setSchedulingBounds(bounds);

   }


   if (floorObjectName != null)
   {
      this.loadFloor( floorObjectName );
      theFloor.setAppearance(floorTexture, floorColor, floorShine, floorDepth);
   }


    sceneRootG.compile();
    addToUniverse(sceneRootG);
    myLocale = universe.getLocale();


    setZoom(BGlobal.STARTZOOM_ARENA);
    setMode(BGlobal.CANVAS_MODE_ARENA_BOTCAM);

  }

  public void attachPlayerBehavior()
  {
    if (behGroup != null)
      if (!behGroup.isLive() )
        pickGroup.addChild(behGroup);

  }

  public void detachPlayerBehavior()
  {
    if (behGroup != null)
      if (behGroup.isLive() )
        behGroup.detach();

  }


  private DirectionalLight createDirLight(Color directLightColor, Group attachGroup, boolean optimise, float dirX, float dirY, float dirZ)
  {

     DirectionalLight light;

     if ( directLightColor == null)
      light = new DirectionalLight(BGlobal.CANVASLIGHT, new Vector3f(-1.0f, -1.0f, -1.0f)) ;
     else
      light = new DirectionalLight(new Color3f(directLightColor.getRed() / 256f, directLightColor.getGreen() / 256f, directLightColor.getBlue() /256f) , new Vector3f(dirX, dirY, dirZ));

      light.setInfluencingBounds(bounds);

      if (!optimise)
      {
        light.setCapability(DirectionalLight.ALLOW_DIRECTION_READ);
        light.setCapability(DirectionalLight.ALLOW_DIRECTION_WRITE);
        light.setCapability(Light.ALLOW_COLOR_READ);
        light.setCapability(Light.ALLOW_COLOR_WRITE);
      }

      attachGroup.addChild(light);

      return  light ;

  }


  private void setZoom(float zoom )
  {

     Transform3D transform = new Transform3D();
     transform.set( new Vector3f(0.0f, 0.0f, zoom) );
     updateView(transform);

     //zoomGroup.setTransform(transform);
  }



  // Accessor methods for behavior management.
  // -------------------------------------------------------------

  public void addBehavior(Behavior b)
  {
    BranchGroup bg = (BranchGroup) behaviorTable.get(b);

    if (bg == null)
    {

        // TODO: set b's parent to null.
        b.setSchedulingBounds(bounds);

        bg = new BranchGroup();
        bg.setCapability(BranchGroup.ALLOW_DETACH);
        bg.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        bg.addChild(b);

        behaviorTable.put(b, bg);
    }

    if (!bg.isLive() )
      pickGroup.addChild(bg);
  }

  public void clearBehaviorTable()
  {
    Enumeration e = behaviorTable.elements();


    while (e.hasMoreElements())
    {
      BranchGroup b = (BranchGroup) e.nextElement();
      b.detach();
     // b.removeChild(0);
    }

    behaviorTable.clear();

  }


  public void removeBehavior(Behavior b)
  {
    if (behaviorTable != null && b != null )
    {
      BranchGroup bg = (BranchGroup) behaviorTable.get(b);

      if (bg != null)
      {
        bg.detach();
      }

      // YLY 92-5-01
      // taken out, cause fatal error in test Panel
      //behaviorTable.remove(b);

    }

  }


  public float getZoom()
  {

  Transform3D transform = new Transform3D();
  zoomGroup.getTransform(transform);

  Vector3f transL = new Vector3f();
  transform.get(transL);

  return transL.z;

  }


  // SJS [09/03/2001] - Framerate metric..
  public BFPSMetric getFPSMetric()
    { return metric; }

   

  

  private void setCursor()
  // this method is left in for old code compatibility
  {


        setCursor(false);
  }

  public void setCursor(boolean busy)
  {

        if (busy)
                setCursor(new Cursor(Cursor.WAIT_CURSOR));
        else

                setCursor(new Cursor(Cursor.HAND_CURSOR));

  }


 public void setAmbientLight ( Color3f newColour)
 {



    AMB_LIGHT.setColor(newColour);
 }


public void exitWireFrame()
// exits the wire frame
    {

    if (BGlobal.WIREFRAME_ON_MOVE)
    {


      try
        {

        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        BArenaObject current;
        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);

        for (int a = 0 ; a < objectList.size() ; a++ )
        {
           current = (BArenaObject)objectList.get(a);
           current.setNormalAppearance();
        }

       // if (getLastSelected() != null )
        //    getLastSelected().getComponent().setHighlight();


        theFloor.setNormalAppearance();

        setCursor();

        } catch (Exception e){BDebug.print("BArena.exitWireFrame.error: " + e.getMessage() );};

     }

   }



  public void setWireFrame()
  // SETS ALL OBJECTS TO WIREFRAME

  {



    if (BGlobal.WIREFRAME_ON_MOVE)
    {

      if (theFloor != null )
        theFloor.setWireFrame();

      try
     {
        BArenaObject current;

        for (int a = 0 ; a < objectList.size() ; a++ )
        {
                current = (BArenaObject)objectList.get(a);
                current.setWireFrame();
        }    // for loop


       // if (wireOnRotate && !isConstruction)
       //

     } catch (Exception e){BDebug.print("BArenaCanvas.setWireFrame ERROR: " + e.getMessage() );}
    }

  }



  public void setWireFrame(BComponent theComponent)
  {
    setWireFrame();

  }
  public  BHighlightShape getLastSelected()
  {
   return componentPick.getLastSelected();
  };

  public void setMode(int newMode)
  {

    // BDesign Panel Modes
    if ( newMode == BGlobal.CANVAS_MODE_ARENAROTATE)
    {
      mode = BGlobal.CANVAS_MODE_ARENAROTATE;
      BDebug.print("BArenaCanvas.setMOde CANVAS_MODE_ARENAROTATE ");
    }
    else if ( newMode == BGlobal.CANVAS_MODE_ARENAMOVE)
    {
      BDebug.print("BArenaCanvas.setMode  CANVAS_MODE_ARENAMOVE ");
      mode = BGlobal.CANVAS_MODE_ARENAMOVE ;
    }
    else if ( newMode == BGlobal.CANVAS_MODE_ARENAELEVATE)
    {
      BDebug.print("BArenaCanvas.setMode  CANVAS_MODE_ARENAELEVATE ");
      mode = BGlobal.CANVAS_MODE_ARENAELEVATE ;
    }
    else if (newMode == BGlobal.CANVAS_MODE_ROTATESCENE)
    {
      BDebug.print("BArenaCanvas.setMode  CANVAS_MODE_ROTATESCENE ");
      mode = BGlobal.CANVAS_MODE_ROTATESCENE;
    }
    // Battle Player player Modes
    else if ( newMode == BGlobal.CANVAS_MODE_ARENA_HUMAN)
    {
      //BDebug.print("BArenaCanvas.setMode  CANVAS_MODE_ARENA_HUMAN");
      mode = BGlobal.CANVAS_MODE_ARENA_HUMAN;
     // mouseRotateBehaviour.setEnable(true);
     // mouseMoveBehaviour.setEnable(true);;
     mouseBehavior.setMode( modeMouseMove  );


    }
    else if ( newMode == BGlobal.CANVAS_MODE_ARENA_AUTOCENTER)
    {
      //BDebug.print("BArenaCanvas.setMode  CANVAS_MODE_ARENA_AUTOCENTER ");
      mode = BGlobal.CANVAS_MODE_ARENA_AUTOCENTER ;
      mouseBehavior.setMode( modeSphereCam  );


    }
    else if ( newMode == BGlobal.CANVAS_MODE_ARENA_BOTCAM)
    {

      modeBotCam.setPosition(0,BPhysics.QUARTER_PI);

      mouseBehavior.setMode( modeBotCam  );
      mode = BGlobal.CANVAS_MODE_ARENA_BOTCAM ;
    }
    else if ( newMode == BGlobal.CANVAS_MODE_ARENA_FIXEDCAM)
    {
      //BDebug.print("BArenaCanvas.setMode CANVAS_MODE_ARENA_FIXEDCAM ");
   //   mouseRotateBehaviour.setEnable(true);
  //    mouseMoveBehaviour.setEnable(false);
      
      //mouseBehavior.setMode( modeFixedCam  );
      //modeFixedCam.setPosition();
      //lookAt(true);

      mode = BGlobal.CANVAS_MODE_ARENA_FIXEDCAM ;
    }

    else if ( newMode == BGlobal.CANVAS_MODE_ARENA_AUTOCAM)
    {
      mouseBehavior.setMode( modeAutoCam  );

      mode = BGlobal.CANVAS_MODE_ARENA_AUTOCAM ;
    }

    else
      BDebug.print("BArenaCanvas.SetMode INCORRENT MODE . MUST BE ONE OF THE MODE DEFINED IN BGLOBAL");

  }

  public void setModeRates(double rate)
	{
		modeMouseMove.setRate(rate);
   	modeSphereCam.setRate(rate);
   	modeBotCam.setRate(rate);
   	modeAutoCam.setRate(rate);
  }

  public void animateMode()
  {
    //((BModeArenaMouse)mouseBehavior.getMode()).animate();


    // use case instead because there is no casting
    
    int mode = getMode();

    if ( mode == BGlobal.CANVAS_MODE_ARENA_HUMAN)
     modeMouseMove.animate();
    else if ( mode == BGlobal.CANVAS_MODE_ARENA_AUTOCENTER)
      modeSphereCam.animate();
    else if ( mode == BGlobal.CANVAS_MODE_ARENA_BOTCAM)
      modeBotCam.animate();
   // else if ( mode == BGlobal.CANVAS_MODE_ARENA_FIXEDCAM)
   //   modeFixedCam.animate();
    else if ( mode == BGlobal.CANVAS_MODE_ARENA_AUTOCAM)
      modeAutoCam.animate();
    else
      BDebug.print("BArenaCanvas - INVALID CAMERA MODE");
  }


  public int getMode()
  {
    return mode;
  };


  public BArenaObject getLastSelectedObject()
  {

    BArenaObject current = null;
    //BArenaObject selected = null;
    BShape3D selectedShape = (BShape3D)componentPick.getLastSelected();

    for (int a = 0 ; a < objectList.size() ; a++ )
    {

      current = (BArenaObject)objectList.get(a);

      if (current.isPartOf(selectedShape))
      {
        return current;

      }



    }    // for loop

    return null;

  }

  public void loadArenaObject(BArenaObject newObject)
  {
    loadArenaObject( newObject, null);
  }

  public void loadArenaObject(BArenaObject newObject, BBattleRecorder optimiseBattle)
  {

   // Rotation Group
   //AxisAngle4d axisAngle = new AxisAngle4d(0, 1, 0, newObject.getArenaPosition().facing );

   Transform3D arenaRotate = new Transform3D();
   arenaRotate.rotY( newObject.getArenaPosition().facing);
   TransformGroup arenaRotateGroup = new TransformGroup(arenaRotate);
   arenaRotateGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
   arenaRotateGroup.setCapability(Group.ALLOW_CHILDREN_WRITE);
   arenaRotateGroup.setUserData(newObject.getName() + " arenaRotateGroup ");

   // Add Shapes
   BranchGroup newStruct = newObject.getStructure3D(addZones && !optimise, addSensors);


   extractShapes(newStruct);
   arenaRotateGroup.addChild(newStruct);
   objectList.add(newObject);

   // Displacement Group
   Vector3d displacementVector = new Vector3d (newObject.getArenaPosition().x,newObject.getArenaPosition().y,newObject.getArenaPosition().z );
   Transform3D displacementTransform = new Transform3D();
   displacementTransform.set(displacementVector);
   TransformGroup displacementGroup = new TransformGroup(displacementTransform);
   displacementGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
   displacementGroup.setUserData(newObject.getName() + " displacementGroup ");
   displacementGroup.addChild(arenaRotateGroup);


   // wrapper Branch
   BranchGroup wrapperBranch = new BranchGroup();
   wrapperBranch.setUserData(newObject.getName() + "  arena Object wrapper branch ");
   wrapperBranch.addChild(displacementGroup);

   //extractShapes (  newStruct );
   if (optimise)
   {
      optimise3dTree(newStruct);

      if (newObject instanceof BBot)
      {
        BBot bot = (BBot)newObject;

        if (optimiseBattle != null)
          optimiseBattle.optimise( bot);

        if (addZones)
          bot.attachZones(false, true);
      }

      else if (newObject instanceof BAnimatedTextureOrnament)
        // HACK: SJS 22/02/2001 - Allow animation of textures..
        ((BAnimatedTextureOrnament) newObject).optimize();



   }
   else if (addZones && (newObject instanceof BBot))
     ((BBot) newObject).attachZones(false, true);

   // set local read to yes for auto camera
   newStruct.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
   newStruct.setCapability(BranchGroup.ALLOW_DETACH);
   wrapperBranch.setCapability(BranchGroup.ALLOW_DETACH);


   BranchGroup center = newObject.getLiveNode(true);

   if ( center != null)
    center.setCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);


     // This must be called after the nodes have been added to the universe
   //newObject.setLiveNodes(newStruct, displacementGroup, arenaRotateGroup);
   newObject.setLiveNodes(newStruct, displacementGroup, arenaRotateGroup);


   //if (newObject instanceof BBot)
   // BDebug.printj3D(newObject + "", wrapperBranch );

   wrapperBranch.compile();

   // Set to Live Scene
   pickGroup.addChild(wrapperBranch);


   if (!optimise && (newObject instanceof BBot))
        ((BBot)newObject).getChassis().setHeight();

  // newObject.setNegateNode(navigationTrans);



  }



  public void addZones(BranchGroup theZones, boolean toAdd, BBot botToAdd)
// if toAdd is true then add, else remove
 {
   try{
        if (toAdd)
          botToAdd.setZonesAttached(true);
        else
        {
          if (zones != null)
            zones.detach();

          zones = null;
        }
      } catch (Exception e) { BDebug.print ("BArenaCanvas.addZones ERROR: " + e.getMessage() );}


 }



  public void optimise3dTree (Node theGroup)
  // Optimisethis tree for this canvas
  {

   try
   {
     // Clear Node capabilities
     theGroup.clearCapability(Node.ALLOW_AUTO_COMPUTE_BOUNDS_READ);
     theGroup.clearCapability(Node.ALLOW_AUTO_COMPUTE_BOUNDS_WRITE);
     theGroup.clearCapability(Node.ALLOW_BOUNDS_READ);
     theGroup.clearCapability(Node.ALLOW_BOUNDS_WRITE);
     theGroup.clearCapability(Node.ALLOW_COLLIDABLE_READ);
     theGroup.clearCapability(Node.ALLOW_COLLIDABLE_WRITE);
     theGroup.clearCapability(Node.ALLOW_LOCAL_TO_VWORLD_READ);
     theGroup.clearCapability(Node.ALLOW_PICKABLE_READ );
     theGroup.clearCapability(Node.ALLOW_PICKABLE_WRITE );
     theGroup.clearCapability(Node.ENABLE_COLLISION_REPORTING  );
     theGroup.clearCapability(Node.ENABLE_PICK_REPORTING  );

    if ( theGroup instanceof Group )
    {

      Group currentGroup = (Group) theGroup;

      //group capabilities
      currentGroup.clearCapability(Group.ALLOW_CHILDREN_EXTEND);
      currentGroup.clearCapability(Group.ALLOW_CHILDREN_READ);
      currentGroup.clearCapability(Group.ALLOW_CHILDREN_WRITE);
      currentGroup.clearCapability(Group.ALLOW_COLLISION_BOUNDS_READ );
      currentGroup.clearCapability(Group.ALLOW_COLLISION_BOUNDS_WRITE);

      // transformgroup capabilites
      if (theGroup  instanceof TransformGroup)
      {
        theGroup.clearCapability(TransformGroup.ALLOW_TRANSFORM_READ);
      }
      else if (theGroup  instanceof BranchGroup)
      {
        theGroup.clearCapability(BranchGroup.ALLOW_DETACH );
      }

      for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
      {

          //System.out.println(" Node" + currentGroup.toString());
          Node newGroup =(Node)e.nextElement();
          optimise3dTree(newGroup);


      }
    }
    else  if (theGroup instanceof Link )
    {
       Link tempGroup = (Link)theGroup;
       Group currentGroup = tempGroup.getSharedGroup()  ;
       System.out.println( tempGroup.toString());
       optimise3dTree(currentGroup );

    }
    else if (theGroup instanceof Shape3D )
    {
           // shape capabilities

          theGroup.clearCapability(Shape3D.ALLOW_APPEARANCE_READ);
          //theGroup.clearCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
          theGroup.clearCapability(Shape3D.ALLOW_COLLISION_BOUNDS_READ);
          theGroup.clearCapability(Shape3D.ALLOW_COLLISION_BOUNDS_WRITE);
          theGroup.clearCapability(Shape3D.ALLOW_GEOMETRY_READ);
          theGroup.clearCapability(Shape3D.ALLOW_GEOMETRY_WRITE);

          theGroup.setPickable(false) ;

        //Geometry shapesGeo = ((Shape3D)theGroup).getGeometry();
         // shapesGeo.clearCapability(Geometry.ALLOW_INTERSECT);

        /*
        if (shapesGeo instanceof GeometryArray )
        {
              shapesGeo.clearCapability( GeometryArray.ALLOW_COUNT_READ);
              shapesGeo.clearCapability( GeometryArray.ALLOW_COORDINATE_READ );


        } */

        Appearance shapesApp = ((Shape3D)theGroup).getAppearance();
        shapesApp.clearCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_READ);
       // shapesApp.clearCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_LINE_ATTRIBUTES_READ);
        shapesApp.clearCapability(Appearance.ALLOW_LINE_ATTRIBUTES_WRITE);
        shapesApp.clearCapability(Appearance.ALLOW_MATERIAL_READ  );
       // shapesApp.clearCapability(Appearance.ALLOW_MATERIAL_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_POINT_ATTRIBUTES_READ );
        shapesApp.clearCapability(Appearance.ALLOW_POINT_ATTRIBUTES_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ );
        shapesApp.clearCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ );
        shapesApp.clearCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_TEXGEN_READ   );
        shapesApp.clearCapability(Appearance.ALLOW_TEXGEN_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_TEXTURE_ATTRIBUTES_READ );
        shapesApp.clearCapability(Appearance.ALLOW_TEXTURE_ATTRIBUTES_WRITE );
        shapesApp.clearCapability(Appearance.ALLOW_TEXTURE_READ );
        shapesApp.clearCapability(Appearance.ALLOW_TEXTURE_WRITE );

        // unset for the fadeout animation
        //shapesApp.clearCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ );
        //shapesApp.clearCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE );

        /*ColoringAttributes shapeCatt = shapesApp.getColoringAttributes();
        if (!shapeCatt.isLive() && !shapeCatt.isCompiled())
        {
          shapeCatt.clearCapability(ColoringAttributes.ALLOW_COLOR_READ);
          shapeCatt.clearCapability(ColoringAttributes.ALLOW_COLOR_WRITE );
          shapeCatt.clearCapability(ColoringAttributes.ALLOW_SHADE_MODEL_READ );
          shapeCatt.clearCapability(ColoringAttributes.ALLOW_SHADE_MODEL_WRITE);
        }*/


        LineAttributes shapeLatt = shapesApp.getLineAttributes();

        if (shapeLatt != null)
          if (!shapeLatt.isLive() && !shapeLatt.isCompiled())
          {

            shapeLatt.clearCapability(LineAttributes.ALLOW_ANTIALIASING_READ);
            shapeLatt.clearCapability(LineAttributes.ALLOW_ANTIALIASING_WRITE);
            shapeLatt.clearCapability(LineAttributes.ALLOW_PATTERN_READ );
            shapeLatt.clearCapability(LineAttributes.ALLOW_PATTERN_WRITE);
            shapeLatt.clearCapability(LineAttributes.ALLOW_WIDTH_READ  );
            shapeLatt.clearCapability(LineAttributes.ALLOW_WIDTH_WRITE );
          }

       /* Material shapeMat = shapesApp.getMaterial();
        if (shapeMat != null)
          if (!shapeMat.isLive() && !shapeMat.isCompiled() )
          {
            shapeMat.clearCapability(Material.ALLOW_COMPONENT_READ);
            shapeMat.clearCapability(Material.ALLOW_COMPONENT_WRITE);
          }  */


        PolygonAttributes shapePol = shapesApp.getPolygonAttributes();
        if ( shapePol != null)
          if (!shapePol.isLive() && !shapePol.isCompiled())
          {
            shapePol.clearCapability(PolygonAttributes.ALLOW_CULL_FACE_READ);
            shapePol.clearCapability(PolygonAttributes.ALLOW_CULL_FACE_WRITE);
            shapePol.clearCapability(PolygonAttributes.ALLOW_MODE_READ);
            shapePol.clearCapability(PolygonAttributes.ALLOW_MODE_WRITE);
            shapePol.clearCapability(PolygonAttributes. ALLOW_NORMAL_FLIP_READ );
            shapePol.clearCapability(PolygonAttributes. ALLOW_NORMAL_FLIP_WRITE);
            shapePol.clearCapability(PolygonAttributes.ALLOW_OFFSET_READ );
            shapePol.clearCapability(PolygonAttributes. ALLOW_OFFSET_WRITE);
          }


        //System.out.println(" Node" + theGroup.toString());

    }
    else if (theGroup instanceof Light )
    {
        theGroup.clearCapability(Light.ALLOW_COLOR_READ);
        theGroup.clearCapability(Light.ALLOW_COLOR_WRITE);
        theGroup.clearCapability(Light.ALLOW_INFLUENCING_BOUNDS_READ );
        theGroup.clearCapability(Light.ALLOW_INFLUENCING_BOUNDS_WRITE );
        theGroup.clearCapability(Light.ALLOW_SCOPE_READ );
        theGroup.clearCapability(Light.ALLOW_SCOPE_WRITE );
        theGroup.clearCapability(Light.ALLOW_STATE_READ );
        theGroup.clearCapability(Light.ALLOW_STATE_WRITE );

    }

    else
    {

     System.out.println(" BArenaCanvas.optimise3d ::Unknown Group ::" + theGroup);

    }


  }catch (Exception e) {BDebug.print("BArenaCanvas.optimiseTree exception:: in " + theGroup + e.getMessage());}


 }


 public void loadFloor(String filePath)
 {
        BDebug.print("BArenaCanvas.loadFloor " + filePath);

        float shine = 0f;
        float tran = 0f;
        Color color = null;
        String texName = null;

        if (theFloor != null)
        {
                BDebug.print("BArenaCanvas.theFloor cleanse" + theFloor.getName());

                shine = theFloor.getShine();
                tran = theFloor.getTransparency();
                color = theFloor.getColor();
                texName = theFloor.getTextureName();

                theFloor.getLiveNode().detach();
                theFloor.cleanse();

        }

       // BDebug.print("BArenaCanvas.theFloor cleansed ok");

        theFloor =  new BArenaOrnament("Floor", filePath);

        if (color != null)
                theFloor.setAppearance(texName, color, shine, tran, BComponent.DEFAULTDEPTH);

        theFloor.setEnableLighting(false);

        BranchGroup tempG =  theFloor.cloneStructure3D(false, true);
        tempG.setPickable(false);

        if (optimise )
        {
                this.optimise3dTree(tempG);
        }
        else
        {
                tempG.setCapability(BranchGroup.ALLOW_DETACH);
                tempG.setCapability(BranchGroup.ALLOW_LOCAL_TO_VWORLD_READ);

        }
        theFloor.setLiveBotNode(tempG);
        navigationTrans.addChild(tempG);
 }

 /*
 private BComponent makeFloor()
 {

        BComponent newFloor = new BComponent("Floor", BGlobal.FLOOROBJECT);
        newFloor.setTexture(BGlobal.FLOORTEXTURE);
        newFloor.setColor(BGlobal.FLOORCOLOR);
        return newFloor;
 }     */


  private void extractShapes ( Node oldBranch )
  {

    if ( oldBranch instanceof Group )
    {
      Group currentGroup = (Group) oldBranch;
      for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
          {
           Node newGroup =(Node)e.nextElement();
           extractShapes(newGroup);
           }   // loop
    }   // if
    else if ( (oldBranch instanceof BShape3D )  )
    {
        shapeList.add(oldBranch);

        ((BShape3D)oldBranch).setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);

    }
  }



    public void modeMethod(BHighlightShape newShape)
  {



        if (transposePicks_ToChassis)
        {

          BShape3D shape = (BShape3D)newShape;
          BComponent theComponent = shape.getComponent();
          DefaultMutableTreeNode theNode = theComponent.getTreeNode();

          // it the Node != null indicates that it is a bot, so Select the root is Chassis Object
          if (theNode != null)
          {
            theNode =  (DefaultMutableTreeNode)theNode.getRoot();
            theComponent = (BComponent)theNode.getUserObject();
          }

          theComponent.getArbitraryShape().setActiveArea();
          componentPick.pick(theComponent.getArbitraryShape());

        }
        else
        {


          if (((BShape3D)newShape).getComponent().getLiveNode() == null)
          {
              BDebug.print ("BArenaCanvas.modeMethod ERROR newSelectedShape.getLiveNode == null in " + selectedComponent.getName()) ;
              return;
          }

          if (newShape == null)
            BDebug.print ("BArenaCanvas.modeMethod ERROR newShape == null") ;



          // reset last selected
          if (selectedComponent != null)
          {
            if (selectedComponent.getLiveNode() == null)
              BDebug.print ("BArenaCanvas.modeMethod ERROR oldSelectedShape.getLiveNode == null") ;
             selectedComponent.getLiveNode().setPickable(true);

          }


          selectedComponent = ((BShape3D)newShape).getComponent();

          if (selectedComponent == null )
          {
            BDebug.print("BArenaCanvas.modeMethod null selected component");

          }
          else
          {

            if (selectedComponent.getLiveNode() == null)
              BDebug.print ("BArenaCanvas.modeMethod ERROR newSelectedShape.getLiveNode == null in " + selectedComponent.getName()) ;
            else
            {
              selectedComponent.getLiveNode().setPickable(false);
              //if (getMode() == BGlobal.CANVAS_MODE_ARENA_SENSORCAM)
              //{
              //  translateCameraToSelectedComponent();
                lookAt(true);

             // }
            }
          }

          BDebug.print ("BCanvas.modeMethod selected "  + selectedComponent.getName() );


        }




  }


  public void handleKeyEvent(KeyEvent e)
  {
    // HACK: Redirect key input to the input behavior.
    // This is done so that the canvas can react to
    // key events even when it does not have the focus.

    if (mouseBehavior instanceof BInputHandlerBehavior)
      ((BInputHandlerBehavior) mouseBehavior).handleKeyEvent(e);
  }



// image stuff
  private boolean takeSnap = false;
  private BufferedImage botImage;
  private Raster rasSnapshot;
  int counter = 0;
  private boolean wait = false;


  public void waitForFrame()
 {


    try
   {

    wait = true;
    repaint();

    while ( wait )
        {
           BDebug.print ("BArenaCanvas Waiting for Frame :");
           Thread.sleep(20);
        }


   }catch (Exception e) {BDebug.print ("BArenaCanvas.takeSnapshot.ERROR " + e.getMessage() ); }



 }


 public Color getAmbientLightColor()
 {
        Color aLight = null;

        if (optimise)
                BDebug.print("BArenaCanvas.getAmbientLightColor can only be called for arena canvases that are not optimised for the battle player ");

        else
        {
                Color3f tempL = new Color3f();
                AMB_LIGHT.getColor(tempL);
                aLight = new Color(tempL.x, tempL.y, tempL.z);

        }


        return aLight;

 }

 public Color getDirLightColor(int lightIndex)
 {
        Color dLight = null;

        if (optimise)
                BDebug.print("BArenaCanvas.getDirLightColor can only be called for arena canvases that are not optimised for the battle player ");
         else if (!BGlobal.USE_DIRLIGHT)
                BDebug.print("BArenaCanvas.getDirLightColor  ERROR use DirLight is Off ");

        else
        {
                Color3f tempL = new Color3f();

                if (lightIndex == 1)
                  dirLight.getColor(tempL);
                else
                  dirLight2.getColor(tempL);

                dLight = new Color(tempL.x, tempL.y, tempL.z);

        }


        return dLight;

 }


  public Color getFogColor()
 {
        Color fLight = null;

        if (optimise)
                BDebug.print("BArenaCanvas.getFogColor can only be called for arena canvases that are not optimised for the battle player ");
        else
        {
                Color3f tempL = new Color3f();
                fog.getColor(tempL);
                fLight = new Color(tempL.x, tempL.y, tempL.z);

        }


        return fLight;

 }






 public Vector3f getDirLightVector(int lightIndex)
 {
        Vector3f vec = new Vector3f();

        if (optimise)
                BDebug.print("BArenaCanvas.getDirLightVector can only be called for arena canvases that are not optimised for the battle player ");
        else
        {
          if (lightIndex == 1)
            dirLight.getDirection(vec);
          else
            dirLight2.getDirection(vec);

         }



        return vec;

 }

 public void setDirLightVector(int index, float x, float y, float z)
 {


        if (optimise)
                BDebug.print("BArenaCanvas.setDirLightVector can only be called for arena canvases that are not optimised for the battle player ");
        else
        {
          if (index == 1)
            dirLight.setDirection(x,y,z);
          else
            dirLight2.setDirection(x,y,z);

        }

 }


 public void setAmbientLight(Color newC)
 {

        setAmbientLight(new Color3f((float)newC.getRed() / 256f, (float)newC.getGreen() /256f , (float)newC.getBlue() / 256f));

 }

 public void setDirLight(int index, Color newC)
 {
    if (index == 1)
      dirLight.setColor(new Color3f((float)newC.getRed() / 256f, (float)newC.getGreen() /256f , (float)newC.getBlue() / 256f));
    else
      dirLight2.setColor(new Color3f((float)newC.getRed() / 256f, (float)newC.getGreen() /256f , (float)newC.getBlue() / 256f));

 }


 public void setFogColor(Color newC)
 {
        fog.setColor(new Color3f((float)newC.getRed() / 256f, (float)newC.getGreen() /256f , (float)newC.getBlue() / 256f));

 }


 public void showFog(boolean show, float newDensity)
 {
        if (optimise)
                BDebug.print ("BArenaCanvas.showFog.ERROR  :: The Method May NOT be called for a optimised canvas ");
        else
        {
                if (show)
                {
                        fog.setDensity( newDensity );


                }
                else
                {
                        fog.setDensity(0.0f);
                }




        }

 }


 public void postSwap()
 {

  super.postSwap();


  wait = false;

  // SJS [09/03/2001] - Update the framerate metric..
  if (metric != null)
    metric.update();

  // SJS [21/03/2001] - Update canvas animator...
  if (animator != null)
    animator.animate();

  // Snapshot capture code
  if (takeSnap)
  {
		captureSnapshot();
    takeSnap = false;
  }

  // updateConsole();

  // Refresh the view...
  // getView().repaint();


 }


 protected void captureSnapshot()
 {
 	try
  {
  	Dimension d = getSize();
    BufferedImage bImage = new BufferedImage(d.width, d.height,
    BufferedImage.TYPE_INT_ARGB);
    ImageComponent2D imgComp = new ImageComponent2D(
    ImageComponent2D.FORMAT_RGB, bImage);
    rasSnapshot = new Raster(new Point3f(), Raster.RASTER_COLOR,
    	0, 0, d.width, d.height, imgComp, null);

    getGraphicsContext3D().readRaster(rasSnapshot);
    botImage= rasSnapshot.getImage().getImage();

    FileOutputStream fos;

    if (savePictureName == null)
	    { fos = new FileOutputStream(counter+ ".jpg"); }
    else
    {
    	if (!BGlobal.JPEGSUFFIX.equalsIgnoreCase(savePictureName.substring(savePictureName.length() - 4 )  )  )
      	savePictureName = savePictureName +  BGlobal.JPEGSUFFIX;

      BDebug.print("Writing snapshot to file: " + savePictureName );
      fos = new FileOutputStream(savePictureName);
      savePictureName = null;
    }

    BufferedOutputStream bos = new BufferedOutputStream(fos);
    JPEGImageEncoder jie = JPEGCodec.createJPEGEncoder(bos);
    JPEGEncodeParam param = jie.getDefaultJPEGEncodeParam(botImage);
    param.setQuality(1.0f,true);
    jie.setJPEGEncodeParam(param);
    jie.encode(botImage);

    bos.flush();
    fos.close();

    counter ++;

    if (snapListener != null)
    {
      snapListener.actionPerformed(new ActionEvent(this, 0,"") );
      snapListener = null;
    }
  }
  catch (Exception e)
  	{ BDebug.print("BArenaCanvas.takeSnapshot() ERROR: " + e.getMessage());}
 }

 private Vector3d setCameraXZ_Vector = new Vector3d();
 private Transform3D setCameraXZ_Transform = new Transform3D();

 public void setCameraXZ(float x, float z)
 {

  setCameraXYZ( x, (float)HUMAN_HEIGHT * 1.5f , z);

 }

  public void setCameraXYZ(float x,float y, float z)
 {

  // temp Test until the new camera modes are in
  //modeFixedCam.setPosition(x,300,z);

  setCameraXZ_Vector.x = x;
  setCameraXZ_Vector.z = z;
  setCameraXZ_Vector.y = y;

  setCameraXZ_Transform.setTranslation(setCameraXZ_Vector);

  //zoomGroup.setTransform(setCameraXZ_Transform);
  this.lookAt(false);

 }


 public void setCameraPos(float x,float y, float z, boolean centerLook, Point3d lookPoint)
 {

  //modeFixedCam.setPosition(x,y,z);

  setCameraXZ_Vector.x = x;
  setCameraXZ_Vector.z = z;
  setCameraXZ_Vector.y = y;

  if (centerLook)
  {
    if (lookPoint == null)
    {
      BPhysics.getMidPoint(lookAt_Point, aCache, bCache);
      lookPoint =  lookAt_Point;
    }

    lookAt(lookPoint, true, setCameraXZ_Vector);
  }

 }


 public void flash()
 // A Lightning style flash
 {
        //flashNextFrame = true;
        //  the flash happens in postswap, flag is unset there too

 }

 public void stopFlash()
 {
        AMB_LIGHT.setColor(ambientColor3f);
        //resetAmbLight = false;
 }


 private Shape3D getArenaSizeShape(int diameter)
 {

//      Cylinder newC = new Cylinder(( diameter * BGlobal.WORLD_TO_CANVAS_SCALE) / 2.0f, 2.0f);
      BCircle3D sizeTop = new BCircle3D(( diameter * BGlobal.WORLD_TO_CANVAS_SCALE) / 2.0f, 40); //newC.getShape(Cylinder.BOTTOM);

      PointAttributes pta = new PointAttributes(5.0f, true);

      PolygonAttributes pa = new PolygonAttributes();
      pa.setPolygonMode(PolygonAttributes.POLYGON_LINE);
      pa.setCullFace(PolygonAttributes.CULL_NONE);

      // Get canvas' UI foreground color...
      Color3f fg = BGlobal.colors.getDarkShade3f();
      Appearance sizeApp = new Appearance();
      sizeApp.setPolygonAttributes(pa);
      sizeApp.setColoringAttributes(new ColoringAttributes( fg, ColoringAttributes.SHADE_FLAT ) );
      sizeApp.setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_WRITE);
      sizeApp.setPointAttributes(pta);


      Shape3D newShape = new Shape3D(sizeTop.getGeometry(), sizeApp);

      return newShape;

 }

 private transient ActionListener snapListener = null;

 public void takeSnapshot(String fileName, ActionListener snapTakenListener)
 {
    savePictureName = fileName;
    snapListener = snapTakenListener;
    takeSnapshot();
 }

 public void takeSnapshot()
 {
 		takeSnap = true;
    repaint();
 }


  public boolean waitingForSnap()
  {

    return takeSnap;

  }

  public void setArenaSize( int size)
  {
    if ( sizeWrapper != null)
      sizeWrapper.detach();

    if (sizeOrientGroup != null)
    {
        sizeWrapper = new BranchGroup();
        sizeWrapper.setCapability(BranchGroup.ALLOW_DETACH);
        sizeWrapper.addChild(this.getArenaSizeShape(size));
        sizeOrientGroup.addChild(sizeWrapper);
    }
  }


 public void clear()
 {
  super.clear();
  aCache = null;
  bCache = null;


  if (optimise)
  {
    pickGroup.detach();

    BShape3D current;
    for (int a = 0 ; a < shapeList.size() ; a++ )
    {
        current = (BShape3D)shapeList.get(a);
        current.setAppearance(null);
    }    // for loop


    BArenaObject currentO;
    for (int a = 0 ; a < objectList.size() ; a++ )
    {

      currentO = (BArenaObject)objectList.get(a);
     // BDebug.print("BArenaCanvas.clear Called for " + currentO);
      currentO.cleanseLiveNodes();

    }    // for loop

    selectedComponent = null;
    objectList.clear();
    shapeList.clear();

  }
  else
  {

        selectedComponent = null;

        if ((fog != null) && !optimise )
                fog.setDensity(0.0f);

        if (theFloor != null)
        {

                theFloor.getLiveNode().detach();
                theFloor.cleanse();
                theFloor = null;
        }

        //setBackgroundImage(null);


        BArenaObject currentO;
        for (int a = 0 ; a < objectList.size() ; a++ )
        {

                currentO = (BArenaObject)objectList.get(a);
                //BDebug.print("BArenaCanvas.clear Called for " + currentO);

                //currentO.getLiveNode(false).detach();
                currentO.cleanseLiveNodes();

        }    // for loop

        objectList.clear();

        BShape3D current;

        for (int a = 0 ; a < shapeList.size() ; a++ )
        {
                current = (BShape3D)shapeList.get(a);

                current.setAppearance(null);
                //current.setGeometry(null);
                //current.setComponent(null);
        }    // for loop

        shapeList.clear();

        if (componentPick != null)
          componentPick.setLastSelected(null);

   }
 }

 /*
 try{

        if (theObject != null)
        {
          // BDebug.print ("BArenaCanvas.remove objectList " + objectList);
           //BDebug.print ("BArenaCanvas.remove componentPick " + componentPick);

           objectList.remove(theObject);

           BranchGroup liveNode = theObject.getLiveNode(false);
           if (liveNode != null)
              liveNode.detach();


          theObject.cleanseLiveNodes();
          if (componentPick != null)
            componentPick.setLastSelected(null);
       }

    }catch (Exception e){BDebug.print("BArenaCanvas.remove ERROR:" + e.getMessage() );};
*/


 public void remove(BArenaObject theObject)

  {

  //  BDebug.print("TEST REMOVE" +  shapeList.size());

 //  try{
    if (theObject != null)
    {



        objectList.remove(theObject);
        theObject.getLiveNode(false).detach();    

        BShape3D current;
        //Vector tempV = new Vector();

        for (int a = shapeList.size()-1  ; a >= 0 ; a-- )
        {
                current = (BShape3D)shapeList.get(a);

                if ( theObject.isPartOf(current) )
                {

                  current.setAppearance(null);
                  //current.setGeometry(null);
                  current.setComponent(null);
                  shapeList.remove(current);

                }
       }    // for loop



       theObject.cleanseLiveNodes();

       if ( componentPick != null)
        componentPick.setLastSelected(null);

   }
   //     BDebug.print("TEST REMOVE" +  shapeList.size());

   // }catch (Exception e){BDebug.print("BArenaCanvas.remove ERROR:" + e.getMessage() );};


  }


  public BComponent getFloor()
  {
    return theFloor;

  }

  public void resetFloor()
  {
   /*
   Resets the floor to be same as when the canvas was first created
   needed for new arena function on ArenaEditor
   Created HSC 14 June 99
   */
   theFloor.setTexture(null);
   theFloor.setColor(Color.gray );

  }



  public javax.media.j3d.Locale getLocale3d()
  {

  return myLocale;
  }

  public void translate(int dx, int dy)

 {
   try{
        double x_Translation_factor = .04;
        double y_Translation_factor = .04;

        Transform3D currXform = new  Transform3D();
        Transform3D transformX = new  Transform3D();
        Vector3d translation = new Vector3d();

        navigationTrans.getTransform(currXform);

        translation.x = dx*x_Translation_factor;
	      translation.y = -dy*y_Translation_factor;

        transformX.set(translation);
        currXform.mul(transformX, currXform);

        navigationTrans.setTransform(currXform);
    } catch (Exception e) { BDebug.print ("BBotCanvas.translate ERROR: " + e.getMessage() );}

 }

  public void removeComponent(BComponent c, boolean sound, boolean animate)
  	{ removeComponent(c); }

  public void removeComponent(BComponent c)
  {
  	if (!c.getChassisLock())
      c.getLiveNode().detach();
  }

 public void addComponent(BComponent newComponent)
 {

  try
  {

    if (newComponent instanceof BChassis )
      BDebug.print ("BArenaCanvas.loadComponent:: Chassis Components CANNOT BE REMOVED ");
    else if (!newComponent.getLiveNode().isLive())
      newComponent.reConnect();
  } catch(Exception e) { BDebug.print("ERROR :BArenaCanvas.addComponent:" + e.getMessage() );  };


 }


 /* public void loadComponent(BComponent newComponent)
 {

 //BComponent parentComponent = newComponent.getParent();
/*

 THIS IS FUNDAMENTALY DIFFERENT FROM THE OTHER CAVASES.LoadComponent.

 This Methods assumes that the Component has already been part of the live scene graph and only wishes to the it back in.





 try
        {

       // Cache Shapes for disposal (BUG HACK)
        //BranchGroup tempLive = newComponent.getLiveNode();
        //BDebug.print("BArenaCanvas.loadComponent.getStructure3D");





    } catch(Exception e) { BDebug.print("ERROR :BArenaCanvas.loadComponent:" + e.getMessage() );  };

 }  */


 public void createBackGroupGeometry(String imageName, BranchGroup sceneRootG)
 {
  if (BGlobal.SHOW_BACKGROUND)
  {
    boolean attachbg = false;

    if (  bg == null )
    {
      bg = new Background(getBackground3f());
      bg.setApplicationBounds(new BoundingSphere(bounds) );
      attachbg = true;
    }

    bgGeometry = new BranchGroup();
    backApp = new Appearance();
    //backApp.setColoringAttributes( new ColoringAttributes(BGlobal.BLACK_3F,  ColoringAttributes.FASTEST  ));

    if (imageName == null)
    {
      backApp.setTexture(null);
      backApp.setColoringAttributes( new ColoringAttributes(BGlobal.BLACK_3F,  ColoringAttributes.FASTEST  ));

    }
    else
    {
      Texture tex = BTextures.getTexture(BGlobal.BACKGROUNDPATH +imageName);
      backApp.setTexture( tex );
      backApp.setColoringAttributes(null);
    }

    Sphere sphere = new Sphere( 1.0f, Primitive.GENERATE_TEXTURE_COORDS | Primitive.GENERATE_NORMALS_INWARD, backApp );

    Transform3D rotyT = new Transform3D();
    rotyT.rotY(java.lang.Math.PI);

    Transform3D rotZ = new Transform3D();
    rotZ.rotZ(java.lang.Math.PI);

    rotyT.mul(rotZ);
    TransformGroup roty = new TransformGroup(rotyT);
    roty.addChild(sphere);

    bgGeometry.addChild( roty );
    if(!optimise)
    {
      bgGeometry.setCapability(BranchGroup.ALLOW_DETACH);
      backApp.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
    }

    bg.setGeometry(bgGeometry);


    if (attachbg)
      sceneRootG.addChild(bg);

    } // if bglobal.show background

 }

 public void setBackgroundImage (String imageName)
/*

* Description: Sets the Background of the Canvas
	* Parameters:  The GIF,
	* Results: displays the image
* Example:
* Modification History ( Name, Date, Notes ):

*/


 {



  if (bgGeometry != null)
  {
    //bgGeometry.detach();
   // BDebug.print ("BArenaCanvas.setBackgroundImage bgGeometry NOT NULL ");

     if (imageName == null)
        backApp.setTexture(null);
     else
     {
      try {
        // Do not use bTextures because we do not want this mip mapped
       TextureLoader tL = new TextureLoader(BGlobal.BACKGROUNDPATH + imageName, this);
       Texture tex = tL.getTexture();
       //Texture tex = BTextures.getTexture(BGlobal.BACKGROUNDPATH + imageName);
       // BDebug.print ("BArenaCanvas.setBackgroundImage tex got ");
       tex.setMagFilter(Texture.BASE_LEVEL_LINEAR ); // BASE_LEVEL_POINT);
       // tex.setMinFilter(Texture.BASE_LEVEL_POINT ); // MULTI_LEVEL_POINT);

        backApp.setTexture( tex );
       // BDebug.print ("BArenaCanvas.setBackgroundImage backApp is set ");
      } catch (Exception ex) {
    		BDebug.print("BArenaCanvas.setBackgroundImage Exception: "+ex);
        backApp.setTexture(null);
   		}




     }
  }


 }




 public BranchGroup getPickGroup()
 {
        return pickGroup;

 }


 public class GroupTranPair
 {
    public TransformGroup group;
    public Transform3D transform;

    public GroupTranPair(TransformGroup group, Transform3D transform )
    {
      this.group = group;
      this.transform = transform;
    }

    public boolean equals(Object o)
    {
      if (o instanceof GroupTranPair )
      {
        GroupTranPair gtp = (GroupTranPair)o;
        return gtp.group == this.group;
      }

      return false;
    }

 }

 // move the automatic camera
 public void moveAutoCam()
 {
   modeAutoCam.updateCamera();
 }

 // translate the camera to follow the bot
 public void translateToBotCam( )
 {
    modeBotCam.updateCamera();
 }

 public void translateToBotCam(float xzParam, float upDown )
 {
    modeBotCam.setPosition(xzParam, upDown);
 }

 public void setSphereCamParams(double zenith, double azimuth)
	 { modeSphereCam.setParameters(zenith, azimuth); }

 public void setBotCam(BBot theBot)
 {
  modeBotCam.setBot(theBot);
  translateToBotCam();
 }

 public void setAutoCam(BBot bot1, BBot bot2)
 {
  modeAutoCam.setBots(bot1, bot2);
 }

 public final void  lookAt(boolean autoY)
 {
  if (aCache != null)
  {
    lookAt(aCache, bCache, autoY);
  }

 }

 // temp statics to prevent memory chewing
 // DO NOT USE THESE ANYWHERE EXCEPT IN  lookAt
 private  static Transform3D lookAt_taTrans = new Transform3D();
 //private  static Transform3D lookAt_tbTrans = new Transform3D();
 private  static Vector3d lookAt_aPos = new Vector3d();
 //private  static Vector3d lookAt_bPos = new Vector3d();
 private  static Point3d lookAt_Point = new Point3d();
 private  static Transform3D lookAt_camPos = new Transform3D();
 //private  static Point3d lookAt_camPosPoint  = new Point3d();
 //private  static Vector3d lookAt_upVector = new Vector3d(0,1.0,0);
 private  static Vector3d lookAt_camPosVec = new Vector3d();
 //private  static Matrix3d cameraRot = new Matrix3d();

 private  static Transform3D rotXTran = new Transform3D();
 private static Vector3d relativeVec = new Vector3d();
 //private static Vector3d v = new  Vector3d();
 private static Vector3d v2 = new  Vector3d();
 private static Vector3d cross = new Vector3d();


 public final void  lookAt(BArenaObject a, boolean autoY)
 {
    BranchGroup lookAtr_aBG = a.getLiveNode(true);
    lookAtr_aBG.getLocalToVworld(lookAt_taTrans);
    lookAt_taTrans.get(lookAt_aPos);

    lookAt_Point.set(lookAt_aPos);
    lookAt(lookAt_Point,  autoY);
 }

 public final void  lookAt(BArenaObject a, BArenaObject b, boolean autoY)
 {

    if (aCache == null)
    {
      aCache = a;
      bCache = b;
    }

    if (a != null && b != null)
    {

      BPhysics.getMidPoint(lookAt_Point, a, b);
      lookAt ( lookAt_Point,  autoY);
    }



 }

 public final void updateCamera()
 {
    if (  getMode() == BGlobal.CANVAS_MODE_ARENA_AUTOCENTER)
      lookAt(true);
    else if (getMode() == BGlobal.CANVAS_MODE_ARENA_BOTCAM)
      translateToBotCam();
    else if (getMode() == BGlobal.CANVAS_MODE_ARENA_AUTOCAM)
      moveAutoCam();
 }

 public final void  lookAt (Point3d lookAt_Point, boolean autoY)
 {
    zoomGroup.getTransform(lookAt_camPos);
    lookAt_camPos.get(lookAt_camPosVec);
    lookAt (lookAt_Point, autoY, lookAt_camPosVec) ;

 }

 public final void  lookAt (Point3d lookAt_Point, boolean autoY, Vector3d lookAt_camPosVec)
 {

   // get camera vector
   //lookAt_camPosVec.set(camPosVec );
   // change vector to point

   // get relative vector
   relativeVec.set(lookAt_camPosVec);
   relativeVec.sub( relativeVec, lookAt_Point);

   // get rotY angle
   //v.set(relativeVec);
   double oldRelativeVecY =  relativeVec.y;
   relativeVec.y = 0;
   v2.set(0, 0, 1.0);
   double theta =  v2.angle(relativeVec);
   cross.cross(v2, relativeVec);
   lookAt_camPos.setIdentity();
   if (cross.y < 0)
     theta = -theta;

   lookAt_camPos.rotY(theta);


   if (autoY)
   {
    // Auto Y tilt calculation

    v2.set(relativeVec);
    relativeVec.y = oldRelativeVecY ;
    theta =  v2.angle(relativeVec);

    cross.cross(v2, relativeVec);

    if (lookAt_Point.y < lookAt_camPosVec.y)
      theta = -theta;

    rotXTran.rotX(theta);
    lookAt_camPos.mul(rotXTran);

    //BDebug.print(" BArenaCanvas.lookAt autoY theta " + theta );

   }

   lookAt_camPos.setTranslation(lookAt_camPosVec);

   updateView(lookAt_camPos);
   //zoomGroup.setTransform(lookAt_camPos);
   //updateConsole();


 }


  protected void finalize() throws Throwable
  {
    BDebug.print ( "[*** BArenaCanvas Finalized]" );
  }


  public void onActivate()
  {
    BDebug.print ("BArenaCanvas.onActivate Called");
    mouseBehavior.requestActivate();
  }

 public void onClose()
 {
   BDebug.print ("BArenaCanvas.onClose Called");

   stopRenderer();
   clear();

   if (mouseBehavior != null)
   {
      mouseBehavior.setMode(null);
      this.removeBehavior(mouseBehavior);
      mouseBehavior = null;

   }

   clearBehaviorTable();

   componentPick = null;
   navigationTrans = null;
   //noFloorTrans = null;
   zoomGroup = null;
   pickGroup = null;
   sizeOrientGroup = null;
   sizeWrapper = null;
   zones = null;

   behaviorTable = null;

   bg = null;
   bgGeometry = null;
   backApp = null;
   //ambientColor = null;
   AMB_LIGHT = null;

   //floorAppearance = null;
   //if (theFloor != null)
   // theFloor.cleanse();
   theFloor = null;
   fog = null;

   bounds = null;
   objectList = null;
   shapeList = null;

   //parentPanel = null;
   myLocale = null;
   
   // animations = null;
   savePictureName = null;

   beh = null;
   behGroup = null;
   dirLight = null;
   dirLight2 = null;
   ambientColor3f = null;

   modeMouseMove = null;
   modeSphereCam = null;
   modeBotCam = null;
  //modeFixedCam = null;
   modeAutoCam = null;

   selectedComponent = null;
   arena = null;

   aCache = null;
   bCache = null;

   animator = null;
   
   super.onClose();

 }


  public BAnimator getAnimator()
 	{ return animator; }


 	protected class BCanvasAnimator extends BManualAnimator
 	{
  	// Arena canvas animator class.

 		public BCanvasAnimator()
  		{ super(); }

 	}



}