package roboforge;
import java.util.*;



public class BEnergyGenerator extends BComponent
/*

* Description:
  A child of BComponent which can be transformed.

* Example:
* Modification History ( Name, Date, Notes ):
  HSC, 25-March-1999

*/

{
  static final long serialVersionUID = -1L;

  public float energyCapacity;              // Maximum energy supply (KWatts) before depleted
  public float energyOutputRate;            // KWatts/Hour recharge rate
  //transient public float energyLevel;        // Current Energy Level in KW

  public static String COMPONENT_TYPE = "Energy";

  public String getComponentType()
  { return COMPONENT_TYPE; }

  public BEnergyGenerator (String nameIn, String filename)
  {
      super(nameIn, filename);
  }

  public void upgrade()
  {
     BEnergyGenerator upgradeTwin =   (BEnergyGenerator)BComponent.loadFromFile( BGlobal.COMPONENTPATH+getComponentFilePath(), false );
     super.upgrade(upgradeTwin);

     energyCapacity = upgradeTwin.energyCapacity;
     energyOutputRate = upgradeTwin.energyOutputRate;

  }

    public Vector getAttributeStrings()
 // returns a Vector of tuples  (heading, value )
 // 2-d Vector
 {

  Vector theList = super.getAttributeStrings();


  Vector tempV;

  tempV = new Vector(2);
  tempV.add("capacity");
  tempV.add(energyCapacity + " kW");
  tempV.trimToSize();
  theList.add(tempV);


  tempV = new Vector(2);
  tempV.add("peak output");
  tempV.add(energyOutputRate + " kW");
  tempV.trimToSize();
  theList.add(tempV);

   return theList;

 }

}


