package roboforge;

import java.awt.*;
import java.io.*;
import java.util.Locale;

import javax.vecmath.*;
import javax.swing.border.*;
import javax.media.j3d.*;
//import javax.swing.plaf.*;

import roboforge.ui.components.*;
import roboforge.util.graphics.*;
import roboforge.util.text.BDictionaryTree;
import roboforge.ui.BLoadingScreen;
//import roboforge.util.io.BFileSystem;
//import roboforge.ui.B3DLimbCanvas;

import roboforge.sound.BSound;
import roboforge.btree.BSerializableTree;


public final class BGlobal implements Serializable
/*

* Description:
Holds static variables for the project.

* Example:
* Modification History ( Name, Date, Notes ):
                        HSC 7th April 1999
                        YLY 19 Aug - The BIG Cleanup
                        SJS 03/02/2000 - Added package name const, some UI stuff.
                        SJS 20/02/2001 - Added virtual referee path
*/

{


 // Serialization ID.
 static final long serialVersionUID = -1L;


 // Current Application Version
 public static float APP_VERSION = 0.11f;

 // The 'official' term for bots:
 public static final String BOT = "bot";

 // The 'official' plural term for bots:
 public static final String BOTS = "bots";
 
 // The 'official' term for designer:
 public static final String DESIGNER = "creator";

 // The 'official' plural term for designer:
 public static final String DESIGNERS = "creators";

 // The official monetary unit:
 public static final String MONEY_UNIT = "creds";

 // The official weight unit:
 public static final String WEIGHT_UNIT = "kg";

 // The official health unit:
 public static final String HEALTH_UNIT = "hp";

 
 
 
 // Whether to execute deprecated code or not.
 // [allows backwards compatibility with the old interface.]
 public static boolean DEPRECATED = true;

 // Base application package name
 public static String BASE_PACKAGE_NAME = "roboforge";

  // SJS [15/06/2000] - Added basic localization.
  public static Locale getLocale()
    { return Locale.US; }


 //*****FILE PATHS  AND SUFFIXES
 public static String SYSTEMPATH = "";
 public static String BOTPATH = SYSTEMPATH +  "bot/";
 public static String CHASSISBOTPATH = SYSTEMPATH + "bot/internal/chassisbots/";
 public static String CHASSISPATH = SYSTEMPATH + "chassis/";
 public static String COMPONENTPATH = SYSTEMPATH + "component/";
 public static String IMAGEPATH = SYSTEMPATH + "image/";
 public static String ANIMATIONPATH = IMAGEPATH + "animation/";
 public static String VRMLPATH = SYSTEMPATH + "vrml/";
 public static String TEXTUREPATH = SYSTEMPATH + "map/";
 public static String ARENAPATH = SYSTEMPATH + "arena/";
 public static String REFPATH = ARENAPATH + "ref/";

 public static String PLACEHOLDERPATH = ARENAPATH + "placeholders/";
 public static String ORNAMENTPATH = ARENAPATH + "ornament/";
 public static String BATTLERECORDINGSPATH = SYSTEMPATH + "battle/";
 public static String BATTLERECORDINGCACHEPATH = SYSTEMPATH + "battle/cache/";
 public static String SOUNDPATH = SYSTEMPATH + "sound/";
 public static String USERPATH = "D:/temp/";
 public static String BACKGROUNDPATH = IMAGEPATH + "background/";
 public static String ARENAFLOOR_EXT =  "arenaFloor/";
 public static String ARENAFLOORPATH =  VRMLPATH + ARENAFLOOR_EXT;
 public static String MATERIALPATH = SYSTEMPATH + "material/";
 public static String HELPPATH = SYSTEMPATH + "help/";
 public static String INTERNAL_ITEM = "internal";
 public static String HIDDENPATH = INTERNAL_ITEM+ "/";
 public static String WIZARDPATH = BOTPATH + HIDDENPATH + "wizardbots/";
 public static String BLOCKPATH = SYSTEMPATH + "blocks/";
 public static String LIMBPATH =  SYSTEMPATH + "limb/";
 public static String ADPATH = SYSTEMPATH + "adverts/";
 public static String LIBPATH = SYSTEMPATH + "lib/";

 public static String JREPATH = "jre/";
 public static String OPENGLPATH = JREPATH + "opengl/";
 public static String DIRECTXPATH = JREPATH + "directx/";


   // The Key locations for the clients
 public static String PUBLIC_KEY_SERVER = LIBPATH + "pubkeyserver.out";
 public static String SYMMETRIC_KEY_CLIENT = LIBPATH + "symkeyclient.out";
 public static String SYMMETRICIV_KEY_CLIENT = LIBPATH + "symkeyivclient.out";


 // currently unsed
 public static String TESTBOTPATH = BOTPATH;


 public static void updatePaths()
 {
        //BDebug.print ("BGlobal.updating paths ");
        BOTPATH = SYSTEMPATH +  "bot/";
        CHASSISBOTPATH = SYSTEMPATH + "bot/internal/chassisBots/";
        CHASSISPATH = SYSTEMPATH + "chassis/";
        COMPONENTPATH = SYSTEMPATH + "component/";
        IMAGEPATH = SYSTEMPATH + "image/";
        ANIMATIONPATH = IMAGEPATH + "animation/";
        VRMLPATH = SYSTEMPATH + "vrml/";
        TEXTUREPATH = SYSTEMPATH + "map/";
        ARENAPATH = SYSTEMPATH + "arena/";
        REFPATH = ARENAPATH + "ref/";

        PLACEHOLDERPATH = ARENAPATH + "placeholder/";
        ORNAMENTPATH = ARENAPATH + "ornament/";
        BATTLERECORDINGSPATH = SYSTEMPATH + "battle/";
        BATTLERECORDINGCACHEPATH = BATTLERECORDINGSPATH + "cache/";
        SOUNDPATH = SYSTEMPATH + "sound/";
        BACKGROUNDPATH = IMAGEPATH + "background/";
        ARENAFLOORPATH =  VRMLPATH + ARENAFLOOR_EXT;
        MATERIALPATH = SYSTEMPATH + "material/";
        WIZARDPATH = BOTPATH + HIDDENPATH + "wizardbots/";
        HELPPATH = SYSTEMPATH + "help/";
        LIBPATH = SYSTEMPATH + "lib/";

        JREPATH =  "jre/";
        OPENGLPATH = JREPATH + "opengl/";
        DIRECTXPATH = JREPATH + "directx/";
        BLOCKPATH = SYSTEMPATH + "blocks/";
        LIMBPATH =  SYSTEMPATH + "limb/";
        ADPATH = SYSTEMPATH + "adverts/";

        PUBLIC_KEY_SERVER = LIBPATH + "pubkeyserver.out";
        SYMMETRIC_KEY_CLIENT = LIBPATH + "symkeyclient.out";
        SYMMETRICIV_KEY_CLIENT = LIBPATH + "symkeyivclient.out";


        // TODO: Make a directory for test bots.
        TESTBOTPATH = BOTPATH;
 }



  // Location of SGateway
  //public static String URLSGATEWAY = "http://edge/servlet/roboforge.SGateway";
  public static String URLSGATEWAY = "http://server.rftournaments.com/servlet/roboforge.SGateway";
  //public static String URLSGATEWAY = "http://localhost:8080/servlet/roboforge.SGateway";

  // Location of SChallengeRoom
  public static String URLSCHALLENGE_ROOM = "http://server.rftournaments.com/servlet/roboforge.SChallengeRoomServlet";

  // Location of the FarmFeeder
  public static String URLSFARMFEEDER = "http://server.rftournaments.com/servlet/roboforge.SFarmFeeder";


  public static final String WORLDPAY_URL = "http://www.roboforge.net/entrypmnt.htm";
  public static final String WORLDPAY_ACCOUNT_URL = "http://www.roboforge.net/wpadmin.htm";
  public static final String PAYPAL_URL =  "http://www.roboforge.net/paypal.htm";

 // suffixes
  public final static String BOTSUFFIX = ".bot";
  public final static String CHASSISSUFFIX = ".chs";
  public final static String COMPONENTSUFFIX = ".cmp";
  public final static String IMAGESUFFIX = ".gif";
  public final static String VRMLSUFFIX = ".wrl";
  public final static String ARENASUFFIX = ".are";
  public final static String RECORDINGSUFFIX = ".rec";
  public final static String STATSSUFFIXA = ".sta";
  public final static String STATSSUFFIXB = ".stb";
  public final static String JPEGSUFFIX = ".jpg";
  public final static String B2DANIMATIONSUFFIX = ".a2d";
  public final static String MATERIALSUFFIX = ".mat";
  public final static String WIZSUFFIX = ".wiz";
  public final static String TESTBOTSUFFIX = BOTSUFFIX;
  public final static String J3DSUFFIX = ".j3d";
  public final static String SOUNDSUFFIX = ".wav";
  public final static String BLOCKSUFFIX = ".aib";
  public final static String LIMBSUFFIX = ".lmb";
  public final static String ADSUFFIX = ".adv";

// NEW INTERFACE:
// ---------------------------------------------------------------------
// NOTE (SJS 03/02/2000): This stuff is currently undergoing development.

  public static final String STUB_EMAIL_SUFFIX = "@robocd";

  public static Dimension SCREEN_RESOLUTION = new Dimension(800, 600);

  public static Color UI_BASE_COLOR       = new Color(200, 200, 255);

  public static final Color3f BLACK_3F      = new Color3f(0.0f, 0.0f, 0.0f);
  public static final Color3f WHITE_3F      = new Color3f(1.0f, 1.0f, 1.0f);
  public static final Color3f LIGHT_GREY_3F = new Color3f(0.8f, 0.8f, 0.8f);

  public static final Color4f BLACK_4F      = new Color4f(0.0f, 0.0f, 0.0f, 1.0f);
  public static final Color4f WHITE_4F      = new Color4f(1.0f, 1.0f, 1.0f, 1.0f);
  public static final Color4f INVISIBLE_4F  = new Color4f(0.0f, 0.0f, 0.0f, 0.0f);

  public static final Color BLACK           = new Color(1f,1f,1f);

  public static Color SELECTED_COLOR        = Color.white;
  public static Color LOCKED_COLOR          = new Color(0.7f,0.0f,0.0f);
  public static Color HIGHLIGHT_COLOR       = new Color(180, 255, 50);
  public static Color ALT_HIGHLIGHT_COLOR   = new Color(0, 220, 255);

  public static Color3f SELECTED_COLOR_3F   = BColors.convert(SELECTED_COLOR);
  public static Color3f LOCKED_COLOR_3F     = BColors.convert(LOCKED_COLOR);
  public static Color3f HIGHLIGHT_COLOR_3F  = BColors.convert(HIGHLIGHT_COLOR);
  public static Color3f ALT_HIGHLIGHT_COLOR_3F  = BColors.convert(ALT_HIGHLIGHT_COLOR);

  public static Color GRAND_MASTER_COLOR     = new Color(200, 190, 0);
  public static Color MASTER_COLOR          = new Color(0, 190, 0);

  // YLY - Warning Color
  public static Color WARNING_COLOR         = Color.red;
  public static float SELECTED_TRANSPARENCY = 0.1f;

  public static BUIColorScheme colors;

  // Highlight appearance constants...
  public static BComponentAppearance JOINT_HIGHLIGHT
    = new BComponentAppearance(HIGHLIGHT_COLOR, BComponentAppearance.DEFAULTDEPTH, 0f, null, 0.4f);



// OLD INTERFACE
// ---------------------------------------------------------------------
// NOTE: The following stuff is likely to disappear soonish.


 // BORDER SIZE
 static int BORDERSIZE = 2;

 public static int FRAMEWIDTH = 800;
 public static int FRAMEHEIGHT = 600;

 public static int BUTTONWIDTH = 70;
 public static int BUTTONHEIGHT = 30;
 public static int HEADERHEIGHT = 45;
 public static int FOOTERHEIGHT = 35;
 public static int FRAMESIZE = BORDERSIZE;

 // Std Metal Blue
 public static Color PRIMARY1 = new Color(204, 204, 255);
 public static Color PRIMARY2 = new Color(153, 153, 204);
 public static Color PRIMARY3 = new Color(102, 102, 153);

 // Blue Theme
 public static Color SECONDARY1 = new Color(196,229,250);
 public static Color SECONDARY2 = new Color(112,180,242);
 public static Color SECONDARY3 = new Color(3,11,72);

 public static Color WAS_WHITE = new Color(3,11,72);

 // BotViewerPanel
 static public Color BBOTPANEL_FOREGROUND = SECONDARY2;
 static public Color BBOTPANEL_BACKGROUND = SECONDARY3;
 static public Border BBOTPANEL_BORDER = new LineBorder(BBOTPANEL_FOREGROUND);

 // DEL ALPHA_BLEND, AND REPLACE WITH  APP_BUTTON_ALPHA_BLEND When BBotViewerPanel is free
 public static float APP_BUTTON_ALPHA_BLEND = 0.2f;

 // Buttons
 static public Color BUTTONHIGHLIGHT = new Color(255,170,78);
 static public Color BUTTONCOLOR1 = new Color(194,219,248); // On Rollver
 static public Color BUTTONCOLOR2 = new Color(91,146,230); // Normal
 static public Color BUTTONCOLOR3 = new Color(23,30,165); // Inactive
 static public Color BUTTONTEXT1 = new Color(255,255,255); // On Rollover
 static public Color BUTTONTEXT2 = new Color(194,219,248);  // Normal
 static public Color BUTTONTEXT3 = new Color(102, 102, 153); // Inactive

 static public Color DAMAGECOLOR = new Color(200, 0, 0); // Damage Progress Bar
 static public Color ENERGYCOLOR = new Color(0, 150, 0); // Energy Progress Bar

 // Fonts
 public static final String FONT_NAME = "Arial";
 /*
 static public FontUIResource SMALLFONT = new FontUIResource("Arial",Font.BOLD,10);
 static public FontUIResource MIDFONT = new FontUIResource("Arial",Font.BOLD,14);
 static public FontUIResource BIGFONT = new FontUIResource("Arial",Font.BOLD,18);   */

// END OLD INTERFACE
// ---------------------------------------------------------------------
// (The canvas 3d stuff is kinda interface stuff, though)


// *****CANVAS 3D CONSTANTS
 // Scale
 public final static float COMPONENT_SCALE = 0.08f;
 public final static float ARENA_SCALE = 1.0f;
 public final static float CHASSIS_SCALE = 1.0f; // 0.03f;  // (0.03)
 public static final float WORLD_TO_CANVAS_SCALE = 28;

 //public static final float WORLD_TO_CANVAS_SCALE = 14;
 public static final float CANVAS_TO_WORLD_SCALE = 1/WORLD_TO_CANVAS_SCALE;

 public final static  BoundingSphere INFINITE_BOUNDS =
  new BoundingSphere(new Point3d(0.0,0.0,0.0), 1000000000000.0);

 // Max. distance of zone center points from bot chassis (meters).
 public static final float ZONE_RANGE    = 10.0f;

 // Default/Min/Max size of zones (meters)...
 public static final float ZONE_DEFAULT_SIZE = 1.0f;
 public static final float ZONE_MIN_SIZE     = 0.5f;
 public static final float ZONE_MAX_SIZE      = 3.0f;

 // Constantc 3d Canvas Objects
 public static final String FLOOROBJECT = "arenaFloor/plane.wrl";
 public static final String PLANEOBJECT = "arenaFloor/plane.wrl";
 public static final String DEFAULT_APP_OBJECT = "appdialog.obj";

 // Sensore ans Zone Appearance
 public static Color SENSOR_RANGE_COLOR = new Color(250,250,250);
 public static Color3f SENSOR_RANGE_COLOR3F = BColors.convert(SENSOR_RANGE_COLOR);

 public static final String SENSORTEXTURE   = HIDDENPATH + "sparkle.gif";
 public static final String ZONETEXTURE   = HIDDENPATH + "zonetex.gif";

 // lights
 public static Color3f CANVASLIGHT = new Color3f(1.0f, 1.0f, 1.0f);
 public static Color3f AMBIENT_DIRLIGHT =  new Color3f(0.5f, 0.5f, 0.5f);
 public static Color3f AMBIENT_NO_DIRLIGHT =  new Color3f(1.0f, 1.0f, 1.0f);

 // ambientcolor is reset in load from file
 public static Color3f AMBIENTCOLOR = AMBIENT_DIRLIGHT;

 // Mode and Scale
 public static final int CANVAS_MODE_ORIENTATE = 500;
 public static final int CANVAS_MODE_CONNECTROTATE = 501;
 public static final int CANVAS_MODE_JOINTMOVE = 502;
 public static final int CANVAS_MODE_APPEARANCEPICK = 503;
 public static final int CANVAS_MODE_APPEARANCESET = 504;
 public static final int CANVAS_MODE_ARENAMOVE = 505;
 public static final int CANVAS_MODE_ARENAROTATE = 506;
 public static final int CANVAS_MODE_ARENAELEVATE = 507;
 public static final int CANVAS_MODE_ARENA_HUMAN = 508;
 public static final int CANVAS_MODE_ARENA_AUTOCENTER = 509;
 public static final int CANVAS_MODE_ARENA_BOTCAM = 510;
 public static final int CANVAS_MODE_ARENA_FIXEDCAM = 511;
 public static final int CANVAS_MODE_ARENA_AUTOCAM = 512;
 public static final int CANVAS_MODE_ROTATESCENE  = 513;
 

 public static final int CANVAS_MODE_ZONE_SCALE = 611;
 public static final int CANVAS_MODE_ZONE_X = 612;
 public static final int CANVAS_MODE_ZONE_Y = 613;
 public static final int CANVAS_MODE_ZONE_Z = 614;




// *****CANVAS3D DEFAULT VARIABLES

 // Default Zoom
 public static float STARTZOOM_MOVES = 100.0f;
 public static float STARTZOOM_CONSTRUCTION = 300.0f;
 public static float STARTZOOM_ARENA = 700.0f;

// public static Color  FLOORCOLOR = Color.blue;
 public static String DEFAULT_DESTRUCT = "default.a2d";

 public static void setLowTextureDetail (boolean b)
 {
  USE_LOW_TEXTURE_DETAIL = b;

  if (b)
    MAX_TEXTURE_SIZE = 64;
  else
    MAX_TEXTURE_SIZE = 256;

 }

 public static int MAX_TEXTURE_SIZE = 256;
 public static boolean USE_LOW_TEXTURE_DETAIL = false;

// *****BATTLE ENGINE AND ARENA

 public static float DEFAULT_FOG_DENSITY = 0.1f;
 public static Color DEFAULT_FOG_COLOR  = new Color(0.9f, 0.9f, 0.9f);
 public static float ARENASIZE = 100;    // diameter   (metres)

 public static float HEIGHT_SCALE = ARENA_SCALE;

 public static float SENSOR_ERRORMARGIN = 0.34f;        // radians (This is scaled by the distance form bot . See BSensor.detect
 public static int FRAMES_PER_SEC = 15;
 //public static int FRAMES_PER_SEC = 60;
 public static float CALC_TIMESLICE = 1f / FRAMES_PER_SEC;  // Timeslice for collision calculation etc

 public static boolean DEADLOCKDETECTED = false;
 public static int DEADLOCKCOUNT = 0;
 public static int DEADLOCKS_TO_RESETFIGHT = 7;
 //public static int DEADLOCKS_TO_RESETFIGHT = 4;

 public static boolean PENETRATION_CORRECTION = false;  // used in BBot.recursetestCollisions
 public static boolean USE_VARIABLE_TIMESLICE = false; // part of passthrough correction
 public static boolean ADVANCED_PASSTHROUGH_CORRECTION = true;

 private static int BATTLE_ACCURACY;
 public static final int BATTLE_ACCURACY_HIGH = 0;
 public static final int BATTLE_ACCURACY_MEDIUM = 1;
 public static final int BATTLE_ACCURACY_LOW = 2;

 public static boolean SHOW_AI_LABELS = false;  // true to show the labels in the AI tree
 public static int USER_MAX_SIM_SLICES = BPhysics.MAX_SLICES;
 public static int USER_VELOCITY_CHECK_CYCLE = BPhysics.VELOCITY_CHECK_CYCLE;
 public static int FULL_ROLLBACK_DEPTH = 4;

 // DJG June 2001
 //public static int SIM_MIN_PROCESS_TIME = 50; // Millisecs alloted to Sim Processing per Render Frame (BSimBehaviour)
 public static float STAND_DOWN_MILLISECS = 250; // Time To Stand Down Repetitive Move Requests (BChassis/BMove)


 public static void setBattleAccuracy(int code)
 {
  if (code == BATTLE_ACCURACY_HIGH)
  {
   // BDebug.print ("BGlobal setBattleAccuracy FULL");
    BATTLE_ACCURACY = BATTLE_ACCURACY_HIGH;
    setCollisionDetail(COLLISION_FULL);
    COLLIDE_SELF = true;

    CALC_TIMESLICE = 1f / FRAMES_PER_SEC;
    BBot.ROLLBACK_DEPTH = 2;
    FULL_ROLLBACK_DEPTH = 4;

    PENETRATION_CORRECTION = true;
    USE_VARIABLE_TIMESLICE = true;
    ADVANCED_PASSTHROUGH_CORRECTION = true;
    USER_MAX_SIM_SLICES = BPhysics.MAX_SLICES;
    USER_VELOCITY_CHECK_CYCLE = BPhysics.VELOCITY_CHECK_CYCLE;

  }
  else  if (code == BATTLE_ACCURACY_MEDIUM)
  {
    //BDebug.print ("BGlobal setBattleAccuracy MEDIUM");

    BATTLE_ACCURACY = BATTLE_ACCURACY_MEDIUM;
    setCollisionDetail(COLLISION_FULL);
    COLLIDE_SELF = true;

    CALC_TIMESLICE = 1f / FRAMES_PER_SEC;
    BBot.ROLLBACK_DEPTH = 1;
    FULL_ROLLBACK_DEPTH = 2;

    PENETRATION_CORRECTION = true;
    ADVANCED_PASSTHROUGH_CORRECTION = false;
    USER_MAX_SIM_SLICES = 4;
    USER_VELOCITY_CHECK_CYCLE = 2;
    USE_VARIABLE_TIMESLICE = true;


  }
  else  if (code == BATTLE_ACCURACY_LOW)
  {
    BATTLE_ACCURACY = BATTLE_ACCURACY_LOW;
    setCollisionDetail(COLLISION_BOUNDS);
    COLLIDE_SELF = false;

    CALC_TIMESLICE = 1f / FRAMES_PER_SEC;
    BBot.ROLLBACK_DEPTH = 0;
    FULL_ROLLBACK_DEPTH = 1;

    PENETRATION_CORRECTION = true;

    ADVANCED_PASSTHROUGH_CORRECTION = false;
    USER_MAX_SIM_SLICES = 2;
    USER_VELOCITY_CHECK_CYCLE = 1;
    USE_VARIABLE_TIMESLICE = true;

  }
  else
    BDebug.print ("BGlobal.setBattleAccuray ERROR, unknown Code ::" + code);
  //MDF - self colliding fix?
  //PENETRATION_CORRECTION = false;
 }


 public static int getBattleAccuracy()
  {return BATTLE_ACCURACY; }

 // Collision
 public static final int COLLISION_FULL = 1;
 public static final int COLLISION_BOUNDS = 2;
 public static final int COLLISION_MINIMAL = 3;

 private static int COLLISION_DETAIL = COLLISION_FULL;
 private static boolean COLLIDE_SELF = true;

 public static int getCollisionCode()
 {
        return  COLLISION_DETAIL;
 }


 public static boolean getCollideSelf()
 {
  return  COLLIDE_SELF;

 }

 public static void setCollisionDetail(int colCode)
 {
     COLLISION_DETAIL = colCode;

     // colliseself code moved to setBattleAccuracy
     /*
     if (colCode == COLLISION_FULL)
     {
        COLLISION_DETAIL =  COLLISION_FULL;
        COLLIDE_SELF = true;
     }
     else if (colCode == COLLISION_BOUNDS)
     {
        COLLISION_DETAIL =  COLLISION_BOUNDS;
        COLLIDE_SELF = false;
     }
     else if (colCode == COLLISION_MINIMAL)
     {
        COLLISION_DETAIL =  COLLISION_MINIMAL;
        COLLIDE_SELF = false;
     }
     else
        BDebug.print("BGlobal.setCollisionDetail INCORRECT CODE.");  */
 }

// BBattlePlayer
 public static Color BATTLEPLAYER_COLOR = SECONDARY3;
 public static double HUMAN_HEIGHT = 1 * BGlobal.WORLD_TO_CANVAS_SCALE ;


 // video options
 public static String VIDEOMODE_OPENGL = "OpenGL";
 public static String VIDEOMODE_DIRECTX = "Direct X" ;

 public static int HIGH_SPEC     = 0;
 public static int MID_SPEC      = 3;
 public static int LOW_SPEC      = 1;
 public static int ADVANCED_SPEC = 2;


// *******FLAGS

 // Hack to allow playback of chassis moves  when construction a chassis bot.
 // Set in MovesPanel.payMove,  Only used if Chassis.getMoveList call returtns null  in BChassis.setNewChassisMove
 public static int CHASSIS_BOT_MOVE_TYPE;
 public static boolean CONSTRUCTING_CHASSISBOT = false;  // used for constructing Moves on the MovesPanel for chassis
                                                        // set in BSimulation.initAreaDetails, Checked in BBot and BChassis
 public static boolean ALLOW_ORIENT = true;
                                          // if this is switched off, then all chassis orients will not work
                                          // set in BSimulation.startMoves,   checked for in moves.getNextSnapShot
 public static boolean DEBUG_MODE = true;

 // SJS [08/05/2000] - Added developer mode switch.
 public static boolean DEVELOPER_MODE = false;

 public static boolean MOVE_FLOOR = true;
 public static boolean MAKE_MOVIE = false;
 public static boolean SKIP_RENDER = false;
 public static boolean SHOW_SIMWINDOW = true;  // Show the simulation window  in the test window

 public static boolean IS_FARMCLIENT = false;


//User preferences
public static boolean WIREFRAME_ON_MOVE = false;
public static boolean USE_AUTOGEN = true;
public static boolean SHOW_TEXTURES = true;
public static boolean SHOW_BACKGROUND = true;
public static boolean USE_DIRLIGHT = true;
public static boolean USE_FOG = true;
public static boolean INVERT_PLAYER_Y = true;
public static boolean USE_ALTERNATE_ROTATION = false;
public static boolean USE_TRANSPARENCY = true;
public static boolean USE_MIPMAP = true;
public static boolean USE_INTERPOLATION = true;
public static boolean FILTER_WORDS = true;

public static float BACKGROUND_SOUND_VOLUME = -4f;    // (-13 to -5 dB  (Scale of windows volume, not absolute)  )
public static float FOREGROUND_SOUND_VOLUME = 0f;    // (-13 to + 4 dB  (Scale of windows volume, not absolute)  )
public static float INTERFACE_SOUND_VOLUME =  FOREGROUND_SOUND_VOLUME;
public static boolean USE_SOUND = true;

public static boolean J3DENGINESTARTED = false;


//Proxy Server Preferences
public static boolean USE_PROXY     = false;
public static String PROXY_HOST     = "";
public static String PROXY_PORT     = "";
public static String PROXY_PASSWORD = "";


public static final int PARTICLE_QUALITY_LOW  = 0;
public static final int PARTICLE_QUALITY_MED  = 1;
public static final int PARTICLE_QUALITY_HIGH = 2;

public static int PARTICLE_QUALITY = PARTICLE_QUALITY_MED;


public static boolean isParticleQualityLow()
  { return PARTICLE_QUALITY == PARTICLE_QUALITY_LOW; }

public static boolean isParticleQualityHigh()
  { return PARTICLE_QUALITY == PARTICLE_QUALITY_HIGH; }
  

public static String VIDEOMODE = VIDEOMODE_OPENGL;
public static boolean SWAPVIDEO = false;

public static int GRAPHICS_SPEC = HIGH_SPEC;

public static boolean DISABLE_FLASHING_OBJECTS = false;

public static boolean SOLID_ZONES = false;

public static boolean AUTOSAVE = false;

// also see COLLISION_DETAIL  in battle engine section


// NON STATIC MEMBERS TO SAVE
// ALL MEMBERS MUST BE - UPDATE THE STATIC WHEN YOU LOAD

public boolean developerMode = false;
public boolean wireFrameOnMovement = false;
public boolean useAutoGen = true;
public boolean showTextures = true;
public boolean showBackground = false;
public boolean useDirLight = true;
//private int collisionDetail = COLLISION_FULL;
public boolean useFog = true;
public boolean invertPlayerY = true;
public String systemPath = SYSTEMPATH;
public boolean useTransparency = true;
public boolean useAlternativeRotate = false;
public float foregroundSoundVolume = 0f;
public float backgroundSoundVolume = 0f;
public float interfaceSoundVolume =  foregroundSoundVolume;
public float app_version = APP_VERSION;
public boolean useSound = USE_SOUND;
public boolean useMipMap = USE_MIPMAP;
public int particleQuality = PARTICLE_QUALITY;
public boolean useInterpolation = USE_INTERPOLATION;

public int battleAccuracy = BATTLE_ACCURACY_MEDIUM;
public boolean showAILabels = false;
public boolean useLowTextureDetail = USE_LOW_TEXTURE_DETAIL;

public Color uiBaseColor = UI_BASE_COLOR;
//public String userPath = USERPATH;
public String urlSGateway = URLSGATEWAY;
public String urlSChallengeRoom = URLSCHALLENGE_ROOM;
public String urlSFarmFeeder = URLSFARMFEEDER;
public String videoMode = VIDEOMODE;

public int graphicsSpec = GRAPHICS_SPEC;

public boolean disableFlashing = DISABLE_FLASHING_OBJECTS;
public boolean solidZones = SOLID_ZONES;
public boolean autosave = AUTOSAVE;

public boolean useProxy     = false;
public String proxyHost     = "";
public String proxyPort     = "";
public String proxyPassword = "";


 public static void swapInVideoMode() throws IOException
 {

    RandomAccessFile installFile = new RandomAccessFile("install.txt", "rw");

    String path = installFile.readLine() ;
    String classPath = installFile.readLine();
    String app = installFile.readLine() ;
    String bitsperPix = installFile.readLine() ;
    String gmode = installFile.readLine() ;
    String params = installFile.readLine() ;

    installFile.close();

    File delFile = new File("install.txt");
    delFile.delete();

    installFile = new RandomAccessFile("install.txt", "rw");

    installFile.writeBytes(path + "\n");
    installFile.writeBytes(classPath + "\n");
    installFile.writeBytes(app + "\n");
    installFile.writeBytes(bitsperPix + "\n");

    if (VIDEOMODE.equals(VIDEOMODE_DIRECTX) )
      installFile.writeBytes ("directx\n");
    else
      installFile.writeBytes("opengl\n");

    installFile.writeBytes(params + "\n");
    installFile.close();

 }


public BGlobal()
{
   //userPath = USERPATH;
   developerMode = DEVELOPER_MODE;
   wireFrameOnMovement =  WIREFRAME_ON_MOVE;
   useAutoGen = USE_AUTOGEN;
   showTextures = SHOW_TEXTURES;
   showBackground =  SHOW_BACKGROUND;
   useDirLight =  USE_DIRLIGHT;
   battleAccuracy = BATTLE_ACCURACY;
   showAILabels = SHOW_AI_LABELS;

   //collisionDetail = COLLISION_DETAIL;
   useFog = USE_FOG;
   invertPlayerY = INVERT_PLAYER_Y;
   systemPath = SYSTEMPATH;
   useTransparency =  USE_TRANSPARENCY;
   useAlternativeRotate =  USE_ALTERNATE_ROTATION;
   foregroundSoundVolume = FOREGROUND_SOUND_VOLUME;
   interfaceSoundVolume = INTERFACE_SOUND_VOLUME;
   backgroundSoundVolume = BACKGROUND_SOUND_VOLUME;
   app_version = APP_VERSION;
   useSound = USE_SOUND;
   useMipMap = USE_MIPMAP;
   particleQuality = PARTICLE_QUALITY;
   useInterpolation = USE_INTERPOLATION;


   uiBaseColor = UI_BASE_COLOR;
   urlSGateway = URLSGATEWAY;
   urlSChallengeRoom = URLSCHALLENGE_ROOM;
   urlSFarmFeeder = URLSFARMFEEDER;
   videoMode = VIDEOMODE;
   useLowTextureDetail = USE_LOW_TEXTURE_DETAIL;

   graphicsSpec = GRAPHICS_SPEC;

   disableFlashing = DISABLE_FLASHING_OBJECTS;
   solidZones = SOLID_ZONES;
   autosave = AUTOSAVE;

  // swapVideo = SWAPVIDEO;

  // Proxy Settings
  useProxy      = USE_PROXY;
  proxyHost     = PROXY_HOST;
  proxyPort     = PROXY_PORT;
  proxyPassword = PROXY_PASSWORD;
}


public static void clearAllHardCaches()
{
    // Clear the 3d shapes cache.
    B3dShapeManager.clear(true);

    // Clear the textures cache.
    BTextures.clear();

    BSound.clearCache();

    // Clear the ConnectPoint animator.
    // This should clear itself, but you can never be too careful
    BConnectPointShape.cleanseStatic();

    BComponentMaterial.clearCache();

    BSerializableTree.clearCache();

    BLoadingScreen.clearStatic();

    BIconCache.clear();
    BIconCache.setHardCache(false);

    BDictionaryTree.clearStatic();
   // B3DLimbCanvas.clearStatic();




}

public static void init()
{

  BGlobal newIn;

  try
    {

      String prefString = BGlobal.USERPATH + "bglobal.prf";

      File prefTest = new File(prefString);
      if (! prefTest.exists())
      {
          BDebug.print("Loading preference from sourcepath");
          prefString =  "bglobal.prf";
          USERPATH = "";

      }

      // READ FILE
      FileInputStream fin = new FileInputStream(prefString);
      ObjectInputStream in = new ObjectInputStream(fin);
      newIn = (BGlobal)in.readObject();
      in.close();

      fin.close();
      // SET UP STATICS
      DEVELOPER_MODE = newIn.developerMode;
      WIREFRAME_ON_MOVE =  newIn.wireFrameOnMovement;
      USE_AUTOGEN = newIn.useAutoGen;
      SHOW_TEXTURES = newIn.showTextures;
      SHOW_BACKGROUND =  newIn.showBackground ;
      USE_DIRLIGHT = newIn.useDirLight;
      INVERT_PLAYER_Y = newIn.invertPlayerY;
      USE_FOG = newIn.useFog;
      USE_TRANSPARENCY = newIn.useTransparency  ;
      USE_ALTERNATE_ROTATION = newIn.useAlternativeRotate ;
      FOREGROUND_SOUND_VOLUME = newIn.foregroundSoundVolume ;
      BACKGROUND_SOUND_VOLUME =  newIn.backgroundSoundVolume  ;
      INTERFACE_SOUND_VOLUME = newIn.interfaceSoundVolume;
      APP_VERSION = newIn.app_version;
      USE_SOUND = newIn.useSound ;
      //MDF enable sound due to previous disable
      BDebug.print("Forcing Sound enable");
      USE_SOUND=true;
      //MDF end
      USE_MIPMAP = newIn.useMipMap;
      PARTICLE_QUALITY = newIn.particleQuality;
      USE_INTERPOLATION = newIn.useInterpolation;

      if (newIn.uiBaseColor != null)
        UI_BASE_COLOR = newIn.uiBaseColor;

      GRAPHICS_SPEC = newIn.graphicsSpec;
      DISABLE_FLASHING_OBJECTS = newIn.disableFlashing;
      SOLID_ZONES = newIn.solidZones;
      AUTOSAVE = newIn.autosave;

      setGraphicsSpec();

      // system path stuff
      SYSTEMPATH = newIn.systemPath;
      BGlobal.updatePaths();

      /*
      if (newIn.videoMode != null )
        VIDEOMODE = newIn.videoMode;    */

      File videoFile = new File(JREPATH +  "bin/j3d.dll");
      File directXFile = new File( DIRECTXPATH  + "bin/j3d.dll");

      if (videoFile.length() == 0)
        VIDEOMODE = VIDEOMODE_OPENGL;
      else if (videoFile.length() == directXFile.length() )
        VIDEOMODE =  VIDEOMODE_DIRECTX;
      else
        VIDEOMODE = VIDEOMODE_OPENGL;

      BDebug.print ("Roboforge video mode: " + VIDEOMODE );

      if (newIn.urlSGateway!= null)
        URLSGATEWAY = newIn.urlSGateway;

      if (newIn.urlSChallengeRoom!= null)
        URLSCHALLENGE_ROOM = newIn.urlSChallengeRoom;

      if (newIn.urlSFarmFeeder!= null)
        URLSFARMFEEDER = newIn.urlSFarmFeeder;



      if (!USE_DIRLIGHT )
        AMBIENTCOLOR = AMBIENT_NO_DIRLIGHT;
      else
        AMBIENTCOLOR = AMBIENT_DIRLIGHT;

      setBattleAccuracy(newIn.battleAccuracy);

      SHOW_AI_LABELS = newIn.showAILabels;

      setLowTextureDetail(newIn.useLowTextureDetail);

      //setCollisionDetail(newIn.collisionDetail);

      USE_PROXY       = newIn.useProxy;
      PROXY_HOST      = newIn.proxyHost;
      PROXY_PORT      = newIn.proxyPort;
      PROXY_PASSWORD  = newIn.proxyPassword;


      // Set up the Proxy location if the settings require it
      if (USE_PROXY && PROXY_HOST.length() > 0 && PROXY_PORT.length() > 0)
      {
        //BDebug.print( "Setting the Proxy");
        //BDebug.print( "Setting the Proxy: " + PROXY_HOST);

        //java.util.Properties systemSettings = System.getProperties();
        //systemSettings.put("proxySet", "true");
        //systemSettings.put("proxyHost", "myProxyServer.com");
        //systemSettings.put("proxyPort", "80");
        //System.setProperties(systemSettings);


        System.getProperties().put("http.proxySet","true");
        System.getProperties().put("http.proxyHost",PROXY_HOST);
        System.getProperties().put("http.proxyPort",PROXY_PORT);
      }

      BDebug.print( "BGlobal.init successful. [user path = " + SYSTEMPATH + "]");
      BDebug.print( "Roboforge v" + APP_VERSION);
      BDebug.print( "Server path : " + URLSGATEWAY);
      BDebug.print( "Challenge Room path : " + URLSCHALLENGE_ROOM);
      BDebug.print( "Farm Feeder path : " + URLSFARMFEEDER);
      BDebug.print( "Video Mode : " + VIDEOMODE);
      BDebug.print( "Proxy Mode : " + USE_PROXY);


    } catch (Exception e) {BDebug.print( "BGlobal.init " + e.getMessage());}


    colors = new BUIColorScheme(UI_BASE_COLOR);
    //SENSOR_RANGE_COLOR3F  = colors.getDarkShade3f();
    //SENSOR_RANGE_COLOR    = colors.getDarkShade3f();




}

 public static void setGraphicsSpec()
 {
   if(GRAPHICS_SPEC == LOW_SPEC)
   {
      USE_AUTOGEN = false;
      setLowTextureDetail(true);
      USE_FOG = false;
      USE_MIPMAP = true;
      PARTICLE_QUALITY = PARTICLE_QUALITY_LOW;
      USE_INTERPOLATION = false;
      USE_TRANSPARENCY = false;
   }

   else if (GRAPHICS_SPEC == MID_SPEC)
   {
      USE_AUTOGEN = true;
      setLowTextureDetail(false);
      USE_FOG = true;
      USE_MIPMAP = true;
      PARTICLE_QUALITY = PARTICLE_QUALITY_MED;
      USE_INTERPOLATION = true;
      USE_TRANSPARENCY = true;
   }

   else if(GRAPHICS_SPEC == HIGH_SPEC)
   {
      USE_AUTOGEN = true;
      setLowTextureDetail(false);
      USE_FOG = true;
      USE_MIPMAP = true;
      PARTICLE_QUALITY = PARTICLE_QUALITY_HIGH;
      USE_INTERPOLATION = true;
      USE_TRANSPARENCY = true;
   }
 }

 public static void save()
 {
   BGlobal globals = new BGlobal();
   globals.saveToFile();
 }

 public void saveToFile()
 // to save global setting, create a new bglobal
 // eg:
 // BGlobal tempG = new BGlobal()
 // tempG.saveToFile()
  {

    try{
      FileOutputStream fout = new FileOutputStream(BGlobal.USERPATH + "bglobal.prf" );
      ObjectOutputStream out = new ObjectOutputStream(fout);
      out.writeObject(this);
      out.close();
      System.out.println(" BGlobal Save completed");
    }
    catch (Exception e) {
      BDebug.print("BGlobal.saveToFile ERROR " + e.getMessage() );
    }
  }





 public static String[] COUNTRIES = new String[] {"Afghanistan",
  "Albania", "Algeria", "American Samoa", "Andorra", "Angola", "Antigua and Barbuda",
  "Argentina", "Armenia", "Aruba", "Australia", "Austria", "Azerbaijan", "Bahamas",
  "Bahrain", "Bangladesh", "Barbados", "Belarus", "Belgium", "Belize", "Benin",
  "Bermuda", "Bhutan", "Bolivia", "Bosnia and Herzegovina", "Botswana", "Brazil",
  "Brunei", "Bulgaria", "Burkina Faso", "Burundi", "Cambodia", "Cameroon", "Canada",
  "Cape Verde", "Cayman Islands", "Central African Republic", "Chad", "Channel Islands",
  "Chile", "China", "Colombia", "Comoros", "Congo", "Costa Rica", "Cote d'Ivoire", "Croatia",
  "Cuba", "Cyprus", "Czech Republic", "Denmark", "Djibouti", "Dominica", "Dominican Republic",
  "Ecuador", "Egypt", "Arab Rep.", "El Salvador", "Equatorial Guinea", "Eritrea", "Estonia",
  "Ethiopia", "Faeroe Islands", "Fiji", "Finland", "France", "French Guiana", "French Polynesia",
  "Gabon", "Gambia", "Georgia", "Germany", "Ghana", "Greece", "Greenland", "Grenada", "Guadeloupe",
  "Guam", "Guatemala", "Guinea", "Guinea-Bissau", "Guyana", "Haiti", "Honduras", "Hong Kong",
  "Hungary", "Iceland", "India", "Indonesia", "Iran", "Islamic Rep.", "Iraq", "Ireland",
  "Isle of Man", "Israel", "Italy", "Jamaica", "Japan", "Jordan", "Kazakstan", "Kenya",
  "Kiribati", "Korea", "Dem. Rep.", "Korea", "Kuwait", "Kyrgyz Republic", "Lao PDR",
  "Latvia", "Lebanon", "Lesotho", "Liberia", "Libya","Liechtenstein","Lithuania","Luxembourg",
  "Macao", "Macedonia", "Madagascar", "Malawi", "Malaysia", "Maldives", "Mali", "Malta",
  "Marshall Islands", "Martinique", "Mauritania", "Mauritius", "Mayotte", "Mexico", "Micronesia",
  "Moldova", "Monaco", "Mongolia", "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal",
  "Netherlands", "Netherlands Antilles", "New Caledonia", "New Zealand", "Nicaragua",
  "Niger", "Nigeria", "Northern Mariana Islands", "Norway", "Oman", "Pakistan", "Panama",
  "Papua New Guinea", "Paraguay", "Peru", "Philippines", "Poland", "Portugal", "Puerto Rico",
  "Qatar", "Reunion", "Romania", "Russian Federation", "Rwanda", "Sao Tome and Principe",
  "Saudi Arabia", "Senegal", "Seychelles", "Sierra Leone", "Singapore", "Slovak", "Republic", "Slovenia",
  "Solomon Islands", "Somalia", "South Africa", "Spain", "Sri Lanka", "St. Kitts and Nevis St.", "Lucia St.",
  "Vincent and the Grenadines", "Sudan", "Suriname", "Swaziland", "Sweden", "Switzerland",
  "Syrian Arab Republic", "Tajikistan", "Tanzania", "Thailand", "Togo", "Tonga", "Trinidad and Tobago",
  "Tunisia", "Turkey", "Turkmenistan", "Uganda", "Ukraine", "United Arab Emirates", "United Kingdom",
  "United States", "Uruguay", "Uzbekistan", "Vanuatu", "Venezuela", "Vietnam",
  "Virgin Islands (U.S.)", "West Bank and Gaza", "Western Samoa", "Yemen", "Yugoslavia",
  "FR (Serbia/Montenegro)", "Zaire", "Zambia", "Zimbabwe"
  };


}
