package roboforge;

import java.io.*;
//import javax.vecmath.*;

public class BJointPosition implements Serializable, Cloneable
{
/*

* Description:
* Example:
* Modification History ( Name, Date, Notes ):
                         YLY , 11 May 99 Creation and stuff


ONLY USE clone, toString and equals unless calling from BJoint or children of Bjoint


*/

  static final long serialVersionUID = -1L;
  private float myFloat;

  private static float infinity = 999999999999999f;
  //private Matrix4f myRotMatrix;


  public BJointPosition(float newF)
  {
        myFloat = newF;
        //myRotMatrix = new Matrix4f();
       // myRotMatrix.m33 = 1.0f;
        //myRotMatrix.setIdentity();


  }

  public void set (BJointPosition other)
  {
    this.myFloat = other.myFloat;
  }

  public Object clone()
  {

       //if (myRotMatrix == null)
       //{
         // myRotMatrix = new Matrix4f();
         // myRotMatrix.setIdentity();
       //}

       BJointPosition tempJ = new BJointPosition(myFloat);
       //tempJ.setMatrix(this.myRotMatrix);
       return tempJ;
  }


  public boolean equals(BJointPosition newP)
  {
    if (newP == null)
        return false;

  //  if (myRotMatrix == null)
    //   {
      //  myRotMatrix = new Matrix4f();
       // myRotMatrix.setIdentity();
       //}

       /*
    if (newP.myRotMatrix == null)
       {
        newP.myRotMatrix = new Matrix4f();
        newP.myRotMatrix.setIdentity();
       } */


   return ( (newP.myFloat == this.myFloat)  ) ;
   //return  (newP.myFloat == this.myFloat)  ;

  };


  public boolean worldTranslateEquals(BJointPosition newP)
  // Returns true if the translation componenet is equal
  {

    int newT = java.lang.Math.round( newP.getWorldTranslate() * 1000.0f );
    int myT =  java.lang.Math.round( getWorldTranslate() * 1000.0f );


   return newT == myT;

  };


  public static float getInfinity(boolean getNegative)
  {
    if (getNegative)
      return -infinity;
    else
      return infinity;
  }

  public String toString()
  {

        Float tempF = new Float(myFloat);
        return tempF.toString();

  }







/******************THE METHODS BELOW SHOULD ONLY BE USED IN BJOINT ***********************/

  public float getAngle()
  {
        return myFloat;


  }

  public void setAngle(float newF)
  {
        myFloat = newF;

  }



  public float getWorldTranslate()
  // Translates are stored in Canvas Co-ordinates,
  // This function returns Real World Co-ordinates for the translate
  {
    return myFloat * BGlobal.CANVAS_TO_WORLD_SCALE;

  }

  public void  setWorldTranslate(float newF)
   // Translates are stored in Canvas Co-ordinates,
  // This function sets Real World Co-ordinates for the translate

  {
    myFloat = newF * BGlobal.WORLD_TO_CANVAS_SCALE;

  }


  public float getTranslate()
  {
        return myFloat;


  }

  public void setTranslate(float newF)
  {
        myFloat = newF;

  }



  public void AVG (BJointPosition otherPos, int weightOnCurrent)
  {
        float weigthedCurrent =  myFloat * (float)weightOnCurrent;
        myFloat = (otherPos.getAngle() + weigthedCurrent) / (weightOnCurrent + 1);
  }


  public void interpolate(BJointPosition a, BJointPosition b, float t)
  {
    // t = 0   --> this.myFloat = a.myFloat.
    // t = 0.5 --> this.myFloat = average(a, b).
    // t = 1   --> this.myFloat = b.myFloat.

    myFloat = a.myFloat * (1-t) + b.myFloat * t;
  }


}