package roboforge;

import java.io.*;
import java.security.*;
//import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;

public class SAccountInfo implements Serializable
{
  /*

  * Description:
    Holds Account information
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 23-November-1999

  */

  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
public byte[] password;
  public byte[] name;
  public byte[] address1;
  public byte[] address2;
  public byte[] city;
  public byte[] country;
  public byte[] post_code;
  public byte[] email;
  public String blurb;
  public float current_balance;
  public String current_version;
  public float winnings_balance;

  private transient PublicKey rsa_pub;


  public SAccountInfo(String passwordIn,String nameIn, String address1In, String address2In,
  String cityIn, String countryIn, String post_codeIn, String emailIn, float current_balanceIn,
  String current_versionIn, float winnings_balanceIn,PublicKey pKey, String blurbIn)
  {
     try
    {
      // SetUp IAIK as the security provider
      //IAIK.addAsProvider(false);

      // Note a different public key is passed depend if the Account information is
      // being passed from the client to the server of vice versa
      rsa_pub = pKey;

      // Set up the Cipher for Encrypt

      //Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
      //rsa.init(Cipher.ENCRYPT_MODE, rsa_pub);


      // Encrypt the password
      //password = rsa.doFinal(passwordIn.getBytes());
      password = SServerAccess.encrypt(passwordIn.getBytes(),rsa_pub);

      // Encrypt the name
      name = SServerAccess.encrypt(nameIn.getBytes(),rsa_pub);

      // Encrypt the address1
      address1 = SServerAccess.encrypt(address1In.getBytes(),rsa_pub);

      // Encrypt the address2
      address2 = SServerAccess.encrypt(address2In.getBytes(),rsa_pub);

      // Encrypt the city
      city = SServerAccess.encrypt(cityIn.getBytes(),rsa_pub);

      // Encrypt the country
      country = SServerAccess.encrypt(countryIn.getBytes(),rsa_pub);

      // Encrypt the post_code
      post_code = SServerAccess.encrypt(post_codeIn.getBytes(),rsa_pub);

      // Encrypt the email
      email = SServerAccess.encrypt(emailIn.getBytes(),rsa_pub);

      blurb = blurbIn;

      current_balance = current_balanceIn;
      current_version = current_versionIn;
      winnings_balance = winnings_balanceIn;

    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      throw new RuntimeException();
    }


  }
}