package roboforge;

import java.io.*;
import java.security.*;
import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

public class SCreateAccount implements Serializable
{
   /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/*

  * Description:
    Holds the information necessary to create a new account
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 24-November-1999

  */

  byte[] registration_key;
  byte[] loginID;
  byte[] password;
  byte[] name;
  byte[] address1;
  byte[] address2;
  byte[] city;
  byte[] country;
  byte[] post_code;
  byte[] email;
  byte[] blurb;

  public SCreateAccount
  (String registrationKeyIn,String loginIDIn, String passwordIn, String nameIn,
  String address1In, String address2In, String cityIn, String countryIn,
  String post_codeIn, String emailIn, String blurbIn)
  {
    try
    {
      // SetUp IAIK as the security provider
      IAIK.addAsProvider(false);

      // Read in and Define the private Key
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      PublicKey rsa_pub = (PublicKey)in.readObject();

      // Set up the Cipher for Encrypt
      Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
      rsa.init(Cipher.ENCRYPT_MODE, rsa_pub);

      // Encrypt the registrationKey
      registration_key = rsa.doFinal(registrationKeyIn.getBytes());

      // Encrypt the password
      password = rsa.doFinal(passwordIn.getBytes());

      // Encrypt the loginID
      loginID = rsa.doFinal(loginIDIn.getBytes());

      // Encrypt the name
      name = rsa.doFinal(nameIn.getBytes());

      // Encrypt the address1
      address1 = rsa.doFinal(address1In.getBytes());

      // Encrypt the address2
      address2 = rsa.doFinal(address2In.getBytes());

      // Encrypt the city
      city = rsa.doFinal(cityIn.getBytes());

      // Encrypt the country
      country = rsa.doFinal(countryIn.getBytes());

      // Encrypt the post_code
      post_code = rsa.doFinal(post_codeIn.getBytes());

      // Encrypt the email
      email = rsa.doFinal(emailIn.getBytes());

      // Encrypt the blurb
      blurb = rsa.doFinal(blurbIn.getBytes());
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      throw new RuntimeException();
    }
  }
}