package roboforge.ai.actions;

import roboforge.*;

public class BAutoJointAction implements BAction
{
  BAutoRotateJoint[] myJoints;

  public BAutoJointAction(BAutoRotateJoint[] newJoints)
  {
    myJoints = newJoints;

  }

  public void start()
  {
        for (int i = 0 ; i < myJoints.length ; i++ )
          myJoints[i].clearVelocity();
  }

  public boolean execute(float s)
  {
    //BDebug.print("BAutoJointAction execute called ");

    for (int i = 0 ; i < myJoints.length ; i++ )
      myJoints[i].move(s, 1.0f);

    return  true;
  }

  public void stop()
  {
    for (int i = 0 ; i < myJoints.length ; i++ )
          myJoints[i].clearVelocity();
  }


  public boolean isValid()
  {
    return true;
  }



  // Conflict resolution methods...
  // -------------------------------------------------------------

  public boolean conflictsWith(BAction a)
  {
    return false;
  }

  public boolean overrides(BAction a)
  { return false; }

  public String getName()
  {
    return new String("Auto Rotate Joint Action ");
  }

  public boolean equals (Object o)
  {
    return (o instanceof BAutoJointAction );
  }




}