package roboforge.ai.decisions;

import roboforge.BGlobal;
import roboforge.BMove;
import roboforge.BBot;

import roboforge.ai.actions.*;
import roboforge.ui.components.HSBImageIcon;

import javax.swing.Icon;


public class BMoveActionNode extends BActionNode
{

  // Class variables...
  // -------------------------------------------------------------

  protected static Icon icon =
    createTreeIcon("ai/move_18.gif", BGlobal.colors.getAIActionColor());

 // protected static Icon selectedIcon =
  //  createTreeIcon("ai/move_18.gif", BGlobal.SELECTED_COLOR, BGlobal.colors.getAIActionColor());


  // Member variables.
  // -------------------------------------------------------------

  protected boolean isOverriding = false;
  protected String nullifiedMoveName;



  // Temporary variables..
  // -------------------------------------------------------------

  protected transient BMove move;



  // Constructor.
  // -------------------------------------------------------------

  public BMoveActionNode()
    { super(); }

  public BMoveActionNode(BActor a)
    { super(a); }

  public BMoveActionNode(BMoveActionNode node)
  {
    super(node);
    this.move = node.move;
    this.isOverriding = node.isOverriding;
    this.nullifiedMoveName = node.nullifiedMoveName;
  }

  public Object clone()
    { return new BMoveActionNode(this); }


  // Accessor functions
  // -------------------------------------------------------------

  public void setMoveAction(BMove m)
  {
    this.action = m;
    setDefaultName();
  }

  public BMove getMoveAction()
    { return (BMove) action; }


  public boolean isOverriding()
    { return isOverriding; }

  public void setOverriding(boolean o)
    { this.isOverriding = o; }


  public Icon getIcon()
    { return icon; }

  public Icon getSelectedIcon()
    { return getIcon(); }

  protected String generateDefaultName()
  {
    if (action == null)
    {
      if (nullifiedMoveName != null)
        return nullifiedMoveName;
      else
        return "Move";
    }
    else
      return action.toString();
  }



  // Initialization method.
  // -----------------------------------------------------------

  public void init()
  {
    move = (BMove) action;
    super.init();
  }


  // Visit method...
  // -----------------------------------------------------------

  public void visit()
  {
    if (move != null)
      move.setOverriding(isOverriding);

    super.visit();
  }



  public void setActor(BActor a)
  {
    if (a == null)
    {
      if (getAction() != null)
        nullifiedMoveName = getAction().getName();
        
      setAction(null);

    }
    else 
    {
      BBot b = (BBot) a;
      move = b.getMoveList().getMove(nullifiedMoveName);
      if (move != null)
        setAction(move);
    }

    super.setActor(a);

  }


  // State storage / retrieval...
  // -----------------------------------------------------------

  public void setState(Object o)
  {
    super.setState(o);

    MoveActionNodeState state =
      (MoveActionNodeState) o;

    this.isOverriding  = state.isOverriding;
    this.nullifiedMoveName = state.nullifiedMoveName;
  }

  public Object getState()
    { return new MoveActionNodeState(this); }

  protected static class MoveActionNodeState extends ActionNodeState
  {
    static final long serialVersionUID = -1L;

    protected boolean isOverriding;
    protected String nullifiedMoveName;

    public MoveActionNodeState(BMoveActionNode node)
    {
      super(node);
      this.isOverriding  = node.isOverriding;
      this.nullifiedMoveName = node.nullifiedMoveName;
    }
  }

}
