package roboforge.ai.decisions;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BSimulation;
import roboforge.BBot;

import roboforge.ai.expressions.*;
import roboforge.ai.values.*;
import roboforge.ai.worldstate.*;
import roboforge.ui.components.HSBImageIcon;
import roboforge.ui.components.BBorderedIcon;

import java.util.Enumeration;

import javax.swing.Icon;
import javax.swing.tree.*;
import java.awt.Color;
import java.io.*;


public class BSimpleAngleNode extends BSimpleDecisionNode
{

  BValue valueRef2;

  public BSimpleAngleNode()
  {
    super();
  }

  public BSimpleAngleNode(String worldItemRef, String operatorRef, BValue valueRef, BValue valueRef2, String iconName, String defaultName)
  {
    super(worldItemRef, operatorRef, valueRef, iconName, defaultName);
    this.valueRef2 = valueRef2;
  }

  public BSimpleAngleNode(BSimpleAngleNode node)
  {
    super(node);
    this.valueRef2 = node.valueRef2;
  }

  public Object clone()
  {
    BSimpleAngleNode node =
      new BSimpleAngleNode(this);

    // Add in dummy nodes as needed...

    node.add(new BNOPNode());

    return node;
  }

  // accessors
  public void setValueRef2(BValue valueRef2)
  {
    this.valueRef2 = valueRef2;
  }
  public BValue getValueRef2()
  {
    return valueRef2;
  }

  public void setState(Object o)
  {
    super.setState(o);

    BSimpleAngleState state =
      (BSimpleAngleState) o;

    this.valueRef2 = state.valueRef2;
  }


  public Object getState()
    { return new BSimpleAngleState(this); }

  protected static class BSimpleAngleState extends BSimpleDecisionState implements Serializable
  {
    static final long serialVersionUID = -1L;

    protected BValue valueRef2;

    public BSimpleAngleState(BSimpleAngleNode node)
    {
      super(node);
      this.valueRef2 = node.valueRef2;
    }
  }
}
