package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BAnd extends BLogicalBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BAnd()
    { super(); }

  public BAnd(BAnd o)
    { super(o); }

  public BAnd(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BAnd(this); }

  public BValue combine(BValue l, BValue r)
  {
    if (l.isBoolean() && r.isBoolean())
    {
      boolean result =
        ((BBoolean) l).getValue() &&
        ((BBoolean) r).getValue();

      value.setValue(result);
      return value;
    }
    else
      return BValue.UNDEFINED;
  }

  public String getName()
    { return "and"; }
}