package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BPlus extends BBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  protected transient BNumber number;
  protected transient BString string;


  public BPlus()
    { super(); }

  public BPlus(BPlus o)
    { super(o); }

  public BPlus(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BPlus(this); }

  public void init()
  {
    number = new BNumber();
    string = new BString();
    super.init();
  }


  public BValue combine(BValue l, BValue r)
  {
    if (l.isNumber() && r.isNumber())
    {
      double result =
        ((BNumber) l).getValue() +
        ((BNumber) r).getValue();

      number.setValue(result);
      return number;
    }

    else if (l.isString() && r.isString())
    {
      String result =
        ((BString) l).getValue() +
        ((BString) r).getValue();

      string.setValue(result);
      return string;
    }

    else
      return BValue.UNDEFINED;
  }

  public int combineType(int l, int r)
  {
    if (l != r)
      return BType.UNDEFINED;
    else if (l == BType.NUMBER)
      return BType.NUMBER;
    else if (l == BType.STRING)
      return BType.STRING;
    else
      return BType.UNDEFINED;
  }

  public String getName()
    { return "+"; }
}