package roboforge.ai.memory;

import roboforge.BLookup;
import roboforge.BMonitoredList;

import java.io.Serializable;
import java.util.Vector;
import roboforge.ai.values.*;


public class BMemoryBank extends BMonitoredList
  implements BLookup, Serializable
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  // Class variables...
  // -------------------------------------------------------------

  protected final static int DEFAULT_CAPACITY = 5;


  // Constructor.
  // -------------------------------------------------------------

  public BMemoryBank()
    { super(DEFAULT_CAPACITY); }


  public void init()
  {
    BMemoryItem item;
    int n = getSize();

    for (int i=0; i<n; i++)
    {
      item = (BMemoryItem) getAt(i);
      item.init();
    }
  }

  // Accessor methods...
  // -------------------------------------------------------------

  public BMemoryItem getItem(int i)
    { return (BMemoryItem) getAt(i); }


  public Object get(Object key)
  {
    if (key instanceof String)
      return getItem((String) key);
    else
      // TODO: What if we want non-string keys?
      return null;
  }

  public BMemoryItem getItem(String key)
    // Lookup method (key = item-name)
  {
    BMemoryItem item;
    int n = getSize();

    for (int i=0; i<n; i++)
    {
      item = (BMemoryItem) getAt(i);
      if (key.equalsIgnoreCase(item.getName()))
        return item;
    }

    return null;
  }

  public void remove(Object o)
  {
    super.remove(o);

    BMemoryItem item =  (BMemoryItem)o;

    item.setInitialValue(BValue.UNDEFINED);

    // YLY 7 feb 2000
    // don't set type to allow creating new nodes
    //item.setType(BType.UNDEFINED);



  }



}