package roboforge.ai.values;

import java.io.*;

public class BBoolean extends BValue
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected boolean value;

  public final static BBoolean TRUE  = new BBoolean(true);
  public final static BBoolean FALSE = new BBoolean(false);


  public BBoolean()
    { this.type = BType.BOOLEAN; }

  public BBoolean(boolean value)
  {
    this.type = BType.BOOLEAN;
    this.value = value;
  }

  public boolean getValue()
    { return value; }

  public void setValue(boolean value)
    { this.value = value; }


  public void writeValue(DataOutput dout) throws IOException
    { dout.writeBoolean(value); }

  public  void readValue(DataInput din) throws IOException
    { value = din.readBoolean(); }

  public boolean equals(Object o)
  {
    if (o instanceof BBoolean)
      return
        this.value == ((BBoolean) o).value;
    else
      return false;
  }

  public String toString()
    { return value ? "yes" : "no"; }

  public void setValue(BValue v)
  {
    if (v instanceof BBoolean)
    {
      BBoolean b = (BBoolean )v;
      this.value = b.value;
    }
  }

}
