package roboforge.ai.values;

import java.io.*;
import roboforge.BDebug;


public class BEnumerated extends BValue
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  protected String[] options;
  protected String value;

  public BEnumerated()
  {
    this.type = BType.ENUMERATED;
    this.value = "";
  }

  public BEnumerated(String[] options, String value)
  {
    this.type = BType.ENUMERATED;
    this.options = options;
    this.value   = value;

    if (!isValid(value))
      throw new IllegalArgumentException(
        "BEnumerated.<init>: "+ value+ " is not a valid value. ");
  }

  public String getValue()
    { return value; }


  public void setValue(String value)
  {
    if (!isValid(value))
      throw new IllegalArgumentException(
        "BEnumerated.setValue(): "+ value+ " is not a valid value. ");

    this.value = value;
  }

  public String[] getOptions()
    { return options; }


  public boolean equals(Object o)
  {
    if (o instanceof BEnumerated)
      return
        this.value.equals (((BEnumerated) o).value);
    else
      return false;
  }

  public String toString()
    { return value; }

  public void writeValue(DataOutput dout) throws IOException
    { dout.writeUTF(value); }

  public void readValue(DataInput din) throws IOException
    { value = din.readUTF(); }

  protected boolean isValid(String v)
  {
    if (options == null)
      return false;

    int n = options.length;

    for (int i=0; i<n; i++)
      if (v.equalsIgnoreCase(options[i]))
        return true;

    return false;
  }

  public void setValue(BValue v)
  {
      // Stubb
      BDebug.print ("BEnumerated.setVAlue WARNING BENUMERATED TYPE IS CURRENTLY DEPRECATED") ;

  }



}
