package roboforge.animation;

import java.util.*;


public class BAnimationSequence extends BAnimationCollection  // extends BAbstractAnimation
{

  // BAnimationSequence keeps track of a set of animations.
  // Animations are played sequentially.

  protected int current;
    // The current animation in the sequence.


  public BAnimationSequence()
    { super(); }

  public BAnimationSequence(int n)
    { super(n); }


  public void start()
  {
    current = 0;
    super.start();
  }


  protected void startSlot(BAnimationSlot slot, int i)
  {
    if (i == 0)
    {
      slot.isActive = true;
      slot.animation.start();
    }
    else
      slot.isActive = false;
  }

  protected boolean animateSlot(BAnimationSlot slot, int i)
  {
    if (i != current)
      return false;

    if (!slot.isActive)
    {
      slot.animation.start();
      slot.isActive = true;
      return true;
    }

    if (slot.animation.animate())
      return true;
    else
    {
      slot.animation.stop();
      slot.isActive = false;
      current++;
      return false;
    }
  }

  protected void stopSlot(BAnimationSlot slot, int i)
  {
    if (slot.isActive)
    {
      slot.animation.stop();
      slot.isActive = false;
    }
  }

}