package roboforge.animation;

import roboforge.BDebug;
import roboforge.sound.*;


public class BSoundAnimation extends BAbstractAnimation
{

  protected BSound sound;


  public BSoundAnimation(String name)
    { this(BSound.getSound(name)); }

  public BSoundAnimation()
    { super(); }

  public BSoundAnimation(BSound sound)
  {
    super();
    this.sound = sound;
  }


  public void setSound(BSound s)
  {
    if (!isAnimating())
      sound = s;
    else
      throw new RuntimeException("Can't set sound while animating.");
  }

  public void start()
  {
    if (!isAnimating());
      if (sound != null)
        sound.play();

    super.start();
  }

  public boolean animate()
    { return sound != null ? sound.isRunning() : false; }

}