package roboforge.animation.alpha;

public class BAlphaFloat extends Number implements BAlphaValue
{
  // An alpha float is similar to java.lang.Float,
  // with the exception that its value can be changed.

  // WARNING: This class is unsynchronized!
  // WARNING: This class may be no good for hashing, not sure...


  private static final long serialVersionUID = -1;
    // Serialization ID.


  protected float value;
    // Current value of this float object.


  public BAlphaFloat()
    { this.value = 0f; }

  public BAlphaFloat(float value)
    { this.value = value; }

  public BAlphaFloat(double value)
    { this.value = (float) value; }

  public BAlphaFloat(BAlphaFloat f)
    { this.value = f.value; }


  public void set(BAlphaValue v)
    { this.value = ((BAlphaFloat) v).value; }

  public void interpolate(BAlphaValue v, float alpha)
    { this.value = (1 - alpha) * value + ((BAlphaFloat) v).value * alpha; }

  public BAlphaValue copy()
    { return new BAlphaFloat(this); }


  public void setValue(float value)
    { this.value = value; }

  public float getValue()
    { return value; }



  public String toString()
    { return String.valueOf(value); }

  public byte byteValue()
    { return (byte) value; }

  public short shortValue()
    { return (short) value; }

  public int intValue()
    { return (int) value; }

  public long longValue()
    {	return (long) value; }

  public float floatValue()
    { return value; }

  public double doubleValue()
    {	return (double) value; }

}