package roboforge.animation.animation.b3d;

import roboforge.animation.*;
import roboforge.*;
import roboforge.sound.*;

import javax.vecmath.*;


public class BTeleportBotAnimation extends BAnimationSequence
{

  protected BBot bot;
  protected BBattleFX fx;
  protected float duration;

  public BTeleportBotAnimation(BBot bot, BArenaObjectPosition p, BBattleFX fx, float duration)
  {
    super(3);

    this.bot       = bot;
    this.fx        = fx;
    this.duration  = duration;
    float halftime = duration/2f;

    add(new BFadeBotAnimation(bot, halftime));
    add(new BMoveBotAnimation(bot, p));
    add(new BFadeBotAnimation(bot, halftime, BFadeBotAnimation.FADE_IN));
  }

  public void start()
  {
    super.start();
    fx.spawnVortex(bot, duration);
  }



  protected class BMoveBotAnimation extends BAbstractAnimation
  {
    protected BBot bot;
    protected BArenaObjectPosition p;

    public BMoveBotAnimation(BBot bot, BArenaObjectPosition p)
      { this.bot = bot; this.p = p; }

    public boolean animate()
    {
      bot.setArenaPosition(p);
      return false;
    }
  }
}


