package roboforge.attributes;

import javax.swing.table.*;
  

public class BAttributeTableModel extends AbstractTableModel
{
  
  // Member variables...
  // -------------------------------------------------------------
  
  protected BAttributeSet attributes;
  
  
  // Constructors...
  // -------------------------------------------------------------

  public BAttributeTableModel()
  {
    super();
    attributes = new BAttributeSet();
  }
  
  public BAttributeTableModel(BAttributeSet as)
  {
    super();
    attributes = as;
  }
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public void setAttributes(BAttributeSet as)
  { 
    this.attributes = as;
    fireTableDataChanged();
  }
  
  public int getRowCount()
    { return attributes.size(); }

  public int getColumnCount()
    { return 2; }
  
  public Object getValueAt(int r, int c)
  {
    BAttribute a =
      attributes.getAttribute(r);
    
    if (c == 0)
      return a.getName();
    else if (c == 1)
      return a.getValue();
    else
      return null;
  }

  public Class getColumnClass(int c)
  {
    if (c == 0)
      return String.class;
    else if (c == 1)
      return BAttributeValue.class;
    else
      return Object.class;
  }

  public String getColumnName(int c)
    { return (c == 0) ? "Name" : "Value"; }
  
}
