package roboforge.internal;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.File;
import javax.swing.event.*;
import javax.swing.border.*;
//import javax.swing.UIManager;
import java.util.*;
//import javax.swing.tree.*;
//import javax.swing.filechooser.*;
import javax.vecmath.*;
//import javax.swing.plaf.metal.*;

import roboforge.ui.components.*;
//import roboforge.ui.*;

import roboforge.BGlobal;
import roboforge.BDebug;
import roboforge.BBot;
//import roboforge.BShape3D;
import roboforge.BComponent;
import roboforge.BFileFilter;
import roboforge.BTextures;
//import roboforge.BTheme;

import roboforge.BArena;
import roboforge.BArenaCanvas;
import roboforge.BColorPicker;
import roboforge.BAppearanceDialog;
import roboforge.BPlaceHolder;
import roboforge.BArenaObject;
import roboforge.BArenaObjectPosition;
import roboforge.BArenaOrnament;
import roboforge.BFile;

/*

* Description:
  Allows the modification, and creation of an Arena

* Example:
* Modification History ( Name, Date, Notes )
  HSC, 1 June 1999
  AWH, 18 Jan 2001  -  modified the UI
  SJS 20/02/2001 - Added virtual-ref combo [refPathCombo].

*/
public class BArenaBuilder extends JFrame implements ActionListener, ChangeListener, MouseListener
{
	static final long serialVersionUID = -1L;
  // resources
  protected BUIResources res = new BUIResources( new Object[]
  {
    "nameField.text",                  "New Arena",
    "nameField.width",                 new Integer(200),

    "ornamentRadio.text",              "Ornaments",
    "ornamentRadio.width",             new Integer(100),

    "holderRadio.text",                "Place Holders",
    "holderRadio.width",               new Integer(100),

    "ambSoundRadio.text",              "Amb Sound:",
    "ambSoundRadio.width",             new Integer(100),

    "ranSoundRadio.text",              "Ran Sound:",
    "ranSoundRadio.width",             new Integer(100),

    "floorRadio.text",                 "Floor",
    "floorRadio.width",                new Integer(100),

    "backRadio.text",                  "Backgrounds",
    "backRadio.width",                 new Integer(100),

    "objectCheck.text",                "Select Objects",
    "objectCheck.width",               new Integer(100),

    "moveRadio.text",                  "Move Object",
    "moveRadio.width",                 new Integer(100),

    "rotateRadio.text",                "Rotate Object",
    "rotateRadio.width",               new Integer(100),

    "elevateRadio.text",               "Elevate Object",
    "elevateRadio.width",              new Integer(100),

    "dirLight1Radio.text",             "Dir Light 1",
    "dirLight1Radio.width",            new Integer(100),

    "dirLight2Radio.text",             "Dir Light 2",
    "dirLight2Radio.width",            new Integer(100),

    "ambLightRadio.text",              "Amb Light",
    "ambLightRadio.width",             new Integer(100),

    "fogRadio.text",                   "Fog",
    "fogRadio.width",                  new Integer(100),

    "fogCheck.text",                   "Use Fog",
    "fogCheck.width",                  new Integer(100),

    "addObjectButton.text",            "Add Object",
    "addObjectButton.width",           new Integer(200),
    "addObjectButton.height",          new Integer(16),

    "remObjectButton.text",            "Rem Object",
    "remObjectButton.width",           new Integer(200),
    "remObjectButton.height",          new Integer(16),

    "newArenaButton.text",             "New Arena",
    "newArenaButton.width",            new Integer(200),

    "loadArenaButton.text",            "Load Arena",
    "loadArenaButton.width",           new Integer(200),

    "saveArenaButton.text",            "Save Arena",
    "saveArenaButton.width",           new Integer(200),

    "floorAppButton.text",             "Floor Appearance",
    "floorAppButton.widht",            new Integer(200),

    "arenaSizeSlider.min",             new Integer(10),
    "arenaSizeSlider.max",             new Integer(100),

    "fogDenSlider.min",                new Integer(0),
    "fogDenSlider.max",                new Integer(100),

    "lightXSlider.min",                new Integer(-100),
    "lightXSlider.max",                new Integer(100),

    "lightYSlider.min",                new Integer(-100),
    "lightYSlider.max",                new Integer(100),

    "lightZSlider.min",                new Integer(-100),
    "lightZSlider.max",                new Integer(100),

    "arenaSizeLabel.text",             "Arena Size - 100",
    "arenaSizeLabel.width",            new Integer(200),

    "ambSoundLabel.text",              "None",
    "ambSoundLabel.fontsize",          new Integer(10),
    "ambSoundLabel.width",             new Integer(100),
    "ambSoundLabel.height",            new Integer(25),

    "ranSoundLabel.text",              "None",
    "ranSoundLabel.fontsize",          new Integer(10),
    "ranSoundLabel.width",             new Integer(100),
    "ranSoundLabel.height",            new Integer(25),

    "fogDenLabel.text",                "Fog Density - 0.0",
    "fogDenLabel.width",               new Integer(200),

    "xLabel.text",                     "LR",
    "xLabel.width",                    new Integer(29),
    "yLabel.text",                     "UD",
    "yLabel.width",                    new Integer(29),
    "zLabel.text",                     "FB",
    "zLabel.width",                    new Integer(29),

    "lightDirLabel.text",              "Light Dir",
    "lightDirLabel.width",             new Integer(60),

    "confirmLabel.text",               "",
    "confirmLabel.width",              new Integer(200),
    "confirmLabel.fontname",           "Arial",
    "confirmLabel.fontsize",           new Integer(18),
    "confirmLabel.fontstyle",          new Integer(1),
    "confirmLabel.height",             new Integer(28),
    "confirmLabel.antialiased",        Boolean.TRUE,

    "objectScroll.width",              new Integer(200),
    // "objectScroll.height",             new Integer(307),

    "refPathCombo.width",              new Integer(130),
    "victorySoundCombo.width",         new Integer(130),

    "advertLabel.width",               new Integer(100),
    "advertLabel.text",                "Advert ID",

    "advertField.width",               new Integer(100),

    "edgeDisButton.text",              "Set",

    "edgeDisField.width",              new Integer(50),
  });

  BArena arena = new BArena();

  TitledBorder viewBorder = BorderFactory.createTitledBorder("3D View");
  TitledBorder objectsBorder = BorderFactory.createTitledBorder("Objects");
  TitledBorder optionsBorder = BorderFactory.createTitledBorder("Options");
  TitledBorder effectsBorder = BorderFactory.createTitledBorder("Effects");
  TitledBorder floorBorder = BorderFactory.createTitledBorder("Floor");

  TitledBorder midBorder = BorderFactory.createTitledBorder("Miscellaneous");

  BTextField nameField = new BTextField(res, "nameField");

  BList objectList = new BList();
  BScrollPane objectScroll = new BScrollPane(res, "objectScroll");

  ButtonGroup objectGroup = new ButtonGroup();
  BRadioButton ornamentRadio = new BRadioButton(res, "ornamentRadio");
  BRadioButton holderRadio = new BRadioButton(res, "holderRadio");
  BRadioButton ambSoundRadio = new BRadioButton(res, "ambSoundRadio");
  BRadioButton ranSoundRadio = new BRadioButton(res, "ranSoundRadio");
  BRadioButton floorRadio = new BRadioButton(res, "floorRadio");
  BRadioButton backRadio = new BRadioButton(res, "backRadio");

  BCheckBox objectCheck = new BCheckBox(res, "objectCheck");

  ButtonGroup objectMoveGroup = new ButtonGroup();
  BRadioButton moveRadio = new BRadioButton(res, "moveRadio");
  BRadioButton rotateRadio = new BRadioButton(res, "rotateRadio");
  BRadioButton elevateRadio = new BRadioButton(res, "elevateRadio");

  ButtonGroup effectsGroup = new ButtonGroup();
  BRadioButton dirLight1Radio = new BRadioButton(res, "dirLight1Radio");
  BRadioButton dirLight2Radio = new BRadioButton(res, "dirLight2Radio");
  BRadioButton ambLightRadio = new BRadioButton(res, "ambLightRadio");
  BRadioButton fogRadio = new BRadioButton(res, "fogRadio");

  BCheckBox fogCheck = new BCheckBox(res, "fogCheck");

  BButton addObjectButton = new BButton(res, "addObjectButton");
  BButton remObjectButton = new BButton(res, "remObjectButton");
  BButton newArenaButton = new BButton(res, "newArenaButton");
  BButton loadArenaButton = new BButton(res, "loadArenaButton");
  BButton saveArenaButton = new BButton(res, "saveArenaButton");
  BButton floorAppButton = new BButton(res, "floorAppButton");
  BButton edgeDisButton = new BButton(res, "edgeDisButton");

  BLabel arenaSizeLabel = new BLabel(res, "arenaSizeLabel");
  BLabel ambSoundLabel = new BLabel(res, "ambSoundLabel");
  BLabel ranSoundLabel = new BLabel(res, "ranSoundLabel");
  BLabel fogDenLabel = new BLabel(res, "fogDenLabel");
  BLabel xLabel = new BLabel(res, "xLabel");
  BLabel yLabel = new BLabel(res, "yLabel");
  BLabel zLabel = new BLabel(res, "zLabel");
  BLabel lightDirLabel = new BLabel(res, "lightDirLabel");
  BLabel confirmLabel = new BLabel(res, "confirmLabel");

  BSlider arenaSizeSlider = new BSlider(res, "arenaSizeSlider");
  BSlider fogDenSlider = new BSlider(res, "fogDenSlider");
  BSlider lightXSlider = new BSlider(res, "lightXSlider");
  BSlider lightYSlider = new BSlider(res, "lightYSlider");
  BSlider lightZSlider = new BSlider(res, "lightZSlider");

  BTextField advertField = new BTextField(res, "advertField");
  BTextField edgeDisField = new BTextField();

  BLabel advertLabel = new BLabel(res, "advertLabel");

  // SJS 20/02/2001 - The combo for specifying which referee to use.
  BFileComboBox refPathCombo = new BFileComboBox(res, "refPathCombo");

  // SJS 20/02/2001 - The combo for specifying which victory sound to use.
  BFileComboBox victorySoundCombo = new BFileComboBox(res, "victorySoundCombo");

  // File handling stuff
  //private File[] files;

  // File Stuff
  private BFileFilter filter;
  private File startFilePath;
  private JFileChooser chooser;
  private String filePath;

  javax.swing.Timer t;

  // 3D Stuff
  private BArenaCanvas arena3dCanvas;

  BColorPicker bColorPicker;

  private static final String CAMERA_VRML =  "Internal/Placeholder/Camera.WRL";

  BPlaceHolder theCam= new BPlaceHolder("Camera",CAMERA_VRML, BPlaceHolder.TYPE_CAMERA);

  BPlaceHolder botHolder1 = null;
  BPlaceHolder botHolder2 = null;

  public BArenaBuilder()
  {
   enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try
    {
      this.setSize(new Dimension(1024, 768));
      this.setResizable(false);

      bColorPicker = new BColorPicker(Color.white);

      arena3dCanvas = new BArenaCanvas(null, true, false, false, null, null, null, -1f, -1f, -1f, null, -1f, -1f, -1f, null,
                                       null,   null, null, 0, 0, true,
                                       BGlobal.DEFAULT_FOG_COLOR, 0.0f, false,
                                       /*allow pick*/true, true, null);

      arena3dCanvas.setSize(new Dimension(800, 540));
      arena3dCanvas.setVisible(true);

      layoutArenaBuilderChildren();
      configArenaBuilderChildren();

      this.validate();
      BTextures.setListener(this);
      this.setVisible(true);
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  // layout the arena builder components
  private void layoutArenaBuilderChildren()
  {

    // set the strut size
    int strutSize = 5;

    BBoxPanel mainBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel leftBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel rightBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel topLeftBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel viewBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel bottomLeftBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel bottomRightBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel effectsBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel effectsLBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel effectsRBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel effectsRadBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel effectsRadLBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel effectsRadRBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel lightDirBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel axisBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel controlBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel floorBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel midRightBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel topRightBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel objectBox = new BBoxPanel(BoxLayout.X_AXIS);
    BBoxPanel objectLBox = new BBoxPanel(BoxLayout.Y_AXIS);
    BBoxPanel objectRBox = new BBoxPanel(BoxLayout.Y_AXIS);

    // add the boxes
    mainBox.add(leftBox);
    mainBox.add(rightBox);

    leftBox.add(topLeftBox);
    leftBox.add(bottomLeftBox);

    rightBox.add(topRightBox);
    rightBox.add(midRightBox);
    rightBox.add(bottomRightBox);

    bottomRightBox.add(newArenaButton);
    bottomRightBox.addVStrut(strutSize);
    bottomRightBox.add(loadArenaButton);
    bottomRightBox.addVStrut(strutSize);
    bottomRightBox.add(saveArenaButton);
    bottomRightBox.setBorder(optionsBorder);

    midRightBox.setBorder(midBorder);
    midRightBox.addLinear(new BLabel("Referee: "), midRightBox.getHGlue(), refPathCombo);
    midRightBox.addSmallMargin();
    midRightBox.addLinear(new BLabel("Victory: "), midRightBox.getHGlue(), victorySoundCombo);

    viewBox.add(arena3dCanvas);
    topLeftBox.add(viewBox);
    topLeftBox.setBorder(viewBorder);

    bottomLeftBox.add(effectsBox);
    bottomLeftBox.add(floorBox);

    floorBox.setBorder(floorBorder);

    objectScroll.getViewport().setView(objectList);
    topRightBox.add(nameField);
    topRightBox.addVStrut(strutSize);
    topRightBox.addVGlued(objectScroll);
    topRightBox.addVStrut(strutSize*2);
    topRightBox.add(objectBox);
    topRightBox.addVStrut(strutSize*2);
    topRightBox.addLinear(advertLabel, advertField);
    topRightBox.add(addObjectButton);
    topRightBox.addVStrut(2);
    topRightBox.add(remObjectButton);
    topRightBox.addVStrut(strutSize*2);
    topRightBox.add(objectCheck);
    topRightBox.add(moveRadio);
    topRightBox.add(rotateRadio);
    topRightBox.add(elevateRadio);
    topRightBox.addVStrut(strutSize);
    topRightBox.setBorder(objectsBorder);

    effectsBox.add(effectsLBox);
    effectsBox.add(effectsRBox);
    effectsBox.setBorder(effectsBorder);

    effectsLBox.add(bColorPicker);
    effectsLBox.addHStrut(strutSize*2);
    effectsLBox.add(lightDirBox);
    effectsLBox.addHStrut(strutSize*2);

    lightDirBox.add(axisBox);
    lightDirBox.add(controlBox);
    lightDirBox.add(lightDirLabel);

    axisBox.add(xLabel);
    axisBox.add(yLabel);
    axisBox.add(zLabel);

    controlBox.add(lightXSlider);
    controlBox.add(lightYSlider);
    controlBox.add(lightZSlider);

    effectsRBox.add(effectsRadBox);
    effectsRadBox.add(effectsRadLBox);
    effectsRadBox.add(effectsRadRBox);

    effectsRadLBox.add(dirLight1Radio);
    effectsRadLBox.add(dirLight2Radio);
    effectsRadRBox.add(ambLightRadio);
    effectsRadRBox.add(fogRadio);

    effectsRBox.addVStrut(strutSize*2);
    effectsRBox.add(fogDenLabel);
    effectsRBox.add(fogDenSlider);
    effectsRBox.add(fogCheck);

    objectBox.add(objectLBox);
    objectBox.add(objectRBox);

    objectLBox.add(ornamentRadio);
    objectLBox.add(holderRadio);
    objectLBox.add(ambSoundRadio);
    objectLBox.add(ranSoundRadio);

    objectRBox.add(floorRadio);
    objectRBox.add(backRadio);
    objectRBox.add(ambSoundLabel);
    objectRBox.add(ranSoundLabel);

    floorBox.addLinear(new BLabel("Bot dis. from edge"), edgeDisField, edgeDisButton);
    floorBox.addVStrut(strutSize * 6 + 2);
    floorBox.add(floorAppButton);
    floorBox.addVStrut(strutSize * 2 - 2);
    floorBox.add(arenaSizeLabel);
    floorBox.add(arenaSizeSlider);
    floorBox.addVStrut(strutSize * 2);
    floorBox.add(confirmLabel);

    this.getContentPane().add(mainBox);
  }


  // configure the arena builder components
  private void configArenaBuilderChildren()
  {
      // SJS 20/02/2001 - Configure refPathCombo.
      try
      {
        refPathCombo.setSourcePath(BGlobal.REFPATH);
        victorySoundCombo.setSourcePath(BGlobal.SOUNDPATH+ "arena/victory");
      }
      catch (Exception e)
        { /* TODO - Handle? */ }

      objectList.setBackground(new Color(51, 51, 102));
      objectList.setForeground(new Color(200, 200, 220));

      nameField.setBackground(new Color(51, 51, 102));
      nameField.setForeground(new Color(200, 200, 220));
      nameField.setCaretColor(new Color(200, 200, 220));
      nameField.setText("New Arena");

      // ******** set up the various radio button groups ******** //
      objectGroup.add(ornamentRadio);
      objectGroup.add(holderRadio);
      objectGroup.add(ambSoundRadio);
      objectGroup.add(ranSoundRadio);
      objectGroup.add(floorRadio);
      objectGroup.add(backRadio);


      objectMoveGroup.add(moveRadio);
      objectMoveGroup.add(rotateRadio);
      objectMoveGroup.add(elevateRadio);

      effectsGroup.add(dirLight1Radio);
      effectsGroup.add(dirLight2Radio);
      effectsGroup.add(ambLightRadio);
      effectsGroup.add(fogRadio);
      // ******************************************************** //

      lightXSlider.setOrientation(SwingConstants.VERTICAL);
      lightYSlider.setOrientation(SwingConstants.VERTICAL);
      lightZSlider.setOrientation(SwingConstants.VERTICAL);

      ornamentRadio.addActionListener(this);
      holderRadio.addActionListener(this);
      ambSoundRadio.addActionListener(this);
      ranSoundRadio.addActionListener(this);
      floorRadio.addActionListener(this);
      backRadio.addActionListener(this);

      objectCheck.addActionListener(this);
      objectCheck.setSelected(true);

      moveRadio.addActionListener(this);
      rotateRadio.addActionListener(this);
      elevateRadio.addActionListener(this);

      dirLight1Radio.addActionListener(this);
      dirLight2Radio.addActionListener(this);
      ambLightRadio.addActionListener(this);
      fogRadio.addActionListener(this);

      fogCheck.addActionListener(this);

      addObjectButton.addActionListener(this);
      remObjectButton.addActionListener(this);

      floorAppButton.addActionListener(this);

      newArenaButton.addActionListener(this);
      loadArenaButton.addActionListener(this);
      saveArenaButton.addActionListener(this);

      fogDenSlider.addChangeListener(this);
      arenaSizeSlider.addChangeListener(this);

      lightXSlider.addChangeListener(this);
      lightYSlider.addChangeListener(this);
      lightZSlider.addChangeListener(this);

      objectList.addMouseListener(this);

      bColorPicker.addActionListener(this);

      arena3dCanvas.addMouseListener(this);
      advertField.addActionListener(this);

      edgeDisField.setText("10");
      edgeDisButton.addActionListener(this);

      // set the initially selected radio button
      floorRadio.setSelected(true);
      moveRadio.setSelected(true);
      dirLight1Radio.setSelected(true);

      // set the fog slider to be initially disabled
      fogDenSlider.setEnabled(false);
      fogRadio.setEnabled(false);

      // init the light vector sliders
      Vector3f vec = arena3dCanvas.getDirLightVector(1);
      lightXSlider.setValue((int)(vec.x * 100));
      lightYSlider.setValue((int)(vec.y * 100));
      lightZSlider.setValue((int)(vec.z * 100));

      // initialize the floor as default object
      BFileFilter filter = new BFileFilter(new String[] {BGlobal.VRMLSUFFIX},"",false);
      fillArenaList(BGlobal.ARENAFLOORPATH, filter);

      // set up the new arena
      startNewArena();
  }

   // mouseListener methods
  public void mouseClicked(MouseEvent e)
  {
    if(e.getSource() == objectList) {
      if(e.getClickCount() == 2) {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        addObject();
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
      }
    }
  }

  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e)
  {
    if(e.getSource() == arena3dCanvas)
    {
      if(t != null)
        t.stop();
      t = new javax.swing.Timer(500,this);
      t.start();
    }
  }
  public void mouseReleased(MouseEvent e) {}


  // action performed method
  public void actionPerformed(ActionEvent e)
  {
    if(e.getSource() == t)
    {
      BDebug.print("BArenaBuilder - mouse clicked in the 3d canvas");
      BArenaObject lastSelectedObject = arena3dCanvas.getLastSelectedObject();
      if(lastSelectedObject != null)
      {
        if(lastSelectedObject.getAdvertID() != null)
        {
          advertField.setText(lastSelectedObject.getAdvertID());
          BDebug.print("BArenaBuilder - advert ID = " +  lastSelectedObject.getAdvertID());
        }
        else
          advertField.setText("");
      }
      t.stop();
    }
    if(e.getSource() == ornamentRadio) {
      BFileFilter filter = new BFileFilter(new String[] {BGlobal.COMPONENTSUFFIX},"",false);
      fillArenaList(BGlobal.ORNAMENTPATH, filter);
    }
    if(e.getSource() == holderRadio) {
      BFileFilter filter = new BFileFilter(new String[] {BGlobal.COMPONENTSUFFIX},"",false);
      fillArenaList(BGlobal.PLACEHOLDERPATH, filter);
    }
    if(e.getSource() == ambSoundRadio) {
      BFileFilter filter = new BFileFilter(new String[] {"au", "wav"},"",false);
      fillArenaList(BGlobal.SOUNDPATH, filter);
    }
    if(e.getSource() == ranSoundRadio) {
      BFileFilter filter = new BFileFilter(new String[] {"au", "wav"},"",false);
      fillArenaList(BGlobal.SOUNDPATH, filter);
    }
    if(e.getSource() == floorRadio) {
      BFileFilter filter = new BFileFilter(new String[] {BGlobal.VRMLSUFFIX},"",false);
      fillArenaList(BGlobal.ARENAFLOORPATH, filter);
    }
    if(e.getSource() == backRadio) {
      BFileFilter filter = new BFileFilter(new String[] {BGlobal.JPEGSUFFIX, BGlobal.IMAGESUFFIX},"",false);
      fillArenaList(BGlobal.BACKGROUNDPATH, filter);
    }
    if(e.getSource() == newArenaButton)
      startNewArena();
    if(e.getSource() == loadArenaButton)
      loadTheArena();
    if(e.getSource() == saveArenaButton)
      saveTheArena();
    if(e.getSource() == addObjectButton)
      addObject();
    if(e.getSource() == remObjectButton)
      removeObject();

    if(e.getSource() == objectCheck)
    {
      if(objectCheck.isSelected())
      {
        moveRadio.setEnabled(true);
        rotateRadio.setEnabled(true);
        elevateRadio.setEnabled(true);

        if(moveRadio.isSelected())
          arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAMOVE);
        if(rotateRadio.isSelected())
          arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAROTATE);
        if(elevateRadio.isSelected())
          arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAELEVATE);
      }
      else
      {
        moveRadio.setEnabled(false);
        rotateRadio.setEnabled(false);
        elevateRadio.setEnabled(false);
        arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ROTATESCENE);
       // arena3dCanvas.setMode(null);
      }
    }
    if(e.getSource() == moveRadio)
      arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAMOVE);
    if(e.getSource() == rotateRadio)
      arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAROTATE);
    if(e.getSource() == elevateRadio)
      arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAELEVATE);

    if(e.getSource() == bColorPicker)
      pickAColour();

    if(e.getSource() == floorAppButton)
      new BAppearanceDialog(this, arena3dCanvas.getFloor(), null);

    if(e.getSource() == dirLight1Radio) {
      lightXSlider.setEnabled(true);
      lightYSlider.setEnabled(true);
      lightZSlider.setEnabled(true);
      bColorPicker.setColor(arena3dCanvas.getDirLightColor(1));
      Vector3f vec = arena3dCanvas.getDirLightVector(1);
      lightXSlider.setValue((int)(vec.x * 100));
      lightYSlider.setValue((int)(vec.y * 100));
      lightZSlider.setValue((int)(vec.z * 100));
    }
    if(e.getSource() == dirLight2Radio) {
      lightXSlider.setEnabled(true);
      lightYSlider.setEnabled(true);
      lightZSlider.setEnabled(true);
      bColorPicker.setColor(arena3dCanvas.getDirLightColor(2));
      Vector3f vec = arena3dCanvas.getDirLightVector(2);
      lightXSlider.setValue((int)(vec.x * 100));
      lightYSlider.setValue((int)(vec.y * 100));
      lightZSlider.setValue((int)(vec.z * 100));
    }
    if(e.getSource() == ambLightRadio) {
      lightXSlider.setEnabled(false);
      lightYSlider.setEnabled(false);
      lightZSlider.setEnabled(false);
      bColorPicker.setColor(arena3dCanvas.getAmbientLightColor());
    }
    if(e.getSource() == fogRadio) {
      lightXSlider.setEnabled(false);
      lightYSlider.setEnabled(false);
      lightZSlider.setEnabled(false);
      bColorPicker.setColor(arena3dCanvas.getFogColor());
    }
    if(e.getSource() == fogCheck) {
      arena3dCanvas.showFog(fogCheck.isSelected(), (float)(fogDenSlider.getValue()) / 4000);
      if(fogCheck.isSelected()) {
        fogDenSlider.setEnabled(true);
        fogRadio.setEnabled(true);
      }
      else {
        fogDenSlider.setEnabled(false);
        fogRadio.setEnabled(false);
        if(fogRadio.isSelected()) {
          dirLight1Radio.setSelected(true);
          lightXSlider.setEnabled(true);
          lightYSlider.setEnabled(true);
          lightZSlider.setEnabled(true);
          bColorPicker.setColor(arena3dCanvas.getDirLightColor(1));
          Vector3f vec = arena3dCanvas.getDirLightVector(1);
          lightXSlider.setValue((int)(vec.x * 100));
          lightYSlider.setValue((int)(vec.y * 100));
          lightZSlider.setValue((int)(vec.z * 100));
        }
      }
    }
    if(e.getSource() == advertField)
      if(advertField.getText().length() > 0)
        arena3dCanvas.getLastSelectedObject().setAdvertID(advertField.getText());

    if(e.getSource() == edgeDisButton)
    {
      setBotHolders();
    }
  }

  // sets the bot holder positions so they are a set distance from the edge
  public void setBotHolders()
  {

    double newEdgeDis = BGlobal.WORLD_TO_CANVAS_SCALE * (double)(Integer.parseInt(edgeDisField.getText()));
    double arenaRadius = BGlobal.WORLD_TO_CANVAS_SCALE * arena.getSize() / 2.0;

    double newCenterDis = arenaRadius - newEdgeDis;

    BArenaObjectPosition pos1 = botHolder1.getArenaPosition();
    BArenaObjectPosition pos2 = botHolder2.getArenaPosition();

    double centerDis1 = Math.sqrt( Math.pow(pos1.getX(), 2) + Math.pow(pos1.getZ(), 2) );
    double centerDis2 = Math.sqrt( Math.pow(pos2.getX(), 2) + Math.pow(pos2.getZ(), 2) );

    double edgeDis1 = arenaRadius - centerDis1;
    double edgeDis2 = arenaRadius - centerDis2;

    BDebug.print("BArenaBuilder - edgeDis1 = " + BGlobal.CANVAS_TO_WORLD_SCALE * edgeDis1);
    BDebug.print("BArenaBuilder - edgeDis2 = " + BGlobal.CANVAS_TO_WORLD_SCALE * edgeDis2);

    double edgeRatio1 = newCenterDis / centerDis1;
    double edgeRatio2 = newCenterDis / centerDis2;

    double newX1 = pos1.getX() * edgeRatio1;
    double newZ1 = pos1.getZ() * edgeRatio1;

    double newX2 = pos2.getX() * edgeRatio2;
    double newZ2 = pos2.getZ() * edgeRatio2;

    pos1.x = (float)newX1;
    pos1.z = (float)newZ1;

    pos2.x = (float)newX2;
    pos2.z = (float)newZ2;

    BArenaObjectPosition p1 = new BArenaObjectPosition(pos1);
    BArenaObjectPosition p2 = new BArenaObjectPosition(pos2);

    botHolder1.setArenaPosition(p1);
    botHolder2.setArenaPosition(p2);
  }

  // the stateChanged method - used here for sliders
  public void stateChanged(ChangeEvent e)
  {
    if(e.getSource() == fogDenSlider) {
      arena3dCanvas.showFog(fogCheck.isSelected(), (float)(fogDenSlider.getValue()) / 4000);
      fogDenLabel.setText("Fog Density - " + (float)(fogDenSlider.getValue()) / 4000);
    }
    if(e.getSource() == arenaSizeSlider) {
      arena.setSize(arenaSizeSlider.getValue());
      arena3dCanvas.setArenaSize(arena.getSize());
      arenaSizeLabel.setText("Arena Size - " + arena.getSize());
    }
    if(e.getSource() == lightXSlider || e.getSource() == lightYSlider || e.getSource() == lightZSlider) {
      if(dirLight1Radio.isSelected())
        setLightVector(1);
      if(dirLight2Radio.isSelected())
        setLightVector(2);
    }
 }

  // sets the selected directional light vector
  private void setLightVector(int light)
  {
    try
    {
      float x = (float)(lightXSlider.getValue()) / 100;
      float y = (float)(lightYSlider.getValue()) / 100;
      float z = (float)(lightZSlider.getValue()) / 100;
      arena3dCanvas.setDirLightVector(light, x ,y,z);
    }catch (Exception ex) {BDebug.print("One or more of the dire co-ords are invalid"); }
  }

  // pick a colour for whatever is selected
  private void pickAColour()
  {
    if (ambLightRadio.isSelected() )
      arena3dCanvas.setAmbientLight(bColorPicker.getSelectedColor());
    else if (dirLight1Radio.isSelected() )
      arena3dCanvas.setDirLight(1,bColorPicker.getSelectedColor());
    else if (fogRadio.isSelected() )
      arena3dCanvas.setFogColor(bColorPicker.getSelectedColor());
    else if (dirLight2Radio.isSelected() )
      arena3dCanvas.setDirLight(2,bColorPicker.getSelectedColor());
    else
      BDebug.print ("BArenaBuilder - Choice Not Implemented");
  }

  // remove an object from the arena
  private void removeObject()
  {
    BArenaObject selectedObject = arena3dCanvas.getLastSelectedObject();

    // Remove from the arena3dcanvas
    arena3dCanvas.remove(selectedObject);
    // Remove from the arena vector of arena objects
    arena.removeArenaObject(selectedObject);

    if(selectedObject instanceof BPlaceHolder)
    {
      if(selectedObject.equals(botHolder1))
      {
        BDebug.print("BArenaBuilder - botHolder1 gone");
        botHolder1 = null;
      }
      if(selectedObject.equals(botHolder2))
      {
        BDebug.print("BArenaBuilder - botHolder2 gone");
        botHolder2 = null;
      }
    }
  }

  // add an object to the arena
  private void addObject()
  {
    String selection = (String)objectList.getSelectedValue();

    // Add the appropriate prefix depending on the ArenaObject
    if (holderRadio.isSelected())
    {
      selection = BGlobal.PLACEHOLDERPATH + selection;
      // Create the Object

      BPlaceHolder placeholder =  (BPlaceHolder)BPlaceHolder.loadFromFile(selection);
      BDebug.print(placeholder);

      if(botHolder1 == null)
        botHolder1 = placeholder;
      else if (botHolder2 == null)
        botHolder2 = placeholder;

      // Add to Arena and Canvas
      arena.addArenaObject(placeholder);
      arena3dCanvas.loadArenaObject(placeholder);

      BDebug.print(selection);
    }

    else if (ornamentRadio.isSelected())
    {
      selection = BGlobal.ORNAMENTPATH + selection;
      // Create the Object
      //BComponent component = BArenaOrnament.loadFromFile(selection);
      // Cast so that it implements BArenaObject
      BArenaOrnament ornament = (BArenaOrnament)BArenaOrnament.loadFromFile(selection);
      BDebug.print(ornament);
      // Add to Arena and Canvas
      arena.addArenaObject(ornament);
      arena3dCanvas.loadArenaObject(ornament);
      BDebug.print(selection);
    }
    else if (floorRadio.isSelected())
    {
      selection = BGlobal.ARENAFLOOR_EXT + selection;
      arena.floorObjectName = selection;
      BDebug.print(selection);
      arena3dCanvas.loadFloor(selection);
      arena.backgroundFileName = selection;
    }
    else if (backRadio.isSelected())
    {
        BDebug.print(selection);
        arena.backgroundFileName = selection;
        arena3dCanvas.setBackgroundImage(arena.backgroundFileName);
    }
    else if (ambSoundRadio.isSelected())
    {
        arena.ambientSoundName = selection;
        ambSoundLabel.setText(arena.ambientSoundName);
    }
    else if (ranSoundRadio.isSelected())
    {
        arena.randomSoundName = selection;
        ranSoundLabel.setText(arena.randomSoundName);
    }
    else
        BDebug.print ("BArenaBuilder - Unknown selection for arenaObjects ");
  }

  // saves the arena to disk
  private void saveTheArena()
  {
    boolean success = true;

    Vector v = arena.getPlaceHolders(BPlaceHolder.TYPE_BOT);
    int placeNumber = v.size();

    if(placeNumber != 2) {
      JOptionPane.showMessageDialog(null, "You must have 2 bot placeholders in the arena.\nYou currently have " + placeNumber + ".", "Save Error", JOptionPane.INFORMATION_MESSAGE);
      success = false;
      arena3dCanvas.setCursor(new Cursor(Cursor.HAND_CURSOR));
    }
    else {
    // Create the File Chooser
    String[] suffix = new String[] {BGlobal.ARENASUFFIX.substring(1,BGlobal.ARENASUFFIX.length())};
    String arenaPath = BGlobal.ARENAPATH;
    BFileFilter filter = new BFileFilter(suffix,arenaPath.substring(BGlobal.ARENAPATH.length()),true);
    File startFilePath = new File(arenaPath);
    JFileChooser chooser = new JFileChooser(startFilePath);
    chooser.setFileFilter(filter);
    chooser.setDialogTitle("Save Current Arena");

    int option = chooser.showSaveDialog(this);
    if (option == JFileChooser.APPROVE_OPTION)
    {
      // Store the Floor details
      BComponent floor = arena3dCanvas.getFloor();
      if (floor != null)
        arena.setFloorDetails(floor.getShine(),floor.getTransparency(),floor.getColor(),floor.getTextureName());

      // set up attributes
      arenaPath = chooser.getSelectedFile().getPath();
      arena.setName(nameField.getText());

      arena.AmbientColor = arena3dCanvas.getAmbientLightColor();
      arena.directionalColor = arena3dCanvas.getDirLightColor(1);
      arena.setDirectionalColor2(arena3dCanvas.getDirLightColor(2) );

      // SJS 20/02/2001 - Save ref. path.
      arena.setRefereePath(refPathCombo.getSelectedFile());

      // SJS 20/02/2001 - Save victory sound path.
      arena.setVictorySound(victorySoundCombo.getSelectedFile());

      Vector3f vec = arena3dCanvas.getDirLightVector(1);
      arena.dirX = vec.x;
      arena.dirY = vec.y;
      arena.dirZ = vec.z;

      vec = arena3dCanvas.getDirLightVector(2);
      arena.setDirX2(vec.x);
      arena.setDirY2(vec.y);
      arena.setDirZ2(vec.z);

      arena.setCameraPos(theCam.getArenaPosition().x, theCam.getArenaPosition().getY() , theCam.getArenaPosition().z );


      // fog
      arena.fogColor = arena3dCanvas.getFogColor();
      arena.useFog = fogCheck.isSelected();

      float d;
      try {
        d =  (float)(fogDenSlider.getValue()) / 4000;
      }
      catch (Exception ex) {
        d = BGlobal.DEFAULT_FOG_DENSITY;
      }
      arena.fogDensity = d;
      // Save
      try {
        arena.saveToFile(arenaPath);
      }
      catch (Exception e1) {
        e1.printStackTrace(System.out);
        success = false;
      }

      if(success)
        confirmLabel.setText(" Arena Saved");
      else
        confirmLabel.setText("");
      // background filename is saved in the addArenaObject method
    }
    }
  }

  // start a new arena
  private void startNewArena()
  {
    arena = new BArena();
    nameField.setText("New Arena");
    arena3dCanvas.clear();
    arena3dCanvas.setBackgroundImage(null);
    loadCam();
    arena3dCanvas.setArenaSize(BArena.DEFAULT_ARENA_SIZE);
    arenaSizeSlider.setValue(arena.getSize());
    arenaSizeLabel.setText("Arena Size - " + arena.getSize());
    fogCheck.setSelected(false);
    arena3dCanvas.showFog(false, 0.0030f);
    fogDenSlider.setValue(12);
    fogDenLabel.setText("Fog Density - 0.0030" );
    ambSoundLabel.setText("None");
    ranSoundLabel.setText("None");
    arena3dCanvas.setMode(BGlobal.CANVAS_MODE_ARENAMOVE);
    confirmLabel.setText("");
  }

  // load an arena from disk
  private void loadTheArena()
  {
    arena3dCanvas.setCursor(true);

    // Create the File Chooser
    setUpChooser(BGlobal.ARENASUFFIX,"Arena",BGlobal.ARENAPATH);

    // Open the Chooser
    int option = chooser.showOpenDialog(this);

    if (option == JFileChooser.APPROVE_OPTION)
    {

      // Clear out the current Canvas
      arena3dCanvas.clear();
      loadCam();
      filePath = chooser.getSelectedFile().getPath();
      arena = BArena.loadFromFile(filePath, true);

      // Loop through all the objects in the arena adding them to the
      // arena3dCanvas.
      botHolder1 = null;
      botHolder2 = null;

      for (ListIterator x = arena.getArenaObjects().listIterator();x.hasNext();)
      {
        Object obj = x.next();
        if (obj instanceof BPlaceHolder)
        {
          arena3dCanvas.loadArenaObject((BPlaceHolder)obj);

          BPlaceHolder ph = (BPlaceHolder)obj;

          // set the botholders for later access
          if(botHolder1 == null)
            botHolder1 = ph;
          else
            botHolder2 = ph;

          BArenaObjectPosition pos = ph.getArenaPosition();

          BDebug.print("BArenaBuilder - starting pos X = " + pos.getX());
          BDebug.print("BArenaBuilder - starting pos Z = " + pos.getZ());

          double dis = Math.sqrt( Math.pow(pos.getX(), 2) + Math.pow(pos.getZ(), 2) );

          BDebug.print("BArenaBuilder - distance from center = " + BGlobal.CANVAS_TO_WORLD_SCALE * dis);
          BDebug.print("BArenaBuilder - distance from edge = " +  BGlobal.CANVAS_TO_WORLD_SCALE * ( (BGlobal.WORLD_TO_CANVAS_SCALE * arena.getSize() / 2) - dis));

        } else if (obj instanceof BBot) {
          arena3dCanvas.loadArenaObject((BBot)obj);
        } else if (obj instanceof BArenaOrnament) {
          arena3dCanvas.loadArenaObject((BArenaOrnament)obj);
        }
      }
    // Setup the floor
    if (arena.floorObjectName != null)
        arena3dCanvas.loadFloor(arena.floorObjectName);

    BComponent floor = arena3dCanvas.getFloor();
    if (floor != null)
        floor.setAppearance(arena.getfloorTexture(),arena.getfloorColor(),arena.getfloorShine(),arena.getfloorTrans(), arena.getFloorColorDepth());

    arena3dCanvas.setArenaSize(arena.getSize());

    nameField.setText(arena.getName());

    arenaSizeSlider.setValue((int)arena.getSize());

    theCam.setArenaPosition(new BArenaObjectPosition(arena.getCameraX(),arena.getCameraY(),arena.getCameraZ(),0f )) ;

    arena3dCanvas.setAmbientLight(arena.AmbientColor);

    arena3dCanvas.setDirLight(1,arena.directionalColor);

    if (arena.getDirectionalColor2() != null)
      arena3dCanvas.setDirLight(2,arena.getDirectionalColor2());;

    if (ambLightRadio.isSelected())
        bColorPicker.setColor(arena3dCanvas.getAmbientLightColor());
    else if (dirLight2Radio.isSelected() )
        bColorPicker.setColor(arena3dCanvas.getDirLightColor(2));
    else if (fogRadio.isSelected() )
        bColorPicker.setColor(arena3dCanvas.getFogColor());
    else
        bColorPicker.setColor(arena3dCanvas.getDirLightColor(1));

    lightXSlider.setValue((int)(arena.dirX * 100));
    lightYSlider.setValue((int)(arena.dirY * 100));
    lightZSlider.setValue((int)(arena.dirZ * 100));

    arena3dCanvas.setDirLightVector(1, arena.dirX, arena.dirY, arena.dirZ);
    arena3dCanvas.setDirLightVector(2, arena.getDirX2(), arena.getDirY2(), arena.getDirZ2());

    if (arena.backgroundFileName != null)
        arena3dCanvas.setBackgroundImage(arena.backgroundFileName);

    // set up the fog related controls
    fogCheck.setSelected(arena.useFog);

    if(fogCheck.isSelected()) {
      fogDenSlider.setEnabled(true);
      fogRadio.setEnabled(true);
    }
    else {
      fogDenSlider.setEnabled(false);
      fogRadio.setEnabled(false);
      if(fogRadio.isSelected()) {
        dirLight1Radio.setSelected(true);
        lightXSlider.setEnabled(true);
        lightYSlider.setEnabled(true);
        lightZSlider.setEnabled(true);
        bColorPicker.setColor(arena3dCanvas.getDirLightColor(1));
        Vector3f vec = arena3dCanvas.getDirLightVector(1);
        lightXSlider.setValue((int)(vec.x * 100));
        lightYSlider.setValue((int)(vec.y * 100));
        lightZSlider.setValue((int)(vec.z * 100));
      }
    }

    // fog
    if (arena.useFog) {
      if (arena.fogColor != null)
        arena3dCanvas.setFogColor(arena.fogColor);

      fogDenSlider.setValue( (int)(arena.fogDensity * 4000) );
      arena3dCanvas.showFog(arena.useFog, arena.fogDensity);
    }

    // SJS 20/02/2001 - Load ref. path.
    refPathCombo.setSelectedFile(arena.getRefereePath());

    // SJS 20/02/2001 - Load victory sound path.
    victorySoundCombo.setSelectedFile(arena.getVictorySound());

    arena3dCanvas.setCursor(false);
    ambSoundLabel.setText(arena.ambientSoundName);
    ranSoundLabel.setText(arena.randomSoundName);

    confirmLabel.setText(" Arena Loaded");
    }
    else {
      confirmLabel.setText("");
      arena3dCanvas.setCursor(false);
    }
  }

  // main method
  static public void main(String[] args)
  {
    BGlobal.init();
    new BArenaBuilder();
  }

  // sets up the camera
  private void loadCam()
  {
    theCam= new BPlaceHolder("Camera",CAMERA_VRML, BPlaceHolder.TYPE_CAMERA);
    theCam.setArenaPosition(new BArenaObjectPosition(arena.getCameraX(),arena.getCameraY(),arena.getCameraZ(),0f )) ;
    arena3dCanvas.loadArenaObject(theCam);

  }

  // overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  // fills the object list with items
  private void fillArenaList (String path, BFileFilter filter)
  {
    BDebug.print(path);
    BFile file = new BFile(path);
    String[] titles = file.list(filter);
    objectList.setListData(titles);
  }

  // set up a file chooser box
  public void setUpChooser (String suffix, String desc, String path)
  {
    // Remove the dot from the suffix.
    suffix = suffix.substring(1,suffix.length());

    // A bit of a hack to allow the editor always see Chassis (chs) types.
    filter = new BFileFilter(new String[] {suffix,"chs"},desc,true);

    startFilePath = new File(path);
    chooser = new JFileChooser(startFilePath);
    chooser.setFileFilter(filter);

  }
}
