package roboforge.internal;

import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;
import java.util.*;
import roboforge.*;
import roboforge.net.*;
import roboforge.net.data.*;
import roboforge.util.io.*;
import roboforge.net.client.*;
import roboforge.ui.*;
import roboforge.ui.fusion.*;
import roboforge.sound.*;
import javax.swing.border.*;

import roboforge.ui.action.*;
import roboforge.ui.components.*;
import roboforge.ui.console.*;
import roboforge.ui.events.*;
import roboforge.ui.modes.*;

////////////////////////////////////////////////////////////////////////////////
//
// Featured fight manager is used to move fights between various categories
//
//
//
public class BFeaturedFightsManager extends JFrame
{

  final int UNASSIGNED = 0;
  final int FEATURED = 1;
  final int ALL_TIME_GREAT = 2;

  int currentLeft = UNASSIGNED;
  int currentRight = FEATURED;

  JButton jBGetFeaturedFights = new JButton();
  JButton jBDownloadFight = new JButton();
  JTextField jTLoginID = new JTextField();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JButton jBLoginIn = new JButton();

  String password = "";
  String loginID = "";
  JTextArea jTDisplay = new JTextArea();
  JLabel jLabel9 = new JLabel();
  JButton downloadAllFightsButton = new JButton();
  JButton viewButton = new JButton();
  JButton unLeftButton = new JButton();
  JButton featureLeftButton = new JButton();
  JButton atgLeftButton = new JButton();
  JScrollPane leftFightScroll = new JScrollPane();
  JList leftFightList = new JList();
  JScrollPane rightFightScroll = new JScrollPane();
  JList rightFightList = new JList();
  JButton moveButton = new JButton();
  JButton copyButton = new JButton();
  JButton unRightButton = new JButton();
  JButton featureRightButton = new JButton();
  JButton atgRightButton = new JButton();
  JButton removeButton = new JButton();
  JScrollPane commentScroll = new JScrollPane();
  JTextArea commentArea = new JTextArea();
  JLabel jLabel1 = new JLabel();

  Vector unassigned = new Vector();
  Vector featured = new Vector();
  Vector allTimeGreat = new Vector();
  JPasswordField jTPassword = new JPasswordField();
  JLabel leftLabel = new JLabel();
  JLabel rightLabel = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  Border border1;
  Border border2;
  JButton commentButton = new JButton();

  BWindow win = new BWindow();
  BBattleScr scr = null;

  //Main method
  public static void main(String[] args)
  {

    BFeaturedFightsManager frame = new BFeaturedFightsManager();

    frame.validate();
    frame.setVisible(true);
  }

  //Construct the frame
  public BFeaturedFightsManager()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      BGlobal.init();
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    BSound.init();

    border1 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,SystemColor.controlLtHighlight,SystemColor.controlLtHighlight,SystemColor.controlShadow,SystemColor.controlShadow);
    border2 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,SystemColor.controlLtHighlight,SystemColor.controlLtHighlight,SystemColor.controlShadow,SystemColor.controlShadow);
    this.getContentPane().setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(909, 484));
    this.setTitle("Featured Fight Manager");
    jBGetFeaturedFights.setText("Get Featured Fights");
    jBGetFeaturedFights.setBounds(new Rectangle(10, 91, 234, 35));
    jBGetFeaturedFights.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBGetFeaturedFights_actionPerformed(e);
      }
    });

    jBDownloadFight.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBDownloadFight_actionPerformed(e);
      }
    });
    jBDownloadFight.setText("Download Fight");
    jTLoginID.setBackground(new java.awt.Color(51, 51, 102));
    jTLoginID.setForeground(new java.awt.Color(200, 200, 220));
    jTLoginID.setBorder(border2);
    jTLoginID.setNextFocusableComponent(jTPassword);
    jTLoginID.setCaretColor(new java.awt.Color(200, 200, 220));
    jTLoginID.setBounds(new Rectangle(119, 15, 135, 21));
    jTLoginID.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jTLoginID_actionPerformed(e);
      }
    });
    jLabel7.setText("LoginID");
    jLabel7.setBounds(new Rectangle(17, 15, 96, 18));
    jLabel8.setText("Password");
    jLabel8.setBounds(new Rectangle(17, 45, 93, 21));
    jBLoginIn.setActionCommand("Log In");
    jBLoginIn.setText("Log In");
    jBLoginIn.setBounds(new Rectangle(269, 48, 105, 21));
    jBLoginIn.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBLoginIn_actionPerformed(e);
      }
    });
    jTDisplay.setLineWrap(true);
    jTDisplay.setWrapStyleWord(true);
    jTDisplay.setCaretColor(new java.awt.Color(200, 200, 220));
    jTDisplay.setBackground(new java.awt.Color(51, 51, 102));
    jTDisplay.setBorder(null);
    jTDisplay.setSelectionColor(new java.awt.Color(200, 200, 220));
    jTDisplay.setForeground(new java.awt.Color(200, 200, 220));
    jTDisplay.setEditable(false);
    jTDisplay.setSelectedTextColor(new java.awt.Color(51, 51, 102));
    jTDisplay.setBounds(new Rectangle(459, 20, 267, 51));
    jTDisplay.setBounds(new Rectangle(25, 108, 267, 54));
    jLabel9.setBounds(new Rectangle(27, 335, 73, 21));
    jLabel9.setBounds(new Rectangle(387, 16, 73, 21));
    jLabel9.setText("Server Info");
    viewButton.setText("View");
    viewButton.setBounds(new Rectangle(404, 90, 80, 36));
    viewButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        viewButton_actionPerformed(e);
      }
    });



    downloadAllFightsButton.setText("D All");
    downloadAllFightsButton.setBounds(new Rectangle(500, 90, 100, 36));
    downloadAllFightsButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        downloadAllFightsButton_actionPerformed(e);
      }
    });

    unLeftButton.setFont(new java.awt.Font("Dialog", 0, 10));
    unLeftButton.setMargin(new Insets(0, 0, 0, 0));
    unLeftButton.setText("Unassigned");
    unLeftButton.setBounds(new Rectangle(162, 143, 82, 38));
    unLeftButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        unLeftButton_actionPerformed(e);
      }
    });
    featureLeftButton.setFont(new java.awt.Font("Dialog", 0, 10));
    featureLeftButton.setMargin(new Insets(0, 0, 0, 0));
    featureLeftButton.setText("Featured");
    featureLeftButton.setBounds(new Rectangle(162, 188, 82, 39));
    featureLeftButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        featureLeftButton_actionPerformed(e);
      }
    });
    atgLeftButton.setFont(new java.awt.Font("Dialog", 0, 10));
    atgLeftButton.setMargin(new Insets(0, 0, 0, 0));
    atgLeftButton.setText("All time great");
    atgLeftButton.setBounds(new Rectangle(162, 233, 82, 38));
    atgLeftButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        atgLeftButton_actionPerformed(e);
      }
    });
    leftFightScroll.setBorder(BorderFactory.createLoweredBevelBorder());
    leftFightScroll.setBounds(new Rectangle(254, 165, 232, 243));
    rightFightScroll.setBorder(BorderFactory.createLoweredBevelBorder());
    rightFightScroll.setBounds(new Rectangle(568, 165, 236, 243));
    moveButton.setMargin(new Insets(0, 0, 0, 0));
    moveButton.setText("Move ->");
    moveButton.setBounds(new Rectangle(494, 190, 65, 32));
    moveButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        moveButton_actionPerformed(e);
      }
    });
    copyButton.setMargin(new Insets(0, 0, 0, 0));
    copyButton.setText("Copy ->");
    copyButton.setBounds(new Rectangle(494, 243, 66, 32));
    copyButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        copyButton_actionPerformed(e);
      }
    });
    unRightButton.setFont(new java.awt.Font("Dialog", 0, 10));
    unRightButton.setMargin(new Insets(0, 0, 0, 0));
    unRightButton.setText("Unassigned");
    unRightButton.setBounds(new Rectangle(812, 142, 81, 37));
    unRightButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        unRightButton_actionPerformed(e);
      }
    });
    featureRightButton.setFont(new java.awt.Font("Dialog", 0, 10));
    featureRightButton.setMargin(new Insets(0, 0, 0, 0));
    featureRightButton.setText("Featured");
    featureRightButton.setBounds(new Rectangle(812, 187, 82, 40));
    featureRightButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        featureRightButton_actionPerformed(e);
      }
    });
    atgRightButton.setFont(new java.awt.Font("Dialog", 0, 10));
    atgRightButton.setMargin(new Insets(0, 0, 0, 0));
    atgRightButton.setText("All time great");
    atgRightButton.setBounds(new Rectangle(812, 235, 82, 40));
    atgRightButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        atgRightButton_actionPerformed(e);
      }
    });
    removeButton.setText("Remove Fight");
    removeButton.setBounds(new Rectangle(300, 415, 138, 32));
    removeButton.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        removeButton_actionPerformed(e);
      }
    });
    commentScroll.setBorder(BorderFactory.createLoweredBevelBorder());
    commentScroll.setBounds(new Rectangle(11, 283, 233, 125));
    jLabel1.setText("Fight Comments");
    jLabel1.setBounds(new Rectangle(13, 267, 126, 14));
    commentArea.setLineWrap(true);
    commentArea.setWrapStyleWord(true);
    commentArea.setCaretColor(new java.awt.Color(200, 200, 220));
    commentArea.setBackground(new java.awt.Color(51, 51, 102));
    commentArea.setSelectionColor(new java.awt.Color(200, 200, 220));
    commentArea.setForeground(new java.awt.Color(200, 200, 220));
    commentArea.setSelectedTextColor(new java.awt.Color(51, 51, 102));
    leftFightList.setBackground(new java.awt.Color(51, 51, 102));
    leftFightList.setFont(new java.awt.Font("Dialog", 0, 10));
    leftFightList.setForeground(new java.awt.Color(200, 200, 220));

    leftFightList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
    {
      public void valueChanged(ListSelectionEvent e)
      {
        leftFightList_valueChanged(e);
      }
    });

    rightFightList.setBackground(new java.awt.Color(51, 51, 102));
    rightFightList.setFont(new java.awt.Font("Dialog", 0, 10));
    rightFightList.setForeground(new java.awt.Color(200, 200, 220));
    rightFightList.setSelectionBackground(new java.awt.Color(51, 51, 102));
    rightFightList.setSelectionForeground(new java.awt.Color(200, 200, 220));
    jTPassword.setCaretColor(new java.awt.Color(200, 200, 220));
    jTPassword.setBackground(new java.awt.Color(51, 51, 102));
    jTPassword.setBorder(border1);
    jTPassword.setForeground(new java.awt.Color(200, 200, 220));
    jTPassword.setBounds(new Rectangle(118, 48, 136, 22));
    jTPassword.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        jTPassword_actionPerformed(e);
      }
    });
    leftLabel.setText("Unassigned Fights");
    leftLabel.setBounds(new Rectangle(255, 147, 230, 14));
    rightLabel.setText("Featured Fights");
    rightLabel.setBounds(new Rectangle(569, 147, 234, 14));
    jScrollPane1.setBorder(BorderFactory.createLoweredBevelBorder());
    jScrollPane1.setBounds(new Rectangle(499, 13, 395, 60));
    commentButton.setSelected(true);
    commentButton.setText("Set Comment");
    commentButton.setBounds(new Rectangle(50, 415, 146, 33));
    commentButton.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        commentButton_actionPerformed(e);
      }
    });

    this.getContentPane().add(jTLoginID, null);
    this.getContentPane().add(jLabel7, null);
    this.getContentPane().add(jLabel8, null);
    this.getContentPane().add(jBLoginIn, null);
    this.getContentPane().add(jLabel9, null);
    this.getContentPane().add(jTPassword, null);
    this.getContentPane().add(jScrollPane1, null);
    this.getContentPane().add(unLeftButton, null);
    this.getContentPane().add(featureLeftButton, null);
    this.getContentPane().add(atgLeftButton, null);
    this.getContentPane().add(atgRightButton, null);
    this.getContentPane().add(featureRightButton, null);
    this.getContentPane().add(unRightButton, null);
    this.getContentPane().add(rightFightScroll, null);
    this.getContentPane().add(leftFightScroll, null);
    this.getContentPane().add(moveButton, null);
    this.getContentPane().add(copyButton, null);
    this.getContentPane().add(leftLabel, null);
    this.getContentPane().add(rightLabel, null);
    this.getContentPane().add(removeButton, null);
    this.getContentPane().add(commentButton, null);
    this.getContentPane().add(commentScroll, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jBDownloadFight, null);
    this.getContentPane().add(viewButton, null);

    this.getContentPane().add(downloadAllFightsButton, null);

    this.getContentPane().add(jBGetFeaturedFights, null);
    commentScroll.getViewport().add(commentArea, null);
    leftFightScroll.getViewport().add(leftFightList, null);
    rightFightScroll.getViewport().add(rightFightList, null);
    jScrollPane1.getViewport().add(jTDisplay, null);



    jBDownloadFight.setBounds(new Rectangle(255, 90, 140, 36));
    jLabel9.setBounds(new Rectangle(27, 335, 73, 21));
    jLabel9.setBounds(new Rectangle(429, 13, 73, 21));
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);

    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      BSound.close();
      System.exit(0);
    }
  }

  void leftFightList_valueChanged(ListSelectionEvent e)
  {
    BFightData d = (BFightData)leftFightList.getSelectedValue();
    String comment = null;

    if(d != null)
    {
      if (d.comments == null || d.comments.equals("") )
        comment = d.winDescription;
      else
        comment = d.comments;
    }

    if(d != null)
      commentArea.setText(comment);

    if(d != null) {
    File f = new File(BGlobal.BATTLERECORDINGCACHEPATH + d.getID() + ".rec");
    boolean fightIsDownloaded = f.exists();

    if(!fightIsDownloaded)
      viewButton.setEnabled(false);
    else
      viewButton.setEnabled(true);
    }
    else
      viewButton.setEnabled(false);
  }

  void jBGetFeaturedFights_actionPerformed(ActionEvent e)
  {

      BMessage response = null;
      BFeaturedFightInfoData featuredFightInfoData;

      try
      {
        BGlobal.init();
        BClientStack server = new BClientStack();
        server.login(loginID, password);

        // FFI - Featured Fight Infomation
        BTransmission t = new BTransmission(
          new BRequest(server, "FFI"));

        // Get the response back from the server...
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          featuredFightInfoData = (BFeaturedFightInfoData)response.getData();
          jTDisplay.append("Featured Fights Retrieved\n");

          updateLists(featuredFightInfoData);

        }
        else
        {
          BDebug.print("NAK " + response);
          jTDisplay.append("NAK: " + response + "\n");
        }


      }
      catch (BNetException ex)
      {
        BDebug.print("Could not init net-stack: "+ ex);
      }
      catch (Exception err)
      {
        BDebug.print("Error: "+ err);
      }


  }

  // update the fight data lists
  void updateLists(BFeaturedFightInfoData d)
  {
    Vector fightData = d.fightData;
    BDebug.print(fightData.size());

    unassigned.clear();
    featured.clear();
    allTimeGreat.clear();

    for (int i = 0; i < fightData.size(); i++)
    {
      BFightData fd = (BFightData)fightData.elementAt(i);

      //HACK SET TOURNAMENT NAME
      if (fd.name == null)
        fd.name = "[TID: " + fd.tournamentID + "]";
      else
        fd.name =   "[TID: " + fd.tournamentID + "] " + fd.name;


      long featuredFightTypes [] = fd.featuredFightTypes;

      BDebug.print(featuredFightTypes.length);
      for (int j = 0; j < featuredFightTypes.length; j++)
      {
        if(featuredFightTypes[j] == BFeaturedFightTypeData.UNASSIGNED)
          unassigned.add(fd);
        if(featuredFightTypes[j] == BFeaturedFightTypeData.FEATURED)
          featured.add(fd);
        if(featuredFightTypes[j] == BFeaturedFightTypeData.ALL_TIME_GREAT)
          allTimeGreat.add(fd);
      }
    }

    leftFightList.setListData(unassigned);
    rightFightList.setListData(featured);

    leftLabel.setText("Unassigned Fights");
    rightLabel.setText("Featured Fights");

    leftFightList.setSelectedIndex(0);

    currentLeft = UNASSIGNED;
    currentRight = FEATURED;
  }


  void downloadAllFightsButton_actionPerformed (ActionEvent e)
  {
    for (int i = 0; i < leftFightList.getModel().getSize() ; i++ )
    {
      BFightData fData = (BFightData)leftFightList.getModel().getElementAt(i);
      downLoad(fData );
    }

  }


  void downLoad(BFightData fData )
  {

    try
    {
      File existingF = new File(BGlobal.BATTLERECORDINGCACHEPATH + fData.getID() + ".rec");
      if (existingF.exists() )
      {
          BDebug.print("BFeaturedFightsManager skipping download of " +  fData);
          return;

      }
      BDebug.print("BFeaturedFightsManager downloading " +  fData);



      BClientStack server = new BClientStack();

      server.login(loginID, password);



      BRequest r = new BRequest(server, "GBA");
      r.setData(new BIdentData(fData.getID()));

      BTransmission t = new BTransmission(r);
      BMessage response = server.request(t);


      if (response.isAcknowledgement())
      {
        BFightRecordData fightData = (BFightRecordData)response.getData();

        System.out.println("Saving battle to local cache...");

        String filename =
          BGlobal.BATTLERECORDINGCACHEPATH + fightData.getID();

        fightData.save(filename);
        System.gc();

        System.out.println("Battle download completed.");
        jTDisplay.append("Battle download completed\n");
        viewButton.setEnabled(true);
        //saveBattle((BFightRecordData) response.getData());
      }
      else
        System.out.println("ERROR: "+ response.getData());
    }
    catch (Exception e1)
    {
      System.out.println("Error :" + e1.getMessage());
    }
  }

  void jBDownloadFight_actionPerformed(ActionEvent e)
  {

    BFightData fData = (BFightData)leftFightList.getSelectedValue();

    if(fData != null)
    {
      downLoad(fData);
    }
  }

  void jBLoginIn_actionPerformed(ActionEvent e)
  {
    try
    {
      BGlobal.init();
      BClientStack server = new BClientStack();
      loginID = jTLoginID.getText();
      password = jTPassword.getText();
      server.login(loginID,password);
      jTLoginID.setText("");
      jTPassword.setText("");
      jTDisplay.append("Logged In OK\n");
    }
    catch (Exception loginErr)
    {
      System.out.println("Error :" + loginErr.getMessage());
      jTDisplay.append("Logged Failed: "+ loginErr.getMessage() + "\n");

    }
  }

  void jTLoginID_actionPerformed(ActionEvent e)
  {

  }


  void viewButton_actionPerformed(ActionEvent e)
  {
    BBattleRecorder rec = null;

    BFightData fData = (BFightData)leftFightList.getSelectedValue();
    BTextures.setListener(win);
    FusionLookAndFeel.install();

    try {
      rec = BBattleRecorder.loadFromFile(BGlobal.BATTLERECORDINGCACHEPATH + fData.getID() + ".rec", false);
    }
    catch (Exception ex) {}

    if(rec != null)
      rec.init();

    scr = new BBattleScr(rec, null, false);
    scr.init(rec, null);

    win.push(scr);
    win.setVisible(true);
  }


  void moveButton_actionPerformed(ActionEvent e)
  {
    BMessage response = null;
    BFeaturedFightInfoData featuredFightInfoData;

    BFightData fightData = (BFightData)leftFightList.getSelectedValue();

    if(fightData != null)
    {
      try
      {
        BGlobal.init();
        BClientStack server = new BClientStack();
        server.login(loginID, password);

        BFeaturedFightUpdateData d = new BFeaturedFightUpdateData(fightData.getID());

        if(currentLeft == UNASSIGNED)
          d.currentType = BFeaturedFightTypeData.UNASSIGNED;
        else if (currentLeft == FEATURED)
          d.currentType = BFeaturedFightTypeData.FEATURED;
        else if (currentLeft == ALL_TIME_GREAT)
          d.currentType = BFeaturedFightTypeData.ALL_TIME_GREAT;

        if(currentRight == UNASSIGNED)
          d.newType = BFeaturedFightTypeData.UNASSIGNED;
        else if (currentRight == FEATURED)
          d.newType = BFeaturedFightTypeData.FEATURED;
        else if (currentRight == ALL_TIME_GREAT)
          d.newType = BFeaturedFightTypeData.ALL_TIME_GREAT;

        // FFI - Featured Fight Infomation
        BRequest r = new BRequest(server, "MFF");
        r.setData(d);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          jTDisplay.append("Fight moved\n");

          if(currentLeft == UNASSIGNED)
          {
            unassigned.remove(fightData);
            leftFightList.setListData(unassigned);
          }
          else if (currentLeft == FEATURED)
          {
            featured.remove(fightData);
            leftFightList.setListData(featured);
          }
          else if (currentLeft == ALL_TIME_GREAT)
          {
            allTimeGreat.remove(fightData);
            leftFightList.setListData(allTimeGreat);
          }

          if(currentRight == UNASSIGNED)
          {
            unassigned.add(fightData);
            rightFightList.setListData(unassigned);
          }
          else if (currentRight == FEATURED)
          {
            featured.add(fightData);
            rightFightList.setListData(featured);
          }
          else if (currentRight == ALL_TIME_GREAT)
          {
            allTimeGreat.add(fightData);
            rightFightList.setListData(allTimeGreat);
          }
        }
        else
        {
          BDebug.print("NAK " + response);
          jTDisplay.append("NAK: " + response + "\n");
        }
      }
      catch (BNetException ex)
      {
        BDebug.print("Could not init net-stack: "+ ex);
      }
      catch (Exception err)
      {
        BDebug.print("Error: "+ err);
      }
    }
  }

  void copyButton_actionPerformed(ActionEvent e)
  {
    BMessage response = null;
    BFeaturedFightInfoData featuredFightInfoData;

    BFightData fightData = (BFightData)leftFightList.getSelectedValue();

    if(fightData != null)
    {
      try
      {
        BGlobal.init();
        BClientStack server = new BClientStack();
        server.login(loginID, password);

        BFeaturedFightUpdateData d = new BFeaturedFightUpdateData(fightData.getID());

        if(currentRight == UNASSIGNED)
          d.newType = BFeaturedFightTypeData.UNASSIGNED;
        else if (currentRight == FEATURED)
          d.newType = BFeaturedFightTypeData.FEATURED;
        else if (currentRight == ALL_TIME_GREAT)
          d.newType = BFeaturedFightTypeData.ALL_TIME_GREAT;

        // FFI - Featured Fight Infomation
        BRequest r = new BRequest(server, "CFF");
        r.setData(d);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          jTDisplay.append("Fight copied\n");

          if(currentRight == UNASSIGNED)
          {
            unassigned.add(fightData);
            rightFightList.setListData(unassigned);
          }
          else if (currentRight == FEATURED)
          {
            featured.add(fightData);
            rightFightList.setListData(featured);
          }
          else if (currentRight == ALL_TIME_GREAT)
          {
            allTimeGreat.add(fightData);
            rightFightList.setListData(allTimeGreat);
          }
        }
        else
        {
          BDebug.print("NAK " + response);
          jTDisplay.append("NAK: " + response + "\n");
        }
      }
      catch (BNetException ex)
      {
        BDebug.print("Could not init net-stack: "+ ex);
      }
      catch (Exception err)
      {
        BDebug.print("Error: "+ err);
      }
    }
  }

  void removeButton_actionPerformed(ActionEvent e)
  {
    BMessage response = null;
    BFeaturedFightInfoData featuredFightInfoData;

    BFightData fightData = (BFightData)leftFightList.getSelectedValue();

    if(fightData != null)
    {
      try
      {
        BGlobal.init();
        BClientStack server = new BClientStack();
        server.login(loginID, password);

        BFeaturedFightUpdateData d = new BFeaturedFightUpdateData(fightData.getID());

        if(currentLeft == UNASSIGNED)
          d.currentType = BFeaturedFightTypeData.UNASSIGNED;
        else if (currentLeft == FEATURED)
          d.currentType = BFeaturedFightTypeData.FEATURED;
        else if (currentLeft == ALL_TIME_GREAT)
          d.currentType = BFeaturedFightTypeData.ALL_TIME_GREAT;

        // FFI - Featured Fight Infomation
        BRequest r = new BRequest(server, "DFF");
        r.setData(d);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          jTDisplay.append("Fight removed from category\n");

          if(currentLeft == UNASSIGNED)
          {
            unassigned.remove(fightData);
            leftFightList.setListData(unassigned);
          }
          else if (currentLeft == FEATURED)
          {
            featured.remove(fightData);
            leftFightList.setListData(featured);
          }
          else if (currentLeft == ALL_TIME_GREAT)
          {
            allTimeGreat.remove(fightData);
            leftFightList.setListData(allTimeGreat);
          }
        }
        else
        {
          BDebug.print("NAK " + response);
          jTDisplay.append("NAK: " + response + "\n");
        }
      }
      catch (BNetException ex)
      {
        BDebug.print("Could not init net-stack: "+ ex);
      }
      catch (Exception err)
      {
        BDebug.print("Error: "+ err);
      }
    }
  }

  void commentButton_actionPerformed(ActionEvent e)
  {
    BMessage response = null;
    BFeaturedFightInfoData featuredFightInfoData;

    BFightData fightData = (BFightData)leftFightList.getSelectedValue();

    if(fightData != null)
    {
      try
      {
        BGlobal.init();
        BClientStack server = new BClientStack();
        server.login(loginID, password);

        BFeaturedFightUpdateData d = new BFeaturedFightUpdateData(fightData.getID());

        d.fightComment = commentArea.getText();

        // FFI - Featured Fight Infomation
        BRequest r = new BRequest(server, "UFFC");
        r.setData(d);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          jTDisplay.append("Comment set\n");
          fightData.comments = commentArea.getText();  
        }
        else
        {
          BDebug.print("NAK " + response);
          jTDisplay.append("NAK: " + response + "\n");
        }
      }
      catch (BNetException ex)
      {
        BDebug.print("Could not init net-stack: "+ ex);
      }
      catch (Exception err)
      {
        BDebug.print("Error: "+ err);
      }
    }
  }

  void unLeftButton_actionPerformed(ActionEvent e)
  {
    leftFightList.setListData(unassigned);
    if(currentRight == UNASSIGNED)
    {
      rightFightList.setListData(featured);
      currentRight = FEATURED;
      rightLabel.setText("Featured Fights");
    }
    currentLeft = UNASSIGNED;
    leftLabel.setText("Unassigned Fights");
    leftFightList.setSelectedIndex(0);
  }

  void featureLeftButton_actionPerformed(ActionEvent e)
  {
    leftFightList.setListData(featured);
    if(currentRight == FEATURED)
    {
      rightFightList.setListData(allTimeGreat);
      currentRight = ALL_TIME_GREAT;
      rightLabel.setText("All Time Great Fights");
    }
    currentLeft = FEATURED;
    leftLabel.setText("Featured Fights");
    leftFightList.setSelectedIndex(0);
  }

  void atgLeftButton_actionPerformed(ActionEvent e)
  {
    leftFightList.setListData(allTimeGreat);
    if(currentRight == ALL_TIME_GREAT)
    {
      rightFightList.setListData(featured);
      currentRight = FEATURED;
      rightLabel.setText("Featured Fights");
    }
    currentLeft = ALL_TIME_GREAT;
    leftLabel.setText("All Time Great Fights");
    leftFightList.setSelectedIndex(0);
  }

  void unRightButton_actionPerformed(ActionEvent e)
  {
    rightFightList.setListData(unassigned);
    if(currentLeft == UNASSIGNED)
    {
      leftFightList.setListData(featured);
      currentLeft = FEATURED;
      leftLabel.setText("Featured Fights");
      leftFightList.setSelectedIndex(0);
    }
    currentRight = UNASSIGNED;
    rightLabel.setText("Unassigned Fights");
  }

  void featureRightButton_actionPerformed(ActionEvent e)
  {
    rightFightList.setListData(featured);
    if(currentLeft == FEATURED)
    {
      leftFightList.setListData(allTimeGreat);
      currentLeft = ALL_TIME_GREAT;
      leftLabel.setText("All Time Great Fights");
      leftFightList.setSelectedIndex(0);
    }
    currentRight = FEATURED;
    rightLabel.setText("Featured Fights");
  }

  void atgRightButton_actionPerformed(ActionEvent e)
  {
    rightFightList.setListData(allTimeGreat);
    if(currentLeft == ALL_TIME_GREAT)
    {
      leftFightList.setListData(featured);
      currentLeft = FEATURED;
      leftLabel.setText("Featured Fights");
      leftFightList.setSelectedIndex(0);
    }
    currentRight = ALL_TIME_GREAT;
    rightLabel.setText("All Time Great Fights");
  }

  void jTPassword_actionPerformed(ActionEvent e)
  {
    jBLoginIn_actionPerformed(e);
  }


  // class BBattleScr extends BBattleScreen - used for showing the battle view outside roboforge
  public class BBattleScr extends BBattleScreen
  {
    BackAction2 backAction2 = new BackAction2(res);

    public BBattleScr (BBattleRecorder battleRecordingIn, BArena theArena , boolean init)
    {
      super(battleRecordingIn, theArena, init);
    }

    protected void configBattleScreenChildren()
    {
      super.configBattleScreenChildren();
      back.setAction(backAction2);
    }

    protected class BackAction2 extends BAction
    {
      public BackAction2(BUIResources res)
        { super(res, "back"); }

      public void actionPerformed(ActionEvent e)
      {
       BGlobal.clearAllHardCaches();
       win.remove(scr, true);
       win.setVisible(false);
      }
    }

    public void requestDeactivate()
    {}

    public void requestActivate()
    {}
  }









}



