package roboforge.net.client;

import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.*;
import java.net.*;


public class BClientTransport implements BTransportLayer
{

  // Constructor...
  // -----------------------------------------------------------

  public BClientTransport(BClientStack stack)
    { }
  
  
  // Interface methods...
  // -----------------------------------------------------------

  public BSocket getSocket(BTransmission t) throws BNetException
  {
    BTarget target  = t.getTarget();
    long    timeout = t.getTimeout();

    if (!(target instanceof BServerTarget))
      throw new BNetException("Cannot create socket - bad target type.");

    BServerTarget server =
      (BServerTarget) target;

    try
      { return new BURLSocket(server.getURL(), timeout); }
    catch (IOException e)
      { throw new BNetException("Could not connect to network."); }
  }

}
