package roboforge.net.data;

import roboforge.*;
import roboforge.util.data.*;

import java.io.*;
import java.util.zip.*;

public class BAcceptChallengeData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BAcceptChallengeData(long challengerAccountID, String challengerDesignerName, byte[] bot, long tournamentID)
  {
    super(challengerAccountID);
    challengerBot = bot;
    this.challengerDesignerName = challengerDesignerName;
    this.tournamentID = tournamentID;
  }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_ACCEPT_CHALLENGE; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------

  private byte[] challengerBot;
  public String challengerDesignerName;
  public long tournamentID;


  // Accessor methods...
  // -------------------------------------------------------------


  // Implementation methods...
  // -------------------------------------------------------------

  public BBot getBot()
  {
    try
    {
      byte[] botBytesUnziped = SServerAccess.gzipInflateArray(challengerBot);
      ByteArrayInputStream byteIS = new ByteArrayInputStream(botBytesUnziped);
      ObjectInputStream in = new ObjectInputStream(byteIS);
      return (BBot)in.readObject();
    }
    catch (Exception e)
      { throw new RuntimeException(""+ e); }
  }
}
