package roboforge.net.services;

import roboforge.BDebug;
import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.*;
import java.security.*;
import javax.crypto.*;

import iaik.security.provider.IAIK;



public class BRSAService extends BAbstractDataService
{
 
  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;

  
  // Member variables...
  // -----------------------------------------------------------

  protected transient PublicKey  encryptionKey;
  protected transient PrivateKey decryptionKey;
  

  // Constructors...
  // -----------------------------------------------------------

  public BRSAService(PrivateKey decryptionKey)
  {
    super();
    
    this.decryptionKey = decryptionKey;
    IAIK.addAsProvider(false);
  }
  
  
  // Implementation methods...
  // -----------------------------------------------------------

  public BSocket getSocket(BSocket s) throws IOException
  { 
    BRSASocket socket = new BRSASocket(s); 
    socket.setEncryptionKey(encryptionKey);
    socket.setDecryptionKey(decryptionKey);
    
    return socket;
  }
  
  public String toString()
    { return "BRSAService"; }
 

  
  // Target methods...
  // -----------------------------------------------------------
  
  public void inform(BServiceInfo info)
  {
    if (info instanceof BTarget)
    {
      BTarget target = 
        (BTarget) info;

      if (encryptionKey == null)
        encryptionKey = target.getPublicKey();
    }
  }

  /*
  public void read(BTarget target)
  { 
    encryptionKey = target.getPublicKey();
  }
  */
  
  
  // Accessor methods...
  // -----------------------------------------------------------

  public void setEncryptionKey(PublicKey key)
    { this.encryptionKey = key; }
  
  
}

