package roboforge.net.sockets;

import java.io.*;


public class BByteSocket implements BSocket
{

  // Member variables...
  // -----------------------------------------------------------

  protected ByteArrayInputStream  in;
  protected ByteArrayOutputStream out;

  protected byte[] data;
  
  
  // Constructors...
  // -----------------------------------------------------------

  public BByteSocket()
    { }

  public BByteSocket(byte[] data)
    { this.data = data; }
  
  
  
  // Interface methods...
  // -----------------------------------------------------------

  public InputStream getInputStream() throws IOException
  {
    if (in == null)
     in = new ByteArrayInputStream(data); 
    
    return in;
  }

  public OutputStream getOutputStream() throws IOException
  {
    if (out == null)
     out = new ByteArrayOutputStream(); 
    
    return out;
  }
  
  public void flush() throws IOException
    { if (out != null) out.flush(); }

  
  
  // Accessor methods...
  // -----------------------------------------------------------

  public byte[] getBytes() throws IOException
    { return out.toByteArray(); }
  
  public void setBytes(byte[] data) throws IOException
    // NB: Will not affect this.in if it has been created.
    { this.data = data; }

  public void close() throws IOException
  { 
    if (in  != null) in.close(); 
    if (out != null) out.close(); 
  }
  
}
