package roboforge.net.sockets;

import roboforge.BDebug;
import roboforge.net.*;

import java.io.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import iaik.security.provider.IAIK;



public class BDESSocket extends BCipherSocket
{

  // Member variables...
  // -----------------------------------------------------------

  protected Key key;
  protected byte[] iv;

  
  // Constructor...
  // -----------------------------------------------------------

  public BDESSocket(BSocket socket)
    { super(socket); }

  
  // Accessor methods...
  // -----------------------------------------------------------
  
  public void setKey(Key key)
    { this.key = key; }
  
  public void setInitVector(byte[] iv)
    { this.iv = iv; }
  
  
  
  // Abstract methods...
  // -----------------------------------------------------------

  protected Cipher getInputCipher() throws IOException
  {
    checkCipherParams();

    try
    {
      Cipher c = 
        Cipher.getInstance("3DES/CBC/PKCS5Padding");
    
      c.init(Cipher.DECRYPT_MODE, key, new IvParameterSpec(iv), null);
      return c;
    }
    catch (Exception e)
      { throw new BNetException("Could not initialize DES input cipher."); }
  }

  
  protected Cipher getOutputCipher() throws IOException
  {
    checkCipherParams();
    
    try
    {
      Cipher c = 
        Cipher.getInstance("3DES/CBC/PKCS5Padding");
        
      c.init(Cipher.ENCRYPT_MODE, key, new IvParameterSpec(iv), null);
      return c;
    }
    catch (Exception e)
      { throw new BNetException("Could not initialize DES output cipher."); }
  }

  
  protected void checkCipherParams() throws BNetException
  {
    if ((key == null) || (iv == null))
      throw new BNetException("Could not create secure socket.");
  }
  
}
