package roboforge.net.sockets;

import roboforge.net.BNetException;
import java.io.*;



public abstract class BFilterSocket implements BSocket
{

  // Member variables...
  // -----------------------------------------------------------

  protected BSocket socket;


  // Constructor...
  // -----------------------------------------------------------

  public BFilterSocket()
    { }

  public BFilterSocket(BSocket socket)
    { this.socket = socket; }



  // Interface methods...
  // -----------------------------------------------------------

  public InputStream getInputStream() throws IOException
  {
    if (socket != null)
      return filter(socket.getInputStream());
    else
      throw new BNetException("BFilterSocket: no source socket specified.");
  }

  public OutputStream getOutputStream() throws IOException
  {
    if (socket != null)
      return filter(socket.getOutputStream());
    else
      throw new BNetException("BFilterSocket: no source socket specified.");
  }
  
  public void flush() throws IOException
    { if (socket != null) socket.flush(); }

  public void close() throws IOException
    { if (socket != null) socket.close(); }
  
  

  // Accessor methods...
  // -----------------------------------------------------------

  public BSocket getSource()
    { return socket; }


  // Abstract methods...
  // -----------------------------------------------------------

  protected abstract InputStream filter(InputStream in)
    throws IOException;

  protected abstract OutputStream filter(OutputStream out)
    throws IOException;
  
}