package roboforge.particles.emitters;

public class BEmissionPatternPeriodic implements BEmissionPattern
{

  public static final float FOREVER = 1000000f;
  
  protected int   n;
  protected float period;
  protected float duration;
  protected float last;

  public BEmissionPatternPeriodic()
    { this(1, 0.1f, 1f); }

  public BEmissionPatternPeriodic(float period)
    { this(1, period, 1f); }

  public BEmissionPatternPeriodic(float period, float duration)
    { this(1, period, duration); }

  public BEmissionPatternPeriodic(int n, float period, float duration)
  {
    this.n        = n;
    this.period   = period;
    this.duration = duration;
    this.last     = 0f;
  }

  public void setN(int n)
    { this.n = n; }

  public int getN()
    { return n; }

  public void setPeriod(float period)
    { this.period = period; }

  public float getPeriod()
    { return period; }

  public void setDuration(float duration)
    { this.duration = duration; }

  public float getDuration()
    { return duration; }



  public int getEmissionCount(float t, float dt)
  {
    if (t >= duration)
      return 0;

    if (t == 0f)
      { last = 0f; return n; }

    float elapsed = (t - last);

    if (elapsed >= period)
     { last = t; return n; }
    else
      return 0;
  }

}