package roboforge.particles.emitters;

import roboforge.particles.*;


public class BSystemEmitterShared
  extends BSystemEmitterAbstract
{

  protected BParticleEmitter shared;
    // Particle emitter, shared by all particles in system.

  public BSystemEmitterShared(BParticleSystem s)
    { this(s, null, null); }

  public BSystemEmitterShared(BParticleSystem s, BEmissionPattern ep)
    { this(s, ep, null); }

  public BSystemEmitterShared(BParticleSystem s, BEmissionPattern ep, BParticleEmitter emitter)
  {
    super(s, ep);
    setSharedEmitter(emitter);
  }


  public void setSharedEmitter(BParticleEmitter emitter)
    { this.shared = emitter; }

  public BParticleEmitter getSharedEmitter()
    { return shared; }


  public BParticleAspect createParticleAspect(BParticle p)
    throws BParticleSystemException
    { return shared; }

}