package roboforge.particles.physics;

import roboforge.particles.*;
import roboforge.particles.forces.*;
import javax.vecmath.*;


public class BPhysicsForces implements BParticlePhysics
{

  // Members...
  // -------------------------------------------------------------

  protected BParticleForce forces;
    // The forces that are applied to a particle.

  protected Vector3f f = new Vector3f();
    // Net-force accumulator for particle physics.



  // Constructors...
  // -------------------------------------------------------------

  public BPhysicsForces()
    { }

  public BPhysicsForces(BParticleForce f)
    { setForces(f); }


  // Accessors...
  // -------------------------------------------------------------

  public void setForces(BParticleForce f)
    { this.forces = f; }

  public BParticleForce getForces()
    { return forces; }



  // Methods...
  // -------------------------------------------------------------

  public void start(BParticle p)
  {
    // TODO: Implementation?
  }

  public void update(BParticle p, float t, float dt)
  {
    // Remember last position.
    p.oldp.set(p.p);

    // First, calculate net force on particle.
    f.set(0f, 0f, 0f);

    if (forces != null)
      forces.apply(p, t, f);

    // Calculate particle's velocity.
    p.v.scaleAdd(dt/p.m, f, p.v);

    // Calculate particle's position.
    p.p.scaleAdd(dt, p.v, p.p);
  }

  public void stop(BParticle p)
  {
    // TODO: Implementation?
  }


}