package roboforge.ui;

import roboforge.BBot;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BPhysics;
import roboforge.BWizardLimb;
import roboforge.ui.components.BUIResources;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.*;

public class B3DWizardBotCanvas extends B3DBotCanvas
{

  // Constants...
  // -------------------------------------------------------------

  protected static double   WIZARD_VIEW_ANGLE    = -BPhysics.degToRad(45);
  protected static Vector3d WIZARD_VIEW_ROTATION = new Vector3d(WIZARD_VIEW_ANGLE, WIZARD_VIEW_ANGLE, 0);
  //protected static Vector3d WIZARD_VIEW_ORIGIN   = new Vector3d(0, 0, 0);
  public static double ZOOMFACTOR = 1.5;

  // Constructor.
  // -------------------------------------------------------------

  public B3DWizardBotCanvas(BUIResources res, String resourceKey)
  {
    super(res, resourceKey);

    /*
    RotationInterpolator rot =
      new RotationInterpolator
      (
        new Alpha(-1, 3000),
        getViewRotateYTG()
      );

    // rot.setSchedulingbounds(bounds);

    addBehavior(rot);
    */

    this.setBackground(BGlobal.colors.getDarkestShade());
    this.setForeground(BGlobal.colors.getDarkestShade());
  }

  public void addBot(BBot b)
  {
    super.addBot(b);

    // Zoom out from the bot an appropriate amount...
    float r = bot.getBoundingRadius();

    bot.getViewTranslation();
    bot.setViewZTranslation(r * ZOOMFACTOR);

    // bot.setViewTranslation(new Vector3d(0, 50, r * 3.0));
    setViewFromParameters();
  }

  protected Color3f getBackground3f()
    { return BGlobal.colors.getDarkestShade3f(); }

  public void addLimb(BWizardLimb limb)
  {
    super.addLimb(limb, limb.getParentComponent());

    //float r = bot.getBoundingRadius();
   // bot.setViewZTranslation(r * ZOOMFACTOR);
    //setViewFromParameters();

  }

  public Vector3d getViewRotation()
    { return WIZARD_VIEW_ROTATION; }





}
