package roboforge.ui;

/*
* File:
*   BBasicScreen.java
*
* Description:
*   Basic Screen - has a 'quit' button.
*
* Modification History: ( Name, Date, Notes )
*   Created SJS, 28/01/2000.
*   TODO: add bg image.
*/

import roboforge.BGlobal;
import roboforge.ui.components.*;
import roboforge.ui.components.border.*;
import roboforge.ui.events.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



public class BBasicScreen extends BScreen
{

  // UI Resources ...
  // -------------------------------------------------------------

  protected static BUIColorScheme colors = BGlobal.colors;

  protected BUIResources res = new BUIResources( new Object[]
  {
    "header.bounds",         new Rectangle(0, 0, 800, 104),
    "header.opaque",         Boolean.FALSE,

    "body.bounds",           new Rectangle(0, 104, 800, 452),
    "body.border",           new BLineBorder(BLineBorder.SIDES_TOP_BOTTOM, colors.getDarkerShade()),
    "body.background",       colors.getDarkestShade(),

    "footer.bounds",         new Rectangle(0, 467, 800, 243),
    "footer.opaque",         Boolean.FALSE,
  });



  // Visual elements ...
  // -------------------------------------------------------------

  protected BBoxPanel header  = new BBoxPanel(res, "header", BBoxPanel.X_AXIS);
  protected BBoxPanel body    = new BBoxPanel(res, "body",   BBoxPanel.X_AXIS);
  protected BBoxPanel footer  = new BBoxPanel(res, "footer", BBoxPanel.X_AXIS);



  // Constructors...
  // -------------------------------------------------------------

  public BBasicScreen()
  {
    super();

    layoutBasicScreenChildren();
    configBasicScreenChildren();

    res.cleanse();
    res = null;
  }


  // Children initialization methods...
  // -------------------------------------------------------------

  protected void layoutBasicScreenChildren()
  {
    add(header);
    add(body);
    add(footer);
  }

  protected void configBasicScreenChildren()
  {
  }

  public void onClose()
  {
      header  = null;
      body    = null;
      footer  = null;
      super.onClose();

  }
}
