package roboforge.ui;

import roboforge.BGlobal;

import java.awt.*;
import java.awt.event.*;

import roboforge.math.BMath;

import javax.vecmath.*;

// BBotSymbol is the circular bot icon
public class BBotSymbol
{
  private Color col;
  private boolean arrow = false;

  // constructors
  public BBotSymbol(boolean arrow)
  {
    this(BGlobal.colors.getMidShade(), arrow);
  }

  public BBotSymbol(Color col, boolean arrow)
  {
    this.col = col;
    this.arrow = arrow;
  }

  // accessor methods /////////////////////
  public void setCol(Color col)
  {
    this.col = col;
  }

  public void paint(Graphics2D g, float theta, String s1, String s2, String s3, boolean drawLabel)
  {
    Color tempCol = g.getColor();
    Font tempFont = g.getFont();

    g.setColor(col);
    g.fillOval(-20, -20, 40, 40);
    g.setColor(BGlobal.colors.getDarkestShade());
    g.fillOval(-15, -15, 30, 30);
    g.setColor(col);
    g.fillOval(-8, -8, 16, 16);

    if(arrow)
    {
      int [] xp = {-10, 0, 10};
      int [] yp = {-16, -28, -16};

      g.fillPolygon(xp, yp, 3);
    }

    if(drawLabel)
    {
      int startX = 30;
      g.setFont(new Font(null, Font.PLAIN, 20));
      int inc = g.getFontMetrics().getHeight();
      g.rotate(theta + Math.PI);
      g.drawString(s1, startX, -16);
      g.drawString(s2, startX, -16 + inc);
      g.drawString(s3, startX, -16 + (inc*2));
      g.rotate(-theta - Math.PI);
      g.setFont(tempFont);
    }

    g.setColor(tempCol);
  }
}