package roboforge.ui;

import roboforge.BBot;
//import roboforge.BChassis;
//import roboforge.BComponent;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BMove;
import roboforge.BMoveList;
import roboforge.BPhysics;

//import roboforge.ui.action.*;
import roboforge.ui.components.*;
//import roboforge.ui.events.*;
//import roboforge.ui.modes.*;
//import roboforge.util.graphics.*;
import roboforge.util.text.*;
import roboforge.util.processors.*;
import roboforge.botanalyst.*;


import roboforge.animation.*;
//import roboforge.animation.animation.b3d.*;

//import java.awt.Event;
import java.awt.event.*;
//import java.beans.PropertyChangeListener;
//import java.beans.PropertyChangeEvent;
import javax.swing.*;

import java.util.Vector;
import javax.vecmath.*;
import java.io.File;

import javax.swing.event.*;




public class BGeneralPanel extends B3DEditingPanel
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;


protected BUIResources res = new BUIResources( new Object[]
  {
    "attribs.background",         colors.getVeryDarkShade()

  });


  protected B3DCanvasYRotator yRotator;
  protected static double   VIEW_ANGLE    = -BPhysics.degToRad(35);
  protected static Vector3d VIEW_ROTATION = new Vector3d(VIEW_ANGLE, VIEW_ANGLE, 0);

  //protected BDemoAutoJoints autoJ;
  protected BGeneralEditPanel editPanel;
  protected BProfileTextPanel profileTextPanel;
  protected BBotAnalystPanel analystPanel;



  protected BComponentAttributeViewer attribs = 
    new BComponentAttributeViewer(res, "attribs");

  // protected Color3f oldCanvasColor;

  public BGeneralPanel
  (
    BWorkshopScreen parent,
    B3DBotCanvas canvas,
    BBot bot
  )
  {
    super(parent, "Profile", canvas, bot);

    editPanel = new BGeneralEditPanel();
    openToolPanel(editPanel);

    profileTextPanel = new BProfileTextPanel();
    openToolPanel(profileTextPanel);

    analystPanel = new BBotAnalystPanel();
    openToolPanel(analystPanel);


    layoutGeneralPanelChildren();
    configGeneralPanelChildren();

    yRotator = new B3DCanvasYRotator( 0.01 );
    //autoJ = new BDemoAutoJoints(bot);

    // Initialize component library...

    res.cleanse();
    res = null;


  }






  protected void layoutGeneralPanelChildren()
  {

  }


   protected void configGeneralPanelChildren()
  {
   // Disable select and component rotate modes..
    select.setEnabled(false);
    rotate.setEnabled(false);
    translate.setEnabled(false);
    zoom.setEnabled(false);


    rotc.setEnabled(false);
    rotj.setEnabled(false);

    rotc.setVisible(false);
    rotj.setVisible(false);

  }



  public void onActivate()
  {
    ((BWorkshopScreen)parent).autosave();

    super.onActivate();

    // canvas appearance
    canvas.setFloor(canvas.getSmallGrid());
    
    // oldCanvasColor = canvas.getBackground3f();
    // canvas.setBackground(BGlobal.colors.getDarkestShade3f());

    Vector3d viewZoom = canvas.getViewTranslation();
    float r = bot.getBoundingRadius();
    viewZoom.z = r*3;
    canvas.setViewTranslation( viewZoom );

    canvas.setViewRotation(VIEW_ROTATION);
    canvas.setViewFromParameters();
    canvas.setEnabled(false);

    // animations
    workshop.getAnimator().add(yRotator);
   // workshop.getAnimator().add(autoJ);

    setDefaultMode();
  }

  public void onDeactivate()
  {

    canvas.setEnabled(true);
    workshop.getAnimator().remove(yRotator);
   // workshop.getAnimator().remove(autoJ);

    // save stuff
    onSaveBegin();

    super.onDeactivate();


  }

   public void onSaveBegin()
   {
      editPanel.onSaveBegin();
      profileTextPanel.onSaveBegin();
   }

    public void onSaveEnd()
   {
      editPanel.onSaveEnd();

   }






  // internal classes
  //----------------------------------------------------------

  class BProfileTextPanel extends BToolPanel
  {
    /**
	 * 
	 */
	private static final long serialVersionUID = -1L;

	protected BUIResources res = new BUIResources( new Object[]
    {

    });

    protected BTextArea description = new BTextArea(this.res, "text");

    public BProfileTextPanel()
    {
      super(BGeneralPanel.this, "Summary");

      // TODO make into a BBot Constant when I can check out BBot.

      // description.setFieldSize(500);
      description.setWrapStyleWord(true);
      description.setLineWrap(true);
      description.setText(bot.getBotDescription() );

      layoutTextChildren();
      
    }

     protected void layoutTextChildren()
    {

      addSmallMargin();
      add(description);

    }

    public void onSaveBegin()
    {
      bot.setBotDescription(description.getText() );

    }

  }

  class BBotAnalystPanel extends  BToolPanel
  {
    /**
	 * 
	 */
	private static final long serialVersionUID = -1L;

	protected BUIResources res = new BUIResources( new Object[]
    {

      "analyzeButton.text",             "Analyze bot.",
      "analyzeButton.height",            new Integer(20),

      "warningTitle.text",               "analysis results.",

      "botWarnings.height",               new Integer (200),

      "warningDescription.height",        new Integer(100),
    });

    protected BButton analyzeButton            = new BButton(res, "analyzeButton");

    protected BLabel warningTitle              = new BLabel(res, "warningTitle");
    protected BList botWarnings                = new BList(res, "botWarnings");
    protected BMultiLabel warningDescription   = new BMultiLabel(res, "warningDescription");


    public BBotAnalystPanel()
    {
      super(BGeneralPanel.this, "Analysis");
      layoutAnalystChildren();
      configureAnalystChildren();
    }

    public void layoutAnalystChildren()
    {
      addHGlued(analyzeButton);
      addSmallMargin();
      addHGlued(warningTitle);
      addHGlued(new BLine() );
      addHGlued(botWarnings);
      addGlue();
      addHGlued(warningDescription);

    }

    public void onDeactivate()
    {
      if (lastBotWarning != null)
        lastBotWarning.setHighlight(false);

      super.onDeactivate();

    }

    public void onActivate()
    {
      super.onActivate();

      if (lastBotWarning != null)
        lastBotWarning.setHighlight(true);

    }

    public void configureAnalystChildren()
    {
     analyzeButton.addActionListener( new AnalyzeListener() );
     botWarnings.addListSelectionListener(new WarningListSelectionListener() );

    // botWarnings.setModel(v);
    }

    BBotWarning lastBotWarning;

    class WarningListSelectionListener implements ListSelectionListener
    {
      public void valueChanged(ListSelectionEvent e)
      {
        if ( botWarnings.getSelectedValue() == null)
        {
          if (lastBotWarning != null)
            lastBotWarning.setHighlight(false);

          warningDescription.setText("");
          lastBotWarning = null;
          
        }
        else
        {
          if (lastBotWarning != null)
            lastBotWarning.setHighlight(false);

          if ( botWarnings.getSelectedValue() instanceof BBotWarning)
          {
            BBotWarning bw = (BBotWarning) botWarnings.getSelectedValue();
            warningDescription.setText(bw.getDescription() );
            bw.setHighlight(true);
            lastBotWarning = bw;

          }


        }

      }
    }

    protected class AnalyzeListener implements ActionListener
    {
      public void actionPerformed(ActionEvent e)
      {
        Vector v = bot.validate(false);

        //botWarnings.clear();
        DefaultListModel l = new DefaultListModel();
        for (int i = v.size() - 1; i >=0; i--)
          l.addElement(v.get(i) );

        if (v.size() == 0)
          l.addElement("No errors found.");

        botWarnings.setModel(l);



      }

    }

  }


  class BGeneralEditPanel extends  BToolPanel
  {
    /**
	 * 
	 */
	private static final long serialVersionUID = -1L;

	protected int LEFT_COLUMN_WIDTH = 80;

    protected BUIResources res = new BUIResources( new Object[]
    {
      "nameLabel.text",             "Bot name: ",
      "nameLabel.h_align",          new Integer(RIGHT),
      "nameLabel.width",            new Integer(LEFT_COLUMN_WIDTH),

      "nameField.text",             "",
      "nameField.h_align",          new Integer(RIGHT),
      "nameField.fieldsize",        new Integer(BBot.MAX_NAME_LENGTH),

      "startMoveLabel.text",        "Start move: ",
      "startMoveLabel.tooltip",     "This bots pre-battle taunting move.",
      "startMoveLabel.h_align",     new Integer(RIGHT),
      "startMoveLabel.width",       new Integer(LEFT_COLUMN_WIDTH),

      "startMoveCombo.tooltip",     "This bots pre-battle taunting move.",

      "victoryMoveLabel.text",      "Victory move: ",
      "victoryMoveLabel.tooltip",   "The move executed when the bot wins a battle.",
      "victoryMoveLabel.h_align",   new Integer(RIGHT),
      "victoryMoveLabel.width",     new Integer(LEFT_COLUMN_WIDTH),

      "victoryMoveLabel.tooltip",   "The move executed when this bot wins a battle.",

      "chassisAttibLabel.text",      "Chassis attributes: ",
      "chassisAttibLabel.width",     new Integer(200),

    });


    protected BLabel nameLabel            = new BLabel(res, "nameLabel");
    protected BTextField nameField        = new BFilenameField(res, "nameField");

    protected BLabel startMoveLabel       = new BLabel(res, "startMoveLabel");
    protected BComboBox startMoveCombo    = new BComboBox(res, "startMoveCombo");

    protected BLabel victoryMoveLabel     = new BLabel(res, "victoryMoveLabel");
    protected BComboBox victoryMoveCombo  = new BComboBox(res, "victoryMoveCombo");

    protected BLabel chassisAttibLabel    = new BLabel(res, "chassisAttibLabel");
    protected BLine  line                 = new BLine();

    public BGeneralEditPanel()
    {
      super(BGeneralPanel.this, "Profile");

      nameField.addFocusListener(new BBotNameVerifier( nameField ));

      layoutEditChildren();


    }

    protected void layoutEditChildren()
    {

      addSmallMargin();
      addLinear(nameLabel, getHStrut(TINY_MARGIN), nameField);

      addBigMargin();
      addLinear(startMoveLabel, getHStrut(TINY_MARGIN), startMoveCombo);
      addSmallMargin();
      addLinear(victoryMoveLabel, getHStrut(TINY_MARGIN), victoryMoveCombo);

      addBigMargin();

      addLinear(chassisAttibLabel, Box.createHorizontalGlue());
      addHGlued(line);
      addTinyMargin();
      add(attribs);





    }

    public void onActivate()
    {
      super.onActivate();
      nameField.setText(bot.getName());
      attribs.setComponent(bot.getChassis());

      BMoveList mList =  bot.getMoveList();
      Vector editingVector = new Vector(mList.getMoves());
      editingVector.insertElementAt(new String("<NONE>"), 0);

      startMoveCombo.setModel( new DefaultComboBoxModel(editingVector) );
      if (mList.getStartMove() != null)
        startMoveCombo.setSelectedItem(mList.getStartMove());


      victoryMoveCombo.setModel(  new DefaultComboBoxModel( editingVector ) );
      if (mList.getVictoryMove() != null)
        victoryMoveCombo.setSelectedItem(mList.getVictoryMove());


    }

    public void onSaveBegin()
    {
      if (this.isActive() )
      {
        if ( startMoveCombo.getSelectedIndex() != 0 )
          bot.getMoveList().setStartMove( (BMove) startMoveCombo.getSelectedItem() );
        else
          bot.getMoveList().setStartMove(null);

        if ( victoryMoveCombo.getSelectedIndex() != 0 )
          bot.getMoveList().setVictoryMove( (BMove) victoryMoveCombo.getSelectedItem() );
        else
          bot.getMoveList().setVictoryMove(null);
      }
      
    }

    public void onSaveEnd()
    {
      nameField.setText(bot.getName());
    }



    
   class BBotNameVerifier implements FocusListener
   {
      JTextField parent;

      public BBotNameVerifier( JTextField parent)
      {
        this.parent = parent;
      }


      public  void focusGained(FocusEvent e)
        {}

      public void focusLost(FocusEvent e)
      {

        if (! parent.getText().equalsIgnoreCase(bot.getName() ) )
        {
          BProcessor p = new BProcessor()
          {
            public void process()
              { validateAndSave(); }
          };

          p.start();


        }
      }

      private void validateAndSave()
      {
        String name =
            BStrings.convertToFilename(parent.getText());

          String fileName =
            BGlobal.BOTPATH+ name+ BGlobal.BOTSUFFIX;

          File f = new File(fileName);

          if (!f.exists())
            renameBot(f);
          else
          {
            BPromptDialog replaceDialog =
              BPromptDialog.createYesNoDialog
              (
                "replace bot...",
                "A bot called '"+ parent.getText()+ "' already exists."+ "\n"+
                "Replace it with this bot?"
              );

            BApplication.showDialog(replaceDialog);

            boolean isReplacing =
              replaceDialog.getResult();

            if (isReplacing)
            {
              f.delete();
              renameBot(f);
            }
            else
              parent.setText(bot.getName() );

          }

      }

      private void renameBot(File newFile)
      {



        String name =
            BStrings.convertToFilename(bot.getName() );

        String fileName =
            BGlobal.BOTPATH+ name+ BGlobal.BOTSUFFIX;

        bot.setName(parent.getText() );

        BDebug.print ("Renaming " + fileName + " to " + newFile);
        File f = new File(fileName);
        f.renameTo(newFile);

        workshop.saveBot(bot.getName());



      }


   }



  }

   // rotation animation
  class B3DCanvasYRotator implements BAnimation
  {
    Vector3d rVector;
    double deltaY;

    public B3DCanvasYRotator (double deltaY)
      { this.deltaY = deltaY;}

    public void start()
      {  rVector = canvas.getViewRotation();  }

    public void stop()
      {canvas.setViewRotation(rVector); }

    public boolean animate()
    {
      if (canvas == null)
        return false;

      rVector.y = rVector.y + deltaY;

      if (rVector.y < 0)
        rVector.y += BPhysics.TWO_PI;
      else if (rVector.y > BPhysics.TWO_PI)
        rVector.y -= BPhysics.TWO_PI;


      canvas.setViewRotation(rVector);
      canvas.setViewFromParameters();
      return true;
    }


  }

  public void onClose()
  {

      //autoJ = null;
      editPanel = null;
      profileTextPanel = null;

      attribs = null;
      super.onClose();

  }



}