package roboforge.ui;

/*
* File:
* BScreen.java
*
* Description:
* Ancestor for all application screens.
*
* Modification History: ( Name, Date, Notes )
* Created SJS, 28/01/2000.
*
*/

import roboforge.BDebug;
import roboforge.BGlobal;

import roboforge.BGhost;
import roboforge.BGhostable;

import roboforge.ui.components.BPanel;
import roboforge.ui.layers.*;
import roboforge.ui.events.*;

import java.awt.*;
import javax.swing.*;



public class BScreen extends BPanel 
  implements BLayer, BGhost
{

  // Member variables...
  // -------------------------------------------------------------

  protected BActivationSupport activation
    = new BActivationSupport(this);



  // Constructors.
  // -------------------------------------------------------------

  public BScreen()
  {
    super();

    // Set this panel to cover the whole screen.
    Dimension d = BGlobal.SCREEN_RESOLUTION;
    setSize(d);

    setBackground(Color.black);

    // Screens are opaque, by default.
    setOpaque(true);
  }

  public boolean isFocusCycleRoot()
    { return true; }



  // Layer methods...
  // -------------------------------------------------------------

  public void addTo(JComponent holder)
  {
    holder.add(this);
    setVisible(true);
    requestFocus();
  }

  public void removeFrom(JComponent holder)
  {
    setVisible(false);
    holder.remove(this);
  }

  public boolean isAlwaysOnTop()
    { return false; }


  
  // Windowing methods...
  // -------------------------------------------------------------
  
  /*
  public void close()
    { BApplication.closeScreen(this); }

  public void hide()
    { BApplication.hideScreen(this); }
  */
  
  
  
  // Ghosting methods...
  // -------------------------------------------------------------
  
  public BGhost createGhost()
    { return this; }
  
  public Object resurrect()
    { return this; }
  
  public void banish()
    { requestClose(); }

  

  // Activation methods...
  // -------------------------------------------------------------

  public boolean isActive()
    { return activation.isActive(); }

  public boolean isClosed()
    { return activation.isClosed(); }

  public void requestActivate()
    { activation.requestActivate(); }

  public void requestDeactivate()
    { activation.requestDeactivate(); }

  public void requestClose()
    { activation.requestClose(); }

  public void onActivate()
    { activation.fireActivate(); }

  public void onDeactivate()
    { activation.fireDeactivate(); }

  public void onClose()
  {
    activation.fireClose();
    super.onClose();
    activation = null;
  }
    
  public void addActivationListener(BActivationListener l)
    { activation.addActivationListener(l); }

  public void removeActivationListener(BActivationListener l)
    { activation.addActivationListener(l); }

}
