package roboforge.ui.ai;

import roboforge.ai.decisions.*;
import roboforge.ui.components.BLabel;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.tree.*;


// DefaultTreeCellEditor
public class BDecisionTreeEditor extends DefaultTreeCellEditor
{

  public BDecisionTreeEditor(JTree tree, DefaultTreeCellRenderer renderer)
    { super(tree, renderer); }

  
  protected void determineOffset
  (
    JTree tree, Object value, boolean isSelected,
    boolean expanded, boolean leaf, int row
  )
  {
    if ( !(value instanceof BDecisionTreeNode))
      throw new IllegalArgumentException(
        "BDecisionTreeEditor.determineOffset(): "+
        "value is not an instance of BDecisionTreeNode.");

    BDecisionTreeNode node = (BDecisionTreeNode) value;

    if (isSelected)
      editingIcon = node.getSelectedIcon();
    else
      editingIcon = node.getIcon();

    if (renderer != null)
    {
      if (editingIcon != null)
	  	  offset = /* renderer.getIconTextGap() + */ editingIcon.getIconWidth();
      else
		    offset = renderer.getIconTextGap();
    }
    else
      offset = editingIcon.getIconWidth();
	}


}