package roboforge.ui.ai;

import roboforge.BBot;

import roboforge.BDebug;
//import roboforge.BZones;

import roboforge.ai.BDecisionTreeAI;
import roboforge.ai.actions.*;
import roboforge.ai.decisions.*;
import roboforge.ai.expressions.*;
import roboforge.ai.values.*;
import roboforge.ui.components.*;


import roboforge.util.graphics.*;
import java.awt.Dimension;

import roboforge.BGlobal;

import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.DefaultComboBoxModel;

import java.util.Hashtable;

import javax.swing.*;

/*
  A panel that displays world item decisions that can be expressed as a multi
  boolean
  */

public class BMultiBooleanPanel extends BSimpleDecisionPanel implements ActionListener
{
  protected BUIResources res = new BUIResources( new Object[]
  {
    "titleIcon.foreground",         colors.getMidShade(),
    "titleIcon.size",               new Dimension(40, 40),

    "titleLabel.text",              "",
    "titleLabel.width",             new Integer(200),
    "titleLabel.fontsize",          new Integer(14),
    "titleLabel.height",            new Integer(20),
    "titleLabel.fontstyle",         new Integer(Font.BOLD),
    "titleLabel.v_align",           new Integer(SwingConstants.BOTTOM),

    "itemLabel.text",               "",
    "itemLabel.width",              new Integer(200),

    "stimLabel.text",               "Stimulant",
    "stimLabel.width",              new Integer(200),

    "smallLine.width",              new Integer(10),

    "infoLabel.text",               "",
    "infoLabel.width",              new Integer(220),

    "optionCombo2.tooltip",         "Stimulant",
  });



  // hashtable containing world item refs mathched with actual words
  protected Hashtable optionTable = new Hashtable(7, 0.75f);

  //-------------- variable between different ref types
  private String title;
  private HSBImageIcon image;
  private String [] options;
  //---------------------------------------------------

  private static BMultiBooleanPanel instance = null;

  protected BBorderedIcon typeImage;

  protected BComboBox optionCombo = new BComboBox(res, "optionCombo");
  protected BComboBox optionCombo2 = new BComboBox(res, "optionCombo2");

  protected BLabel titleLabel = new BLabel(res, "titleLabel");
  protected BButton titleIcon = new BButton(res, "titleIcon")
  {
    protected void processMouseEvent(MouseEvent e)
    {}
  };
  
  protected BLabel itemLabel = new BLabel(res, "itemLabel");
  protected BLabel stimLabel = new BLabel(res, "stimLabel");

  protected BLabel infoLabel = new BLabel(res, "infoLabel");

  protected BLine titleLine = new BLine();
  protected BLine smallLine = new BLine(res, "smallLine");

  protected boolean initialized = false;

  protected String optionString = "";
  protected String optionString2 = "";

  //protected BZones zones;
  //protected Vector zoneList;

  // constructor
  public BMultiBooleanPanel()
  {
    super("decision");
    //super(title);

    layoutPanelChildren();
    configPanelChildren();
  }

  protected void layoutPanelChildren()
  {
    BBoxPanel mainBox = createHBoxPanel();
    BBoxPanel leftBox = createVBoxPanel();
    BBoxPanel iconBox = createHBoxPanel();
    BBoxPanel lineBox = createVBoxPanel();
    BBoxPanel rightBox = createVBoxPanel();
    BBoxPanel operatorBox = createHBoxPanel();

    titleIcon.setHorizontalAlignment(BLabel.CENTER);

    leftBox.add(iconBox);
    leftBox.addGlue();

    iconBox.add(titleIcon);
    iconBox.add(lineBox);

    lineBox.addVStrut(1);
    lineBox.addSmallMargin();
    lineBox.add(smallLine);

    rightBox.addHGlued(titleLabel);
    rightBox.addTinyMargin();
    rightBox.addHGlued(titleLine);
    rightBox.addMargin();
    rightBox.addHGlued(itemLabel);
    rightBox.add(optionCombo);
    rightBox.addMargin();
    rightBox.addHGlued(stimLabel);
    rightBox.add(optionCombo2);
    rightBox.addMargin();
    rightBox.addHGlued(infoLabel);
    rightBox.addGlue();

    mainBox.add(leftBox);
    mainBox.add(rightBox);
    add(mainBox);
 }


  protected void configPanelChildren()
  {
    optionCombo.addActionListener(this);
    optionCombo2.addActionListener(this);
  }

  public void actionPerformed(ActionEvent e)
  {
    if(this.isActive())
    {
      if(e.getSource() == optionCombo)
        if(optionCombo.getSelectedItem() != null)
          optionString = optionCombo.getSelectedItem().toString();

      if(e.getSource() == optionCombo2)
        if(optionCombo2.getSelectedItem() != null)
          optionString2 = (String)optionCombo2.getSelectedItem();

      if(initialized)
      {
        updateInfo();
        //setNodeFromPanel();
      }
    }
  }

  // setup the AI
  public void setAI(BDecisionTreeAI ai)
  {
    super.setAI(ai);

    BBot bot  = ai.getBot();
    //zones  =  bot.getZones();

    //bot.getZones().addListDataListener( new ZonesChangeListener() );
    refreshCombo();

    //if (zones.size() > 0)
    //  optionString = zones.getZones().elementAt(0).toString();
    //else
    //  optionString = "";
  }

  // refresh the zone combo box
  public void refreshCombo()
  {
  }


  // save the data from the panel to the node
  protected void setNodeFromPanel()
  {
    if(node != null)
    {
      //BDebug.print ("BMutilBooleanPanel setNodeFromPanel setting worldRef " + optionTable.get(optionString2) );
      node.setWorldItemRef((String)optionTable.get(optionString2));
      node.setValueRef(new BString(optionString));
      String exp = "[" + optionString + optionTable.get(optionString2) + "]";
      updateNodeExpression(exp);

      // setr nice name
      //node.setName(title);
      node.setName(optionString + " " + optionString2 + "?");

    }
  }

  // set up the panel data from the node
  protected void setPanelFromNode(BDecisionTreeNode n)
  {
    if(initialized)
    {
      refreshCombo();

      this.node = (BSimpleDecisionNode)n;

      //BDebug.print ("BMutilBooleanPanel setPanelFromNode recieveing " + node.getWorldItemRef());
      //BDebug.print ("BMutilBooleanPanel setPanelFromNode parsed " + optionTable.get(node.getWorldItemRef()));

      optionCombo2.setSelectedItem(optionTable.get(node.getWorldItemRef()));

      optionString = ((BString)node.getValueRef()).getValue();
      optionString2 = (String)optionTable.get(node.getWorldItemRef());

      updateInfo();
    }
  }

  public static BAINodePanel getInstance()
  {
    if (instance == null)
      instance = new BMultiBooleanPanel();

    return instance;
  }

  // updates the useful message at the base of the panel
  protected void updateInfo()
  {
  }

  // sets the panel data from a simple number data object
  protected void setData(BSimpleDecisionData data)
  {
    initialized = false;
    image = data.getIcon();
    title = data.getTitle();
    options = data.getOptions();

    titleLabel.setText(title);
    titleIcon.setIcon(data.getIcon());

    // clear the comboBox and hashtable
    //optionCombo.removeAllItems();
    optionCombo2.removeAllItems();
    optionTable.clear();

    // fill the comboBox and hashtable
    for (int i = 0; i < options.length; i += 2)
    {
      optionTable.put(options[i], options[i+1]);
      optionTable.put(options[i+1], options[i]);
      optionCombo2.addItem(options[i + 1]);
    }
    optionString2 = options[1];
    initialized = true;
  }

  public void onClose()
  {
    instance = null;
  }

  public static void clearInstance()
    { instance = null; }



}