package roboforge.ui.components;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.*;

import javax.swing.Icon;

public class BBorderedIcon implements Icon
{
  private Color borderColor;
  private Icon innerIcon;
  private int borderGap;
  private boolean drawBackground;
  private static int ARC = 5;
  private static int DEFAULTSIZE = 28;


  public BBorderedIcon(Color borderColor, Icon innerIcon, int borderGap, boolean drawBackground)
  {
    this.borderColor =  borderColor;
    this.innerIcon = innerIcon;
    this.borderGap = borderGap;
    this.drawBackground = drawBackground;
  }

  public void paintIcon(Component c, Graphics g, int x, int y)
  {

    if (drawBackground)
    {
      Color temp = g.getColor();
      g.setColor(borderColor.darker().darker().darker().darker());
      if (innerIcon == null)
        g.fillRoundRect(x,y, DEFAULTSIZE, DEFAULTSIZE,ARC,ARC);
      else
        g.fillRoundRect(x,y, getIconWidth()-1, getIconHeight()-1,ARC,ARC);
      g.setColor(temp);
    }

    if (innerIcon != null)
      innerIcon.paintIcon(c, g, x + borderGap, y + borderGap);

    if (borderColor != null)
      g.setColor(borderColor);

    if (innerIcon == null)
      g.drawRoundRect(x,y, DEFAULTSIZE, DEFAULTSIZE,ARC,ARC);
    else
      g.drawRoundRect(x,y, getIconWidth()-1, getIconHeight()-1,ARC,ARC);

  }


  public void setBorderColor(Color borderColor)
    { this.borderColor = borderColor; }

  public  int getIconWidth()
  {
    if (innerIcon == null)
      return DEFAULTSIZE;
    return
      innerIcon.getIconWidth() + ( borderGap * 2);
  }

    /**
     * Returns the icon's height.
     *
     * @return an int specifying the fixed height of the icon.
     */
  public int getIconHeight()
  { if (innerIcon == null)
      return DEFAULTSIZE;

    return innerIcon.getIconHeight()+ ( borderGap * 2);
  }



}