package roboforge.ui.components;

//import roboforge.BDebug;
//import roboforge.BGlobal;

import javax.swing.JButton;
import javax.swing.AbstractButton;
import javax.swing.Icon;

import java.awt.Component;
//import java.awt.Font;
//import java.awt.event.*;



public class BButton extends JButton
{

  /*
  protected ClickSoundListener click =
    new ClickSoundListener();

  protected String clickSound;
  */
  
  
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
protected boolean focusTraversable = true;
  protected boolean isShowingText    = true;
  
  
  
  // Constructor.
  // -------------------------------------------------------------

  public BButton(BUIResources res, String resourceKey)
  {
    super();
    initializeUI(res, resourceKey);
  }

  public BButton()
    { this(null, null); }

  public BButton(String text)
  {
    super();
    setText(text);
    initializeUI(null, null);
  }

  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    // setOpaque(false);
    
    // click.install(this);
    // clickSound = "button.click";

    if (res != null)
    {
      res.initComponent((AbstractButton) this, key);
      
      Boolean showText =
        (Boolean) res.get(key+ ".showText");
      
      if (showText != null)
        setShowingText(showText.booleanValue());
      
      // String cs = res.getString(key+ ".clickSound");
      // if (cs != null)
      //   clickSound = cs;
    }

    
    // Set centered alignment, for correct BoxLayout display...
    setAlignmentX(Component.CENTER_ALIGNMENT);
    setAlignmentY(Component.CENTER_ALIGNMENT);
  }

  public void setFocusTraversable(boolean b)
    { focusTraversable = b; }

  public boolean isFocusTraversable()
    { return focusTraversable; }


  public void setIcon(Icon icon)
  {
    super.setIcon(icon);

    if (icon instanceof HSBImageIcon)
      setDisabledIcon(icon);
  }
  
  public void setShowingText(boolean s)
  {
    this.isShowingText = s;
    
    if (!isShowingText)
      super.setText(null);
  }
  
  public boolean isShowingText()
    { return isShowingText; }
  
  
  public void setText(String text)
  { 
    if (isShowingText)
      super.setText(text);
  }
  
  
  /*
  protected static class ClickSoundListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      BButton source = 
        (BButton) e.getSource();
      
      // BUISounds.play(source.clickSound);
    }
    
    public void install(BButton b)
      { b.addActionListener(this); }
  }
  */

}
