package roboforge.ui.components;

import roboforge.BGlobal;
import roboforge.util.io.*;

import java.io.*;
import java.util.TreeSet;
import java.util.Iterator;


public class BFileComboBox extends BComboBox
{
  protected String path;
  protected String[] files;

  protected BFilenameFilter filter;

  // protected String mask;

  public BFileComboBox()
    { this(null, null); }

  public BFileComboBox(BUIResources res, String key)
    { this(res, key, new BInternalFilter()); }

  public BFileComboBox(BUIResources res, String key, BFilenameFilter filter)
  {
    super(res, key);
    this.filter = filter;
  }

  /*
  public void setFilteredExtension(String ext)
  {
    filter.addExtension(ext);
    mask = ext;
  }
  */

  public void setFilter(BFilenameFilter filter)
  {
    this.filter = filter;

    try
    {
      if (path != null)
        setSourcePath(path);
    }
    catch (FileNotFoundException e)
      { }
  }


  public void setSourcePath(String path)
    throws FileNotFoundException
  {
    removeAllItems();

    this.path = path;

    // Load the files in this path.
    File file = new File(path);


    if (!file.canRead())
      throw new FileNotFoundException("BFileComboBox.setSourcePath: path ["+path+"] does not exist!");

    files = file.list(filter);

    String [] files2 = new String [files.length];

    TreeSet sortSet = new TreeSet() ;

    for (int i = files.length-1 ; i >= 0 ; i-- )
      sortSet.add(files[i]);

    int i = 0;
    for (Iterator it = sortSet.iterator(); it. hasNext()   ; )
    {
      String name = (String)it.next();
      addItem(toDisplayable(name));
      files2[i] = name;
      //files[i] = name;
      i++;
    }

    files = files2;
    //for(int i=0; i<files.length; i++)
    //  addItem(toDisplayable(files[i]));


    /* COPIED FROM BLIST
        File file = new File(path);

    if (!file.canRead())
      throw new FileNotFoundException("BFileList.setSourcePath: path ["+path+"] does not exist!");

    files = file.list(filter);

    model.removeAllElements();

    // sort the files alphabetically
    TreeSet sortSet = new TreeSet() ;

    for (int i = files.length-1 ; i >= 0 ; i-- )
      sortSet.add(files[i]);

    int i = 0;
    for (Iterator it = sortSet.iterator(); it. hasNext()   ; i++ )
    {
      String name = (String)it.next();
      model.addElement(toDisplayable(name));
      files[i] = name;

    }
    */
  }

  protected String toDisplayable(String file)
    { return filter.toDisplayable(file); }

  /*
  protected String toFileName(String display)
  {
    if (mask != null)
      return display + mask;
    else
      return display;
  }
  */

  protected String toFileName(int index)
  {
    if (index == -1)
      return null;
    else if (files != null)
      return files[index];
    else
      return null;
  }


  public String getSourcePath()
    { return path; }

  public boolean isEmpty()
    { return (getItemCount() == 0); }

  public String getFileAt(int index)
    { return toFileName(index); }

  public String getSelectedFile()
    { return toFileName(getSelectedIndex()); }

  public String getSelectedFileWithPath()
    { return path+ getSelectedFile(); }

  public String getSelectedFileWithPathNoExt()
    { return path+ (String) getSelectedItem(); }

  public void setSelectedFile(String file)
  {
    for(int i=0; i<getItemCount(); i++)
      if (getItemAt(i).equals(file))
      {
        setSelectedIndex(i);
        return;
      }
  }

}