package roboforge.ui.components;

import java.util.Vector;
import javax.swing.AbstractListModel;
import javax.swing.DefaultListModel;

public class BListModel
  extends    AbstractListModel
  implements BMutableListModel
{
  protected Vector data;

  public BListModel()
  {
    super();
    this.data = new Vector();
  }

  public BListModel(Vector data)
  {
    super();
    this.data = data;
  }

  public synchronized void setData(Vector data)
    { this.data = data; }

  public void add(Object o)
  {
  	int i = data.size();
  	data.addElement(o);
	  fireIntervalAdded(this, i, i);
  }

  public void addAt(Object o, int i)
  {
  	data.insertElementAt(o, i);
	  fireIntervalAdded(this, i, i);
  }

  public Object getAt(int i)
    { return data.elementAt(i); }

  public Object getElementAt(int i)
    { return data.elementAt(i); }


  public int getSize()
    { return data.size(); }

  public int indexOf(Object o)
    { return data.indexOf(o); }

  public void remove(Object o)
  {
  	int i = indexOf(o);
	  data.removeElement(o);
  	if (i >= 0)
	    fireIntervalRemoved(this, i, i);
  }

  public void removeAt(int i)
  {
  	data.removeElementAt(i);
	  fireIntervalRemoved(this, i, i);
  }

  public boolean isRemoveable(Object o)
    { return true; }

  public boolean isRemoveableAt(int i)
    { return true; }
    
  public void notifyChange(Object o)
  {
    int i = data.indexOf(o);
    if (i != -1)
      fireContentsChanged(this, i, i);
  }

  public void notifyChange()
    { fireContentsChanged(this, -1, -1); }


}
