package roboforge.ui.components;

import roboforge.ui.modes.*;
import roboforge.ui.B3DCanvas;

import java.awt.Dimension;
import java.awt.event.*;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;



public class BModeButton extends BToggleButton
{


  // Class variables...
  // -------------------------------------------------------------

  protected static final Dimension SIZE =
    new Dimension(31, 31);

  protected BModeMouse mode;
  protected B3DCanvas  canvas;


  // Constructor.
  // -------------------------------------------------------------

  public BModeButton(BUIResources res, String key)
    { super(res, key); }


  // Initialization helper...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    super.initializeUI(res, key);

    setMinimumSize(SIZE);
    setMaximumSize(SIZE);
    setPreferredSize(SIZE);
    
    setShowingText(false);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public void setMode(BModeMouse mode, B3DCanvas canvas)
  {
    this.mode    = mode;
    this.canvas  = canvas;

    ActionListener l = new ModeListener();
    addActionListener(l);
    
    CanvasListener c = new CanvasListener();
    canvas.addPropertyChangeListener(c);
  }

  public BModeMouse getMode()
    { return mode; }


  
    
  // UI Listeners...
  // -------------------------------------------------------------

  protected class ModeListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
      { canvas.setMode(mode); }
  }

  protected class CanvasListener implements PropertyChangeListener
  {
    public void propertyChange(PropertyChangeEvent e)
    {
      if (e.getPropertyName().equalsIgnoreCase("mode"))
      {
        BModeMouse old = 
          (BModeMouse) e.getOldValue();

        BModeMouse cur = 
          (BModeMouse) e.getNewValue();
      
        if (old == mode)
          BModeButton.this.setSelected(false);
      
        if (cur == mode)
          BModeButton.this.setSelected(true);
      }
    }
  }

}
