package roboforge.ui.components;

import roboforge.BGlobal;

import java.awt.Component;
import java.awt.Font;
import javax.swing.JRadioButton;
import javax.swing.AbstractButton;

public class BRadioButton extends JRadioButton
{

  // Constructor.
  // -------------------------------------------------------------

  public BRadioButton(BUIResources res, String resourceKey)
  {
    super();
    initializeUI(res, resourceKey);
  }

  public BRadioButton(String label)
  {
    super(label);
    initializeUI(null, null);
  }

  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    setOpaque(false);

    if (res != null)
      res.initComponent((AbstractButton) this, key);

    // Set centered alignment, for correct BoxLayout display...
    setAlignmentX(Component.CENTER_ALIGNMENT);
    setAlignmentY(Component.CENTER_ALIGNMENT);
  }

}