package roboforge.ui.components;

import roboforge.BGlobal;

import java.awt.Color;
import java.awt.Font;

import javax.swing.border.EmptyBorder;

public class BTitlebarLabel extends BLabel
{

  // UI Resources ...
  // -------------------------------------------------------------

  protected BUIResources res = new BUIResources( new Object[]
  {
    "title.background",      BGlobal.colors.getDarkerShade(),
    "title.border",          new EmptyBorder(0,8,0,0),
    "title.foreground",      BGlobal.colors.getMidShade(),
    "title.font",            new Font("Dialog", Font.BOLD, 11),
    "title.height",          new Integer(20),
    "title.opaque",          new Boolean(true),
    "title.v_align",         ALIGN_CENTER
  });



  // Constructor...
  // -------------------------------------------------------------

  public BTitlebarLabel()
    { this(null, null, null); }

  public BTitlebarLabel(BUIResources res, String key)
    { this(res, key, null); }

  public BTitlebarLabel(String text)
    { this(null, null, text); }

  public BTitlebarLabel(BUIResources res, String key, String text)
  {
    super();

    // Apply our specific formatting...
    super.initializeUI(this.res, "title");

    // Apply any overriding formatting...
    super.initializeUI(res, key);

    if (text != null)
      setText(text);

    this.res.cleanse();
    this.res = null;
  }

}
