package roboforge.ui.components;

import java.util.Vector;

import javax.swing.JTree;
import javax.swing.tree.*;

import java.util.*;
                         
public class BTree extends JTree
{

  // Constructor.
  // -------------------------------------------------------------

  public BTree()
    { this(null, null); }

  public BTree(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BTree(Vector v)
  {
    super(v);
    initializeUI(null, null);
  }

  public BTree(TreeModel m)
  {
    super(m);
    initializeUI(null, null);
  }

  public BTree(TreeNode n)
  {
    super(n);
    initializeUI(null, null);
  }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    if (res != null)
      res.initComponent(this, key);
  }


  // Helper methods...
  // -------------------------------------------------------------

  protected void selectNode(TreeNode node)
  {
    if (node != null)
      selectionModel.setSelectionPath(getPath(node));
  }

  protected void expandNode(TreeNode node)
  {
    if (node != null)
      expandPath(getPath(node));
  }


  protected TreePath getPath(TreeNode node)
    { return new TreePath(getNodesToRoot(node, 0)); }

  protected TreeNode[] getNodesToRoot(TreeNode node, int depth)
  {
	  TreeNode[] result;

  	if (node == null)
    {
	    if (depth == 0)
		    return null;
	    else
    		result = new TreeNode[depth];
  	}
	  else
    {
	    depth++;
	    result = getNodesToRoot(node.getParent(), depth);
	    result[result.length - depth] = node;
  	}

	  return result;
  }

  public void expandChildren(DefaultMutableTreeNode node)
  {

    Enumeration e = node.depthFirstEnumeration();
    TreePath rootPath = new TreePath( node );

    while (e.hasMoreElements() )
    {
      DefaultMutableTreeNode currentN = (DefaultMutableTreeNode) e.nextElement();

      if (currentN.isLeaf() )
      {
        makeVisible( new TreePath(currentN.getPath() ));

      }

    }

  }




}