package roboforge.ui.components;

import roboforge.BDebug;

import java.awt.*;
import javax.swing.Icon;

public class BotIcon
  implements Icon, ColorableIcon
{
  protected static final float INSET_RATIO = 0.3f;

  protected int size;
  protected int inset, insetSize;
  protected Color color = Color.white;

  protected BasicStroke stroke;

  public BotIcon(int size)
    { setSize(size); }

  public void setSize(int size)
  {
    this.size = size;
    calculateInset();

    stroke = new BasicStroke(size * 0.1f);
  }

  public void setColor(Color c)
    { this.color = c; }

  public void setUseComponentColor(boolean b)
    { /* IGNORED */ }

  protected void calculateInset()
  {
    inset = (int) (size * INSET_RATIO);
    insetSize = size - (inset * 2) + 1;
  }

  public void paintIcon(Component c, Graphics g, int x, int y)
  {
    Graphics2D g2D = (Graphics2D) g;
    Stroke old = g2D.getStroke();

    setColor(c.getForeground());

    g2D.setColor(color);
    g2D.translate(-0.5, -0.5);
    g2D.fillOval(x+inset, y+inset, insetSize, insetSize);
    g2D.translate(0.5, 0.5);

    g2D.setStroke(stroke);
    g2D.drawOval(x, y, size, size);
    g2D.setStroke(old);
  }

  public int getIconWidth()
    { return size; }

  public int getIconHeight()
    { return size; }

}
