package roboforge.ui.components.table;

import roboforge.BDebug;
import roboforge.BNameable;
import roboforge.ui.components.BTextField;

import java.awt.Component;
import java.awt.event.*;
import java.util.EventObject;
import javax.swing.border.EmptyBorder;

import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.table.*;

public class BNameCellEditor extends DefaultCellEditor
{
  protected BTextField field;

  protected static final EmptyBorder BORDER =
    new EmptyBorder(0, 4, 0, 0);

  public BNameCellEditor()
  {
    super(new BTextField());

    field = (BTextField) editorComponent;
    field.setBorder(BORDER);

    // Uninstall superclass editor delegate...
    field.removeActionListener(delegate);

    // Install name editor delegate...
    delegate = new NameEditorDelegate(field);
  	field.addActionListener(delegate);
  }


  protected class NameEditorDelegate extends EditorDelegate
  {
    protected BNameable item;
    protected BTextField field;

    public NameEditorDelegate(BTextField field)
    {
      super();
      this.field = field;
    }

    public void setValue(Object o)
    {
      item = (BNameable) o;
      if (o != null)
        field.setText(item.toString());
      else
        field.setText("");
    }

    public Object getCellEditorValue()
    {
      item.setName(field.getText());
    	return item;
    }
  }
}