package roboforge.ui.components.table;

import roboforge.ui.BEditable;

import java.util.Vector;
import javax.swing.*;
import javax.swing.table.*;

public class BTableModel extends DefaultTableModel
{

  // Internal variables...
  // -------------------------------------------------------------

  protected boolean defaultEditable = false;


  // Constructors...
  // -------------------------------------------------------------

  public BTableModel()
    { super(); }

  public BTableModel(int numRows, int numColumns)
    { super(numRows, numColumns); }

  public BTableModel(Object[] columnNames, int numRows)
    { super(columnNames, numRows); }

  public BTableModel(Object[][] data, Object[] columnNames)
    { super(data, columnNames); }

  public BTableModel(Vector columnNames, int numRows)
    { super(columnNames, numRows); }

  public BTableModel(Vector data, Vector columnNames)
    { super(data, columnNames); }


  // Accessor methods...
  // -------------------------------------------------------------

  public boolean isCellEditable(int r, int c)
  {
    Object cell = getValueAt(r, c);

    if (cell instanceof BEditable)
      return ((BEditable) cell).isEditable();
    else
      return defaultEditable;
  }

  public boolean isRowRemoveable(int r)
    { return true; }

  public boolean isColumnRemoveable(int c)
    { return true; }

  public void setDefaultEditability(boolean e)
    { this.defaultEditable = e; }

  public boolean getDefaultEditability()
    { return this.defaultEditable; }
}