package roboforge.ui.components.text;

public class BFloatGuard implements BTextGuard
{

  // Constants...
  // -------------------------------------------------------------

  protected static final char MINUS = '-';
  protected static final char PLUS  = '+';
  protected static final char POINT = '.';

  
  // Interface methods...
  // -------------------------------------------------------------
  
  public boolean isValidInsertion(String cur, String ins, int offset)
  {
    boolean hasPoint = 
      (cur.indexOf(POINT) != -1);

    char[] c = ins.toCharArray();

    for (int i=0; i<c.length; i++)
      if (c[i] == POINT)
      {
        if (hasPoint) 
          return false;
        
        hasPoint = true;
      }
      else if (!isValidChar(c[i], offset++))
        return false;
    
    return true;
  }
  
  public boolean isValidDeletion(String cur, int offset, int length)
    { return true; }

  
  
  // Helper methods...
  // -------------------------------------------------------------

  protected boolean isValidChar(char c, int i)
  {
    if (Character.isDigit(c))
      return true;

    if (i == 0)
      if ((c == MINUS) || (c == PLUS))
        return true;

    return false;
  }
}

