package roboforge.ui.console;

import javax.media.j3d.*;
import javax.vecmath.*;


public class BConsoleComponent extends BranchGroup
{

  protected BConsoleComponent parent = null;

  protected int x, y, z;
  protected int width, height;

  protected Vector3d       loc               = new Vector3d();
  protected Transform3D    locTransform      = new Transform3D();
  protected TransformGroup locTransformGroup = new TransformGroup();

  protected boolean isRemoveable = false;
  protected boolean isMoveable   = false;


  public BConsoleComponent()
  {
    super();
    addChild(locTransformGroup);
  }

  public void setParent(BConsoleComponent parent)
    { this.parent = parent; }


  public void setLocation(int x, int y)
  {
    this.x = x;
    this.y = y;
    update3DLocation();
  }

  public void setSize(int w, int h)
  {
    this.width = w;
    this.height = h;
  }

  public void setBounds(int x, int y, int w, int h)
  {
    setLocation(x, y);
    setSize(w, h);
  }

  public int getWidth()
    { return width; }

  public int getHeight()
    { return height; }

  public void cleanse()
    { parent = null; }


  public boolean isRemoveable()
    { return isRemoveable; }

  public void setRemoveable(boolean r)
  {
    this.isRemoveable = r;

    if (isRemoveable)
      this.setCapability(BranchGroup.ALLOW_DETACH);
  }

  public boolean isMoveable()
    { return isMoveable; }

  public void setMoveable(boolean m)
  {
    this.isMoveable = m;

    if (isMoveable)
      locTransformGroup.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
  }



  protected void update3DLocation()
  {
    setLocationVector(loc);

    if (parent != null)
      parent.transformChildLocationVector(this, loc);

    locTransform.set(loc);
    locTransformGroup.setTransform(locTransform);
  }

  protected void setLocationVector(Vector3d v)
    { v.set(this.x, -this.y, this.z); }

  protected void transformChildLocationVector(BConsoleComponent child, Vector3d v)
    { }


}

