package roboforge.ui.console;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.geometry.BRectangle3D;
import roboforge.math.*;

import java.awt.*;

import java.awt.image.BufferedImage;
import java.awt.font.FontRenderContext;
import java.awt.geom.*;

import javax.media.j3d.*;
import javax.vecmath.*;


import com.sun.j3d.utils.geometry.Text2D;


public class BConsoleLabel extends BConsoleImage
{
  int realW;
  int realH;

  public BConsoleLabel(String text, Font f)
  {
    super();

    BufferedImage graphicsImage = new BufferedImage(2,2, BufferedImage.TYPE_INT_ARGB);
    //((Graphics2D)graphicsImage.getGraphics()).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );

    FontRenderContext fontR = ((Graphics2D)graphicsImage.getGraphics()).getFontRenderContext();

    Rectangle2D rectB = f.getStringBounds(text, fontR);


    int w = (int)rectB.getWidth();
    int h = (int)rectB.getHeight();

    realW = w;
    realH = h;

    w = (int)BMath.getNearestEnclosingPowerOf2(w);
    w =  (int)BMath.getNearestEnclosingPowerOf2(w + 1);  // need one more gap for font size bug

    // cap texture size for Voodoos
    if (BGlobal.VIDEOMODE.equals(BGlobal.VIDEOMODE_DIRECTX) )
      if (w > 256)
        w = 256;


    h = (int)BMath.getNearestEnclosingPowerOf2(h);

    //BDebug.print ("BConsoleLabel real " + realW + " po2 " + w);

    graphicsImage = new BufferedImage(w,h, BufferedImage.TYPE_INT_ARGB);
    Graphics2D g = (Graphics2D) graphicsImage.getGraphics();

    // g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );

    // test

    g.setFont(f);
    g.setColor(BGlobal.colors.getLightestShade());
    g.drawString(text, 0, h / 2 + 2);

    setImage(graphicsImage);

    setTransparency(0);
  }

  public void cleanse()
  {
    super.cleanse();
  }

  public int getWidth()
  { return realW;  }
  public int getHeight()
  { return realH;  }

  /*
  protected int getNearestEnclosingPowerOf2(int n)
  {
    int p = 1;

    for (int i=0; p < n; i++)
      p = p << 1;

    return p;
  }
  */
}
