package roboforge.ui.events;

import roboforge.util.processors.*;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.SwingUtilities;

public class BAsyncActionAdapter extends BSingleObjectProcessor
  implements ActionListener
{
  public BAsyncActionAdapter()
    { super(); }

  public BAsyncActionAdapter(int priority)
    { super(priority); }

  protected boolean accept(ActionEvent e)
    { return true; }

  public final void actionPerformed(ActionEvent e)
  {
    if (accept(e))
    {
      preActionApproved(e);
      request(e);
    }
  }

  public void processObject(Object o)
  {
    ActionEvent e = (ActionEvent) o;
    asyncActionApproved(e);
    SwingUtilities.invokeLater(new PostActionInvoker(e));
  }

  public void preActionApproved(ActionEvent e)
    // This method is executed from the Swing thread,
    // PRIOR to executing asyncActionApproved from
    // a separate thread.
    {  }

  public void asyncActionApproved(ActionEvent e)
    // This method is executed from a spawned thread,
    // NOT the Swing thread.
    { }

  public void postActionApproved(ActionEvent e)
    // This method is executed from the Swing thread,
    // AFTER asyncActionApproved returns.
    // NB: No guarantees as to exactly how long after
    // [since request is posted using SwingUtilities].
    {  }


  protected class PostActionInvoker
    implements Runnable
  {
    // This class is responsible for invoking
    // postActionApproved() on the Swing thread.
    
    protected ActionEvent event;

    public PostActionInvoker(ActionEvent e)
      { event = e; }

    public void run()
      { postActionApproved(event); }
  }

}

