package roboforge.ui.fusion;

import java.awt.*;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

import roboforge.ui.components.HSBImageIcon;

public class FusionCheckBoxUI extends BasicCheckBoxUI
{
  private final static FusionCheckBoxUI checkBoxUI = new FusionCheckBoxUI();

  // protected static FusionActionSound select =
  //   new FusionActionSound("8-2.wav");      

  private static Color disabledColor = 
    Color.white;

  protected static RenderingHints hints = new RenderingHints (
    RenderingHints.KEY_ANTIALIASING,
    RenderingHints.VALUE_ANTIALIAS_ON );

  public static ComponentUI createUI(JComponent b)
    { return checkBoxUI; }

  
  protected void installDefaults(AbstractButton b)
  {
    super.installDefaults(b);
    String pp = "CheckBox.";

    disabledColor  = UIManager.getColor(pp+ "disabledColor");
  }

  protected void installListeners(AbstractButton b)
  {
    super.installListeners(b);
    // select.install(b);
  }

  
  protected Dimension fSize     = new Dimension();
  protected Rectangle fViewRect = new Rectangle();
  protected Rectangle fTextRect = new Rectangle();
  protected Rectangle fIconRect = new Rectangle();

  public synchronized void paint(Graphics g, JComponent c)
  {
    Graphics2D g2D = (Graphics2D) g;
    g2D.addRenderingHints(hints);

    super.paint(g, c);

    AbstractButton b = (AbstractButton) c;
    ButtonModel model = b.getModel();

    Font f = c.getFont();
    g.setFont(f);
    FontMetrics fm = g.getFontMetrics();

    fSize = b.getSize(fSize);
    fViewRect.x = fViewRect.y = 0;
    fViewRect.width = fSize.width;
    fViewRect.height = fSize.height;
    fIconRect.x = fIconRect.y = fIconRect.width = fIconRect.height = 0;
    fTextRect.x = fTextRect.y = fTextRect.width = fTextRect.height = 0;

    Icon altIcon = b.getIcon();
    Icon selectedIcon = null;
    Icon disabledIcon = null;

    String text = SwingUtilities.layoutCompoundLabel(
      c, fm, b.getText(), altIcon != null ? altIcon : getDefaultIcon(),
      b.getVerticalAlignment(), b.getHorizontalAlignment(),
      b.getVerticalTextPosition(), b.getHorizontalTextPosition(),
      fViewRect, fIconRect, fTextRect, getDefaultTextIconGap(b));

    // Draw the Text
    if ((text != null) && !model.isEnabled())
    {
      // Clear the text area.
      g.setColor(b.getBackground());
      g.fillRect
      (
        fTextRect.x,
        fTextRect.y,
        fTextRect.width,
        fTextRect.height
      );

      g.setColor(disabledColor);
      BasicGraphicsUtils.drawString(
        g,text,model.getMnemonic(),
        fTextRect.x,
        fTextRect.y + fm.getAscent());
    }
  }

}


