package roboforge.ui.layers;

import roboforge.ui.events.*;


public interface BLayerStack extends BActivateable
{
  
  public void push(BLayer l);
    // Push a layer onto the stack.
  
  public BLayer peek();
    // Peek at the current top layer.

  public BLayer pop();
    // Pop a layer from the stack.
  
  public BLayer pop(boolean close);
    // Pop a layer from the stack, optionally closing the layer.
    
  public boolean remove(BLayer l);
    // Remove this layer from the stack.
  
  public boolean remove(BLayer l, boolean close);
    // Remove this layer from the stack, optionally closing it.
  
  public void moveToTop(BLayer l);
    // Move layer l to top of the stack.

  public boolean contains(BLayer l);
    // Returns true if layer l is contained in the layer stack.
  
  public boolean isOpen(BLayer l);
    // Returns true if layer l is open.
  
  public int size();
    // The number of layers on the stack.

}
