package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BConnectPoint;
import roboforge.BConnectPointShape;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BHighlightShape;
import roboforge.BPhysics;
import roboforge.BShape3D;
import roboforge.BZone;
import roboforge.BZoneShape;

import roboforge.math.*;
import roboforge.ui.*;

import java.awt.event.MouseEvent;

import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.picking.*;
// import com.sun.j3d.utils.behaviors.picking.*;


public class BModePlanePickDrag extends BModePlaneDrag
{

  // Constructors...
  // -------------------------------------------------------------

  public BModePlanePickDrag(B3DCanvas canvas)
    { super(canvas); }


  // Mouse-event methods.
  // -------------------------------------------------------------

  public void mousePressed(MouseEvent e)
  {
    pickCanvas.setShapeLocation(e);
    PickResult picked = pickCanvas.pickClosest();

    Shape3D pickedShape = (picked == null) ?
      null : (Shape3D) picked.getObject();

    /*
   	pickedShape = (Shape3D)
      pickObject.pickNode(
        pickObject.pickClosest(e.getX(), e.getY(), PickObject.USE_GEOMETRY),
        PickObject.SHAPE3D
      );
    */

    if (pickedShape == null)
      onPickNothing();

    if (pickedShape instanceof BShape3D)
    {
      BShape3D s = (BShape3D) pickedShape;
      onPickComponent(s.getComponent());
    }

    else if (pickedShape instanceof BConnectPointShape)
    {
      BConnectPointShape s = (BConnectPointShape) pickedShape;
      onPickConnectPt(s.getConnectPoint());
    }

    else if (pickedShape instanceof BZoneShape)
    {
      BZoneShape z = (BZoneShape) pickedShape;
      onPickZone(z.getZone());
    }

    // Do picking first, as it could impact the drag-plane.
    super.mousePressed(e);
  }


  // Picking methods.
  // -------------------------------------------------------------

  protected void onPickNothing()
    { }

  protected void onPickComponent(BComponent c)
    { }

  protected void onPickConnectPt(BConnectPoint c)
    { }

  protected void onPickZone(BZone z)
    { }

}