package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BConnectPoint;
import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.BZone;

import roboforge.ui.*;
import roboforge.ui.components.BUIResources;
import roboforge.ui.dnd.*;
import roboforge.util.graphics.*;

import java.awt.Cursor;
import java.awt.event.*;
import javax.media.j3d.*;
import javax.swing.*;
import javax.vecmath.Color3f;




public class BModeSelect extends BModePick
{

  
  // Constructor.
  // -------------------------------------------------------------

  public BModeSelect(B3DCanvas canvas)
  { 
    super(canvas); 
    
  }
    

  // Activation methods.
  // -------------------------------------------------------------

  public void onActivate()
  {
    super.onActivate();
    BComponent c = canvas.getSelectedComponent();

    if (c != null)
      onPickComponent(c, null);

    // Enable mouse-event relay [for tooltips].
    canvas.setMouseRelayEnabled(true);
    canvas.setDragActive(true);

  }

  public void onDeactivate()
  {
    // Enable mouse-event relay [for tooltips].
    canvas.setMouseRelayEnabled(false);
    super.onDeactivate();
    canvas.setDragActive(false);
  }



  // Picking methods.
  // -------------------------------------------------------------

  protected void onPickNothing(MouseEvent e)
    { canvas.setSelectedComponent(null); }

  protected void onPickComponent(BComponent c, MouseEvent e)
  {
    Color3f selectColor = null;

    if (c != null)
      // Determine selection color.
      selectColor = c.getChassisLock() ?
        BGlobal.LOCKED_COLOR_3F :
        BGlobal.SELECTED_COLOR_3F;

    canvas.setSelectedComponent(c, true, true, true, false, selectColor);
  }

  protected void onPickConnectPt(BConnectPoint c, MouseEvent e)
    { canvas.setSelectedConnectPt(c); }

  protected void onPickZone(BZone z, MouseEvent e)
    { }

}




