package roboforge.ui.net;

//import roboforge.BGlobal;

import roboforge.ui.components.tree.*;

//import roboforge.net.data.*;
import roboforge.util.data.*;
//import roboforge.util.graphics.*;

//import java.awt.Color;
import javax.swing.*;



public class BDataNode extends BRenderingTreeNode
{
  
  protected BDataAtom data;
    // The piece of data that this node represents.
  
  
  // Constructor...
  // -------------------------------------------------------------

  public BDataNode(String name)
  {
    super();
    this.data = new BRootData(name);
  }

  public BDataNode(BDataAtom data)
  {
    super();
    this.data = data;
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public BDataAtom getData()
    { return data; }
  
  public int getType()
    { return data.getType(); }
  
  public boolean isOfType(int type)
    { return type == data.getType(); }

  public Long getID()
    { return data.getIDLong(); }
  
  public String getName()
    { return data.toString(); }

  public Icon getIcon()
    { return BDataIcons.get(data); }

  public Icon getSelectedIcon()
    { return BDataIcons.getSelected(data); }



  // Dummy root-data class...
  // -------------------------------------------------------------

  protected static class BRootData extends BAbstractAtom
  { 
    protected String name;
    
    public BRootData(String name)
    { 
      super(0);
      this.name = name; 
    }
    
    public int getType() 
      { return -1; } 
    
    public String toString()
      { return name; }
  }
}