package roboforge.ui.net;

import java.awt.Component;
import javax.swing.*;
import javax.swing.tree.*;

import roboforge.ui.components.tree.*;

import roboforge.ui.components.*;
import roboforge.ui.net.*;
import roboforge.util.graphics.*;


public class BHistoryTreeCellRenderer extends BTreeCellRenderer
{

  protected static Icon nominated =  BIconCache.getHSB("nominate_small_icon.gif");
  protected static Icon nominatedSel =  BIconCache.getHSB("nominate_small_icon.gif", java.awt.Color.white);

  protected static BLabel nominatedLabel = new BLabel(nominated);
  protected static BLabel nominatedSelLabel = new BLabel(nominatedSel);

  public BHistoryTreeCellRenderer()
    { super(); }

  public Component getTreeCellRendererComponent
  (
    JTree tree, Object value,
    boolean isSelected, boolean expanded,
		boolean leaf, int row, boolean hasFocus
  )
  {
    Component c = super.getTreeCellRendererComponent(tree, value, isSelected, expanded, leaf, row, hasFocus);

    BBoxPanel bp = new BBoxPanel(BoxLayout.X_AXIS);
    bp.add(c);

    if(value instanceof BFightDataNode)
    {
      BFightDataNode node = (BFightDataNode)value;

      if(node.isNominated())
      {
        bp.addTinyMargin();
        if(isSelected)
          bp.add(nominatedSelLabel);
        else
          bp.add(nominatedLabel);
      }
    }

    bp.setBackground(roboforge.BGlobal.colors.getVeryDarkShade());

    return bp;
	}

}

