package roboforge.util;


import java.io.IOException;
import roboforge.BDebug;

public class BSystemBrowser
{
      // Used to identify the windows platform.
    private static final String WIN_ID = "Windows";

    protected static final String W2K_TOKEN = "Windows 2000";

    // The default system browser under windows.
    private static final String WIN_PATH = "rundll32";

    // The flag to display a url.
    private static final String WIN_FLAG = "url.dll,FileProtocolHandler";

    // The default browser under unix.
    private static final String UNIX_PATH = "netscape";

    // The flag to display a url.
    private static final String UNIX_FLAG = "-remote openURL";

    public BSystemBrowser()
    {
      // this is a static class do not create any instances
    }

    public static void displayURL(String url) throws Exception
    {
        boolean windows = isWindowsPlatform();
        String cmd = null;


            if (windows)
            {

                  try
                  {
                    // win95 jigeripoke
                    Runtime.getRuntime().exec("start " + url);
                  }
                  catch(Exception e)
                  {

                    try
                    {
                      Process p = Runtime.getRuntime().exec("c:/program files/internet explorer/iexplore " + url);
                    }
                    catch(Exception e2)
                    {
                      // cmd = 'rundll32 url.dll,FileProtocolHandler http://...'
                      cmd = WIN_PATH + " " + WIN_FLAG + " " + url;
                      Process p = Runtime.getRuntime().exec(cmd);
                    }
                  }

            }
            else
            {
                // Under Unix, Netscape has to be running for the "-remote"
                // command to work. So, we try sending the command and
                // check for an exit value. If the exit command is 0,
                // it worked, otherwise we need to start the browser.

                // cmd = 'netscape -remote openURL(http://www.javaworld.com)'
                cmd = UNIX_PATH + " " + UNIX_FLAG + "(" + url + ")";
                Process p = Runtime.getRuntime().exec(cmd);

                    // wait for exit code -- if it's 0, command worked,
                    // otherwise we need to start the browser up.
                    int exitCode = p.waitFor();

                    if (exitCode != 0)
                    {
                        // Command failed, start up the browser

                        // cmd = 'netscape http://www.javaworld.com'
                        cmd = UNIX_PATH + " " + url;
                        p = Runtime.getRuntime().exec(cmd);
                    }
            }



    }


   public static boolean isWin2k()
   {
     String os = System.getProperty("os.name");

     return  W2K_TOKEN.equalsIgnoreCase(os);

       /* if ( os != null && os.startsWith(WIN_ID))
            return true;
        else
            return false;  */

   }

   public static boolean isWindowsPlatform() 
    { 
        String os = System.getProperty("os.name");

        if ( os != null && os.startsWith(WIN_ID))
            return true;
        else
            return false;
    } 






} 