package roboforge.util.data;

import java.io.Serializable;
import java.util.Vector;


public class BDataSet
  implements BData, Serializable
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Member variables...
  // -------------------------------------------------------------

  public BData[] data;


  // Constructor...
  // -------------------------------------------------------------

  public BDataSet()
    { }


  // Accessor methods...
  // -------------------------------------------------------------

  public void store(BDatabase db)
  {
    int n = data.length;

    for (int i=0; i<n; i++)
      data[i].store(db);
  }
  
  
  
  public void add(BData datum)
  {
    // TODO: Very inefficient, naive algorithm!

    int n = 0;
        
    if (data == null)
      data = new BData[1];
    else
    {
      n = data.length;
      
      BData[] old = data;
      data = new BData[n + 1];
      
      System.arraycopy(old, 0, data, 0, n);
    }
    
    data[n] = datum;
  }
  
  
  public void add(Vector v)
  {
    int n = v.size();

    if (data != null)
    {
      int o = data.length;


      // Reallocate storage space...
      BData[] old = data;
      data = new BData[o + n];

      // Retrieve vector elements...
      Object[] obj = new Object[n];
      v.copyInto(obj);

      // Copy old data into new array...
      System.arraycopy(old, 0, data, 0, o);

      // Copy vector elements into new array...
      for (int i=0; i<n; i++)
        data[o++] = (BData) obj[i];
    }
    else
    {
      // Data null so need to allocate storage space
      data = new BData[n];

      // Populate array with vector elements
      v.copyInto(data);
    }
  }


}