package roboforge.util.graphics;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.util.BSoftCache;

import roboforge.ui.components.HSBImageIcon;
import java.awt.Color;
import javax.swing.*;


public class BIconCache
{

  // Member variables...
  // -------------------------------------------------------------

  protected static BSoftCache cache = new BSoftCache();

  /*private static BSoftCache initCache()
  {
    BSoftCache cache = new BSoftCache();
    cache.retainAll();
    return cache;

  } */
    // Cache to hold the icons.


  // Icon lookup methods...
  // -------------------------------------------------------------

  public static ImageIcon get(String name)
  {
    ImageIcon icon =
      (ImageIcon) cache.get(name);

    if (icon == null)
    {
      icon = BGraphics.getIcon(name);
      cache.put(name, icon);
    }

    return icon;
  }

  public static HSBImageIcon getHSB(String name)
  {
    HSBImageIcon icon =
      (HSBImageIcon) cache.get(name);

    if (icon == null)
    {
      icon = BGraphics.getHSBIcon(name);
      cache.put(name, icon);
    }

    return icon;
  }

  public static HSBImageIcon getHSB(String name, Color c)
  {
    HSBImageIcon icon =
      (HSBImageIcon) cache.get(name + c.toString() );

    if (icon == null)
    {
      icon = BGraphics.getHSBIcon(name, c);
      cache.put(name + c.toString(), icon);
    }

    return icon;
  }

  public static void setHardCache(boolean b)
  {
  //  BDebug.print ("BIconcache setHardCacche " + b);
    
    if (b)
      cache.retainAll();
    else
      cache.retainNone();

  }

  public static void clear()
  {
    cache.clear();
  }

}
