package roboforge.util.io;


import java.io.OutputStream;

/**
 * This class counts the  number of bytes sent to a stream.
 * The bytes sent are thrown away (never actually sent anywhere)
 * Hence the word Dispose in the class name.
 */

public class BCountDisposeOutputStream extends OutputStream {

  private int bytecount = 0;

  public int getByteCount()
  {
    return bytecount;
  }

  public void close()
  {
	  return;
  }

  public void flush()
  {

	  return;
  }

  public void write(byte b[])
  {
	  bytecount += b.length;
  }

  public void write(byte b[], int off, int len)
  {
	  bytecount += len;
  }

  public void write(int b)
  {
	  bytecount++;
  }

  public BCountDisposeOutputStream()
  {
	  this.bytecount = 0;
  }

}
