package roboforge.util.io;

import java.io.*;
import roboforge.BDebug;


public class BFileSystem
// static help functions for handling files
{

  public BFileSystem()
  {
  }

  public static void clearOldFiles (String sourcePath, long msOldToDelete )
  {
    try
    {
      File path = new File(sourcePath);

      File[] files = path.listFiles();

      long now = System.currentTimeMillis();

      for (int i = files.length - 1; i >=0; i--)
      {
        if (now - files[i].lastModified()  > msOldToDelete )
        {
          BDebug.print ("BFileSystem.clearOldFiles deleting " + files[i].toString() );
          files[i].delete();
        }

      }

    }
    catch (Exception e)
      { BDebug.print ("BFileSystem.clearOldFile error clearing :" + sourcePath + " :: " + e.getMessage() ); }


  }

  public static void copyFile(String source, String target) throws IOException
  {


     File in = new File(source);
     File out = new File(target);

     if (out.exists() )
      out.delete();


     FileInputStream fis  = new FileInputStream(in);
     FileOutputStream fos = new FileOutputStream(out);
     byte[] buf = new byte[1024];
     int i = 0;
     while((i=fis.read(buf))!=-1)
     {
       fos.write(buf, 0, i);
     }
     fis.close();
     fos.close();

  }

  public static void copyDirectory(String sourceString, String targetString ) throws IOException
  {
      File source = new File(sourceString);

      if (sourceString.charAt(sourceString.length()-1) != '/' )
        sourceString = sourceString + "/";

      String[] files = source.list();

      for (int i = files.length - 1; i >=0; i-- )
      {
        BDebug.print ("BFileSystem.copyDirectory copying " + sourceString + files[i] + " to " + targetString );
        copyFile(sourceString + files[i], targetString + files[i] );

      }

  }


} 