package roboforge.util.text;


import roboforge.BDebug;
import java.io.*;
import roboforge.BGlobal;

public class BDictionaryTree
{
  BDictionaryTreeNode[] rootLetters = new  BDictionaryTreeNode[26];
  private static char A_INDEX = 'a';


  public BDictionaryTree()
    { }

  public void printWords()
  {
    for (int i = rootLetters.length - 1 ; i >=0; i-- )
    {

      if (rootLetters[i] != null)
        rootLetters[i].printWords();

    }

  }

  public void addWord(String word)
  {
    if (word == null)
      return;

    if (word.length() == 0)
      return;
      
    word = word.toLowerCase();
    char header = word.charAt(0);

    if (rootLetters[header - A_INDEX] == null)
      rootLetters[header - A_INDEX] = new BDictionaryTreeNode(word);
    else
      rootLetters[header - A_INDEX].add(word);


  }


  public char toLower(char c)
  {
    return BDictionaryTreeNode.toLower(c);
  }

  public boolean isAlpha(char c)
  {
    return (c >= 'a' && c <= 'z')  || (c >= 'A' && c <= 'Z');
  }

  public String filter(String s)
  {
    if (s == null)
      return null;
      
    if (!BGlobal.FILTER_WORDS)
      return s;

    char[] sChar = s.toCharArray();

    for (int i = 0; i < sChar.length; i++)
    {
     // BDebug.print ("BDicTree filter checking " + sChar[i] + "isAlpha(sChar[i])" + isAlpha(sChar[i]));
     // BDebug.print ("toLower(sChar[i])" + toLower(sChar[i]));

        if (isAlpha(sChar[i]))
        {
          char currentCharIndex =  (char)(toLower(sChar[i])- A_INDEX);
          if (rootLetters[ currentCharIndex] != null)
            rootLetters[ currentCharIndex].filter(sChar, i + 1);

        }

    }

    String newString = new String(sChar);

    return newString;

  }

  public void loadWords(String filename)
  {
    try
    {
      RandomAccessFile installFile = new RandomAccessFile(filename, "r");

      String word = installFile.readLine();

      while ( word != null)
      {                               
        addWord(word);
        word = installFile.readLine();
      }
      installFile.close();

    }
    catch(Exception e)
    {
      BDebug.print ("BDictionaryTree loadWords " + filename + " ERROR : " + e.getMessage());
    }




  }

  private static BDictionaryTree sharedInstance;


  public static BDictionaryTree getSharedInstance()
  {
    if (sharedInstance == null)
    {
      sharedInstance = new   BDictionaryTree();
      sharedInstance.loadWords(BGlobal.LIBPATH + "dirt.dll");
    }
    return  sharedInstance;

  }

  public static void clearStatic()
  {
    sharedInstance = null;
  }




}