package roboforge;

import roboforge.animation.*;
//import roboforge.animation.animation.*;
//import roboforge.animation.animation.b2d.*;
import roboforge.animation.animation.b3d.*;
import roboforge.animation.time.*;



public class BAnimatedTextureOrnament extends BAnimatedArenaOrnament
{

  // Serialization ID.
  static final long serialVersionUID = -1L;

  protected static String DEFAULT_EXT = ".gif";
  protected static long   DEFAULT_DELAY = 500;


  protected String root;
    // Root of the texture filenames, relative to BGlobal.SYSTEMPATH.

  protected String ext;
    // Extension of the texture filenames.

  protected long delay;
    // Animation delay, in ms.


  protected transient BTextureAnimation anim;


  public BAnimatedTextureOrnament(String name, String filename)
  {
    super(name, filename);
    ext = DEFAULT_EXT;
    delay = DEFAULT_DELAY;
  }



  public void setTextureRoot(String root)
    { this.root = root; }

  public String getTextureRoot()
    { return this.root; }

  public void setTextureExt(String ext)
    { this.ext = ext; }

  public String getTextureExt()
    { return this.ext; }

  public void setDelay(long delay)
    { this.delay = delay; }

  public long getDelay()
    { return this.delay; }


  public BAnimation getAnimation()
  {
    anim = new BTextureAnimation(normalAppearance, BGlobal.SYSTEMPATH+ root, 4, ext);
    return new BScheduledAnimation(anim, delay);
  }


  protected void setAppearance()
  {
    super.setAppearance();

    if (anim != null)
      anim.setAppearance(normalAppearance);
  }


  public void optimize()
  {
    if (anim != null)
      anim.setAppearanceCapabilities();
  }

}

