package roboforge;

//: BComponentInfo.java

import java.awt.*;
import javax.swing.*;
import java.util.*;

public class BComponentInfo extends JPanel 
{

/**
	 * 
	 */
	private static final long serialVersionUID = -1L;


/*

* Description: Display panel of Component Stats and general info.

* Example:
* Modification History ( Name, Date, Notes ):
                        DJG 13-Apr-99
*/


  //private static final float radToDegreeConvert = 180 / (float)java.lang.Math.PI  ;


  static int FHEIGHT = 1;
  static int GAP = 5;
  static int MARGIN = 1;
  Float fValue;


  static int pWidth = 210;
  static int pHeight = 500;



  public BComponentInfo(boolean editable)
  {



    int pWidth = 210;
    int pHeight = 500;
    this.setSize(pWidth,pHeight);
    this.setLayout(new FlowLayout(FlowLayout.CENTER, 1, 1)   );





  }

  public void loadComponent(BComponent bComponent)
  {

    
    this.removeAll();

    //JTextField label;
    //JTextField value;

    Vector headings = new Vector(2);
    headings.add("Attribute");
    headings.add("Value");


    Vector data = bComponent.getAttributeStrings();

    JTable theTable = new JTable(data, headings);
    theTable.setSize(pWidth, pHeight);
    theTable.setEnabled(false);
    this.add(theTable);
    
    /*

    Vector tuple;
    for (int i = 0; i <  data.size(); i++ )
    {
      tuple = (Vector) data.get(i);

      label = new JTextField( (String)tuple.get(0) );
      label.setEditable(false);
      this.add(label,c);


    }         */



  /*
    setInvisible();
    title.setText("Component:");
    name.setText(bComponent.getName());
    details.setText(bComponent.getDetails());
    price.setText("$"+getFloatString(bComponent.price));
    weight.setText(getFloatString(bComponent.weight)+" Kg");
    damageMax.setText(getIntString(bComponent.damageMax)+" Units");
    damageDealStriking.setText(getFloatString(bComponent.damageDealStriking)+" Units per Kg/M/Sec");
    //damageResistStriking.setText(getIntString(bComponent.damageResistStriking)+"%");
    //damageResistPiercing.setText(getIntString(bComponent.damageResistPiercing)+"%");
    //damageResistCrushing.setText(getIntString(bComponent.damageResistCrushing)+"%");
    //damageResistEnergy.setText(getIntString(bComponent.damageResistEnergy)+"%");
    energyUsage.setText(getFloatString(bComponent.energyUsage)+" KW/Hr");

    if (bComponent instanceof BCpu)
    {
      title.setText("CPU:");
      BCpu bCpu = (BCpu) bComponent;
      cpuClass.setText(getIntString(bCpu.cpuClass));
      cpuCyclesPerSecond.setText(getIntString(bCpu.cpuCyclesPerSecond)+" Cycles/Sec");
      cpuCapacity.setText(getIntString(bCpu.cpuCapacity)+" Decisions");
      label1.setText("Cpu Class:");
      label2.setText("Cpu Speed:");
      label3.setText("Cpu Size:");
      cpuClass.setVisible(true);
      cpuCyclesPerSecond.setVisible(true);
      cpuCapacity.setVisible(true);
    }

    if (bComponent instanceof BJoint)
    {
      title.setText("Joint:");
      BJoint bJoint = (BJoint) bComponent;
      jointPowerOutput.setText(getFloatString(bJoint.jointPowerOutput)+" KW");
      jointEnergyUsage.setText(getFloatString(bJoint.jointEnergyUsage)+" W/Kg/Rad/Sec");
      label1.setText("Power:");
      label2.setText("Energy Use:");
      jointPowerOutput.setVisible(true);
      jointEnergyUsage.setVisible(true);
      if (bJoint instanceof BRotateJoint)
      {

        if ( bJoint.getFreedomMax() > java.lang.Math.PI * 2 )
           jointAxis.setText( "Unlimited " );
        else
           jointAxis.setText((int)bJoint.getFreedomMin() * radToDegreeConvert + " - " +  (int)bJoint.getFreedomMax() * radToDegreeConvert  +" degrees");

        label3.setText("Rotate Freedom:");
        jointAxis.setVisible(true);
      }
      else if (bJoint instanceof BTelescopicJoint)
      {
        jointDirection.setText(((BTelescopicJoint)bJoint).getDirectionOfMovement()+"");
        label3.setText("Direction:");
        jointDirection.setVisible(true);
      }
    }

    if (bComponent instanceof BSensor)
    {
      title.setText("Sensor:");
      BSensor bSensor = (BSensor) bComponent;
      sensorRange.setText(getIntString(bSensor.sensorRange)+" Metres");
      sensorScope.setText(getIntString(bSensor.sensorScope)+" Degrees");
      sensorAccuracy.setText(getIntString(bSensor.sensorAccuracy)+"%");
      label1.setText("Range:");
      label2.setText("Scope:");
      label3.setText("Accuracy:");
      sensorRange.setVisible(true);
      sensorScope.setVisible(true);
      sensorAccuracy.setVisible(true);
    }

    if (bComponent instanceof BWeapon)
    {
      title.setText("Weapon:");
      BWeapon bWeapon = (BWeapon) bComponent;
      strikingMass.setText(getFloatString(bWeapon.strikingMass)+" Kg");
      damageDealPiercing.setText(getFloatString(bWeapon.damageDealPiercing)+" Units per Kg/M/Sec");
      damageDealCrushing.setText(getFloatString(bWeapon.damageDealCrushing)+" Units per Kg/M/Sec");
      damageDealEnergy.setText(getFloatString(bWeapon.damageDealEnergy)+" Units per Strike");
      label1.setText("Strike Mass:");
      label2.setText("Pierce Dmg:");
      label3.setText("Crush Dmg:");
      label4.setText("Energy Dmg:");
      strikingMass.setVisible(true);
      damageDealPiercing.setVisible(true);
      damageDealCrushing.setVisible(true);
      damageDealEnergy.setVisible(true);
    }
    if (bComponent instanceof BChassis)
    {
      title.setText("Chassis:");
      BChassis bChassis = (BChassis) bComponent;
      chassisEnergyUsage.setText(getFloatString(bChassis.chassisEnergyUsage)+" W/KG/M/S");
      label1.setText("Energy Use:");
      chassisEnergyUsage.setVisible(true);
    }
    if (bComponent instanceof BEnergyGenerator)
    {
      title.setText("Joint:");
      BEnergyGenerator bEnGen = (BEnergyGenerator) bComponent;
      energyCapacity.setText(getFloatString(bEnGen.energyCapacity)+" KW");
      energyOutputRate.setText(getFloatString(bEnGen.energyOutputRate)+" KW/Hr");
      label1.setText("Capacity:");
      label2.setText("Output:");
      energyCapacity.setVisible(true);
      energyOutputRate.setVisible(true);
    }           */
  }
/*
  private String getFloatString(float floatValue)
  {
    Float fValue = new Float(floatValue);
    return fValue.toString();
  }

  private String getIntString(int intValue)
  {
    Integer iValue = new Integer(intValue);
    return iValue.toString();
  }
*/
  public void setInvisible()
  {

  }

  public void remove()
  {
    
  }

}///:~
