package roboforge;

import roboforge.ui.BApplication;

//import javax.vecmath.*;
import java.util.*;
import javax.media.j3d.*;
//import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;

import java.awt.*;
import roboforge.util.timing.*;

public class BDebug {
/*
* Description: General Debugging Class, will be maily made up of static methods
* Example:
* Modification History ( Name, Date, Notes ):
                         YLY, 4- Apr - Creation
                         YLY, 8th Mar 99, Added print and debugmode
                         YLY, 29th Apr 99, Adden PrintFreeMem
*/



private static int TREE_POPUP_WIDTH = 400;
private static int TREE_POPUP_HEIGHT = 600;

public static void printj3D (String title, Node top)
{


      printTree(title, getTreeBranches(top));
}

public static void printTree(String title, DefaultMutableTreeNode node)
{
      final JFrame popup = new JFrame(title);
      popup.setSize(TREE_POPUP_WIDTH, TREE_POPUP_HEIGHT);
      final Container pane = popup.getContentPane();
      final JTree tree = new JTree(node);
      final JScrollPane scrollPane = new JScrollPane(tree);
      pane.add(scrollPane);
      popup.show();
}

public static DefaultMutableTreeNode getTreeBranches(Node node)
{
      if (node == null)
        return null;

      String name = node.toString();

      if (node instanceof BShape3D)
      {
        String compName = ((BShape3D)node).getComponent().getName();
        name = compName + ":: " + name ;
      }
      else if (node.getUserData() != null)
      {
        String nodeName =  (String)node.getUserData();
        name = nodeName + " :: " + name ;
      }


      DefaultMutableTreeNode treeNode =  new DefaultMutableTreeNode(name);
      if (node instanceof Group)
      {
         Group group = (Group)node;
	 final int n = group.numChildren();
         for (int i = 0; i < n; i++)
	    treeNode.add(getTreeBranches(group.getChild(i)));
      }

      return treeNode;
}




private static void printGraph3D(Node theGroup, int depth )
  {

  if ( theGroup instanceof Group )
    {

      Group currentGroup = (Group) theGroup;

      for (Enumeration e = currentGroup.getAllChildren(); e.hasMoreElements();)
      {

          System.out.println(Integer.toString(depth) +  " Node" + currentGroup.toString());
          Node newGroup =(Node)e.nextElement();
          printGraph3D(newGroup, depth + 1 );


      }
    }
  else
    if (theGroup.getClass() == new Link().getClass() )
    {
       Link tempGroup = (Link)theGroup;
       Group currentGroup = tempGroup.getSharedGroup()  ;
       System.out.println(Integer.toString(depth) +  tempGroup.toString());
       printGraph3D(currentGroup, depth + 1 );

    }

  else
  {

     System.out.println(Integer.toString(depth) + theGroup.toString() );

  }


 }

// DEBUG WRITER


public static void print (Vector v)
{
  if ( v == null)
    BDebug.print ("null Vector");
  else if (v.size() ==0)
    BDebug.print("[]");
  else
  {
    for (int i = 0; i < v.size(); i++)
      BDebug.print ("[ " + v.get(i) + " ]");
  }
}

public static void print (Object o)
{

  if (BGlobal.DEBUG_MODE)
    System.out.println(o);

}

public static  void print (String o )
{

  if (BGlobal.DEBUG_MODE)
     System.out.println(o);

}

public static void print(boolean o )
{

  if (BGlobal.DEBUG_MODE)
    System.out.println(o);

}

public static void print(double o )
{

  if (BGlobal.DEBUG_MODE)
    System.out.println(o);

}

public static void assert(boolean assertion, String msg)
{
  if (!assertion)
  {
    print("ERROR: Assertion failed - "+ msg);

    if (BGlobal.DEPRECATED)
      System.exit(1);
    else
      BApplication.abort(msg);
  }
}

public static void printFreeMem()
{
  print("USED Memory " +(  Runtime.getRuntime().totalMemory()  -  Runtime.getRuntime().freeMemory()  )/ 1024 + " Kb");
  print("Total Memory " + Runtime.getRuntime().totalMemory() / 1024 + " Kb ");

}

public static void printMemUsage()
{
  int memUsed = (int)((Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory())/1024);
  print("Memory Used: "+memUsed+" Kb");

}


private static double time; // milliseconds

public static void seedTimer()
{
  print ("BDebug.seedTimer()");
  time = BClock.time();

}


public static void  printTime(String msg, boolean justPrintms)
{
  if (BGlobal.DEBUG_MODE)
  {

    if ( justPrintms )
      System.out.println(msg + " " +  Math.round(  (BClock.time() - time ) * 1000 )   );
    else
    {

      double deltaTime = BClock.time() - time;
      System.out.println(msg + " " +  Math.round( deltaTime * 1000 ) );



      double min = (deltaTime / 60000);
      double sec =  (  deltaTime  - (min * 60000)  ) / 1000;

      System.out.println(min  + "min" );
      System.out.println(sec  + "s" );


    }

  }
}


public static void  printTime(String msg)
{
  printTime(msg, true);

}



}