package roboforge;

//: BTest.java

import java.io.*;
import java.util.*;

public class BTest implements Serializable
{
/*

* Description:
  Class for holding Decision Test information

* Modification History ( Name, Date, Notes )
  Created DJG 19 May 99

*/
  static final long serialVersionUID = -1L;

  private String description;
  private BAiOperator operator1;   // State,Channel (BState,BChannel)
  private String operand;     // =,!=,>,<,>=,<=
  private BAiOperator operator2;   // State,Channel,Value (BState,BChannel,String)


  public BTest(String descIn)
  {
    this.setDesc(descIn);
  }

  public String toString()
  {
    if (operator1 != null && operator2 != null)
      return this.getDesc();
    else
      return description;
  }

  public void setDesc(String descIn)
  {
    description = new String(descIn);
  }

  public String getDesc()
  {
   // BDebug.print("BTest.getDesc called");
    String  description = null;

    if ( operator1 != null && operator2 != null )
      { description = operator1.getDesc() + " "+operand+ " "+ operator2.getDesc(); }
    return description;
  }

  public void setOperator1(BAiOperator operatorIn)
  {
    operator1 = operatorIn;
  }

  public BAiOperator getOperator1()
  {
    return operator1;
  }

  public void setOperand(String operandIn)
  {
    operand = operandIn;
  }

  public String getOperand()
  {
    return operand;
  }

  public static Vector getOperandVector()
  {
    Vector v = new Vector();
    v.add("=");
    v.add("!=");
    v.add(">");
    v.add("<");
    v.add(">=");
    v.add("<=");
    return v;
  }

  public void setOperator2(BAiOperator operatorIn)
  {
    operator2 = operatorIn;
  }

  public BAiOperator getOperator2()
  {
    return operator2;
  }

}///:~
