package roboforge;

import java.awt.event.*;
import javax.swing.*;

/*

* Description:
  Creates a dialog box which allows a user to select from
  a list of textures.
  Returns a texture file name.
  Use the static method getTextureName to create the dialog.
  It needs to be passed the parent JFrame object.

* Example:  String element = BTextureDialog.getTextureName(this);
* Modification History ( Name, Date, Notes )
  HSC, 13 April 1999


*/

public class BTextureDialog extends JDialog
{ 
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
String selectedValue;

  public BTextureDialog(JFrame frame)
  {

    super(frame,"Texture Picker",true);

    // Define and place objects on the Dialog object.

    final BTextureList textureList = new BTextureList();

    textureList.addMouseListener(new MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        if (e.getClickCount()==2)
          {
          selectedValue = (String)textureList.getModel().getElementAt(textureList.getSelectedIndex());
          BTextureDialog.this.setVisible(false);
          BTextureDialog.this.dispose();
          }
      }
    });


    JScrollPane scrollPane = new JScrollPane(textureList);

    JButton button = new JButton("Apply Texture");
    button.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent ev)
        {
          selectedValue = (String)textureList.getModel().getElementAt(textureList.getSelectedIndex());
          BTextureDialog.this.setVisible(false);
          BTextureDialog.this.dispose();

        }

    });


    scrollPane.setSize(175,243);
    scrollPane.setLocation(0,0);

    this.getContentPane().setLayout(null);
    this.setSize(182,300);
    this.setLocation(BGlobal.FRAMEWIDTH/2,20);

    button.setSize(175,30);
    button.setLocation(0,244);

    this.getContentPane().add(scrollPane);
    this.getContentPane().add(button);

    this.setVisible(true);
  }

  static public String getTextureName(JFrame f)
  {
    BTextureDialog dialog = new BTextureDialog(f);
    return dialog.getValue();
  }

  private String getValue()
  {
    return selectedValue;
  }
}