package roboforge;

import java.util.*;


public class SAccount
{
  /*  Holds the details of an account
   *  in a challenge room
  */

  // Member variables...
  // -------------------------------------------------------------

  Long accountID;
  private Vector messages = new Vector();
  long timeLastConnected;
  // In milliseconds
  String password;
  String loginID;
  String designerName;
  String type;
  String designerBlurb;
  boolean afk = false;;
  // afk - away from the keyboard

  String proStatus;

  public SAccount(Long accountID, String password, String loginID, String designerName, String type, String designerBlurb, String proStatus)
  {
    this.accountID      = accountID;
    this.password       = password;
    this.loginID        = loginID;
    this.designerName   = designerName;
    this.type           = type;
    this.designerBlurb  = designerBlurb;
    this.proStatus      = proStatus;
    timeLastConnected = System.currentTimeMillis();
  }

  public synchronized void setMessage (Object o)
  {
    //if (!afk)
    //{
      //BDebug.print("Account: " + accountID.longValue() + " Got Message: " + ((roboforge.util.data.BAbstractAtom)o).getType());
      messages.addElement(o);
    //}
  }

  public boolean isEmptyOfMessages ()
  {
    return messages.isEmpty();
  }

  public synchronized Vector getAndClearMessages ()
  {
    timeLastConnected = System.currentTimeMillis();
    Vector copyOfMessages = messages;
    messages = new Vector();
    return copyOfMessages;
  }

} 