package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.awt.event.*;
import javax.swing.*;
import roboforge.server.util.*;

public class SBugServlet extends SHttpServletJXGB implements ActionListener  {

  /*

  * Description:
    Mails new bug list as attachment to designated person.
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 8-Feb-2000

  */

  Connection con = null;
  javax.swing.Timer t;


  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

    //86400000 number of milli seconds in a day
    t = new javax.swing.Timer(1800000,this);
  }

  //Service the request
  public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
   SResponseWrapper responseWrapper = null;


    try
    {
      // First get the Request object from the stream
      ObjectInputStream ois = new ObjectInputStream(request.getInputStream());
      SRequestWrapper requestWrapper = (SRequestWrapper)ois.readObject();

      // Determine if the password is ok
      if (requestWrapper.getPassword().equals("bkd835gbb$*(KJnmcz"))
      {
        if (requestWrapper.getRequestType().equals("STA"))
        {
          if (t.isRunning())
          {
            // Tournament Server is already running
            responseWrapper = new SResponseWrapper("ERR","Tournament Server Already Running");
          }
          else
          {
            // Tournament Server started
            responseWrapper = new SResponseWrapper("STA",null);
            t.start();
          }
        }
        else if (requestWrapper.getRequestType().equals("STO"))
        {
          // Request the Service to stop
          responseWrapper = new SResponseWrapper("STO",null);
          t.stop();
        }
        else
        {
          // Unknown Request Type
          responseWrapper = new SResponseWrapper("ERR","Unknown Request");
        }
      }
      else
      {
        // Password invalid
        responseWrapper = new SResponseWrapper("ERR","Password Invalid");
      }

      response.setContentType("application/octet-stream");
      ObjectOutputStream oos = new ObjectOutputStream(response.getOutputStream());
      oos.writeObject(responseWrapper);
      oos.flush();
      oos.close();

    }
    catch (ClassNotFoundException cnfe)
    {
      responseWrapper = new SResponseWrapper("ERR",(Object)cnfe.getMessage());
      System.err.println(cnfe.getMessage());
    }
    catch (Exception e)
    {
      responseWrapper = new SResponseWrapper("ERR",(Object)e.getMessage());
      System.err.println(e.getMessage());
    }
  }

  public void actionPerformed (ActionEvent ae)
  {

    try
    {
      con = getDatabaseConnection();
      mailNewBugs(con);

    }

    catch (Exception e)
    {
      System.err.println(e.getMessage());
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          // Close the connection no matter what
          myBroker.freeConnection(con);
        }

      }
      catch(Exception sqle1)
      {
        System.err.println(sqle1.getMessage());
      }
    }
  }

 
 
   private void mailNewBugs(Connection con)
  {
    /*
     Look after all the Fighting Touranaments
    */

    long greatestBugID = 0;

    try
    {

      init();
      con.setAutoCommit(false);

      // Get the Constants
      String sql = "SELECT last_bug_id, bug_email FROM CONSTANTS";

      Statement statement = con.createStatement();
      ResultSet rs = statement.executeQuery(sql);

      rs.next();

      long lastBugID = rs.getLong("last_bug_id");
      String bugEmailAddress = rs.getString("bug_email");

      rs.close();
      statement.close();


      // Find the the new bugs

      sql = "SELECT BUG.id, account_id, area, BUG.type, name, email, designer_name, detail, output";
      sql += " FROM BUG, ACCOUNT ";
      sql += " WHERE BUG.account_id = account.id";
      sql += " AND BUG.id > " + lastBugID;
      sql += " ORDER BY BUG.id";


      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      while (rs.next())
      {
        // Get current bug ID
        greatestBugID = rs.getLong("id");

        // Build Up the Bug String
        String bug = "";

        bug += "BUG ID: " + greatestBugID + "\r\n";
        bug += "ACCOUNT ID: " + rs.getLong("account_id") + "\r\n";
        bug += "NAME: " + rs.getString("name") + "\r\n";
        bug += "DESIGNER NAME: " + rs.getString("designer_name") + "\r\n";
        bug += "EMAIL: " + rs.getString("email") + "\r\n";
        bug += "AREA: " + rs.getString("area") + "\r\n";
        bug += "TYPE: " + rs.getString("type") + "\r\n";  
        bug += "DETAIL: " + (String)rs.getString("detail")+ "\r\n";
        bug += "OUTPUT: " + (String)rs.getObject("output");

        // Mail the bug
        // *** NOTE TO USE ATTACHMENTS USE THE JNET SMTPClient Bean

        System.err.println("Sending Bug: " + greatestBugID + " to: " +  bugEmailAddress);
        //new SMTPBean("edge", 25, "hugh@roboforge.com", bugEmailAddress, "Bug Reported", bug);
        new SMTPBean("mail2.clearfield.co.nz", 25, "rforge@roboforge.com", bugEmailAddress, "Bug Reported", bug);
        System.err.println("Sent Bug: " + greatestBugID + " to: " +  bugEmailAddress);

      }

      rs.close();
      statement.close();

      if (greatestBugID > 0)
      {
        // Update the CONSTANTS table to reflect the last bug mailed
        sql = "UPDATE CONSTANTS SET last_bug_id = " + greatestBugID;
        statement = con.createStatement();
        statement.executeUpdate(sql);

        statement.close();
      }


      con.commit();
      con.setAutoCommit(true);
    }
    catch (Exception e)
    {
      try
      {
        con.rollback();
        con.setAutoCommit(true);
      }
      catch (SQLException sqle1)
      {
        System.err.println(sqle1.getMessage());
      }
      
      System.err.println(e.getMessage());
    }


  }
  
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.STournamentController";
  }

   private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();
      //Class.forName ("oracle.jdbc.driver.OracleDriver");
      //con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }
    catch (Exception sqle)
    {
      System.err.println(sqle.getMessage());
    }
  return con;
  }
}
