package roboforge;

import java.io.*;
import java.security.*;
import javax.crypto.Cipher;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

public class SCCDetail implements Serializable
{
  /*

  * Description:
    Holds details of a credit card

  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 6-December-1999

  */


  byte[] cardType;
  byte[] cardName;
  byte[] cardNumber;
  byte[] cardExp;


  public SCCDetail(String cardTypeIn,String cardNameIn,String cardNumberIn, String cardExpIn )
  {
    try
    {
      // SetUp IAIK as the security provider
      IAIK.addAsProvider(false);

      // Read in and Define the private Key
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      PublicKey rsa_pub = (PublicKey)in.readObject();

      // Set up the Cipher for Encrypt
      Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
      rsa.init(Cipher.ENCRYPT_MODE, rsa_pub);

      // Encrypt the cardType
      cardType = rsa.doFinal(cardTypeIn.getBytes());

      // Encrypt the cardName
      cardName = rsa.doFinal(cardNameIn.getBytes());

      // Encrypt the cardNumber
      cardNumber = rsa.doFinal(cardNumberIn.getBytes());

      // Encrypt the cardExp
      cardExp = rsa.doFinal(cardExpIn.getBytes());
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      throw new RuntimeException();
    }
  }
}
