package roboforge;

/*import java.io.*;
import java.net.*;
import java.rmi.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

 */
import roboforge.net.*;
import roboforge.net.data.*;
import roboforge.net.client.*;
import roboforge.net.server.*;
import roboforge.net.services.*;

import roboforge.util.io.*;
import roboforge.util.data.*;

import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

import oracle.sql.*;
import oracle.jdbc.driver.*;

import java.lang.reflect.Array;
import java.io.*;
import java.util.*;
import java.security.*;
import java.sql.*;
import java.util.zip.*;

import javax.crypto.Cipher;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.swing.ImageIcon;
import roboforge.server.util.*;

//SHttpServletJXGB

public class SChatServlet extends SGatewayAbstract
{

  // source acts as the distributor of new messages
  static MessageSource source = new MessageSource();

  protected void initializeHandlers()
  {
    handlers = new HashMap();

    register(new EchoHandler());
    //register(new AccountCreationHandler());
    register(new LoginHandler());
    /*register(new OpenTournamentRequestHandler());
    register(new BattleRecordingRequestHandler());
    register(new TournamentHistoryRequestHandler());
    register(new SubmitBotRequestHandler());
    register(new AccountInformationRequestHandler());
    register(new RemoveBotFromTournamentRequestHandler());
    register(new CreateAccountRequestHandler());
    register(new AutoPatchRequestHandler());
    register(new MessageRequestHandler());
    register(new ChangeAccountRequestHandler());
    register(new SetTournamentImageRequestHandler());*/
    register(new GetMessage());
    register(new SendMessage());


  }
  // Login request handler...
  // -------------------------------------------------------------

  protected static class LoginHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "LOG"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
       return BMessage.ACK("LOG", new BIdentData(reqState.accountID));

      /*
      BRequestHeader header =
        request.getRequestHeader();

      // TODO: Lookup user in database...
      boolean isValidUser =
        header.getUser().equals("hc");

      if (isValidUser)
        return BMessage.ACK("LOG");
      else
        return BMessage.error("LOG", "Not a valid user."); */
    }
  }

  // Echo handler (this class should be deleted)...
  // -------------------------------------------------------------

  protected static class EchoHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "ECHO"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
      BMessage response =
        BMessage.ACK("ECHO");

      response.setData(request.getData());

      // Zip and encrypt the response...
      services.add(BServices.zip());
      //services.add(BServices.encrypt());

      return response;
    }
  }


  // GetMessage...
  // -------------------------------------------------------------

  protected static class GetMessage extends ValidatedRequestHandler
  {
    public String getType()
      { return "GMES"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
      BMessage response = BMessage.ACK("GMES");
      //BMessageData messageData = new BMessageData(-1);
      //messageData.message = getNextMessage();
      response.setData(getNextMessage());

      // Zip and encrypt the response...
      //services.add(BServices.zip());
      //services.add(BServices.encrypt());

      return response;
    }
  }

  // Echo handler (this class should be deleted)...
  // -------------------------------------------------------------

  protected static class SendMessage extends ValidatedRequestHandler
  {
    public String getType()
      { return "SMES"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
      BData message = request.getData();


      // Accept the new message as the "message" parameter
      //String message = messageData.message;

      // Broadcast it to all listening clients
      if (message != null) broadcastMessage(message);

      // Set the status code to indicate there will be no response
      //res.setStatus(res.SC_NO_CONTENT);


      BMessage response = BMessage.ACK("SMES");
      // Zip and encrypt the response...
      //services.add(BServices.zip());
      //services.add(BServices.encrypt());

      return response;
    }
  }
  // Servlet info method...
  // -------------------------------------------------------------

  public String getServletInfo()
    { return "roboforge.SGateway1"; }
  
// MessageSource acts as the source for new messages.
// Clients interested in receiving new messages can
// observe this object.
static class MessageSource extends Observable
{
  public void sendMessage(BData message)
  {
    setChanged();
    notifyObservers(message);
  }
}

// MessageSink acts as the receiver of new messages.
// It listens to the source.
static class MessageSink implements Observer
{

  // set by update() and read by getNextMessage()
  BData message = null;
  // Called by the message source when it gets a new message
  synchronized public void update(Observable o, Object arg)
  {
    // Get the new message
    message = (BData)arg;

    // Wake up our waiting thread
    notify();
  }

  // Gets the next message sent out from the message source
  synchronized public BData getNextMessage(MessageSource source)
  {
    // Tell source we want to be told about new messages
    source.addObserver(this);

    // Wait until our update() method receives a message
    while (message == null)
    {
      try
      {
        wait();
      }
      catch (Exception ignored)
      {
      }
    }

    // Tell source to stop telling us about new messages
    source.deleteObserver(this);

    // Now return the message we received
    // But first set the message instance variable to null
    // so update() and getNextMessage() can be called again.
    //String messageCopy = message;
    //message = null;
    //return messageCopy;
    return message;
  }
}

  // getNextMessage() returns the next new message.
  // It blocks until there is one.
  public static BData getNextMessage()
  {
    // Create a message sink to wait for a new message from the
    // message source.
    return new MessageSink().getNextMessage(source);
  }

  // broadcastMessage() informs all currently listening clients that there
  // is a new message.  Causes all calls to getNextMessage() to unblock.
  public static void broadcastMessage(BData message)
  {


    // Send the message to all the HTTP-connected clients by giving the
    // message to the message source
    source.sendMessage(message);
  }
}


