package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SCreateAccBean extends SJDBCBean
{

  private String sql;
  private Statement statement;
  private ResultSet rs;

  private String name;
  private String email;
  private String returnHTML;
  private String regKey;

  public SCreateAccBean() throws Exception
  {
    super();
  }

  public void setName(String name)
  {
    this.name   = name;
  }

  public void setEmail(String email)
  {
    this.email  = email.toLowerCase();
  }


  public String getReturnHTML()
  {

    Connection con = null;
    String returnHTML = "";
    try
    {
      con = this.getConnection();

      // Determine if an account already exists with this email address

      sql = "SELECT id, name, registration_key FROM ACCOUNT";
      sql += " WHERE LOWER(email) = '" + email + "'";

      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      if (rs.next())
      {
        // Account already exists
        long accID = rs.getLong("id");
        String accName = rs.getString("name");
        regKey = rs.getString("registration_key");
        rs.close();
        statement.close();

        // If the Registration Key doesn't exist then create it and update the account
        if(regKey == null)
        {
          sql = "SELECT getRegKey As key FROM dual";
          statement = con.createStatement();
          rs = statement.executeQuery(sql);
          rs.next();

          regKey = rs.getString("key");

          rs.close();
          statement.close();

          sql = "UPDATE ACCOUNT SET registration_key = '" + regKey + "'";
          sql += " WHERE id = " + accID;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }

        // Return the HTML for account already Existing
        returnHTML = "Account already Exists for that email address:<BR>";
        returnHTML += "Name: " + accName + "<BR>";
        returnHTML += "Registration Key: " + regKey + "<BR>";
        returnHTML += "Account ID: " + accID;
        return returnHTML;

      }
      else
      {

        rs.close();
        statement.close();

        // Account doesn't exist so create it and return the registration key
        sql = "INSERT INTO ACCOUNT (email,name,status,registration_key)";
        sql += " VALUES (LOWER('" + email + "'),'" + name + "','P', getRegKey)";

        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        // Need to get and set the accountID and regKey
        sql = "SELECT registration_key FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        regKey = rs.getString("registration_key");
        rs.close();
        statement.close();

        returnHTML = "Account created for email address: " + email +  "<BR>";
        returnHTML += "Name: " + name + "<BR>";
        returnHTML += "Registration Key: " + regKey;
        return returnHTML;
      }
    }
    catch (Exception e)
    {
      System.err.println("Error: SLoginBean: " + e.getMessage());
    }
    finally
    {
      if (con != null)
        this.freeConnection(con);
    }

    return returnHTML;

  }
}