package roboforge;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
//import java.net.*;
import java.io.*;

//import javax.media.j3d.Behavior;
//import javax.media.j3d.WakeupOnElapsedFrames;
//import javax.vecmath.*;
//import javax.media.j3d.*;
import java.util.*;
import javax.swing.event.*;

//import java.security.*;
//import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;

//import roboforge.*;
import roboforge.net.*;
import roboforge.net.data.*;
//import roboforge.util.io.*;
import roboforge.net.client.*;

import roboforge.sound.*;
import roboforge.util.data.*;
import roboforge.ui.BSystemLogger;

public class SFarmClient extends JFrame implements ActionListener
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
private javax.swing.Timer t;
  private BArenaCanvas arena3dCanvas;
  private String filePath;
  private BArena arena;
  private BSimulation simulation;
  private BSimulationBehaviour simRunner;
  private BBot bot1;
  private BBot bot2;
  private boolean battleRunning = false;
  private boolean simToSendUp = false;
  private BFightToRunData fight;
  private PrintStream logfile = null;
  private BClientStack server;

  // Keep those multiple threads in order
  boolean busy = false;
  JTextField jTInfo = new JTextField();

  File dirFile = new File(SGlobal.FARM_CLIENT_ERROR_PATH);

  public SFarmClient(BClientStack server)
  {
  enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      this.server = server;
      jbInit();
    }
    catch(Exception e)
    {
      System.err.println("Error public SFarmClient(): " + e.getMessage());
      e.printStackTrace();

    }
  }

  private void jbInit() throws Exception
  {
    // Remove the error file if it exists
    //dirFile = new File(SGlobal.FARM_CLIENT_ERROR_PATH);

    //if (dirFile.exists())
      //dirFile.delete();

    // Set up log file...
    //logfile = new PrintStream(new BufferedOutputStream(new FileOutputStream(SGlobal.FARM_CLIENT_ERROR_PATH)));

    // Set all errors to go to the Log File
    //System.setErr(logfile);

    //BGlobal.init();

    BGlobal.SHOW_TEXTURES = false;
    BGlobal.USE_SOUND = false;
    BGlobal.USE_FOG = false;
    BGlobal.USE_MIPMAP = false;
    BGlobal.USE_TRANSPARENCY = false;
    BGlobal.USE_DIRLIGHT = false;

    //TODO: Set these back to default if Farm Client not being run from main
    // ie it is being run as part of a challenge room

    t = new javax.swing.Timer(10000,this);
    t.start();

    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(466, 500));
    this.setTitle("Fight Client");
    this.addWindowListener(new java.awt.event.WindowAdapter()
    {

      public void windowClosed(WindowEvent e)
      {
        this_windowClosed(e);
      }
    });


    //BDebug.print(name);

    // %% Need set the PrivateKEy for the FarmClient to be the same as the PRivateKEy for the Server
    // If this is being run on a clients PC then the bots will have been encrypted using the clients public key so all
    // should be ok
    // So need to init different PrivateKey depending upon the mode
    //
    // ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(BGlobal.PRIVATE_KEY_CLIENT));
    // PrivateKey privateKey = (PrivateKey)in1.readObject();

    // initialize canvas3d
    arena3dCanvas = new BArenaCanvas((JPanel)this.getContentPane());
    arena3dCanvas.setSize(315,200);
    arena3dCanvas.setLocation(5,5);
    arena3dCanvas.setVisible(true);
    this.getContentPane().add(arena3dCanvas,null);


    // Set the simulation running behaviour
    simRunner = new BSimulationBehaviour();
    simRunner.addChangeListener(new ChangeListener()
      {
       public void stateChanged(ChangeEvent e)
       {
          // is running, auto cam, else send the fight stuff up to the server
          if ( simRunner.isRunningSimulation() )
            arena3dCanvas.lookAt(false);
          else
          {
            simToSendUp = true;
            battleRunning = false;
            arena3dCanvas.clear();

            // Removed HSC 18/04/00 thread issue
            // Safer to let the thread control call doStuff than call it from here
            //doStuff(null);
           }

       }
    });
    arena3dCanvas.addBehavior(simRunner);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }

  public static void main(String[] args)
  {
    try
    {

      // Set up log file...
      BSystemLogger.start(SGlobal.FARM_CLIENT_ERROR_PATH);

      if (args.length>0)
      {
        System.out.println("Overiding URLFARMFEEDER with: " + args[0]);
        SGlobal.URLFARMFEEDER = args[0];
      }



      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      // Get the properties of the farm client from the file
      Properties prop = new Properties();
      FileInputStream fIS = new FileInputStream(SGlobal.FARM_CLIENT_PROPERTIES);

      prop.load(fIS);

      String name = prop.getProperty("FCLIENT_NAME");
      String password = prop.getProperty("PASSWORD");

      // Set up the network
      BGlobal.init();
      BGlobal.setBattleAccuracy(BGlobal.BATTLE_ACCURACY_HIGH);

      BGlobal.IS_FARMCLIENT = true;

      BClientStack server = new BClientStack();
      BServerTarget serverTarget = new BServerTarget(SGlobal.URLFARMFEEDER);
      server.setServerTarget(serverTarget);


      server.login(name, password);

      // Create the farm client
      SFarmClient sFarmClient = new SFarmClient(server);
      sFarmClient.validate();
      sFarmClient.setVisible(true);
    }
    catch(Exception e)
    {
      System.err.println("Error main: " + e.getMessage());
      e.printStackTrace();
    }






  }

/*
  public SResponseWrapper pull(URLConnection connection) throws Exception
  {
    SResponseWrapper response = null;

  try
    {
      //ProgressMonitorInputStream monitor = new ProgressMonitorInputStream (this,"Test",connection.getInputStream());

      //monitor.getProgressMonitor().setMillisToPopup(1);
      //monitor.getProgressMonitor().setMillisToDecideToPopup(0);
      ObjectInputStream is = new ObjectInputStream(connection.getInputStream());

      //ObjectInputStream is = new ObjectInputStream(monitor);

      BDebug.print ("Getting object back");

      response = (SResponseWrapper)is.readObject();
      is.close();

    }

    catch (Exception e)
    {
      throw new Exception("Error: SFarmClient/pull: " + e.getMessage());
    }

    return response;
  }

  public void push (URLConnection connection, Object value) throws Exception
  {
    try
    {
      //ByteArrayOutputStream bOS = new ByteArrayOutputStream();
      //ObjectOutputStream OS = new ObjectOutputStream(bOS);
      //OS.writeObject(value);
      //BDebug.print("Size of Object: " + bOS.size());


      connection.setUseCaches(false);
      connection.setRequestProperty("CONTENT_TYPE","application/octet-stream");
      connection.setDoInput(true);
      connection.setDoOutput(true);

      //bOS.writeTo(connection.getOutputStream());
      //bOS.flush();
      //bOS.close();

      ObjectOutputStream os = new ObjectOutputStream(connection.getOutputStream());

      BDebug.print ("Sending object up stream");

      os.writeObject(value);
      os.flush();
      os.close();
    }
    catch (Exception ex)
    {
      throw new Exception("Error: SFarmClient/push: " + ex.getMessage());
    }
  }


  private SResponseWrapper getTransferResponse (String clientName,String transferType, String transferError, Object requestObject) throws Exception
  {

   SResponseWrapper responseWrapper = null;

    try
    {
      // Create the request Wrapper
      SRequestWrapper requestWrapper = new SRequestWrapper(clientName, password, transferType,requestObject,null);

      requestWrapper.setClientID(fightClientID);

      // Prep the connection
      URL url = new URL(SGlobal.URLFARMFEEDER);
      BDebug.print ("Opening Connection");
      URLConnection con = url.openConnection();

      // Send the Request Up
      SServerAccess.push(con,requestWrapper);

      // Get the response back
      responseWrapper = SServerAccess.pull(con);

     }

      catch (Exception ex)
      {
        throw new Exception("Error: SFarmClient/getTransferResponse: " + ex.getMessage());
      }
      return responseWrapper;
     }*/

  public synchronized void doStuff (BData bData) throws Exception
  {

    BMessage response = null;
    BRequest r = null;
    try
    {
      /*if (responseWrapper != null)
      {
        if (responseWrapper.getResponseType().equals("REG"))
        {
          // Set the registration details
          fightClientID = ((Long)responseWrapper.getResponseObject()).longValue();
          //busy = false;
        }
      }

      // Get registered
      if (fightClientID == 0l)
      {
        doStuff(getTransferResponse(name,"REG","Transfer Error",null));
      }*/

      if (simToSendUp)
      {
        // There is a completed simulation to send up
        simToSendUp = false;

        // Create the SFightResult

        BBattleRecorder battleRecording  = simulation.getBattleRecorder();
        BStats bStats1 = battleRecording.getStats(bot1);
        BStats bStats2 = battleRecording.getStats(bot2);
        battleRecording.setTournamentName(fight.tournamentName);
        battleRecording.setRoundName("Round: " + fight.round);

        battleRecording.setTournament(true);
        battleRecording.setFinal(fight.isFinal);

        if (fight.adverts.data != null)
        {
          // Add and required adds
          for(int i = 0;i<fight.adverts.data.length;i++)
          {
            BAdvertData advertData = (BAdvertData)fight.adverts.data[i];
            battleRecording.addAdvert(advertData.getAdvert());
          }
        }
        battleRecording.convertToSaveFormat();
        long winningBot;

        if (battleRecording.getVictoriousBot() == null)
        {
          // It was a draw
          winningBot = 0;
        }
        else if (battleRecording.getVictoriousBot() == bot1)
        {
          // Bot 1 Won
          winningBot = fight.tournamentEntryID1;
        }
        else
        {
          // BOt 2 Won
          winningBot = fight.tournamentEntryID2;
        }

        //SFightResult fightResult = new SFightResult(fight.fightID,battleRecording,bStats1,bStats2,winningBot,fight.tournamentEntryID1,fight.tournamentEntryID2);

        BFightResultData fightResultData = new BFightResultData(fight.getID());
        fightResultData.battleRecordingBytes = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(battleRecording));
        fightResultData.bot1StatsBytes = SServerAccess.gzipDeflateArray(bStats1.toByteArray());
        fightResultData.bot2StatsBytes = SServerAccess.gzipDeflateArray(bStats2.toByteArray());
        fightResultData.winner = winningBot;
        fightResultData.tournamentEntryID1 = fight.tournamentEntryID1;
        fightResultData.tournamentEntryID2 = fight.tournamentEntryID2;
        fightResultData.winDescription = battleRecording.getWinString();

        // Clean Up
        bot1.cleanse();
        bot2.cleanse();

        arena.cleanse();

        battleRecording.cleanse();

        simulation.cleanse();
        simulation = null;
        bot1 = null;
        bot2 = null;
        arena = null;
        simulation = null;
        battleRecording = null;
        BGlobal.clearAllHardCaches();
        System.gc();


        // FRS - Fight ReSult
        r = new BRequest(server, "FRS");

        // Prepare the request Data...
        r.setData(fightResultData);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          doStuff((BData)response.getData());
          //return;
        }
        else
        {
          BDebug.print("NAK");
          //return;
        }

        // FRS - Fight Result
        //doStuff (getTransferResponse(name,"FRS","Transfer Error",fightResult));

        // Removed HSC 18/04/00 thread issue
        //battleRunning = false;

      }
      else if (bData == null)
      {

        // NTS - Nothing To Send
        r = new BRequest(server, "NTS");

        // Prepare the request Data...

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          doStuff((BData)response.getData());
          //return;
        }
        else
        {
          BDebug.print("NAK");
          //return;
        }
        //doStuff (getTransferResponse(name,"NTS","Transfer Error",null));

      }
      else
      {
        // Perform the request

        if (bData instanceof BWaitData)
        {
          // We need to wait so we fall out of the loop
          BDebug.print("**** Waiting ****");
          t.setDelay(((BWaitData)bData).getIDLong().intValue());
          //busy = false;
        }
        else if (bData instanceof BFightToRunData)
        {
          // Fight Time!
          BDebug.print("**** Fight Time ****");

          //fight = (BFight)responseWrapper.getResponseObject();
          fight = (BFightToRunData)bData;

          battleRunning = true;
          // Run the fight
          runFight(fight);
        }
        else if (bData instanceof BBotValidationData)
        {
          // Validation time
          BDebug.print("**** Validation Time ****");
          Vector validationResponse = new Vector();

          BBotValidationData validation = (BBotValidationData)bData;

          // Turn the byte arrays into a Bot
          ByteArrayInputStream byteIS = new ByteArrayInputStream(validation.getBotBytes());
          ObjectInputStream in = new ObjectInputStream(byteIS);
          BBot bot = (BBot)in.readObject();

          Vector validationIssues = new Vector();

          if (botValid(bot, validationIssues,validation.uniqueItems,validation))
          {
            validation.isValid = true;
            //validationResponse.addElement(new Integer(validation.getIDLong().intValue()));
            //validationResponse.addElement("Y");
          }
          else
          {
            BDebug.print ("**** VALIDATION FAILED **** " + bot.getName());
            // Validation Failed so there must be Validation Issues
            // Add all the validation Issues to a string
            String validationProblems = new String();
            for (int i = 0;i < validationIssues.size();i++)
            {
              validationProblems = validationProblems + (String)validationIssues.elementAt(i) + ":";
            }

            validation.isValid = false;
            validation.validationErrors = validationProblems;
            //validationResponse.addElement(new Integer(validation.getIDLong().intValue()));
            //validationResponse.addElement("N");
            //validationResponse.addElement(validationProblems);

          }

          // VAL - VALidation Response
          r = new BRequest(server, "VAL");

          // Prepare the request Data...
          r.setData(validation);

          // Get the response back from the server...
          BTransmission t = new BTransmission(r);
          response = server.request(t);

          if (response.isAcknowledgement())
          {
            BDebug.print("ACK");
            doStuff((BData)response.getData());
            //return;
          }
          else
          {
            BDebug.print("NAK");
            //return;
          }
          //doStuff (getTransferResponse(name,"VAL","",validationResponse));
          battleRunning = false;
        }

        // %% Need to sort out client name on creation - get from file??
        //doStuff (getTransferResponse(name,"VAL","Validation Error",validationResponse));
        }
      }
    catch (Exception e)
    {
      throw new Exception("Error: SFarmClient/doStuff: " + e.getMessage());
    }

  }

  private boolean botValid(BBot bot, Vector validationIssues, Vector uniqueItems,BBotValidationData val)
  {
    // Init the bot

    // The Old Way
    //bot.init(true,validationIssues,uniqueItems,false);
    bot.init(true);
    validationIssues = bot.validate(true);

    // Check to see if the bot is the correct cost for the tournament
    if (bot.getTotalPrice() > val.tournamentPriceCap)
    {
      // The bot is over priced for the tournament
      validationIssues.addElement("Bot is Overpriced");
    }

    if (validationIssues.isEmpty())
      return true;
    else
      return false;

  }

  protected void stripOutArenaDetails()
  {
    // Remove anena ornaments and cache them
    Vector arenaObjects = arena.getArenaObjects(false);
    BArenaObject a = null;

    for (int i=0; i<arenaObjects.size(); i++)
    {
      a = (BArenaObject) arenaObjects.get(i);
      arena.removeArenaObject(a);
    }
  }

    protected void addBotToArena(BBot b)
  {
    // Clean-up the bot.
    b.cleanseLiveNodes();
    b.clearCurrentJointTransforms();

    // Place the Bot into the first spare slot in the arena.
    Vector v = arena.getPlaceHolders(BPlaceHolder.TYPE_BOT);
    arena.addArenaObject((BPlaceHolder) v.firstElement(), b);
  }


  private void runFight (BFightToRunData fightIn) throws Exception
  {

    try
    {

      // Turn the byte arrays into Bots
      // Bot1
      ByteArrayInputStream byteIS = new ByteArrayInputStream(fightIn.getBot1());
      ObjectInputStream in = new ObjectInputStream(byteIS);
      bot1 = (BBot)in.readObject();
      bot1.setCreatorName(fightIn.bot1CreatorName);
      bot1.setBotSerialID(fight.tournamentEntryID1 + "");

      // Bot2
      byteIS = new ByteArrayInputStream(fightIn.getBot2());
      in = new ObjectInputStream(byteIS);
      bot2 = (BBot)in.readObject();
      bot2.setCreatorName(fightIn.bot2CreatorName);
      bot2.setBotSerialID(fight.tournamentEntryID2 + "");

      bot1.init(false);
      bot2.init(false);
      bot1.validate(false);
      bot2.validate(false);

      // Create the Arena
      filePath = BGlobal.ARENAPATH + fightIn.arenaFileName + BGlobal.ARENASUFFIX;

      arena = BArena.loadFromFile(filePath, false);

      stripOutArenaDetails();

      addBotToArena(bot1);
      arena3dCanvas.loadArenaObject(bot1);

      addBotToArena(bot2);
      arena3dCanvas.loadArenaObject(bot2);

      simulation = new BSimulation(bot1, bot2, arena, fightIn.fightDuration, arena3dCanvas, true, true);
      BDebug.print("starting simRunner;");

      simRunner.start(simulation);

    }
    catch (Exception e)
    {
      throw new Exception("Error: SFarmClient/runFight: " +e.getMessage());
    }

  }

  public void actionPerformed (ActionEvent ae)
  {

    try
    {

      BDebug.print("BUSY : " + busy);
      BDebug.print("BattleRunning : " + battleRunning);
      BDebug.print("!busy && !battleRunning : " + (!busy && !battleRunning));
      if (!busy && !battleRunning)
      {
        // If it's not busy processing then do something
        busy = true;

        doStuff(null);

        // Finished process now available for another task
        busy = false;

        // Clean up the output file
        if (dirFile.exists() && dirFile.length() > 524288)
        {
          BDebug.print("DELETED ERROR FILE ");
          BSystemLogger.stop();
          BSystemLogger.start(SGlobal.FARM_CLIENT_ERROR_PATH);
        }

        // %%Write something to the auto re-boot file here??
      }
      else if (battleRunning  && !busy)
      {
        BMessage response = null;
        BRequest r = null;

        // Send a battle progress report to the server
        float complete = (simulation.getElapsedTime()/(simulation.getElapsedTime() + simulation.getRemainingTime())*100);
        //Integer percentComplete = new Integer((int)complete);

        BDebug.print("******* PC: " + complete + " FightID: " + fight.getID());

        //Vector v = new Vector();

        //v.addElement(percentComplete);
        //v.addElement(new Long(fight.fightID));

        //getTransferResponse(name,"PRO","Transfer Error",v);

        BProgressData progressData = new BProgressData(fight.getID());
        progressData.progress = (int)complete;

        // PRO - PROgress of Fight
        r = new BRequest(server, "PRO");

        // Prepare the request Data...
        r.setData(progressData);

        // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          //return;
        }
        else
        {
          BDebug.print("NAK");
          //return;
        }
      }
    }

    catch (Exception e)
    {

      System.out.println("Error actionPerformed: " + e.getMessage());
      System.err.println("Error actionPerformed: " + e.getMessage());


      /*// Save old settings.
  	  PrintStream oldErrOut = System.err;

  	  // Create/Open logfile.

      System.err.println("Error actionPerformed: " + e.getMessage());

  	  // Start redirecting the output.
      System.setErr(logfile);


      System.err.println(e.getMessage());
      busy = false;
      logfile.flush();


      // Set things back to how they were
      System.setErr(oldErrOut);*/
    }
  }

  void this_windowClosed(WindowEvent e)
  {
    BSound.close();
    logfile.close();
  }
}
