package roboforge;


import roboforge.net.*;
import roboforge.net.data.*;
import roboforge.net.client.*;
import roboforge.net.server.*;
import roboforge.net.services.*;

import roboforge.util.io.*;
import roboforge.util.data.*;

//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;

import oracle.sql.*;
import oracle.jdbc.driver.*;

//import java.lang.reflect.Array;
import java.io.*;
import java.util.*;
//import java.security.*;
import java.sql.*;
//import java.util.zip.*;

//import javax.crypto.Cipher;
//import javax.servlet.*;
//import javax.servlet.http.*;
import javax.swing.ImageIcon;
import roboforge.server.util.*;

public class SFarmFeeder extends SGatewayAbstract
{

  // Member variables...
  // -------------------------------------------------------------


  // Servlet info method...
  // -------------------------------------------------------------

  public String getServletInfo()
    { return "roboforge.SFarmFeeder"; }

  // Request Handler initialization...
  // -------------------------------------------------------------

  protected void initializeHandlers()
  {
    handlers = new HashMap();

    register(new EchoHandler());
    //register(new AccountCreationHandler());
    register(new LoginHandler());
    register(new NothingToSendRequestHandler());
    register(new ProgressReportHandler());
    register(new ValidationReturnedHandler());
    register(new ProcessFightResultsHandler());
    register(new SetFightOverHandler());

  }

  // Echo handler (this class should be deleted)...
  // -------------------------------------------------------------

  protected static class EchoHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "ECHO"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
      BMessage response =
        BMessage.ACK("ECHO");

      response.setData(request.getData());

      // Zip and encrypt the response...
      services.add(BServices.zip());
      //services.add(BServices.encrypt());

      return response;
    }
  }


  protected static void closeResultSet(ResultSet rs, String location)
  {
    try
    {
      if (rs != null)
        rs.close();
    }
    catch (Exception e)
    {
      System.err.println("SFarmFeeder/closeResultSet: "+ location + ": " + e);
    }

  }

  protected static void closeStatement(Statement statement, String location)
  {
    try
    {
      if (statement != null)
        statement.close();
    }
    catch (Exception e)
    {
      System.err.println("SFarmFeeder/closeStatement: "+ location + ": " + e);
    }

  }


  // Login request handler...
  // -------------------------------------------------------------

  protected static class LoginHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "LOG"; }

    public BMessage respond
      (BRequest request, RequestState reqState, BServiceSet services)
    {
      BLoginData loginData = new BLoginData(-1);
      loginData.accountID = reqState.accountID;

      Calendar cal = Calendar.getInstance(TimeZone.getDefault());
      cal.setTime(new java.util.Date(System.currentTimeMillis()));

      loginData.serverTime = cal;

      //loginData.serverTime = System.currentTimeMillis();

      return BMessage.ACK("LOG", loginData);


       //return BMessage.ACK("LOG", new BIdentData(reqState.accountID));

    }
  }
  private static BData getSomethingToDo (RequestState reqState)
  {
   String sql;
   Statement statement = null;
   ResultSet rs = null;
   Statement statement1 = null;
   ResultSet rs1 = null;

   try
   {
    Connection con = reqState.con;


    // Turn off autocommit so we can rollback in the event of any errors
    con.setAutoCommit(false);

    long fightclientID = reqState.accountID;

    // See if there are any fights that need running of the type the fight client can run
    // Build different SQL depending upon the Type of Farm Client making the request

    if (reqState.type.equals("INTFC"))
    {
      // Request comes from an Internal Tournament Farm Client
      sql = "SELECT t.close_date, f.id";
      sql = sql + " FROM FIGHT f, TOURNAMENT t";
      sql = sql + " WHERE t.id = f.tournament_id";
      sql = sql + " AND f.status = 'WAITING'";
      sql = sql + " AND t.type = 'INTFC'";
      sql = sql + " ORDER BY t.close_date, f.id";
    }
    else if (reqState.type.equals("INCFC"))
    {
      // Request comes from an Internal Challenge Farm Client
      sql = "SELECT t.close_date, f.id";
      sql = sql + " FROM FIGHT f, TOURNAMENT t";
      sql = sql + " WHERE t.id = f.tournament_id";
      sql = sql + " AND f.status = 'WAITING'";
      sql = sql + " AND t.type = 'INCFC'";
      sql = sql + " ORDER BY t.close_date, f.id";
    }
    else if (reqState.type.equals("EXCFC"))
    {
      // Request comes from an External Challenge Farm Client
      sql = "SELECT t.close_date, f.id";
      sql = sql + " FROM FIGHT f, TOURNAMENT t";
      sql = sql + " WHERE t.id = f.tournament_id";
      sql = sql + " AND f.status = 'WAITING'";
      sql = sql + " AND t.type = 'EXCFC'";
      sql = sql + " AND t.clientID = " + reqState.accountID;
      sql = sql + " ORDER BY t.close_date, f.id";
    }
    else
    {
      // Request is of type not known or currently allowed
      // eg EXTFC  - External Tournament Farm Client
      return null;
    }



    statement = con.createStatement();
    rs = statement.executeQuery(sql);

    if (rs.next())
    {
      // There is at least one fight that needs running
      // Attempt to assign that fight to this Fight Client

      long fightID = rs.getLong("id");
      rs.close();
      statement.close();

      sql = "UPDATE FIGHT";
      sql = sql + " SET status = 'FIGHTING', fight_client_id = "+ fightclientID;
      sql = sql + " WHERE id = "+ fightID;
      sql = sql + " AND status = 'WAITING'";
      statement = con.createStatement();
      if (statement.executeUpdate(sql) == 1)
      {
        long tournamentID;

        statement.close();
        // The fight was assigned to the Fight_Client
        // Get the Fight Duration, arena_file_name and the two bots, wrap them up in a BFightToRunData object
        // and send it to the Fight Client

        sql = "SELECT f.tournament_entry1_id, f.tournament_entry2_id, t.arena_file_name, t.fight_duration, t.name, f.round, final,t.id AS TID";
        sql = sql + " FROM TOURNAMENT t, FIGHT f";
        sql = sql + " WHERE t.id = f.tournament_id";
        sql = sql + " AND f.id = " + fightID;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        long tournamentEntry1 = rs.getLong("tournament_entry1_id");
        long tournamentEntry2 = rs.getLong("tournament_entry2_id");
        String arenaFileName = rs.getString("arena_file_name");
        float fightDuration = rs.getFloat("fight_duration");
        String tournamentName = rs.getString("name");
        int fightRound = rs.getInt("round");
        tournamentID = rs.getLong("TID");

        String isFinalTemp = rs.getString("final");
        boolean isFinal;

        if (isFinalTemp.equals("Y"))
          isFinal = true;
        else
          isFinal = false;



        rs.close();
        statement.close();

        // Get the designer name of the first bot
        sql = "SELECT designer_name FROM ACCOUNT a, TOURNAMENT_ENTRY te";
        sql = sql + " WHERE te.account_id = a.id";
        sql = sql + " AND te.id = " + tournamentEntry1;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        String designerName1 = rs.getString("designer_name");

        rs.close();
        statement.close();

        // Get the designer name of the second bot
        sql = "SELECT designer_name FROM ACCOUNT a, TOURNAMENT_ENTRY te";
        sql = sql + " WHERE te.account_id = a.id";
        sql = sql + " AND te.id = " + tournamentEntry2;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        String designerName2 = rs.getString("designer_name");

        rs.close();
        statement.close();

        // Get the first bot out of the fight
        sql = "SELECT bot_file";
        sql = sql + " FROM TOURNAMENT_ENTRY";
        sql = sql + " WHERE id = " + tournamentEntry1;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        // And turn it into a byte array
        byte[] bot1Bytes = SServerUtility.blobToByteArray (((OracleResultSet)rs).getBLOB("bot_file"));
        rs.close();
        statement.close();

        // Get the second bot out of the fight
        sql = "SELECT bot_file";
        sql = sql + " FROM TOURNAMENT_ENTRY";
        sql = sql + " WHERE id = " + tournamentEntry2;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);
        rs.next();

        // And turn it into a byte array
        byte[] bot2Bytes = SServerUtility.blobToByteArray (((OracleResultSet)rs).getBLOB("bot_file"));
        rs.close();
        statement.close();

        // Find all the related Advert objects
        sql = "SELECT id, advert FROM TOURNAMENT_ADVERT WHERE tournament_id = " + tournamentID;
        statement = con.createStatement();
        rs = statement.executeQuery(sql);

        BDataSet dataSet = new BDataSet();

        while (rs.next())
        {
          BAdvertData advertData = new BAdvertData(rs.getLong("id"));
          advertData.setAdvertArray(SServerUtility.blobToByteArray (((OracleResultSet)rs).getBLOB("advert")));
          dataSet.add(advertData);
        }

        rs.close();
        statement.close();

        // Update the fight_client_log
        sql = "INSERT INTO FIGHT_CLIENT_LOG (fight_client_id, task_type, fight_id)";
        sql = sql + " VALUES(" + fightclientID + ",'FGT'," + fightID + ")";
        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        // Create the BFightToRunObject
        BFightToRunData fightToRunData = new BFightToRunData(fightID);
        fightToRunData.bZippedBotBytes1 = bot1Bytes;
        fightToRunData.bZippedBotBytes2 = bot2Bytes;
        fightToRunData.tournamentEntryID1 = tournamentEntry1;
        fightToRunData.tournamentEntryID2 = tournamentEntry2;
        fightToRunData.arenaFileName = arenaFileName;
        fightToRunData.fightDuration = fightDuration;
        fightToRunData.bot1CreatorName = designerName1;
        fightToRunData.bot2CreatorName = designerName2;
        fightToRunData.round = fightRound;
        fightToRunData.tournamentName = tournamentName;
        fightToRunData.isFinal = isFinal;
        fightToRunData.adverts = dataSet;
        /*
        // Create the SFight object and wrap it
        SFight fight = new SFight(bot1Bytes,bot2Bytes,tournamentEntry1,tournamentEntry2,arenaFileName,fightDuration,fightID);

        // Set the additional properties
        fight.bot1CreatorName = designerName1;
        fight.bot2CreatorName = designerName2;
        fight.round = fightRound;
        fight.tournamentName = tournamentName;

        // FGT = Fight Tells the client that it's a fight object coming it's way
        responseWrapper =  new SResponseWrapper("FGT",fight); */
        return fightToRunData;

      }
      else
      {
        // Another Fight_Client got in before this fight could
        // be assigned to this Fight_Client therefore tell the client to wait
        statement.close();

        //responseWrapper =  new SResponseWrapper("WAI",null);
        return null;

      }

    }
    else
    {
      rs.close();
      statement.close();

      // Create the SQL, depending upon the type of Farm client making the request
      // to see if there are any tournament entries that need to be validated

      if (reqState.type.equals("INTFC"))
      {
        // Request comes from an Internal Tournament Farm Client
        sql = "SELECT te.id, te.account_id, te.bot_file";
        sql = sql + " FROM TOURNAMENT t, TOURNAMENT_ENTRY te";
        sql = sql + " WHERE t.id = te.tournament_id";
        sql = sql + " AND (t.status <> 'CLOSED' AND t.status <> 'FIGHTING')";
        sql = sql + " AND te.status IS NULL";
        sql = sql + " ORDER BY t.close_date";
      }
      else if (reqState.type.equals("INCFC"))
      {
        // Request comes from an Internal Challenge Farm Client
        sql = "SELECT te.id, te.account_id, te.bot_file";
        sql = sql + " FROM TOURNAMENT t, TOURNAMENT_ENTRY te";
        sql = sql + " WHERE t.id = te.tournament_id";
        sql = sql + " AND (t.status <> 'CLOSED' AND t.status <> 'FIGHTING')";
        sql = sql + " AND te.status IS NULL";
        sql = sql + " AND t.type = 'INCFC'";
        sql = sql + " ORDER BY t.close_date";
      }
      else if (reqState.type.equals("EXCFC"))
      {
        // Request comes from an External Challenge Farm Client
        sql = "SELECT te.id, te.account_id, te.bot_file";
        sql = sql + " FROM TOURNAMENT t, TOURNAMENT_ENTRY te";
        sql = sql + " WHERE t.id = te.tournament_id";
        sql = sql + " AND (t.status <> 'CLOSED' AND t.status <> 'FIGHTING')";
        sql = sql + " AND te.status IS NULL";
        sql = sql + " AND t.type = 'EXCFC'";
        sql = sql + " AND t.clientID = " + reqState.accountID;
        sql = sql + " ORDER BY t.close_date";
      }
      else
      {
        // Request is of type not known or currently allowed
        // eg EXTFC  - External Tournament Farm Client
        return null;
      }


      // Check to see if there are any Tournament_Entries that need to be Validated
      sql = "SELECT te.id, t.bot_price_cap, te.account_id, te.bot_file";
      sql = sql + " FROM TOURNAMENT_CLASSIFICATION t, TOURNAMENT_ENTRY te";
      sql = sql + " WHERE t.id = te.tournament_id";
      sql = sql + " AND (t.status <> 'CLOSED' AND t.status <> 'FIGHTING')";
      sql = sql + " AND te.status IS NULL";
      sql = sql + " ORDER BY t.close_date";
      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      if (rs.next())
      {
        // There is at least one Tournament Entry that needs Validation


        int tournamentEntryID = rs.getInt("id");
        int accountID = rs.getInt("account_id");
        float botPriceCap = rs.getFloat("bot_price_cap");
        // Get the bot file
        //Blob myReadBlob =  rs.getBlob("bot_file");
        // Changed fromn the Oracle way
        byte[] botBytes = SServerUtility.blobToByteArray (((OracleResultSet)rs).getBLOB("bot_file"));
        //byte[] botBytes = blobToByteArray (myReadBlob);
        rs.close();
        statement.close();

        // Set the Tournament_Entry to P for processing
        sql = "UPDATE tournament_entry";
        sql = sql + " SET status = 'P'";
        sql = sql + " WHERE id = "+ tournamentEntryID;
        sql = sql + " AND status IS NULL";
        statement = con.createStatement();


        if (statement.executeUpdate(sql) == 1)
        {
          statement.close();
          // The record was updated
          // Get the Unique Items that the Account Holds
          statement.close();

          sql = "SELECT id";
          sql = sql + " FROM COMPONENT";
          sql = sql + " WHERE current_owner = " + accountID;

          statement1 = con.createStatement();
          rs1 = statement1.executeQuery(sql);

          Vector uniqueItems = new Vector();

          while(rs1.next())
          {
            // Add all the Unique items for this Account to the Vector
            uniqueItems.addElement(new Integer(rs1.getInt("id")));

          }
          rs1.close();
          statement1.close();

          // Update the fight_client_log
          sql = "INSERT INTO FIGHT_CLIENT_LOG (fight_client_id, task_type, tournament_entry_id)";
          sql = sql + " VALUES(" + fightclientID + ",'VAL'," + tournamentEntryID + ")";
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();


          BBotValidationData botValidationData = new BBotValidationData(tournamentEntryID);
          botValidationData.botBytes = botBytes;
          botValidationData.uniqueItems = uniqueItems;
          botValidationData.tournamentPriceCap = botPriceCap;

          return botValidationData;
          // Create the validation object
          //SValidation validation = new SValidation(botBytes,tournamentEntryID,uniqueItems);

          // 'VAL' for validation
          //responseWrapper = new SResponseWrapper("VAL", validation);
        }
        else
        {
          // Not updated another client got it (very unlikely)
          // Tell the client to wait
          statement.close();
          //responseWrapper =  new SResponseWrapper("WAI",null);
          return null;
        }
      }
      else
      {
        // There aren't any bots to validate - Tell the client to wait
        rs.close();
        statement.close();

        return null;
        //responseWrapper =  new SResponseWrapper("WAI",null);
      }
    }

   }
   catch (Exception e)
   {
      System.err.println("SFarmFeeder/getSomethingToDo: " + e.getMessage());
      return null;
   }
   finally
   {
    closeResultSet(rs,"SFarmFeeder/getSomethingToDo");
    closeResultSet(rs1,"SFarmFeeder/getSomethingToDo");
    closeStatement(statement,"SFarmFeeder/getSomethingToDo");
    closeStatement(statement1,"SFarmFeeder/getSomethingToDo");
   }
  }

  // Get the Nothing To Send request handler...
  // -------------------------------------------------------------
  protected static class NothingToSendRequestHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "NTS"; }


    public BMessage respond (BRequest request, RequestState reqState, BServiceSet services)
    {

      try
      {
          BData bData = getSomethingToDo(reqState);
          services.add(BServices.zip());

          if (bData != null)
            return BMessage.ACK("NTS",bData);
          else
          {
            // If there's nothing to do or there's an error tell the
            // client to wait
            // TODO: Improve the response in the case of an error
            return BMessage.ACK("NTS",new BWaitData(10000));
          }

      }
      catch (Exception e)
      {
        System.err.println("SFarmFeeder/NothingToSendRequestHandler: " + e.getMessage());
        return BMessage.error("NTS", "SFarmFeeder/NothingToSendRequestHandler: " + e.getMessage());
      }
    }

  }

  

  // Get the ProgressReportHandler request handler...
  // -------------------------------------------------------------
  protected static class ProgressReportHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "PRO"; }

    public BMessage respond (BRequest request, RequestState reqState, BServiceSet services)
    {
      Statement statement = null;
      //ResultSet rs = null;
      String sql;

      try
      {
        Connection con = reqState.con;

        BProgressData progressData = (BProgressData)request.getData();

        // First see if the Client already exists
        sql = "UPDATE FIGHT_CLIENT_LOG SET fight_progress = " + progressData.progress;
        sql = sql + " WHERE fight_id = " + progressData.getID();
        sql = sql + " AND fight_client_id = " + reqState.accountID;
        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        services.add(BServices.zip());
        //services.add(BServices.encrypt());

        return BMessage.ACK("PRO", null);
      }
      catch (Exception e)
      {
        System.err.println(e.getMessage());
        return BMessage.error("PRO",e.getMessage());
      }
      finally
      {
        closeStatement(statement,"SFarmFeeder/ProgressReportHandler");
      }
    }
  }



  // Get the ValidationReturnedHandler request handler...
  // -------------------------------------------------------------
  protected static class ValidationReturnedHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "VAL"; }


    public BMessage respond (BRequest request, RequestState reqState, BServiceSet services)
    {
      Connection con = null;
      String sql;

      Statement statement = null;
      ResultSet rs = null;

      try
      {
        /*
          If the entry hasn't been validated then update it.
        */
        BBotValidationData botValidationData = (BBotValidationData)request.getData();

        long id = reqState.accountID;
        con = reqState.con;

        long tournamentEntryID = botValidationData.getID();

        sql = "SELECT Count(*) As count FROM TOURNAMENT_ENTRY WHERE id = " + tournamentEntryID;
        sql = sql + " AND status = 'P'";
        statement = con.createStatement();
        rs = statement.executeQuery(sql);

        rs.next();
        int count = rs.getInt("count");

        rs.close();
        statement.close();

        if (count != 0)
        {
          con.setAutoCommit(false);

          String validationIssues = null;
          //String value = (String)validationVector.elementAt(1);

          System.err.println("Got the validation results for te: " + tournamentEntryID);

          if (!botValidationData.isValid)
          {
            System.err.println("Validation Issues");
            //validationIssues = (String)validationVector.elementAt(2);
            // There are validation issues so update the SQL accordingly
            sql = "UPDATE TOURNAMENT_ENTRY SET status = 'N', validation_notes = '"+botValidationData.validationErrors+ "'";
            sql = sql + " WHERE id = " + tournamentEntryID;
            sql = sql + " AND status = 'P'";
            System.err.println(sql);
          }
          else
          {
            // No validation Issues
            sql = "UPDATE TOURNAMENT_ENTRY SET status = 'Y'";
            sql = sql + " WHERE id = " + tournamentEntryID;
            sql = sql + " AND status = 'P'";
          }
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // Update the fight_client_log
          sql = "UPDATE FIGHT_CLIENT_LOG SET date_time_finish	= SysDate";
          sql = sql + " WHERE tournament_entry_id	= " + tournamentEntryID + " AND fight_client_id = " + id;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // TODO: As email structure has changed work out new structure
          /*
          // If there were any validation issues send a warning Email
          if (!value.equals("Y"))
          {
            // Get Information about this entry
            sql = "SELECT a.id, a.email, te.bot_name FROM ACCOUNT a, TOURNAMENT_ENTRY te";
            sql = sql + " WHERE te.account_id = a.id";
            sql = sql + " AND te.id = " + tournamentEntryID;
            System.err.println(sql);
            Statement statement1 = con.createStatement();
            rs = statement1.executeQuery(sql);

            rs.next();
            int accountID = rs.getInt("id");
            String email = rs.getString("email");
            String botName = rs.getString("bot_name");

            rs.close();
            statement1.close();

            // Create the Email entry
            sql = "INSERT INTO EMAIL (account_id, tournament_entry_id, email, subject, body, status)";
            sql = sql + " VALUES ("+ accountID + "," + tournamentEntryID + ",'" + email + "','" + botName + " Failed Validation','" +validationIssues + "','P')";
            System.err.println(sql);
            statement1 = con.createStatement();
            statement1.executeUpdate(sql);
            statement1.close();
          }
          */


        }
        else
        {
          // Couldn't find status set to P
          System.err.println("Error: SFarmFeeder/ValidationReturnedHandler: Couldn't Find Tournament Entry Set to 'P' for teid: " + tournamentEntryID);
        }
        return BMessage.ACK("VAL",null);
        
      }
      catch (Exception e)
      {
        try
        {
          con.rollback();
        }
        catch (SQLException sqle)
        {
          System.err.println("SFarmFeeder/ValidationReturnedHandler: " + sqle );
          return BMessage.error("VAL", sqle.getMessage());
        }

          System.err.println("SFarmFeeder/ValidationReturnedHandler: " + e );
          return BMessage.error("VAL", e.getMessage());
      }
      finally
      {
        closeResultSet(rs,"SFarmFeeder/ValidationReturnedHandler");
        closeStatement(statement,"SFarmFeeder/ValidationReturnedHandler");
      }
    }
  }

  // Get the SetFightOverHandler handler...
  // -------------------------------------------------------------
  // This is only used for fights run on External Farm clients for challenge rooms
  // to let the challenge room servelt that the fight has completed and therefore
  // don't delete it so soon if it doesn't finish
  protected static class SetFightOverHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "SFO"; }

    public BMessage respond (BRequest request, RequestState reqState, BServiceSet services)
    {
      String sql;
      Statement statement = null;
      ResultSet rs = null;
      Connection con = null;

      try
      {
        con = reqState.con;

        BIdentData identData = (BIdentData)request.getData();

        /*
          If the fight hasn't been updated then update it.
        */

        sql = "SELECT Count(*) As count FROM FIGHT WHERE id = " + identData.getID();
        sql += " AND status <> 'FOUGHT'";

        statement = con.createStatement();
        rs = statement.executeQuery(sql);

        rs.next();
        int count = rs.getInt("count");

        rs.close();
        statement.close();

        if (count != 0)
        {
          // Update the fight_client_log
          sql = "UPDATE FIGHT_CLIENT_LOG SET fight_progress = 100";
          sql = sql + " WHERE fight_id = " + identData.getID() + " AND fight_client_id = " + reqState.accountID;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }
        else
        {
          // This will be very odd as couldn't find the fighting fight
          System.err.println("SFarmFeeder/SetFightOverHandler:Couldn't find the fighting fight for fight id: " + identData.getID());
        }
      }
      catch (Exception e)
      {
        System.err.println("SFarmFeeder/SetFightOverHandler: " + e );
        return BMessage.error("SFO", e.getMessage());
      }
      finally
      {
        closeResultSet(rs,"SFarmFeeder/SetFightOverHandler");
        closeStatement(statement,"SFarmFeeder/SetFightOverHandler");
      }

    return BMessage.ACK("SFO");
    }

  }

  // Get the ProcessFightResultsHandler handler...
  // -------------------------------------------------------------
  protected static class ProcessFightResultsHandler extends ValidatedRequestHandler
  {
    public String getType()
      { return "FRS"; }

    public BMessage respond (BRequest request, RequestState reqState, BServiceSet services)
    {
      String sql;
      Statement statement = null;
      ResultSet rs = null;
      Statement stmt_1 = null;
      ResultSet rset = null;
      Connection con = null;

      try
      {
        con = reqState.con;

        BFightResultData fightResultData = (BFightResultData)request.getData();

        /*
          If the fight hasn't been updated then update it.
        */

        sql = "SELECT Count(*) As count FROM FIGHT WHERE id = " + fightResultData.getID();
        sql = sql + " AND status <> 'FOUGHT'";
        statement = con.createStatement();
        rs = statement.executeQuery(sql);

        rs.next();
        int count = rs.getInt("count");

        rs.close();
        statement.close();

        if (count != 0)
        {
          con.setAutoCommit(false);

          // Update the fight
          sql = "UPDATE FIGHT SET status = 'FOUGHT', result = "+ fightResultData.winner + ",won_by = '" + fightResultData.winDescription + "'";
          sql = sql + " WHERE id = " + fightResultData.getID();
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // Update the fight_client_log
          sql = "UPDATE FIGHT_CLIENT_LOG SET date_time_finish	= SysDate, fight_progress = 100";
          sql = sql + " WHERE fight_id = " + fightResultData.getID() + " AND fight_client_id = " + reqState.accountID;
          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();

          // Get the round from the fight
          sql = "SELECT round FROM FIGHT";
          sql = sql + " WHERE id = "+ fightResultData.getID();
          statement = con.createStatement();
          rs = statement.executeQuery(sql);
          rs.next();

          int round = rs.getInt("round");
          rs.close();
          statement.close();

          // Update the Tournament
          if (fightResultData.winner == 0)
          {
            // Fight is a draw - Update both Tournament_Entries setting their final round
            sql = "UPDATE TOURNAMENT_ENTRY SET highest_round = " + round;
            sql = sql + " WHERE id = " + fightResultData.tournamentEntryID1;
            sql = sql + " OR id = " + fightResultData.tournamentEntryID2;
            //BDebug.print(sql);
            statement = con.createStatement();
            statement.executeUpdate(sql);
            statement.close();
          }
          else
          {
            // Update the highest round on the losing bot
            long loserBot;

            if (fightResultData.tournamentEntryID1 == fightResultData.winner)
              loserBot = fightResultData.tournamentEntryID2;
            else
              loserBot = fightResultData.tournamentEntryID1;

            sql = "UPDATE TOURNAMENT_ENTRY SET highest_round = " + round;
            sql = sql + " WHERE id = " + loserBot;
            statement = con.createStatement();
            statement.executeUpdate(sql);
            statement.close();
          }

          // Add the battle recording and the bot stats as BLOBS to the FIGHT table
          String cmd = "SELECT battle_recording, battle_stats1, battle_stats2";
          cmd = cmd + " FROM FIGHT";
          cmd = cmd + " WHERE id=" + fightResultData.getID() + " FOR UPDATE";

          stmt_1 = con.createStatement();
          rset = stmt_1.executeQuery(cmd);
          rset.next();

          // Get the handles to the three blobs

          BLOB blobBattleRecording = ((OracleResultSet)rset).getBLOB("battle_recording");
          BLOB blobBattleStats1 = ((OracleResultSet)rset).getBLOB("battle_stats1");
          BLOB blobBattleStats2 = ((OracleResultSet)rset).getBLOB("battle_stats2");

          //System.err.println("Battle Recording Size: " + java.lang.reflect.Array.getLength(fightResultData.battleRecordingBytes));
          //System.err.println("Bot 1 Stats: " + java.lang.reflect.Array.getLength(fightResultData.bot1StatsBytes));
          //System.err.println("Bot 2 Stats: " + java.lang.reflect.Array.getLength(fightResultData.bot2StatsBytes));
          System.err.println("Got the fight results for fight: " + fightResultData.getID());

          // Get the BattleRecording and insert into blob
          OutputStream outstream = blobBattleRecording.getBinaryOutputStream();

          ByteArrayInputStream instream = new ByteArrayInputStream(fightResultData.battleRecordingBytes);

          int chunk = 4096;
          byte[] buffer = new byte[chunk];
          int length = -1;

          while ((length = instream.read(buffer)) != -1)
            outstream.write(buffer, 0, length);

          instream.close();
          outstream.flush();
          outstream.close();

          blobBattleRecording = null;
          //System.gc();

          // BattleStats1 to into blob
          instream = new ByteArrayInputStream(fightResultData.bot1StatsBytes);
          outstream = blobBattleStats1.getBinaryOutputStream();


          buffer = new byte[chunk];

          while ((length = instream.read(buffer)) != -1)
            outstream.write(buffer, 0, length);

          instream.close();
          outstream.close();

          blobBattleStats1 = null;
          //System.gc();

          // BattleStats2 to into blob
          instream = new ByteArrayInputStream(fightResultData.bot2StatsBytes);

          outstream = blobBattleStats2.getBinaryOutputStream();


          buffer = new byte[chunk];

          while ((length = instream.read(buffer)) != -1)
            outstream.write(buffer, 0, length);

          //Before the zip

          instream.close();
          outstream.close();

          blobBattleStats1 = null;
          //System.gc();

          rset.close();
          stmt_1.close();

        }
        else
        {
          // This will be very odd as couldn't find the fighting fight
          System.err.println("SFarmFeeder/ProcessFightResultsHandler:Couldn't find the fighting fight for fight id: " + fightResultData.getID());
        }
      }
      catch (Exception e)
      {
        try
        {
          con.rollback();
        }
        catch (SQLException sqle)
        {
          System.err.println("SFarmFeeder/ProcessFightResultsHandler: " + sqle );
          return BMessage.error("FRS", sqle.getMessage());
        }

        System.err.println("SFarmFeeder/ProcessFightResultsHandler: " + e );
        return BMessage.error("FRS", e.getMessage());
      }
      finally
      {
        closeResultSet(rs,"SFarmFeeder/ProcessFightResultsHandler");
        closeStatement(statement,"SFarmFeeder/ProcessFightResultsHandler");
        closeResultSet(rset,"SFarmFeeder/ProcessFightResultsHandler");
        closeStatement(stmt_1,"SFarmFeeder/ProcessFightResultsHandler");
      }

    return BMessage.ACK("FRS");
    }

  }
}



