package roboforge;

import java.io.*;
import java.security.*;
import javax.crypto.Cipher;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

public class SFight implements Serializable
{

  /*

  * Description:
    Holds the information necessary for a Fight_Client to perform a fight
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 10-Feb-2000

  */

  private byte[] bZippedBotBytes1;
  private byte[] bZippedBotBytes2;
  long tournamentEntryID1;
  long tournamentEntryID2;
  String arenaFileName;
  float fightDuration;
  long fightID;
  String tournamentName;
  int round;
  String bot1CreatorName;
  String bot2CreatorName;

  public SFight(byte[] bot1In, byte[] bot2In, long tournamentEntryID1In, long tournamentEntryID2In, String arenaFileNameIn, float fightDurationIn, long fightIDIn)
  {
    bZippedBotBytes1 = bot1In;
    bZippedBotBytes2 = bot2In;
    tournamentEntryID1 = tournamentEntryID1In;
    tournamentEntryID2 = tournamentEntryID2In;
    arenaFileName = arenaFileNameIn;
    fightDuration = fightDurationIn;
    fightID = fightIDIn;
  }

  public byte[] getBot1(PrivateKey prvKey) throws Exception
  {
    try
    {
      //return toBotBytes(bEncryptedObjectBytes1, prvKey);
      return SServerAccess.gzipInflateArray(bZippedBotBytes1);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }
  public byte[] getBot2(PrivateKey prvKey) throws Exception
  {
    try
    {
      //return toBotBytes(bEncryptedObjectBytes2, prvKey);
      return SServerAccess.gzipInflateArray(bZippedBotBytes2);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }

 /* private byte[] toBotBytes (byte[] bEncryptedObjectBytes, PrivateKey prvKey) throws Exception
  {

    try
    {
      // First turn array into BEncryptedObject
      ByteArrayInputStream byteIS = new ByteArrayInputStream(bEncryptedObjectBytes);
      ObjectInputStream in = new ObjectInputStream(byteIS);
      BEncryptedObject encryptedObject = (BEncryptedObject)in.readObject();

      // Now we have the BEncryptedObject get it to return the Unencrypted Array
      // and unzip it
      return SServerAccess.gzipInflateArray(encryptedObject.getDecryptedObjectArray(prvKey));
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }



  }     */
} 