package roboforge;

import java.io.*;
public class SFightResult implements Serializable
{
   /*

  * Description:
    Holds the results of a fight run by a fight client
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 11-Feb-2000

  */

  long fightID;
  byte[] battleRecordingBytes;
  byte[] bot1StatsBytes;
  byte[] bot2StatsBytes;
  long winner = 0;
  long tournamentEntryID1;
  long tournamentEntryID2;


  public SFightResult(long fightIDIn, BBattleRecorder battleRecording, BStats bot1Stats,BStats bot2Stats, long winnerIn, long tournamentEntryID1In, long tournamentEntryID2In)
  {
    try
    {
      fightID = fightIDIn;

      battleRecordingBytes = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(battleRecording));

      // Changed due to stats being stored in a random array
      //bot1StatsBytes = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(bot1Stats));
      //bot2StatsBytes = SServerAccess.gzipDeflateArray(SServerAccess.objectToByteArray(bot2Stats));

      bot1StatsBytes = SServerAccess.gzipDeflateArray(bot1Stats.toByteArray());
      bot2StatsBytes = SServerAccess.gzipDeflateArray(bot2Stats.toByteArray());
      BDebug.print("Battle Recording Size: " + java.lang.reflect.Array.getLength(battleRecordingBytes));
      BDebug.print("Bot 1 Stats: " + java.lang.reflect.Array.getLength(bot1StatsBytes));
      BDebug.print("Bot 2 Stats: " + java.lang.reflect.Array.getLength(bot2StatsBytes));

      winner = winnerIn;

      tournamentEntryID1 = tournamentEntryID1In;
      tournamentEntryID2 = tournamentEntryID2In;
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
} 