package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SJDBCBean implements Serializable{
  protected static transient SDbConnectionBroker myBroker;


 protected void destroy()
  {
    myBroker.destroy();
  }

  public SJDBCBean() throws Exception
  {
    if(myBroker == null)
    {
      // Only created by first Bean call
      String dbDriver = SGlobal.dbDriver;
      String dbServer = SGlobal.dbServer;
      String dbLogin  = SGlobal.dbLogin;
      String dbPassword = SGlobal.dbPassword;
      int minConns   = 1;
      int maxConns   = 2;
      String logFileString = SGlobal.logFileString;
      double maxConnTime = SGlobal.maxConnTime;

      myBroker = new
		    SDbConnectionBroker(dbDriver,dbServer,dbLogin,dbPassword,minConns,maxConns,logFileString,maxConnTime);
    }
  }

  protected Connection getConnection()
  {
    return myBroker.getConnection();
  }

  protected void freeConnection(Connection con)
  {
    myBroker.freeConnection(con);
  }
}

