package roboforge;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;
import javax.swing.tree.*;
import java.util.*;
import java.util.zip.*;
import roboforge.net.data.BPatchData;



public class SMakeRelease extends JFrame
{
  JButton jBMakePatch = new JButton();
  JLabel jLabel2 = new JLabel();
  JTextField jTPreviousDir = new JTextField();


  ZipOutputStream out = null;
  FileOutputStream f = null;
  CheckedOutputStream csum = null;


  final int DATA_BLOCK_SIZE = 2048;

  private FileReader file;
  private StreamTokenizer st;
  JTextField jReleaseDir = new JTextField();
  JLabel jLabel6 = new JLabel();
  JTextField jPatchDir = new JTextField();
  JLabel jLabel7 = new JLabel();


    //Main method
  public static void main(String[] args)
  {
    try 
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
    SMakeRelease frame = new SMakeRelease();

    frame.validate();
    frame.setVisible(true);
  }


  //Construct the frame
  public SMakeRelease()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(342, 231));
    this.setTitle("Create Release");
    jBMakePatch.setText("Create Zip File");
    jBMakePatch.setBounds(new Rectangle(182, 140, 122, 30));
    jBMakePatch.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBMakePatch_actionPerformed(e);
      }
    });

    jReleaseDir.setText("y:/release/");
    jReleaseDir.setBounds(new Rectangle(13, 33, 291, 30));
    jLabel6.setText("Release Directory");
    jLabel6.setBounds(new Rectangle(11, 9, 231, 15));
    jPatchDir.setText("y:/release/patches/");
    jPatchDir.setBounds(new Rectangle(13, 102, 291, 27));
    jLabel7.setText("Patch Directory");
    jLabel7.setBounds(new Rectangle(13, 75, 291, 15));

    this.getContentPane().add(jReleaseDir, null);
    this.getContentPane().add(jLabel6, null);
    this.getContentPane().add(jPatchDir, null);
    this.getContentPane().add(jLabel7, null);
    this.getContentPane().add(jBMakePatch, null);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }


  void addFileToZip (String fileName, String zipFileName)
  {
    try
    {

      if (out == null)
      {
        // If the output streams haven't been initialised then do so
        f = new FileOutputStream(zipFileName);
        out = new ZipOutputStream(f);
        out.setMethod(ZipOutputStream.DEFLATED);
      }

      System.out.println("Writing file " + fileName);
      BufferedInputStream in = new BufferedInputStream(new FileInputStream(fileName));

      ZipEntry zEntry = new ZipEntry(fileName);
      out.putNextEntry(zEntry);
      byte[] data = new byte[DATA_BLOCK_SIZE];
      int byteCount;
      while((byteCount = in.read(data, 0, DATA_BLOCK_SIZE)) != -1)
          out.write(data, 0, byteCount);

      out.flush();
      out.closeEntry();

      in.close();
    }
    catch (Exception e)
    {
      BDebug.print("Error: " + e.getMessage());
    }
  }

  void jBMakePatch_actionPerformed(ActionEvent e)
  {
    // Create a StreamTokenizer and based on the syncDiff.csv file
    // process the file getting every file name fifth
    // parameter is either a ? or a < symbol, and adds that file to a zip file
    try
    {

      // Get a list of all the release sub directories in the release directory
      // Create an inner class that implements the BCompare Interface for the sorting
        class FloatCompare implements BCompare
        {
          public boolean lessThan(Object l, Object r)
          {
            return ((Float)l).compareTo(((Float)r)) < 0;
          }
          public boolean lessThanOrEqual(Object l, Object r)
          {
            return ((Float)l).compareTo(((Float)r)) <= 0;
          }
        }

        BSortVector sortVector = new BSortVector(new FloatCompare());

        // Get a list of all the files/directory in the release directory

        File file1 = new File(jReleaseDir.getText());
        String[] cacheTitles = file1.list();

        // Loop through and add all the  names to the vector if they
        // start with the character 'v'
        for (int k = 0;k< cacheTitles.length;k++)
        {
          //BDebug.print("Vector Name: " + cacheTitles[k].substring(cacheTitles[k].length()-4));
          if(cacheTitles[k].substring(0,1).equals("v"))
            sortVector.addElement(new Float(cacheTitles[k].substring(1,cacheTitles[k].length())));
        }

        sortVector.sort();

        float latestReleaseNumber = ((Float)sortVector.lastElement()).floatValue();


     // Delete all the old patches
     File deleteFile = new File(jPatchDir.getText());
     String[] deleteTitles = deleteFile.list();

     for (int i = 0;i < deleteTitles.length;i++)
     {

        File fileToDelete = new File(this.jPatchDir.getText() + deleteTitles[i]);
        BDebug.print("File To Delete: " + this.jPatchDir.getText() + deleteTitles[i]);
        fileToDelete.delete();

     }

     // Do the patch build for all the releases except the latest

     for (int i = 0;i<sortVector.size()-1;i++)
     {

        file = new FileReader(jReleaseDir.getText() + "v" + ((Float)sortVector.elementAt(i)).floatValue() + "/syncDiff.csv");
        st = new StreamTokenizer(new BufferedReader(file));

        String s;
        String fileToAdd = "";
        String filePathToDelete = "";
        String fileToDelete = "";
        String token = "";
        Vector filesToDelete = new Vector();
        int count = 0;
        int filesAdded = 0;
        st.resetSyntax();
        st.slashSlashComments(false);
        st.slashStarComments(false);

        st.wordChars('!','z');
        st.wordChars(' ',' ');
        st.whitespaceChars(',',',');

        while(st.nextToken() != StreamTokenizer.TT_EOF)
        {
          if (st.ttype == StreamTokenizer.TT_WORD)
          {
            count++;
            if (count == 1)
            {
              filePathToDelete = st.sval.trim() + "\\";
            }

            if (count == 2)
            {
              fileToDelete = st.sval.trim();
            }

            if (count == 5)
            {
              token = st.sval.trim();
            }

            if (count == 6 && token.equals(">"))
            {
              String pathAndFile = filePathToDelete.toLowerCase() + fileToDelete.toLowerCase();

              // This is a file to add to the delete list
              if(pathAndFile.indexOf("syncdiff.csv")==-1
              && pathAndFile.indexOf("bglobal.prf")==-1
              && pathAndFile.indexOf("install.txt")==-1
              && pathAndFile.indexOf("jre\\bin\\")==-1
              && pathAndFile.indexOf("jre\\lib\\")==-1
              && pathAndFile.indexOf("patch\\")==-1)
              {
                fileToDelete = filePathToDelete + fileToDelete;
                BDebug.print("File To Delete: " + fileToDelete);
                filesToDelete.addElement(fileToDelete);
              }
            }

            if (count == 8)
              fileToAdd = st.sval.trim();


            if (count == 9 && (token.equals("?") || token.equals("<") || token.equals("!")))
            {
              //String pathAndFile = st.sval.trim().toLowerCase() + "\\" + fileToAdd.toLowerCase();
              String pathAndFile = st.sval.trim().toLowerCase() + "\\" + fileToAdd.toLowerCase();

              // This is a file to add
              if
              (
              !(pathAndFile.indexOf("syncdiff.csv")!=-1
              || pathAndFile.indexOf("bglobal.prf")!=-1
              || pathAndFile.indexOf("jre\\bin\\")!=-1
              || pathAndFile.indexOf("jre\\lib\\")!=-1
              || pathAndFile.indexOf("install.txt")!=-1)
              || (pathAndFile.indexOf("patch\\")!= -1
              || pathAndFile.indexOf("jre\\opengl\\")!=-1
              || pathAndFile.indexOf("jre\\directx\\")!=-1)
              )
              {
                fileToAdd = st.sval.trim() + "\\" + fileToAdd;
                BDebug.print("File To Add: " + fileToAdd);
                addFileToZip(fileToAdd,jPatchDir.getText() + ((Float)sortVector.elementAt(i)).floatValue() + ".zip");
                filesAdded++;
              }
              count = 0;
            }
            else if (count == 9)
              count = 0;
          }

        }

        // Create the header object and Serialize it out

        String patchName = jPatchDir.getText() + ((Float)sortVector.elementAt(i)).floatValue() + ".pat";

        BDebug.print("Patch Name: " + patchName);


        /*boolean JCDUpdated;
        if (jTJ3DUpdate.getText().equals("N"))
          JCDUpdated = false;
        else
            JCDUpdated = true;*/

        BPatchData pData                  = new BPatchData(0l);
        pData.patchName                   = jPatchDir.getText() + ((Float)sortVector.elementAt(i)).floatValue() + ".zip";
        pData.directoryStripLength        = jReleaseDir.getText().length() + ("v" + latestReleaseNumber + "").length();
        pData.deleteDirectoryStripLength  = jReleaseDir.getText().length() + ("v" + ((Float)sortVector.elementAt(i)).floatValue()).length();
        pData.itemsInPatch                = filesAdded;
        pData.filesToDelete               = (String[])filesToDelete.toArray(new String [0]);
//        pData.isJ3DUpdated                = JCDUpdated;
        pData.versionID                   = latestReleaseNumber;

        pData.SaveToFile(patchName);


        if (out != null)
        {
          out.close();
          f = null;
          csum = null;
          out = null;
        }
     }


    }
    catch (Exception e1)
    {
      BDebug.print(e1.getMessage());
      try
      {
        out.close();
        f = null;
        csum = null;
        out = null;
      }
      catch (Exception e2)
      {
        BDebug.print(e2.getMessage());
      }
    }
  }
}
