package roboforge;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;
import javax.swing.tree.*;
import java.util.*;
import java.util.zip.*;

// SUPERSEDED BY SMakeRelease

public class SPatchMaker extends JFrame
{
  JButton jBMakePatch = new JButton();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField jTLatestDir = new JTextField();
  JTextField jTPreviousDir = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField jTPatchLocation = new JTextField();


  ZipOutputStream out = null;
  FileOutputStream f = null;
  CheckedOutputStream csum = null;


  boolean headerFileCreated = false;
  JTextField jTRestart = new JTextField();
  JLabel jLabel4 = new JLabel();

  final int DATA_BLOCK_SIZE = 2048;

    //Main method
  public static void main(String[] args)
  {
    try 
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
    SPatchMaker frame = new SPatchMaker();

    frame.validate();
    frame.setVisible(true);
  }


  //Construct the frame
  public SPatchMaker()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception 
  {
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(413, 300));
    this.setTitle("Patch Maker");
    jBMakePatch.setText("Make Patch");
    jBMakePatch.setBounds(new Rectangle(257, 212, 122, 30));
    jBMakePatch.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBMakePatch_actionPerformed(e);
      }
    });
    jLabel1.setText("Latest Release Directory");
    jLabel1.setBounds(new Rectangle(26, 5, 153, 23));
    jLabel2.setText("Previous Release Directory");
    jLabel2.setBounds(new Rectangle(24, 69, 181, 29));
    jTLatestDir.setText("y:/Source/FolderCurrent/");
    jTLatestDir.setBounds(new Rectangle(21, 34, 355, 21));
    jTPreviousDir.setText("y:/Source/FolderPrevious/");
    jTPreviousDir.setBounds(new Rectangle(21, 103, 356, 23));
    jLabel3.setText("Patch Path and Name");
    jLabel3.setBounds(new Rectangle(26, 139, 145, 30));
    jTPatchLocation.setText("y:/Source/Release/35.0.ZIP");
    jTPatchLocation.setBounds(new Rectangle(20, 174, 359, 25));
    jTRestart.setText("N");
    jTRestart.setBounds(new Rectangle(163, 217, 21, 24));
    jLabel4.setText("Patch Requires Restart");
    jLabel4.setBounds(new Rectangle(19, 215, 140, 24));
    this.getContentPane().add(jTLatestDir, null);
    this.getContentPane().add(jTPreviousDir, null);
    this.getContentPane().add(jBMakePatch, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jTPatchLocation, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(jLabel4, null);
    this.getContentPane().add(jTRestart, null);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }


  void addFileToZip (String fileName)
  {
    try
    {
      if (!headerFileCreated)
      {
        // Create the header object and Serialize it out
        String patchName = jTPatchLocation.getText();

        // Change the suffix
        patchName = patchName.substring(0,(patchName.length() - 4)) + ".pat";



        boolean restart;
        if (jTRestart.getText().equals("N"))
          restart = false;
        else
          restart = true;

        //SPatchInfo patchInfo = new SPatchInfo("",jTPatchLocation.getText(),jTLatestDir.getText().length(),restart);
        SPatchInfo patchInfo = null;

        patchInfo.SaveToFile(patchName);
        headerFileCreated = true;
      }


      if (out == null)
      {
        // If the output streams haven't been initialised then do so
        f = new FileOutputStream(jTPatchLocation.getText());
        //csum = new CheckedOutputStream(f, new Adler32());
        //out = new ZipOutputStream(new BufferedOutputStream(csum));
        out = new ZipOutputStream(f);
        out.setMethod(ZipOutputStream.DEFLATED);
      }

      System.out.println("Writing file " + fileName);
      BufferedInputStream in = new BufferedInputStream(new FileInputStream(fileName));

      ZipEntry zEntry = new ZipEntry(fileName);
      out.putNextEntry(zEntry);
      byte[] data = new byte[DATA_BLOCK_SIZE];
      int byteCount;
      //(int byteCount = sourceStream.read(data, 0, DATA_BLOCK_SIZE)) != -1
      while((byteCount = in.read(data, 0, DATA_BLOCK_SIZE)) != -1)
          out.write(data, 0, byteCount);

      out.flush();
      out.closeEntry();

      in.close();
    }
    catch (Exception e)
    {
      BDebug.print("Error: " + e.getMessage());
    }
  }

  void jBMakePatch_actionPerformed(ActionEvent e)
  {
    // Create the BFileSelection Tree object for comparison with the previous directory
    try
    {

      // Get all the files from the latest directory
      BFileSelectionTree fileSelectionTree = new BFileSelectionTree(jTLatestDir.getText(),"","Will Never See",false);

      DefaultMutableTreeNode rootNode = (DefaultMutableTreeNode)fileSelectionTree.getModel().getRoot();
      Enumeration enumerator = rootNode.breadthFirstEnumeration();

      while (enumerator.hasMoreElements())
      {
        DefaultMutableTreeNode node = (BFileSelectionTree.FileTreeNode)enumerator.nextElement();
        String filePathAndName = ((BFileSelectionTree.FileTreeNode)node).fullName;
        BDebug.print(filePathAndName);

        File currentFile = new File(filePathAndName);
        if (!currentFile.isDirectory())
        {
          // The file isn't a directory so lets see if it exists in the previous release

          // Replace the start of the file with the previous directory path
          int len = jTLatestDir.getText().length();
          String strippedPath = filePathAndName.substring(len);
          BDebug.print("Stripped Path: " + strippedPath);

          String comparePath = jTPreviousDir.getText() + strippedPath;
          BDebug.print("Comnpare Path: " + comparePath);

          File previousFile = new File(comparePath);

          if(previousFile.exists())
          {
            // The file exists test to see if it has the same last modified date
            if (currentFile.lastModified() != previousFile.lastModified())
            {
              // Has a different date so add the file to the zip patch file
              addFileToZip(filePathAndName);
            }
          }
          else
          {
            // Add the file to the zip patch file as the file is new
            addFileToZip(filePathAndName);
          }
        }
      }
      // Close zip the output file
      if (out != null)
      {
        out.close();
        f = null;
        csum = null;
        out = null;
        headerFileCreated = false;
      }


    }
    catch (Exception e1)
    {
      BDebug.print(e1.getMessage());
      try
      {
        out.close();
        f = null;
        csum = null;
        out = null;
        headerFileCreated = false;
      }
      catch (Exception e2)
      {
        BDebug.print(e2.getMessage());
      }
    }
  }
}
