package roboforge;

import java.io.*;
import java.security.*;
//import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;
public class SRequestWrapper implements Serializable
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/*

  * Description:
    Object wrapper for a request sent from the client to the server
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 16-November-1999

  */

  //private byte[] loginID;
  //private byte[] password;
  private String loginID;
  private String password;
  private String requestType;
  private Object requestObject;
  private PublicKey clientPublicKey;
  private long clientID = 0;

  public SRequestWrapper(String loginIDIn, String passwordIn, String requestTypeIn, Object requestObjectIn, PublicKey clientPublicKeyIn)
  {

    try
    {

      // This if condition is for when this object is being used as a internal wrapper
      // in Tournament Schedulers and Farm Feeder transfer
      if ((loginIDIn != null) && (passwordIn != null))
      {
        // SetUp IAIK as the security provider
        // IAIK.addAsProvider(false);

        // Read in and Define the Client Public Key
        //ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_CLIENT));
        //clientPublicKey = (PublicKey)in1.readObject();

        clientPublicKey = clientPublicKeyIn;

        // Read in and Define the Server Public Key
        //ObjectInputStream in = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
        //PublicKey rsa_pub = (PublicKey)in.readObject();

        // Set up the Cipher for Encrypt
        //Cipher rsa = Cipher.getInstance("RSA/ECB/PKCS1Padding");
        //rsa.init(Cipher.ENCRYPT_MODE, rsa_pub);

        // Encrypt the LoginID
        //loginID = rsa.doFinal(loginIDIn.getBytes());

        loginID = loginIDIn;
        // Encrypt the Password
        //password = rsa.doFinal(passwordIn.getBytes());

        password = passwordIn;


      }
      else
      {
        // Will be null in the case of a Tournament Scheduler request
        if (loginIDIn != null)
          loginID = loginIDIn;
      }

      requestType = requestTypeIn;
      requestObject = requestObjectIn;
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      throw new RuntimeException();
    }
  }

  public String getRequestType()
  {
    return requestType;
  }

  public PublicKey getClientPubKey ()
  {
    return clientPublicKey;
  }

  public Object getRequestObject()
  {
    return requestObject;
  }

  public String getLoginID()
  {
    return loginID;
  }

  public String getPassword()
  {
    return password;
  }

  public long getClientID()
  {
    return clientID;
  }

  public void setClientID(long clientID)
  {
    this.clientID = clientID;
  }
}
