package roboforge;

import java.io.*;
import java.security.*;
public class SResponseWrapper implements Serializable
{
/**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/* 

  * Description:
    Object wrapper for a response sent to the client from the server
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 16-November-1999

  */

  private String responseType;
  private Object responseObject;
  private boolean encrypted;
  private boolean zipped;
  private PublicKey pubKey;

  public SResponseWrapper(String responseTypeIn, Object responseObjectIn)
  {
    this(responseTypeIn, responseObjectIn, true, true);
  }

  public SResponseWrapper(String responseTypeIn, Object responseObjectIn, boolean isEncrypted, boolean isZipped)
  {

    responseType = responseTypeIn;
    responseObject = responseObjectIn;
    encrypted = isEncrypted;
    zipped = isZipped;

  }

  public String getResponseType()
  {
    return responseType;
  }

  public void setResponseType(String responseTypeIn)
  {
    responseType = responseTypeIn;
  }

  public Object getResponseObject()
  {
    return responseObject;
  }


  public boolean isEncrypted()
  {
    return encrypted;
  }

  public boolean isZipped()
  {
    return zipped;
  }

  public void setEncrypted(boolean encrypted)
  {
    this.encrypted = encrypted;
  }

  public void setZipped(boolean zipped)
  {
    this.zipped = zipped;
  }
  public void setPubKey(PublicKey pubKeyIn)
  {
    pubKey = pubKeyIn;
  }

  public PublicKey getPubKey()
  {
    return pubKey;
  }
}
