package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;
import java.math.*;

public class SSoftWrapRegister extends SHttpServletJXGB
{

  String emailDL = "";


  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);


    try
    {
      // Load the text for the purchase download
      BufferedReader br = new BufferedReader(new FileReader("D:/Roboforge/saleconfirm.txt"));

      String s = new String();
      while ((s = br.readLine()) != null)
        emailDL += s + "\n";
      br.close();
    }
    catch (Exception e)
    {
      System.out.println("Error:SSoftWrapRegister:init " + e.getMessage());
    }
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    Connection con = null;
    Statement statement = null;
    ResultSet rs = null;
    String sql = null;

    long accountID;
    String status;
    String regKey;

    PrintWriter out;

    String type = "PURCH";
    String desc = "Purchase RoboForge Download";
    float  productAmount = 19.95f;

    boolean testMode = false;

    int loc;

    try
    {

      // Ensure that the request isn't null
      if (request == null)
      {
        System.err.println("SSoftWrapRegister: Null request");
        out = response.getWriter();
        out.println("resp=failure&reason=Null Request");
        out.close();
        return;
      }


      // Check that the request comes from the correct URL
      // TODO change this to compare only the IP address as it is possible
      // that someone could spoof this address by having the IP as a parameter


      String url = request.getRemoteAddr();
      System.err.println("** SOFTWRAP ADDRESS IS:" +  url);
      /*
      String url = request.getRemoteAddr();

      if (url.indexOf("203.96.111") == -1 &&
          url.indexOf("62.164.185.97") == -1 &&
          url.indexOf("64.39.74.137") == -1 )
      {
        // Request not from correct address
        System.err.println("SSoftWrapRegister: Invalid Request Source: " + url);
        out = response.getWriter();
        out.println("resp=failure&reason=Invalid Request Source");

        // When Live maybe Return all problems with this error as security measure
        //out.println("NAK,Invalid Request");
        out.close();
        return;
      } */


      // Check that the merchant ID is ok
      if (request.getParameter("merchant_id")!= null)
      {
        if (!request.getParameter("merchant_id").equals("SW17CSq9y"))
        {
          System.err.println("SSoftWrapRegister: Invalid merchant_id ");
          out = response.getWriter();
          out.println("resp=failure&reason=Invalid merchant identifier");
          out.close();
          return;
        }
      }
      else
      {
        // No Merchant_id parameter
        System.err.println("SSoftWrapRegister: No merchant_id");
        out = response.getWriter();
        out.println("resp=failure&reason=No merchant identifier");
        out.close();
        return;
      }


      // Check that the email exists
      if (request.getParameter("email")== null)
      {

        // No email parameter
        System.err.println("SSoftWrapRegister: No email");
        out = response.getWriter();
        out.println("resp=failure&reason=No email");
        out.close();
        return;
      }

      // Check that the name exists
      if (request.getParameter("name")== null)
      {

        // No name parameter
        System.err.println("SSoftWrapRegister: No name");
        out = response.getWriter();
        out.println("resp=failure&reason=No name");
        out.close();
        return;
      }

      // Check that the softwrap_ref exists
      if (request.getParameter("softwrap_ref")== null)
      {

        // No email parameter
        System.err.println("SSoftWrapRegister: No softwrap_ref");
        out = response.getWriter();
        out.println("resp=failure&reason=No SoftWrap Reference");
        out.close();
        return;
      }

      // Check and set the mode to testing if required
      if (request.getParameter("testing")!= null)
      {
        if (request.getParameter("testing").equals("T"))
          testMode = true;
      }

      String setStatus = "P";
      if (testMode)
        setStatus = "D";

      // Now everything has verified ok get and set the values
      String email  = request.getParameter("email");
      String name   = request.getParameter("name");
      String transID    = request.getParameter("softwrap_ref");


      con = getDatabaseConnection();
      con.setAutoCommit(false);

      sql = "SELECT id, registration_key, status FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
      statement = con.createStatement();

      rs = statement.executeQuery(sql);

      if (rs.next())
      {
        // Account already exists

        accountID = rs.getLong("id");
        regKey = rs.getString("registration_key");
        status = rs.getString("status");

        rs.close();
        statement.close();

        if (status.equals("OPEN") && regKey != null)
        {
          // We don't need to do anything as the client already has
          // an active account and they are simply ordering
          // another copy of RoboForge

          System.err.println("Customer: " + accountID + " Ordered ANOTHER copy of RoboForge: ");
        }
        else
        {
          // If not in test mode then account to pending and create the RegKey
          // Else set the account to 'D' for deleted

          sql = "UPDATE ACCOUNT";
          sql += " SET status = '" + setStatus + "', registration_key = getRegKey,";
          sql += " name = '" + name + "' WHERE id = " + accountID;

          statement = con.createStatement();
          statement.executeUpdate(sql);
          statement.close();
        }

      }
      else
      {
        // Account doesn't exist so create it

        sql = "INSERT INTO ACCOUNT (email,name,status,registration_key)";
        sql += " VALUES (LOWER('" + email + "'),'" + name + "','" + setStatus + "', getRegKey)";

        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();
      }

      // Need to get and set the accountID and regKey
      sql = "SELECT id, registration_key FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
      statement = con.createStatement();
      rs = statement.executeQuery(sql);
      rs.next();

      accountID = rs.getLong("id");
      regKey = rs.getString("registration_key");
      rs.close();
      statement.close();


      sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,ref, sw_ref)";
      sql += "VALUES (" + accountID + ",'" + type + "','" + desc + "',-" + productAmount + ",'C','C','RF01','" + transID + "')";

      statement = con.createStatement();
      statement.executeUpdate(sql);
      statement.close();

      sql = "INSERT INTO TRANSACTION (account_id, type, details, amount, status,account_from,sw_ref)";
      sql += "VALUES (" + accountID + ",'PYMNT','SoftWrap Payment'," + productAmount + ",'C','C','" + transID + "')";

      statement = con.createStatement();
      statement.executeUpdate(sql);
      statement.close();

      con.commit();
      con.setAutoCommit(true);

      // Return the good result to Softwrap
      System.err.println("SSoftWrapRegister: ACK for email: " + email + " SW_ref: " + transID);
      out = response.getWriter();
      out.println("resp=success&regKey="+regKey);
      out.close();

      // Send the email to the purchaser.

      String emailText = emailDL;

      loc = emailText.indexOf("[WP_REF]");
      emailText = emailText.substring(0,loc) + transID + emailText.substring(loc+8,emailText.length());

      loc = emailText.indexOf("[EMAIL]");
      emailText = emailText.substring(0,loc) + email + emailText.substring(loc+7,emailText.length());

      loc = emailText.indexOf("[REGKEY]");
      emailText = emailText.substring(0,loc) + regKey + emailText.substring(loc+8,emailText.length());

      System.err.println("About to send the email to: " + email);
      new SMTPBean("mail-int.clearfield.com", 25, "rforge@roboforge.com", email, "RoboForge Order Confirmation", emailText);
      System.err.println("Sent the email to: " + email);

/*
    response.setContentType("text/html");
    PrintWriter out = new PrintWriter (response.getOutputStream());
    out.println("<html>");
    out.println("<head><title>SSoftWrapRegister</title></head>");
    out.println("<body>");
    out.println("</body></html>");
    out.close();
*/

    }
   catch (Exception e)
    {
      System.err.println("Error SSoftWrapRegister.doPost: SQL: "+ sql + " Error: " + e.getMessage());
      out = response.getWriter();
      out.println("resp=failure&reason=" + e.getMessage());
      out.close();
      try
      {
        if (con != null)
        {
          con.rollback();
          con.setAutoCommit(true);
        }
      }
      catch (Exception e2)
      {
        System.err.println("Error SSoftWrapRegister.doPost.rollback: " + e2.getMessage());
      }

      return;
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
        {
          rs.close();
        }

        if (statement != null)
        {
          statement.close();
        }
      }
      catch(Exception e3)
      {
        System.err.println("Error SSoftWrapRegister.myBroker.freeConnection: "+e3.getMessage());
      }
    }
  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();
    }

    catch (Exception sqle)
    {
      System.err.println("Error SSoftWrapRegister.getDatabaseConnection: " + sqle.getMessage());
    }
    return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SSoftWrapRegister Information";
  }
} 