package roboforge;

import java.io.*;
//import java.security.*;
//import javax.crypto.Cipher;
//import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;

public class STransferDetail implements Serializable
{
  /*

  * Description:
    Details of funds that need to between transferred between accounts
    The request is sent to the server which if the transfer is possible the card and description
    fields are filled in by the server for the client to authorise the transfer.

  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 16-November-1999

  */

  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
String transferType;
  float transferAmt;
  String cardType;
  String cardName;
  String cardNumber;
  private long cardId;  // The database id corresponding to the card
  String transferDescription;
  int tournamentId;
  byte[] botBytes;  // Don't send the bot up if it's a request to see if the transaction can be performed
  //private byte[] encryptedBytes; //The first 100 bytes of the bot are removed and encrypted
  //byte[] bEncryptedObjectBytes;
  String fromDescription;
  String toDescription;
  String transferHeader;
  String botName;
  //private transient PublicKey rsa_pub;


  public STransferDetail(String transferTypeIn, float transferAmtIn,String cardTypeIn,String cardNameIn,String cardNumberIn, String transferDescriptionIn,int tournamentIdIn, String fromDescriptionIn, String toDescriptionIn, String transferHeaderIn)
  {
    transferType = transferTypeIn;
    transferAmt = transferAmtIn;
    cardType = cardTypeIn;
    cardName = cardNameIn;
    cardNumber = cardNumberIn;
    transferDescription = transferDescriptionIn;
    tournamentId = tournamentIdIn;
    fromDescription = fromDescriptionIn;
    toDescription = toDescriptionIn;
    transferHeader = transferHeaderIn;
  }

  public void setCardId (long id)
  {
    cardId = id;
  }
  public void setBot (String botFileName)
  {
     try
    {
      // Create the bot
      BBot bot = BBot.loadFromFile(botFileName, false);

      // Set the botName
      botName = bot.getName();

     /*
      Test zipping speed
      byte[] bBytes = SServerAccess.objectToByteArray(bot);

      System.out.println("Starting Bot Zip: " + System.currentTimeMillis());
      byte[] botZipped = SServerAccess.gzipDeflateArray(bBytes);

      System.out.println("Ending Bot Zip: " + System.currentTimeMillis());

      System.out.println("Starting Bot Encrypt: " + System.currentTimeMillis());
      
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      PublicKey rsa_pub = (PublicKey)in.readObject();
      in.close();

      in = new ObjectInputStream(new FileInputStream(SGlobal.PRIVATE_KEY_SERVER));
      PrivateKey rsa_pri = (PrivateKey)in.readObject();
      in.close();


      BEncryptedObject encObj = new BEncryptedObject((Object)botZipped,rsa_pub);

      byte[] bArray = encObj.getDecryptedObjectArray(rsa_pri);

      System.out.println("Finished Bot Encrypt: " + System.currentTimeMillis());

      System.out.println("Size: " + bArray.length); */


      // Turn the bot into an array of bytes
      botBytes = SServerAccess.objectToByteArray(bot);


      BDebug.print("Size of botBytes " + botBytes.length);

      // Zip up the bot bytes
      botBytes = SServerAccess.gzipDeflateArray(botBytes);

      // Init the Public Server Key
      // ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      // PublicKey publicKeyServer = (PublicKey)in1.readObject();


      // BEncryptedObject encryptedBot = new BEncryptedObject(botBytes,publicKeyServer);

      //  Turn the BEncryptedObject into a byte array
      // bEncryptedObjectBytes = SServerAccess.objectToByteArray(encryptedBot);

      /* Not needed as whole bot is now encrypted
      // Assign the first 100 bytes to the encryptedBytes array
      // and set the first 100 bytes of the bot to 0
      byte[] tempBytes = new byte[100];
      for (int i = 0;i < 100;i++)
      {
        tempBytes[i] = botBytes[i];
        botBytes[i] = 0;
      }

      BDebug.print("** Byte Test: "+ tempBytes[0]);
      BDebug.print("** Byte Test: "+ tempBytes[1]);
      BDebug.print("** Byte Test: "+ tempBytes[2]);
      BDebug.print("** Byte Test: "+ tempBytes[3]);

      // Init the Public Client Key
      ObjectInputStream in1 = new ObjectInputStream(new FileInputStream(BGlobal.PUBLIC_KEY_SERVER));
      PublicKey publicKeyServer = (PublicKey)in1.readObject();


      encryptedBytes = SServerAccess.encrypt(tempBytes, publicKeyServer);

      */


    }
    catch(Exception ex)
    {
      ex.printStackTrace();
      throw new RuntimeException();
    }
  }

  /*public  byte[] getBotBytesDecrypted(PrivateKey privKey) throws Exception
  {
    try
    {
      byte[] tempBytes = SServerAccess.decrypt(encryptedBytes,privKey);
      for (int i = 0;i < 100;i++)
      {
        botBytes[i] = tempBytes[i];
      }
      return botBytes;
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception(e.getMessage());
    }
  } */
}
