package roboforge;

import java.sql.*;
import java.io.*;
import java.util.Properties;

public class STransferReg
{
/*
* Description: Transfers temp registration information into the database
*
*
* Modification History ( Name, Date, Notes ):
                          HSC, 19-June-2000
*/

  public STransferReg()
  {
   Connection con = null;
   try
   {
      // Create the database connection
      Class.forName (SGlobal.dbDriver);
      con = DriverManager.getConnection(SGlobal.dbServer,SGlobal.dbLogin,SGlobal.dbPassword);

      // Loop through the directory containing the Offline pre-registrations
      // Either update or create records as required

      // Get a list of all the files in the Pre Registration Directory
     File file = new File(SGlobal.OFFLINE_PRE_REG_FILES);
     String[] cacheTitles = file.list();

    System.out.println("** " + cacheTitles.length + " Registrations to process **");

     int count = 0;
     int type = 0;

     // Loop through all the files adding them to the database
     for (int k = 0;k< cacheTitles.length;k++)
     {
        // Get the properties of the file
        FileInputStream fileIS = new FileInputStream(SGlobal.OFFLINE_PRE_REG_FILES + cacheTitles[k]);
        Properties p = new Properties();
        p.load(fileIS);

        // Turn off autocommit so we can rollback in the event of any errors
        con.setAutoCommit(false);

        Statement statement = con.createStatement();
        String sql = "SELECT id FROM ACCOUNT WHERE email = '" +  p.getProperty("EMAIL") + "'";
        ResultSet rs = statement.executeQuery(sql);

        if (!rs.next())
        {
          // Account doesn't exist so build Insert Statement
          sql = "INSERT INTO ACCOUNT (email,name,country,d_method,g_platform,notify,m_like,hear,beta,draw,age,sex,occupation,cpu,speed,ram,opsys,g_card,status)";
          sql = sql + " VALUES ('" + p.getProperty("EMAIL") + "','" + p.getProperty("NAME") + "'";
          sql = sql + ",'" + p.getProperty("COUNTRY") + "','" + p.getProperty("DMETHOD") + "','"+ p.getProperty("GPLATFORM") + "'";
          sql = sql + ",'" + p.getProperty("NOTIFY") + "','" + p.getProperty("LIKE") + "','"+ p.getProperty("HEAR") + "'";
          sql = sql + ",'" + p.getProperty("BETA") + "','" + p.getProperty("DRAW") + "','"+ p.getProperty("AGE") + "','"+ p.getProperty("SEX") + "'";
          sql = sql + ",'" + p.getProperty("OCCUPATION") + "','" + p.getProperty("CPU") + "','"+ p.getProperty("SPEED") + "'";
          sql = sql + ",'" + p.getProperty("RAM") + "','" + p.getProperty("OPSYS") + "','"+ p.getProperty("GCARD") + "'";
          sql = sql + ",'P')";

          type = 0;
        }
        else
        {
          // Account already exists so build Update statement
          int accountID = rs.getInt("id");

          sql = "UPDATE ACCOUNT";
          sql = sql + " SET email = '" + p.getProperty("EMAIL") + "',name = '" + p.getProperty("NAME") + "'";
          sql = sql + ",country = '" + p.getProperty("COUNTRY") + "',d_method = '" + p.getProperty("DMETHOD") + "'";
          sql = sql + ",g_platform = '" + p.getProperty("GPLATFORM") + "',notify = '" + p.getProperty("NOTIFY") + "'";
          sql = sql + ",m_like = '" + p.getProperty("LIKE") + "',hear = '" + p.getProperty("HEAR") + "'";
          sql = sql + ",beta = '" + p.getProperty("BETA") + "',draw = '" + p.getProperty("DRAW") + "',age = '" + p.getProperty("AGE") + "'";
          sql = sql + ",sex = '" + p.getProperty("SEX") + "',occupation = '" + p.getProperty("OCCUPATION") + "'";
          sql = sql + ",cpu = '" + p.getProperty("CPU") + "',speed = '" + p.getProperty("SPEED") + "'";
          sql = sql + ",ram = '" + p.getProperty("RAM") + "',opsys = '" + p.getProperty("OPSYS") + "'";
          sql = sql + ",g_card = '" + p.getProperty("GCARD") + "'";
          sql = sql + " WHERE id = " + accountID;

          type = 1;
        }

        // Added additional close statements HSC 19/4/2000

        rs.close();
        statement.close();

        System.out.println("Preparing to process "+ p.getProperty("EMAIL"));

        statement = con.createStatement();
        statement.executeUpdate(sql);
        statement.close();

        con.commit();
        con.setAutoCommit(true);

        if (type ==0)
          System.out.println("Inserted "+ p.getProperty("EMAIL"));
        else
          System.out.println("Updated "+ p.getProperty("EMAIL"));

        System.out.println(++count + " Registrations processed");

        // Don't delete the files for now let the operator do so
     }

    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
      try
      {
        con.rollback();
      }
      catch (SQLException sqle2)
      {
        System.err.println(sqle2.getMessage());
      }
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          //Close the connection no matter what
          con.close();
          System.out.println("** Database Connection Closed **");
        }

      }
      catch(Exception sqle1)
      {
        System.err.println(sqle1.getMessage());
      }
    }
  }
  public static void main(String[] args)
  {
    STransferReg sTransferReg = new STransferReg();
    sTransferReg.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
} 