package roboforge.advertising;

import java.io.*;
import java.util.*;

import java.awt.image.*;
import javax.media.j3d.*;

import roboforge.util.graphics.BSerializableImage;

import roboforge.BGlobal;
import roboforge.BDebug;
import roboforge.BTextures;

////////////////////////////////////////////////////////////////////////////////
//
// Advert class - holds an advertising image and its advertID
//
//
public class BAdvert implements Serializable
{

  static final long serialVersionUID = -1L;

  private String advertID;
  private BSerializableImage advertImage;

  private String fileName;

  // constructor
  public BAdvert(BufferedImage advertImage)
  {
    this.advertImage = new BSerializableImage(advertImage);
  }

  // accessor methods
  public void setAdvertID(String advertID)
  { this.advertID = advertID; }

  public String getAdvertID()
  { return advertID; }

  public Texture getTexture()
  { return BTextures.getTexture(advertImage.getImage()); }

  // save and load
  public void saveToFile (String filename) throws IOException
  {
    if (!BGlobal.ADSUFFIX.equalsIgnoreCase(filename.substring(filename.length()-4)))
      filename = filename +  BGlobal.ADSUFFIX;

    setFileName(fileName);  

    FileOutputStream fout = new FileOutputStream(filename);
    ObjectOutputStream out = new ObjectOutputStream(fout);

    out.writeObject(this);
    out.close();
  }

  public String getFileName()
  { return fileName; }

  public void setFileName(String fileName)
  { this.fileName = fileName; }

  public static BAdvert loadFromFile(String filename)
  {
    BAdvert advert = null;

    try
    {
      filename = filename.toLowerCase();

      FileInputStream fin = new FileInputStream(filename);
      ObjectInputStream in = new ObjectInputStream(fin);

      advert = (BAdvert) in.readObject();

      if(advert.getFileName() == null)
        advert.setFileName(filename);

      in.close();
      fin.close();
    }

    catch (Exception e)
      { BDebug.print("BAdvert - advert load error: " + e); }

    return advert;
  }
}
