package roboforge.ai.actions;

public interface BAction
{

  // Execution Methods...
  // -------------------------------------------------------------

  public void start();
    // Prepare this action for execution.

  public boolean execute(float s);
    // Execute this action for a number of seconds,
    // indicated by the parameter 's'.

  public void stop();
    // Indicate that this action is stopping.



  // Conflict resolution methods...
  // -------------------------------------------------------------

  public boolean conflictsWith(BAction a);
    // Returns true if this action and 'a' can not be
    // executed simultaneously.

  public boolean overrides(BAction a);
    // Returns true if this action takes precedence over 'a'.

  public String getName();
  // return the name

  public boolean isValid();
  // Is Active


}
