package roboforge.ai.actions;

import roboforge.ai.worldstate.*;


public interface BActor
  // An Actor is an entity which can be controlled through AI via
  // Actions.  Additionally, it can supply AI with a perceived
  // world-state.
{

  // OUTPUT Methods
  // -----------------------------------------------------------

  public boolean canAddAction(BAction a);
    // Can the specified action be executed by the Actor?

  public boolean addAction(BAction a);
    // Request that the Actor executes Action a.


  // INPUT Methods
  // -----------------------------------------------------------

  public BWorldState getWorldState();
    // Returns an object that contains information about the
    // Actor's perceived world-state.

}
