package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BLessEqThan extends BCompareBinaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public BLessEqThan()
    { super(); }

  public BLessEqThan(BLessEqThan o)
    { super(o); }

  public BLessEqThan(BExpression l, BExpression r)
    { super(l, r); }

  public Object clone()
    { return new BLessEqThan(this); }

  public BValue combine(BValue l, BValue r)
  {
    if (l.isNumber() && r.isNumber())
    {
      boolean result =
        ((BNumber) l).getValue() <=
        ((BNumber) r).getValue();

      value.setValue(result);
      return value;
    }
    else
      return BValue.UNDEFINED;
  }

  public String getName()
    { return "<="; }

}