package roboforge.ai.values;

import java.io.*;
import roboforge.math.BMath;
import roboforge.BPhysics;


public class BNumber extends BValue
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected double value;


  public BNumber()
    { this.type = BType.NUMBER; }

  public BNumber(double value)
  {
    this.type  = BType.NUMBER;
    this.value = value;
  }


  public double getValue()
    { return value; }

  public void setValue(double value)
    { this.value = value; }

  public void writeValue(DataOutput dout) throws IOException
    { dout.writeDouble(value); }

  public  void readValue(DataInput din) throws IOException
    { value = din.readDouble(); }

  public boolean equals(Object o)
  {
    if (o instanceof BNumber)
      return
        this.value == ((BNumber) o).value;
    else
      return false;
  }

  public String toString()
  {
    //return BPhysics.roundToString(value, 2);
    return value + "";
    // do not format because it will break the expression parser
    //return BMath.format(value);
  }

  public void setValue(BValue v)
  {
    if (v instanceof BNumber)
    {
      BNumber b = (BNumber) v;
      this.value = b.value;
    }
  }

}
