package roboforge.ai.worldstate;

import java.util.*;

import roboforge.ai.expressions.*;


public class BHashedWorldState implements BWorldState
{

  // Internal variables...
  // -----------------------------------------------------------

  protected Hashtable items;


  // Constructor.
  // -----------------------------------------------------------

  public BHashedWorldState()
    { items = new Hashtable(); }


  // Accessor methods...
  // -----------------------------------------------------------

  public BWorldItem get(String key)
    { return (BWorldItem) items.get(key); }

  public Object get(Object key)
    { return items.get(key); }

  public void put(String key, BWorldItem item)
    { items.put(key, item); }

  public void put(BWorldItem item)
    { items.put(item.key, item); }

  public void remove(String key)
    { items.remove(key); }

  public Enumeration getWorldItems()
    { return items.elements(); }



  // Evaluation method...
  // -----------------------------------------------------------

  public void evaluate()
  {
    Enumeration e = items.elements();
    BTerminal   item;

    while (e.hasMoreElements())
    {
      item = (BTerminal) e.nextElement();
      item.evaluate();
    }
  }

}