package roboforge.ai.worldstate;

import roboforge.*;
import roboforge.BNameable;
import roboforge.ai.expressions.*;
import roboforge.ai.values.*;


public class BWorldItem extends BTerminal
  implements BNameable
{

  // Member variables...
  // -------------------------------------------------------------

  String key;
  String name;
  BValue myValue;
  BValue defaultValue;
  BValue lowerValue;
  BValue upperValue;
  String units;
  String description;




  // Constructors...
  // -------------------------------------------------------------

  public BWorldItem(String key, String name, BValue defaultValue, BValue lower, BValue upper, String units, String description)
  {
    this.key = key;
    this.name = name;
    this.defaultValue =  (BValue)defaultValue.clone();
    this.myValue = defaultValue;
    this.lowerValue = lower;
    this.upperValue = upper;
    this.description = description;

    if (defaultValue instanceof BBoolean)
      this.units = "yes/no";
    else
      this.units = units;

  }


  // Accessor functions...
  // -------------------------------------------------------------

  public String getName()
  {
    if (units.equals(""))
      return name ;
    else
      return name + " (" + units + ")";
  }

  public void setName(String name)
  { this.name = name;}

  public String getKey()
  { return key;}

  public String toString()
    { return getName(); } //  + " = " + myValue+ " ("+ units+ "): "+ key;

  public BValue evaluate()
  { return myValue;}

  public BValue getValue()
  { return myValue;}

  public void setValue(BValue v)
  { myValue = v; }

  public int getType()
  { return myValue.getType(); }

  public void setDescription(String desc)
    { description = desc; }

  public String getDescription()
    { return description; }

  public void initForSim(BSimulation sim)
  {
    this.myValue.setValue(defaultValue);
  }


}