package roboforge.animation.animation;

import roboforge.animation.*;

public abstract class BLinearAcceleration implements BAnimation
{

  protected double current, target;
  private double velocity = 0;
  private double acceleration = 3;
  private boolean down = false;

  public BLinearAcceleration(double current,double target,double acceleration)
  {
    this.acceleration = acceleration;

    setPath( current, target );
  }

   public void setPath( double start, double fin )
   {
      current = start;
      target = fin;
      down = start > fin;
      velocity = 0;
   }


   protected boolean continueExecuting()
   {
      if (down)
        return current > target ;
      else
        return current < target;

   }

   public boolean animate()
    {
       velocity = velocity + acceleration;

        if (down)
        {
          current = current - velocity;
          if (current < target)
            current = target;

        }
        else
        {
          current = current + velocity;
          if (current > target)
            current = target;
        }


        return true;


    }

    public void start()
      {}
    public  void stop()
      {}




}

/*
 class ZoomAnimation implements BAnimation
  {

    private  Vector3d translation;
    private double currentZ, finishZ;

    private double velocity = 0;    // canvas units per loop
    private double acceleration = 3; // canvas units per loop squared

    private boolean down = false;

    public ZoomAnimation( double start, double fin )
    {
      setPath(  start,  fin );
    }

    public void setPath( double start, double fin )
    {
      currentZ = start;
      finishZ = fin;
      down = start > fin;
      velocity = 0;
    }

    private boolean continueExecuting()
    {
      if (down)
        return currentZ > finishZ ;
      else
        return currentZ < finishZ;

    }

    public boolean animate()
    {
       velocity = velocity + acceleration;

        if (down)
        {
          currentZ = currentZ - velocity;
          if (currentZ < finishZ)
            currentZ = finishZ;

        }
        else
        {
          currentZ = currentZ + velocity;
          if (currentZ > finishZ)
            currentZ = finishZ;
        }


        translation.z =  currentZ;
        getCanvas().setViewTranslation ( translation );
        getCanvas().setViewFromParameters();

        return continueExecuting();
    }

    public void start()
      {}
    public  void stop()
      {}


  }
  */