package roboforge.animation.animation;

import java.awt.*;

public abstract class BSinColorCycler extends BColorCycler
{
  float minMix = 0.01f;
  float maxMix = 1f - minMix;


  public BSinColorCycler(Color base, Color highlight, int deltaT, int cycleRange)
  {
    this( base,  highlight,  deltaT,  cycleRange, 0.2f, 0.8f);
  }

  public BSinColorCycler(Color base, Color highlight, int deltaT, int cycleRange, float minMix, float maxMix)
  {
    super( base,  highlight,  deltaT,  cycleRange);

    this.minMix = minMix;
    this.maxMix = maxMix;

  }

  protected void calculateMixtValue()
  {
    super.calculateMixtValue();
    mix = (float)java.lang.Math.sin(mix);

    if (mix < minMix)
        mix = minMix;
    else if (mix > maxMix)
        mix = maxMix;   

  }

}

