package roboforge.animation.animation.b3d;

import roboforge.BDebug;
import roboforge.BTextures;
import roboforge.animation.animation.*;
import roboforge.animation.*;

import java.util.*;
import javax.media.j3d.*;



public class BTextureAnimation extends BAppearanceAnimation
{

  protected List textures;
    // Set of textures to cycle through.

  protected int current;


  public BTextureAnimation(Appearance a, String root, int digits, String ext)
    { this(a, BTextures.getTextureSet(root, digits, ext)); }

  public BTextureAnimation(Appearance a, List ts)
  {
    super(a);
    textures = (ts.size() > 0) ? ts : null;
    current  = 0;

    setAppearanceCapabilities();
  }


  public boolean animate()
  {
    if (textures == null)
      return true;

    // Swap textures...
    Texture t = (Texture) textures.get(current++);
    appearance.setTexture(t);

    // Loop if at end of texture list.
    if (current == textures.size())
      current = 0;

    // BDebug.print("BTextures.animate("+ current+ ")");
    return true;
  }

  public void stop()
    { current = 0; }

  public void start()
    { }

  public void setAppearance(Appearance a)
    { appearance = a; }

  public void setAppearanceCapabilities()
    { appearance.setCapability(Appearance.ALLOW_TEXTURE_WRITE); }


  public int getCurrentFrame()
    { return current; }

}