package roboforge.animation.time;

import roboforge.animation.*;


public class BDelayedAnimation extends BTimeAnimation
{

  // BDelayedAnimation waits for 'duration' seconds
  // before animating its child.

  protected BAnimation child;
    // Child animation.

  protected float duration;
    // Amount of time to wait, in seconds.

  protected boolean isChildAnimating;
    // Whether child is animating or not,

  public BDelayedAnimation(BAnimation child, float duration)
  {
    setDuration(duration);
    this.child            = child;
    this.isChildAnimating = false;
  }


  public void setDuration(float duration)
  {
    if (duration < 0)
      throw new IllegalArgumentException
        ("Duration can not be negative.");

    this.duration = duration;
  }

  public float getDuration()
    { return duration; }


  public void start(float t)
    { }

  public boolean animate(float t, float dt)
  {
    if (t < duration)
      return true;

    if (!isChildAnimating)
      { child.start(); isChildAnimating = true; }

    return child.animate();
  }

  public void stop(float t)
  {
    if (isChildAnimating)
      { child.stop(); isChildAnimating = false; }
  }

}