package roboforge.attributes;

public class BAttribute
{

  // Class variables...
  // -------------------------------------------------------------
  
  public static final int LOW   = 0;
  public static final int MED   = 1;
  public static final int HIGH  = 2;
  
  
  // Member variables...
  // -------------------------------------------------------------
  
  public String           name;
  public BAttributeValue  value;
  public int              importance;
  
  
  // Constructor...
  // -------------------------------------------------------------
  
  public BAttribute(String name, BAttributeValue value)
    { this(name, value, MED); }
  
  public BAttribute(String name, BAttributeValue value, int importance)
  {
    this.name       = name;
    this.value      = value;
    this.importance = importance;
  }
  
  
  // Accessor methods...
  // -------------------------------------------------------------
  
  public String getName()
    { return name; }
  
  public BAttributeValue getValue()
    { return value; }

  public int getImportance()
    { return importance; }
  
  public boolean isImportantEnough(int min)
    { return importance >= min; }
  
  public boolean equals(Object o)
  {
    if (o instanceof BAttribute)
    {
      BAttribute a = (BAttribute) o;
      return (name.equals(a.name));
    }
    else
      return false;
  }
}
