package roboforge.btree;

import javax.swing.tree.*;
import roboforge.*;

import java.util.*;

public abstract class BTreeNode
  extends DefaultMutableTreeNode
  implements BStateful
{
  // defines all tree nodes that can be used with a BSeralizedTree

  public BTreeNode()
    { super(); }

  public BTreeNode cloneTree()
  {
    BTreeNode node = this;

    BTreeNode root = (BTreeNode) node.clone();
    Hashtable hash = new Hashtable();
    hash.put(node, root);

    Enumeration children = node.breadthFirstEnumeration();

    while(children.hasMoreElements())
    {
      BTreeNode current = (BTreeNode) children.nextElement();
      if (current != node)
      {
        BTreeNode newNode = ((BTreeNode)current.clone() );
        hash.put(current, newNode);
        BTreeNode parent = (BTreeNode)hash.get(current.getParent());

        int index = current.getParent().getIndex(current);
        if (parent.getChildCount() > index)
        {
          parent.replaceChild(index , newNode);
        }
        else
          parent.insert(newNode, index);

      }

    }


    root.removeFromParent();
    return root;

  }

  public void replaceChild(MutableTreeNode old, MutableTreeNode n)
  {
    int index = getIndex(old);
    replaceChild( index,  n);

  }

  protected void replaceChild(int index, MutableTreeNode n)
  {
    super.remove(index);
    super.insert(n, index);
  }




} 