package roboforge.internal;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
//import javax.swing.border.*;
//import javax.swing.plaf.metal.*;
import javax.swing.event.*;

//import roboforge.*;

import roboforge.BDebug;
import roboforge.BGlobal;
import roboforge.sound.BSound;



public class BPreferencePanel extends JPanel
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;

static boolean standAlone = false;

  JCheckBox cbDevMode = new JCheckBox();

  JCheckBox cbUseMipMap = new JCheckBox();
 // XYLayout xYLayout1 = new XYLayout();
  JButton bSave = new JButton();
  JButton bDefaults = new JButton();
 // JCheckBox cbSensorLights = new JCheckBox();
  JCheckBox cbShowTextures = new JCheckBox();
  JCheckBox cbShowBackground = new JCheckBox();
  JCheckBox cbUseDirLight = new JCheckBox();
  JCheckBox cbInvertMouseY = new JCheckBox();
  JCheckBox cbUseFog = new JCheckBox();
  JCheckBox cbUseAlternateRotation = new JCheckBox();
  JCheckBox cbUseTransparency = new JCheckBox();
  JTextField tfSourcePath = new JTextField();
  JTextField tfUserPath = new JTextField();

  JTextField farmFeederPath = new JTextField();
  JTextField challengePath = new JTextField();


  JButton bChooseColor = new JButton();


  // Added to allow easy updation of client version while testing autopatching
  // Will only appear on StandAlone version. HSC 03/02/00 %%
  JTextField tfClientVersion = new JTextField();

  JTextField tfGateway = new JTextField();

  JSlider slBackSound;
  JSlider slForeSound;
  JCheckBox cbUseSound = new JCheckBox();

  private static final int CHECKHEIGHT = 15;
  private static final int CHECKWIDTH = 300;
  private static final int CHECKX = 10;
  private static final int GAP = 10;
  private int yFactor = 0;

  final int backOffSet = (int)-BSound.BACKGROUND_SOUND_MIN;
  final int offSet = 20;
  
  public BPreferencePanel()
  {
    try
    {
    //  parent = dia;

      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }



  private int getNextY()
  // gets the next aviable y coordinarte
  {
    yFactor++;

    return   (CHECKHEIGHT * yFactor) + ( GAP * (yFactor-1) );

  }

  private void jbInit() throws Exception
  {
    this.setLayout(null);
    //int throwAway;

    cbDevMode.setText("Developer Mode (new interface)");
    cbDevMode.setSelected(BGlobal.DEVELOPER_MODE);
    cbDevMode.setSize(CHECKWIDTH, CHECKHEIGHT);
    cbDevMode.setLocation( CHECKX, getNextY());
    cbDevMode.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
        { BGlobal.DEVELOPER_MODE = cbDevMode.isSelected(); }
    });

    /*cbUseMipMap.setText("Mip Map textures ");
    cbUseMipMap.setSelected(BGlobal.USE_MIPMAP);
    cbUseMipMap.setSize(CHECKWIDTH, CHECKHEIGHT);
    cbUseMipMap.setLocation( CHECKX, getNextY());
    cbUseMipMap.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        BGlobal.USE_MIPMAP = cbUseMipMap.isSelected();
      }
    });


    cbShowBackground.setText("Show Background");
    cbShowBackground.setSelected(BGlobal.SHOW_BACKGROUND);
    cbShowBackground.setLocation(CHECKX, getNextY());
    cbShowBackground.setSize(CHECKWIDTH, CHECKHEIGHT);
    cbShowBackground.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbShowBackground_actionPerformed(e);
      }
    });


    cbUseDirLight.setText("Use DirLight");
    cbUseDirLight.setSelected(BGlobal.USE_DIRLIGHT);
    cbUseDirLight.setLocation(CHECKX, getNextY() );
    cbUseDirLight.setSize(CHECKWIDTH, CHECKHEIGHT);

    cbUseDirLight.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbUseDirLight_actionPerformed(e);
      }
    });  */





    cbInvertMouseY.setText("Invert Mouse Horizontal Input in player");
    cbInvertMouseY.setSelected(BGlobal.INVERT_PLAYER_Y );
    cbInvertMouseY.setLocation(CHECKX, getNextY() );
    cbInvertMouseY.setSize(CHECKWIDTH, CHECKHEIGHT);

    cbInvertMouseY.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbInvertMouseY_actionPerformed(e);
      }
    });

    // create a gap
    //throwAway = 
    	getNextY();

    /*cbUseFog.setText("Use Fog Effects");
    cbUseFog.setSelected(BGlobal.USE_FOG );
    cbUseFog.setLocation(CHECKX, getNextY());
    cbUseFog.setSize(CHECKWIDTH, CHECKHEIGHT);

    cbUseFog.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbUseFog_actionPerformed(e);
      }
    });

    cbUseAlternateRotation.setText("Use Alternate Rotation Method");
    cbUseAlternateRotation.setSelected(BGlobal.USE_ALTERNATE_ROTATION);
    cbUseAlternateRotation.setLocation(CHECKX, getNextY());
    cbUseAlternateRotation.setSize(CHECKWIDTH, CHECKHEIGHT);
    cbUseAlternateRotation.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbUseAlternateRotation_actionPerformed(e);
      }
    });

    cbUseTransparency.setText("Use Transparency");
    cbUseTransparency.setSelected(BGlobal.USE_TRANSPARENCY );
    cbUseTransparency.setLocation(CHECKX,getNextY());
    cbUseTransparency.setSize(CHECKWIDTH, CHECKHEIGHT);

    cbUseTransparency.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        cbUseTransparency_actionPerformed(e);
      }
    });
            */

    bChooseColor.setText("Choose UI Color");
    bChooseColor.setSize(CHECKWIDTH, CHECKHEIGHT);
    bChooseColor.setLocation(CHECKX, getNextY());
    bChooseColor.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        bChooseColor_actionPerformed(e);
      }
    });



    //throwAway = 
    getNextY();

    cbUseSound.setText("Use Sound");
    cbUseSound.setSelected(BGlobal.USE_SOUND );
    cbUseSound.setLocation(CHECKX,getNextY());
    cbUseSound.setSize(CHECKWIDTH, CHECKHEIGHT);

    cbUseSound.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {

        BGlobal.USE_SOUND = cbUseSound.isSelected();

      }
    });


    // Sliders
    //Image sliderIcon =  getToolkit().getImage(BGlobal.IMAGEPATH + "sliderKnob.gif" );


    int backSliderY = getNextY();
    JLabel backLabel = new JLabel("Background Vol");
    backLabel.setLocation(CHECKX, backSliderY);
    backLabel.setSize(CHECKWIDTH / 3, CHECKHEIGHT);


    int vol =  java.lang.Math.min( (int)BGlobal.BACKGROUND_SOUND_VOLUME, (int)BSound.BACKGROUND_SOUND_MAX );

    slBackSound = new JSlider((int)BSound.BACKGROUND_SOUND_MIN + backOffSet , (int)BSound.BACKGROUND_SOUND_MAX + backOffSet , vol + backOffSet);
    slBackSound.setLocation(CHECKX + backLabel.getWidth(), backSliderY);
    slBackSound.setSize(CHECKWIDTH - backLabel.getWidth(), CHECKHEIGHT);
    slBackSound.addChangeListener (new ChangeListener()
    {
          public void stateChanged(ChangeEvent e)
          {

                  BGlobal.BACKGROUND_SOUND_VOLUME =  (float)slBackSound.getValue() - backOffSet;
                  BDebug.print("Setting Background Sound to " +  BGlobal.BACKGROUND_SOUND_VOLUME);


          }


    });
    slBackSound.setToolTipText("Background Sound Volume");


    //BSlider slForeSound;
    int foreSliderY = getNextY();

    JLabel foreLabel = new JLabel("Foreground Vol");
    foreLabel.setLocation(CHECKX, foreSliderY);
    foreLabel.setSize(CHECKWIDTH / 3, CHECKHEIGHT);



    BDebug.print ("jbInit BGlobal.BACKGROUND_SOUND_VOLUME + backOffSet " + BGlobal.FOREGROUND_SOUND_VOLUME + offSet);
    BDebug.print ("jbInit BGlobal.BACKGROUND_SOUND_VOLUME + min " + BSound.FOREGROUND_SOUND_MIN + offSet);
    BDebug.print ("jbInit BGlobal.BACKGROUND_SOUND_VOLUME + max " + BSound.FOREGROUND_SOUND_MAX + offSet);


    slForeSound = new JSlider((int)BSound.FOREGROUND_SOUND_MIN + offSet, (int)BSound.FOREGROUND_SOUND_MAX + offSet, (int)BGlobal.FOREGROUND_SOUND_VOLUME + offSet);
    slForeSound.setLocation(CHECKX + foreLabel.getWidth(), foreSliderY);
    slForeSound.setSize(CHECKWIDTH - foreLabel.getWidth(), CHECKHEIGHT);
    slForeSound.addChangeListener (new ChangeListener()
    {
          public void stateChanged(ChangeEvent e)
          {

                  BGlobal.FOREGROUND_SOUND_VOLUME =  (float)slForeSound.getValue() - offSet;
                  BDebug.print("Setting Foareground Sound to " +  BGlobal.FOREGROUND_SOUND_VOLUME);

          }


    });
    slForeSound.setToolTipText("Foreground Sound Volume");





    //throwAway = 
    getNextY();


    tfSourcePath.setText(BGlobal.SYSTEMPATH);
    tfSourcePath.setLocation(CHECKX, getNextY());
    tfSourcePath.setSize(CHECKWIDTH, CHECKHEIGHT);
    tfSourcePath.addKeyListener(new KeyAdapter()
    {

      public void keyReleased(KeyEvent e)
      {
        BGlobal.SYSTEMPATH = tfSourcePath.getText();
        BDebug.print ("change detected ");
      }
    });

    farmFeederPath.setText(BGlobal.URLSFARMFEEDER);
    farmFeederPath.setLocation(CHECKX, getNextY());
    farmFeederPath.setSize(CHECKWIDTH, CHECKHEIGHT);
    farmFeederPath.addKeyListener(new KeyAdapter()
    {
      public void keyReleased(KeyEvent e)
      {
        BGlobal.URLSFARMFEEDER = farmFeederPath.getText();
        if (BGlobal.URLSFARMFEEDER.equals(""))
        {
          System.out.println("Setting to null");
          BGlobal.URLSFARMFEEDER = null;
        }
        BDebug.print ("change detected ");
      }
    });

    challengePath.setText(BGlobal.URLSCHALLENGE_ROOM);
    challengePath.setLocation(CHECKX, getNextY());
    challengePath.setSize(CHECKWIDTH, CHECKHEIGHT);
    challengePath.addKeyListener(new KeyAdapter()
    {
      public void keyReleased(KeyEvent e)
      {
        BGlobal.URLSCHALLENGE_ROOM = challengePath.getText();
        if (BGlobal.URLSCHALLENGE_ROOM.equals(""))
        {
          System.out.println("Setting to null");
          BGlobal.URLSCHALLENGE_ROOM = null;
        }
        BDebug.print ("change detected ");
      }
    });


    /*
    tfUserPath.setText(BGlobal.USERPATH);
    tfUserPath.setLocation(CHECKX, getNextY());
    tfUserPath.setSize(CHECKWIDTH, CHECKHEIGHT);
    tfUserPath.addKeyListener(new KeyAdapter()
    {

      public void keyReleased(KeyEvent e)
      {
        BGlobal.USERPATH = tfUserPath.getText();
      }
    });
    */


    if (standAlone)
    {
      tfClientVersion.setText(BGlobal.APP_VERSION + "");
      tfClientVersion.setLocation(CHECKX, getNextY());
      tfClientVersion.setSize(CHECKWIDTH, CHECKHEIGHT);
      tfClientVersion.addKeyListener(new KeyAdapter()
      {

        public void keyReleased(KeyEvent e)
        {
          BGlobal.APP_VERSION = (new Float(tfClientVersion.getText()).floatValue());
          BDebug.print ("change detected ");
        }
      });


      tfGateway.setText(BGlobal.URLSGATEWAY);
      tfGateway.setLocation(CHECKX, getNextY());
      tfGateway.setSize(CHECKWIDTH, CHECKHEIGHT);
      tfGateway.addKeyListener(new KeyAdapter()
      {

        public void keyReleased(KeyEvent e)
        {
          BGlobal.URLSGATEWAY = (tfGateway.getText());
          if (BGlobal.URLSGATEWAY.equals(""))
          {
            System.out.println("Setting to null");
            BGlobal.URLSGATEWAY = null;
          }
          BDebug.print ("change detected ");
        }
      });
    }


    getNextY();
    getNextY();
    



    bDefaults.setText("Set Defaults");
    bDefaults.setSize(CHECKWIDTH, CHECKHEIGHT);
    bDefaults.setLocation(CHECKX,getNextY());
    bDefaults.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        bDefaults_actionPerformed(e);
      }
    });

    bSave.setText("Save To Disk");
    bSave.setSize(CHECKWIDTH, CHECKHEIGHT);
    bSave.setLocation(CHECKX,getNextY());
    bSave.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        bSave_actionPerformed(e);
      }
    });


    this.add(bDefaults);

    this.add(cbDevMode);
    this.add(cbUseMipMap);
    this.add(bSave);
    //this.add(cbSensorLights);
    //this.add(cbShowTextures);
   // this.add(cbShowBackground);
    //this.add(cbUseDirLight);
    this.add(cbInvertMouseY);
    //this.add(cbUseFog);
    //this.add(cbUseAlternateRotation);
    this.add(tfSourcePath);
    this.add(challengePath);
    this.add(farmFeederPath);
    //this.add(tfUserPath);

    this.add(bChooseColor);

    if (standAlone)
      this.add(tfClientVersion);
      this.add(tfGateway);
    this.add(cbUseTransparency);
    this.add(backLabel);
    this.add(slBackSound);
    this.add(foreLabel);
    this.add(slForeSound);
    this.add(cbUseSound);





    /*
    this.add(cbWireFrame, new XYConstraints(9, 9, -1, -1));
    this.add(bSave, new XYConstraints(255, 246, 123, -1));
    this.add(cbSensorLights, new XYConstraints(9, 32, -1, -1));
    this.add(cbShowTextures, new XYConstraints(9, 54, -1, -1));
    this.add(cbShowBackground, new XYConstraints(9, 77, -1, -1));
    this.add(cbUseDirLight, new XYConstraints(8, 108, -1, -1));
    */
  }

  public static  void showDialog()
  {
      JDialog dia = new JDialog(new JFrame(), true);
      dia.setSize(new Dimension(320,570));

      dia.setResizable(false);
      dia.setTitle("Preferences");

      dia.getContentPane().add( new BPreferencePanel( )) ;
      dia.setVisible(true);
  }


  static public void main (String[] args)
  {
      standAlone = true;
      BGlobal.init();
      showDialog();
  }

  void bDefaults_actionPerformed(ActionEvent e)
  {
    BDebug.print ("Defaults loaded");
    tfSourcePath.setText("");
    BGlobal.SYSTEMPATH = "";

    BGlobal.USERPATH = "";
    tfUserPath.setText("");

    BGlobal.URLSFARMFEEDER = null;
    farmFeederPath.setText("");

    BGlobal.URLSCHALLENGE_ROOM = null;
    challengePath.setText("");

    BGlobal.URLSGATEWAY = null;
    tfGateway.setText("");

    BGlobal.DEVELOPER_MODE = false;
    cbDevMode.setSelected(false);

    BGlobal.USE_SOUND = true;
    cbUseSound.setSelected(true);

    BGlobal.BACKGROUND_SOUND_VOLUME = -6;    // (-13 to -5 dB  (Scale of windows volume, not absolute)  )
    BGlobal.FOREGROUND_SOUND_VOLUME = BSound.FOREGROUND_SOUND_MAX;
    BGlobal.INTERFACE_SOUND_VOLUME = BSound.INTERFACE_SOUND_MAX;
    slBackSound.setValue((int)BGlobal.BACKGROUND_SOUND_VOLUME + backOffSet );
    slForeSound.setValue((int)BGlobal.FOREGROUND_SOUND_VOLUME + offSet) ;
    

    BGlobal.USE_TRANSPARENCY = true;
    BGlobal.SHOW_AI_LABELS = false;
    BGlobal.VIDEOMODE = BGlobal.VIDEOMODE_OPENGL;
    BGlobal.UI_BASE_COLOR = new Color(200, 200, 255);
    BGlobal.setBattleAccuracy(BGlobal.BATTLE_ACCURACY_MEDIUM);
    BGlobal.GRAPHICS_SPEC = BGlobal.MID_SPEC;
    BGlobal.setGraphicsSpec();

  }

  void bSave_actionPerformed(ActionEvent e)
  {
      // create a bglobal ( the constructor fills out the members from the static
    BGlobal tempG = new BGlobal();
    tempG.saveToFile();
    //parent.dispose();

    if (standAlone)
        System.exit(0);
  }

  void cbSensorLights_actionPerformed(ActionEvent e)
  {
   // BGlobal.SHOW_SENSORLIGHTS = cbSensorLights.isSelected();
  }

  void cbShowTextures_actionPerformed(ActionEvent e)
  {
    BGlobal.SHOW_TEXTURES = cbShowTextures.isSelected();
  }

  void cbShowBackground_actionPerformed(ActionEvent e)
  {
    BGlobal.SHOW_BACKGROUND =  cbShowBackground.isSelected();

  }

  void cbUseDirLight_actionPerformed(ActionEvent e)
  {
    BGlobal.USE_DIRLIGHT =  cbUseDirLight.isSelected();

  }

  void cbInvertMouseY_actionPerformed(ActionEvent e)
  {
    BGlobal.INVERT_PLAYER_Y =  cbInvertMouseY.isSelected();

  }


  void cbUseFog_actionPerformed(ActionEvent e)
  {
    BGlobal.USE_FOG =  cbUseFog.isSelected();
  }

  void cbUseAlternateRotation_actionPerformed(ActionEvent e)
  {
    BGlobal.USE_ALTERNATE_ROTATION = cbUseAlternateRotation.isSelected();
  }

  void cbUseTransparency_actionPerformed(ActionEvent e)
  {
    BGlobal.USE_TRANSPARENCY = cbUseTransparency.isSelected();
  }

  void bChooseColor_actionPerformed(ActionEvent e)
  {
    BGlobal.UI_BASE_COLOR =
      JColorChooser.showDialog(this, "Choose UI Color", BGlobal.UI_BASE_COLOR);
  }


}