package roboforge.net.data;

import roboforge.util.data.*;


public class BFightData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BFightData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.FIGHT; }


  // Status codes...
  // -------------------------------------------------------------

  public static final int WAITING  = 0;
  public static final int FIGHTING = 1;
  public static final int COMPLETE = 2;

  public static final Long DRAW = new Long(-1);
    // Used in winnerID field.


  // Data fields...
  // -------------------------------------------------------------

  public Long tournamentID;

  public String name;
    // Name of this fight.
  
  public Long entry01ID;
    // Refers to a BTournamentEntryData object.

  public Long entry02ID;
    // Refers to a BTournamentEntryData object.

  public Long winnerID;
    // Matches the ID of the winning entry.
    // If a draw occured, equals -1.

  public int status;
  public int round;
  public String roundDescription;
  public float duration;

  public String comments;
    // Comments about this fight.

  public long[] featuredFightTypes;
  // The list of featured Fight Types related to this fight

  public String winDescription;
  // The description of how the fight was won

  public String winnerName;
  // The name of the winning bot
  

  public long designerAccountID1;
  public String designerName1;
  public String botName1;

  public long designerAccountID2;
  public String designerName2;
  public String botName2;

  // Accessor methods...
  // -------------------------------------------------------------

  public String toString()
  {
    if (roundDescription != null)
      return (name +" [ round " + round +" ]"+ " ["+ roundDescription+ "]");
    else
      return name + " [ round " + round +" ]";
  }
  
}