package roboforge.net.data;

import roboforge.util.data.*;
import roboforge.*;
import java.util.Vector;

public class BFightToRunData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BFightToRunData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.FIGHT_TO_RUN; }


  // Status codes...
  // -------------------------------------------------------------



  // Data fields...
  // -------------------------------------------------------------
  public byte[] bZippedBotBytes1;
  public byte[] bZippedBotBytes2;
  public long tournamentEntryID1;
  public long tournamentEntryID2;
  public String arenaFileName;
  public float fightDuration;
  public String tournamentName;
  public int round;
  public String bot1CreatorName;
  public String bot2CreatorName;
  public boolean isFinal = false;

  public BDataSet adverts;

  
  // Accessor methods...
  // -------------------------------------------------------------

  public byte[] getBot1() throws Exception
  {
    try
    {

      return SServerAccess.gzipInflateArray(bZippedBotBytes1);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }
  public byte[] getBot2() throws Exception
  {
    try
    {

      return SServerAccess.gzipInflateArray(bZippedBotBytes2);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }

  
}
