package roboforge.net.data;

import roboforge.util.data.*;
import java.util.Calendar;

import java.awt.Image;
import java.awt.Toolkit;
import java.util.Date;
import java.text.DateFormat;




public class BTournamentData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BTournamentData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.TOURNAMENT; }


  // Status codes...
  // -------------------------------------------------------------

  public static final int OPEN     = 0;
  public static final int PENDING  = 1;
  public static final int FIGHTING = 2;
  public static final int COMPLETE = 3;


  // Data fields...
  // -------------------------------------------------------------

  public String name;
  public String description;

  public String arena;
  public int    maximumEntries;
  public int    currentEntries;
  public int    allowedEntriesPerAccount;

  public Calendar   closingDate;
  public int    statusCode;
  public int    currentRound;

  public int    fightDuration;
  public float  entryFee;

  public String commentary;
  public String summary;

  public byte[] sponsorImage;

  // The maximum price of a bot allowed to enter this tournament
  public float botPriceCap;

  public String tournamentType;
  
  
  
  // Accessor methods...
  // -------------------------------------------------------------

  public String toString()
  {


        String timeString = "";
        if ( closingDate != null)
        {
          DateFormat df =   DateFormat.getDateInstance(DateFormat.FULL );
          timeString = " [ " +  df.format(closingDate.getTime())  + " ]";
        }



    return name + timeString;

  }
  
  protected transient Image image;
    
  public Image getImage()
  {
    if (image == null)
      if (sponsorImage != null)
        image = Toolkit.getDefaultToolkit()
          .createImage(sponsorImage);
  
    return image;
  }
}
