package roboforge.net.data;

import roboforge.util.data.*;
import java.util.Date;


public class BTournamentEntryData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BTournamentEntryData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.TOURNAMENT_ENTRY; }


  // Status codes...
  // -------------------------------------------------------------

  public static final int WAITING     = 0;
  public static final int VALIDATING  = 1;
  public static final int VALID       = 2;
  public static final int INVALID     = 3;


  // Data fields...
  // -------------------------------------------------------------

  public Long tournamentID;
  public Long accountID;

  public String botName;

  public float botCost;
    // Is this updated? If not, maybe delete.
    // Could be useful information for the client, though.

  public Date dateSubmitted;

  public int statusCode;
    // NB: If entry crashes on a farm-client during validation,
    // Return a status code of 'pending' to the client, even
    // though it has a 'BAD' code on the server.

  public float winnings;
    // The amount of money won by this entry to date.
    // While the associated tournament is open/pending, this is set to 0.0f.

  public int currentRound;
    // While the associated tournament is open/pending, this is set to 0.

  public String validationNotes;
    // Once status is either VALID or INVALID, this field
    // contains information about the validation results.


  
  // Accessor methods...
  // -------------------------------------------------------------

  public String toString()
    { return botName; }
  
} 