package roboforge.net.data;

import roboforge.BBot;
import roboforge.util.data.*;

import java.io.*;
import java.util.zip.*;



public class BTournamentSubmitData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BTournamentSubmitData(BBot bot, Long tournamentID)
  {
    super(tournamentID);
    
    if (bot != null)
    {
      this.botName = bot.getName();
      this.botCost = bot.getTotalPrice();
      this.botData = getBotData(bot);
      this.bot = bot;
    }
  }
  

  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.TOURNAMENT_SUBMIT; }


  // Data fields...
  // -------------------------------------------------------------

  public Long   tournamentID;
  public String botName;
  public float botCost;
  public transient BBot bot;

  public byte[] botData;
    // Bot file bytes, zipped.

  

  // Implementation methods...
  // -------------------------------------------------------------
  
  protected byte[] getBotData(BBot bot)
  {
    try
    {
      ByteArrayOutputStream bytes =
        new ByteArrayOutputStream();

      GZIPOutputStream zip =
        new GZIPOutputStream(bytes);
          
      ObjectOutputStream out = 
        new ObjectOutputStream(zip);

      out.writeObject(bot);
      out.close();
    
      byte[] result =
        bytes.toByteArray();

      return result;
    }
    catch (Exception e)
      { throw new RuntimeException(""+ e); }
  }
  
}
