package roboforge.net.data;

import roboforge.util.data.*;


public class BTournamentUpdateData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BTournamentUpdateData(long tournamentID, int status, Long challengerID,
                                Long challengedID, String challengerDesignerName,
                                String challengedDesignerName,  String tournamentStatus,
                                float fightProgress, String tournamentName, long fightID,
                                String challengerBotName, String challengedBotName)
    {
      super(tournamentID);
      this.status                   = status;
      this.challengerID             = challengerID;
      this.challengedID             = challengedID;
      this.challengerDesignerName   = challengerDesignerName;
      this.challengedDesignerName   = challengedDesignerName;
      this.tournamentStatus         = tournamentStatus;
      this.fightProgress            = fightProgress;
      this.tournamentName           = tournamentName;
      this.fightID                  = fightID;
      this.challengerBotName        = challengerBotName;
      this.challengedBotName        = challengedBotName;
    }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_TOURNAMENT_UPDATE; }


  // Status codes...
  // -------------------------------------------------------------

  public static final int ADDED   = 0;
  public static final int UPDATED = 1;
  public static final int DELETED = 2;



  // Data fields...
  // -------------------------------------------------------------

  // Accessor methods...
  // -------------------------------------------------------------
  public int status;
  public Long challengerID;
  public Long challengedID;
  public String challengerDesignerName;
  public String challengedDesignerName;
  public String tournamentStatus;
  public float fightProgress;

  public String tournamentName;

  public long fightID;
  public String challengerBotName;
  public String challengedBotName;
}