package roboforge.net.server;

import roboforge.BGlobal;
import roboforge.BDebug;
import roboforge.SGlobal;

import roboforge.net.*;
import roboforge.net.sockets.*;
import roboforge.net.services.*;
import roboforge.util.io.BIOUtils;

import java.io.*;
import java.security.*;




public class BServerPresentation extends BAbstractPresentation
{

  // Constructor...
  // -------------------------------------------------------------

  public BServerPresentation(BServerStack stack) throws BNetException
    { super(stack, SGlobal.PRIVATE_KEY_SERVER); }
    // { super(stack, BGlobal.PRIVATE_KEY_CLIENT); }


  
  // Implementation methods...
  // -------------------------------------------------------------
  
  protected void sendSecurityHeader(BTarget target, BSocket socket)
    throws IOException
  { 
    /* Do nothing, since server sends no security header. */ 
  }
  
  protected void receiveSecurityHeader(BTarget target, BSocket socket)
    throws IOException
  {
    BRSASocket secure =
      new BRSASocket(socket);
    
    BObjectSocket in =
      new BObjectSocket(secure);
    
    secure.setDecryptionKey(key);
    
    try
    {
      Key symKey   = (Key)    in.read();
      byte[] symIV = (byte[]) in.read();

      target.setSymmetricKey(symKey);
      target.setSymmetricIV(symIV);
    }
    catch (Exception e)
    { 
      throw new BNetException(
        "Couldn't deserialize security header contents."); 
    }
  }

  protected void inform(BTransmission t, String s)
    { /*BDebug.print("NET: "+ s);*/ }

  protected void inform(BTransmission t, long in, long out)
    { }

}