package roboforge.net.server;

import roboforge.net.*;
import roboforge.net.client.*;
import roboforge.net.services.*;
                                


public class BServerStack extends BNetworkStack
{
  
  // Constructors...
  // -------------------------------------------------------------

  public BServerStack() throws BNetException
    { super(); }
  

  // Layer factory methods...
  // -------------------------------------------------------------
  
  protected BPresentationLayer createPresentationLayer() 
    throws BNetException
    { return new BServerPresentation(this); }

  protected BTransportLayer createTransportLayer()
    throws BNetException
    { return new BServerTransport(this); }


  // Message send method...
  // -------------------------------------------------------------

  public void send
  (
    BTarget target,
    BMessage message,
    BDataService service
  )
    throws BNetException
  {
    BTransmission t = new BTransmission(message);
    t.setTarget(target);
    t.setSendService(service);

    presentation.send(t);
  }


  // Message receive method...
  // -------------------------------------------------------------

  public BRequest receive(BClientTarget target)
    throws BNetException
  {
    BTransmission t = new BTransmission();
    t.setTarget(target);

    // Receive message from target...
    presentation.receive(t);

    /*
    BRequestHeader header =
      request.getRequestHeader();

    target.setPublicKey(header.getPublicKey());
    */

    return (BRequest) t.getMessage();
  }


}
