package roboforge.net.server;

import roboforge.net.*;
import roboforge.net.sockets.*;

import java.io.*;
import java.net.*;


public class BServerTransport implements BTransportLayer
{

  // Constructors...
  // -----------------------------------------------------------
  
  public BServerTransport(BServerStack stack)
    { }
  
    
  // Interface methods...
  // -----------------------------------------------------------

  public BSocket getSocket(BTransmission t) throws BNetException
  {
    BTarget target  = t.getTarget();

    if (!(target instanceof BClientTarget))
      throw new BNetException("Cannot create socket - bad target type.");

    BClientTarget client =
      (BClientTarget) target;

    try
    {
      InputStream  in  = client.getInputStream();
      OutputStream out = client.getOutputStream();

      return new BGenericSocket(in, out);
    }
    catch (IOException ie)
      { throw new BNetException("Could not open connection."); }
  }

}
