package roboforge.particles.forces;

import java.util.*;
import javax.vecmath.*;
import roboforge.particles.*;


public class BNetForce implements BParticleForce
{

  protected List forces;
    // A set of contributing forces.

  public BNetForce()
    { forces = new ArrayList(2); }


  public void add(BParticleForce f)
    { forces.add(f); }

  public void remove(BParticleForce f)
    { forces.remove(f); }


  public void apply(BParticle p, float t, Vector3f f)
  {
    int n = forces.size();
    BParticleForce force;

    for (int i=0; i<n; i++)
    {
      force = (BParticleForce) forces.get(i);
      force.apply(p, t, f);
    }
  }

  public void update(float t)
  {
    int n = forces.size();
    BParticleForce force;

    for (int i=0; i<n; i++)
    {
      force = (BParticleForce) forces.get(i);
      force.update(t);
    }
  }

}