package roboforge.particles.forms;

import roboforge.BGlobal;
import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;


public class BParticleFormCard extends BParticleFormShape
{

  protected static final float[] coordinates =
    { -1f,  1f,  0f,   -1f, -1f,  0f,
       1f, -1f,  0f,    1f,  1f,  0f  };

  protected static final float[] textureCoordinates =
    { 0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f  };

  protected static GeometryArray card;

  static
  {
    // Static Initializer.
    card = new QuadArray(4,
        GeometryArray.COORDINATES |
        GeometryArray.TEXTURE_COORDINATE_2);

    card.setCoordinates(0, coordinates);
    card.setTextureCoordinates(0, 0, textureCoordinates);
  }


  public BParticleFormCard(BranchGroup parent)
    { super(parent, true); }

  public BParticleFormCard(BranchGroup parent, boolean isAdditive)
    { super(parent, isAdditive); }

  protected Shape3D createShape3D()
  {
    OrientedShape3D shape = new OrientedShape3D();
    shape.setRotationPoint(0f, 0f, 0f);
    shape.setAlignmentMode(OrientedShape3D.ROTATE_ABOUT_POINT);
    shape.setGeometry(card);

    return shape;
  }

}