package roboforge.particles.forms;

import roboforge.BGlobal;
import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;


public class BParticleFormCluster extends BParticleFormShape
{

  protected static final float[] coordinates =
  {
    -1f,  1f,  0f,   -1f, -1f,  0f,   1f, -1f,  0f,    1f,  1f,  0f,
     // 1f,  1f,  0f,    1f, -1f,  0f,  -1f, -1f,  0f,   -1f,  1f,  0f,
     0f,  1f,  1f,    0f, -1f,  1f,   0f, -1f, -1f,    0f,  1f, -1f,
     // 0f,  1f, -1f,    0f, -1f, -1f,   0f, -1f,  1f,    0f,  1f,  1f,
    -1f,  0f, -1f,   -1f,  0f,  1f,   1f,  0f,  1f,    1f,  0f, -1f,
     // 1f,  0f, -1f,    1f,  0f,  1f,  -1f,  0f,  1f,   -1f,  0f, -1f,
  };

  protected static final float[] textureCoordinates =
  {
    0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
    // 0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
    0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
    // 0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
    0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
    // 0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f,
  };




  protected static final GeometryArray cluster;

  static
  {
    // Static Initializer.
    cluster = new QuadArray(12,  // 24
        GeometryArray.COORDINATES |
        GeometryArray.TEXTURE_COORDINATE_2);

    cluster.setCoordinates(0, coordinates);
    cluster.setTextureCoordinates(0, 0, textureCoordinates);
  }


  public BParticleFormCluster(BranchGroup parent)
    { this(parent, true); }

  public BParticleFormCluster(BranchGroup parent, boolean isAdditive)
    { super(parent, isAdditive); }


  protected Shape3D createShape3D()
  {
    Shape3D shape = new Shape3D();
    shape.setGeometry(cluster);
    return shape;
  }

  protected void createAppearance()
  {
    super.createAppearance();

    PolygonAttributes pAttrib = new PolygonAttributes();
    pAttrib.setCullFace(PolygonAttributes.CULL_NONE);

    appearance.setPolygonAttributes(pAttrib);
  }

}