package roboforge.particles.forms;

import roboforge.particles.*;
import javax.vecmath.*;
import javax.media.j3d.*;



public class BParticleFormPoint implements BParticleForm
{

  protected PointArray points;
    // Shared PointArray object for a group of particles.

  protected int index;
    // Index of this particle within PointArray.


  protected static final Color4f INVISIBLE =
    new Color4f(0f, 0f, 0f, 0f);


    
  public BParticleFormPoint(PointArray ps, int index)
  {
    this.points = ps;
    this.index  = index;
  }

  public void start(BParticle p)
    { points.setCoordinate(index, p.p); }

  public void update(BParticle p, float t, float dt)
    { points.setCoordinate(index, p.p); }

  public void stop(BParticle p)
    { setColor(INVISIBLE); }



  public void setColor(Color4f c)
    { points.setColor(index, c); }

  public void setTexture(Texture t)
    { /* Not applicable. */ }

  public void setSize(float s)
    { /* Not applicable. */ }

  public void setAdditive(boolean isAdditive)
    { /* TODO: Implement? */ }


}