package roboforge.particles.forms;

import roboforge.BGlobal;
import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;




public class BParticleFormQuad implements BParticleForm
{

  // SJS [07/04/2001] - Unfinished, since immediate mode is buggy.
  // Specifically, it doesn't seem to render textures on shapes.
  // TODO: Get Textures working.

  
  // Members...
  // -------------------------------------------------------------

  protected BSystemFormQuad parent;
    // Parent form, holds an array of quads.

  protected QuadArray quads;
    // Shared QuadArray object for a group of particles.

  protected Transform3D camera;
    // Camera transform; used to transform particles
    // into camera space.

  protected int index;
    // Index of this particle within QuadArray.

  protected float size;
    // Size of this particle form.
    // Used to offset quad coordinates from particle center.


  // Static members...
  // -------------------------------------------------------------

  protected static Point3f pt = new Point3f();
    // Working point, for storing transformed particle loc.

  protected static Point3f[] points = new Point3f[4];
    // Working array, for setting particle position.

  protected static Color4f[] colors = new Color4f[4];
    // Working array, for setting particle color.

  static
  {
    // Initialize working arrays...
    for (int i=0; i<4; i++)
    {
      points[i] = new Point3f();
      colors[i] = new Color4f();
    }
  }




  // Constructor...
  // -------------------------------------------------------------

  public BParticleFormQuad(BSystemFormQuad parent, int index)
  {
    this.parent = parent;
    this.quads  = parent.getQuadArray();
    this.camera = parent.getCameraTransform3D();
    this.index  = index;
  }



  // BParticleForm implementation...
  // -------------------------------------------------------------

  public void start(BParticle p)
    { updateParticle(p); }

  public void update(BParticle p, float t, float dt)
    { updateParticle(p); }

  public void stop(BParticle p)
    { setColor(BGlobal.INVISIBLE_4F); }


  protected void updateParticle(BParticle p)
  {
    // Calculate particle's location in camera space.
    pt.set(p.p);
    camera.transform(pt);

    // pt.set(0f, 40f, 0f);

    float o = size;

    // Offset the particle's quad geometry.
    points[0].set(pt.x - o, pt.y + o, pt.z);
    points[1].set(pt.x - o, pt.y - o, pt.z);
    points[2].set(pt.x + o, pt.y - o, pt.z);
    points[3].set(pt.x + o, pt.y + o, pt.z);

    quads.setCoordinates(index, points);
  }




  // BVisualForm implementation...
  // -------------------------------------------------------------

  public void setColor(Color4f c)
  {
    colors[0].set(c);
    colors[1].set(c);
    colors[2].set(c);
    colors[3].set(c);

    quads.setColors(index, colors);
  }

  public void setTexture(Texture t)
  {
    // For now, pass texture set up to parent.
    // TODO: Change.
    // parent.setTexture(t);
  }

  public void setSize(float s)
    { this.size = s; }

  public void setAdditive(boolean isAdditive)
    { /* Not applicable. */ }


}