package roboforge.particles.forms;

import roboforge.BDebug;

import roboforge.particles.*;
import javax.media.j3d.*;


public abstract class BSystemForm3D extends BSystemFormAbstract
{

  // Members...
  // -------------------------------------------------------------

  protected BranchGroup parent;
    // Parent branch group.

  protected BranchGroup root;
    // Branch group containing the 3D form.

	protected boolean isAttached;
  	// Whether this form is attached to a parent BG.



  // Constructors...
  // -------------------------------------------------------------

  public BSystemForm3D()
    { this(null, ADDITIVE); }

  public BSystemForm3D(BranchGroup parent)
    { this(parent, ADDITIVE); }

  public BSystemForm3D(BranchGroup parent, boolean isAdditive)
  {
    super(isAdditive);

    this.parent 		= parent;
    this.isAttached = false;

    root = new BranchGroup();
    root.setCapability(BranchGroup.ALLOW_DETACH);
    root.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
    root.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);

    // Compile the scene subgraph...
    root.compile();

  }


  // Accessor Methods...
  // -------------------------------------------------------------

  public void setParent(BranchGroup parent)
    { this.parent = parent; }

  public BranchGroup getParent()
    { return parent; }



  // BSystemAspect implementation...
  // -------------------------------------------------------------

  public void start()
  {
    super.start();

  	if (!isAttached)
    {
      parent.addChild(root);
      isAttached = true;
    }
  }

  public void stop()
  {
    super.stop();

    if (isAttached)
    {
	    root.detach();
      isAttached = false;
    }
  }
}
