package roboforge.particles.forms;

import roboforge.particles.*;
import javax.vecmath.*;
import javax.media.j3d.*;


public class BSystemFormLine extends BSystemFormGeomArray
{

  // Members...
  // -------------------------------------------------------------

  protected LineArray lines;


  // Constructor...
  // -------------------------------------------------------------

  public BSystemFormLine(BranchGroup parent, int n)
    { super(parent, n); }


  // Methods...
  // -------------------------------------------------------------

  protected GeometryArray createGeometry()
  {
    lines = new LineArray(
      n << 1,
      LineArray.COORDINATES |
      LineArray.COLOR_4);

    lines.setCapability(LineArray.ALLOW_COORDINATE_WRITE);
    lines.setCapability(LineArray.ALLOW_COLOR_WRITE);

    return lines;
  }


  public BParticleForm createForm(BParticle p)
    throws BParticleSystemException
  {
    if (used >= n)
      throw new BParticleSystemException(
        "Can't create appearance for particle: "+ p);

    BParticleForm pa =
      new BParticleFormLine(lines, used << 1);

    used++;

    return pa;
  }

}