package roboforge.particles.forms;

import roboforge.BRenderer;
import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;


public class BSystemFormQuad extends BSystemFormRenderableGeomArray
{

  // SJS [07/04/2001] - Unfinished, since immediate mode is buggy.
  // Specifically, it doesn't seem to render textures on shapes.
  // TODO: Get Textures working.


  // Static members...
  // -------------------------------------------------------------

  protected static final float[] textureCoordinates =
    { 0f, 1f,  0f, 0f,  1f, 0f,  1f, 1f  };

  protected static final float[] INVISIBLE =
    { 0f, 0f, 0f, 0f,  0f, 0f, 0f, 0f,  0f, 0f, 0f, 0f,  0f, 0f, 0f, 0f };

  // protected static final float[] INVISIBLE =
  //  { 1f, 1f, 1f, 0f,  1f, 1f, 1f, 1f,  1f, 1f, 1f, 0f,  1f, 1f, 1f, 1f };



  // Members...
  // -------------------------------------------------------------

  protected QuadArray quads;
    // The array of quads used to render particles.





  // Constructor...
  // -------------------------------------------------------------

  public BSystemFormQuad(BRenderer renderer, int n)
    { super(renderer, ADDITIVE, n); }

  public BSystemFormQuad(BRenderer renderer, boolean isAdditive, int n)
    { super(renderer, isAdditive, n); }



  // Methods...
  // -------------------------------------------------------------

  protected GeometryArray createGeometry()
  {
    quads = new QuadArray(
      n * 4,
      QuadArray.COORDINATES |
      QuadArray.TEXTURE_COORDINATE_2 |
      QuadArray.COLOR_4);

    quads.setCapability(PointArray.ALLOW_COORDINATE_WRITE);
    quads.setCapability(PointArray.ALLOW_COLOR_WRITE);

    int index = 0;

    for (int i=0; i<n; i++)
    {
      quads.setTextureCoordinates(0, index, textureCoordinates);
      quads.setColors(index, INVISIBLE);
      index += 4;
    }

    return quads;
  }



  protected QuadArray getQuadArray()
    { return quads; }
     

  public BParticleForm createForm(BParticle p)
    throws BParticleSystemException
  {
    if (used >= n)
      throw new BParticleSystemException(
        "Can't create appearance for particle: "+ p);

    BParticleForm form =
      new BParticleFormQuad(this, used << 2);

    used++;

    return form;
  }



}