package roboforge.ui.action;

import roboforge.ui.components.*;
import java.awt.event.*;
import javax.swing.*;


public abstract class BSwingAction extends BAction
{

  // Guarantees that upon actionbPerformed(),
  // swingAction() will be called on the swing 
  // event-dispatch thread.
  
  
  public BSwingAction()
    { super();}

  public BSwingAction(String name)
    { super(name); }

  public BSwingAction(String name, Icon icon)
    { super(name, icon); }

  public BSwingAction(BUIResources res, String key)
    { super(res, key); }


  public final void actionPerformed(ActionEvent e)
  {
    if (SwingUtilities.isEventDispatchThread())
      swingAction(e);
    else 
      try
        { SwingUtilities.invokeAndWait(new SwingActor(e)); }
      catch (Exception ex)
        { }
  }

  protected class SwingActor implements Runnable
  {
    protected ActionEvent event;

    public SwingActor(ActionEvent e)
      { this.event = e; }

    public void run()
      { swingAction(event); }
  }

  public abstract void swingAction(ActionEvent e);
  
} 