package roboforge.ui.ai;

import roboforge.ai.BDecisionTreeAI;
import roboforge.ai.decisions.*;

import roboforge.ui.BToolPanel;
import roboforge.ui.events.*;

import java.awt.event.*;


public class BAINodePanel extends BToolPanel
{

  // Class variables...
  // -------------------------------------------------------------

  protected static BAINodePanel instance = null;
    // A single instance of this panel type.
    // Returned by getInstance().


  // Member variables...
  // -------------------------------------------------------------

  protected BDecisionTreeAI    ai;
  protected BDecisionTreeModel model;

  protected UpdateListener     updateListener;


  // Constructor.
  // -------------------------------------------------------------

  public BAINodePanel(String name)
  {
    super(name);
    updateListener = new UpdateListener();
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public void setNode(BDecisionTreeNode node)
    { setPanelFromNode(node); }

  public BDecisionTreeNode getNode()
    { return null; }

  public void setAI(BDecisionTreeAI ai)
    { this.ai = ai; }

  public BDecisionTreeAI getAI()
    { return ai; }

  public void setModel(BDecisionTreeModel model)
    { this.model = model; }

  public BDecisionTreeModel getModel()
    { return model; }


  public static BAINodePanel getInstance()
  {
    if (instance == null)
      instance = new BAINodePanel("");

    return instance;
  }


  // Activation methods...
  // -------------------------------------------------------------

  public void onDeactivate()
  {
    setNodeFromPanel();
    super.onDeactivate();
  }

  public void onClose()
  {
    ai       = null;
    instance = null;

    model = null;
    updateListener = null;


    super.onClose();
  }


  // UI Methods
  // -------------------------------------------------------------

  protected void setPanelFromNode(BDecisionTreeNode node)
    { }

  protected void setNodeFromPanel()
    { }

  public void updateModel()
  {
    if (model != null)
    {
      setNodeFromPanel();
      model.nodeChanged(getNode());
    }
  }


  protected class UpdateListener extends BActionAdapter
  {
    public void actionApproved(ActionEvent e)
      { updateModel(); }
  }


}