package roboforge.ui.ai;

import roboforge.BDebug;
import roboforge.BZones;
import roboforge.BComponent;
import roboforge.BBot;
import roboforge.ai.decisions.*;
import roboforge.ai.values.*;
import roboforge.ai.worldstate.*;


import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;

import java.util.Hashtable;
import javax.swing.*;

import roboforge.ui.components.HSBImageIcon;

public class BAINodePanelLibrary
{

  // Internal variables...
  // -------------------------------------------------------------

  protected Hashtable library = new Hashtable(20, 0.75f);
  protected Hashtable refLibrary = new Hashtable(20, 0.75f);
  protected Hashtable dataLibrary = new Hashtable(20, 0.75f);

  protected String simpleNumberPanel = new String("roboforge.ui.ai.BSimpleNumberPanel");
  protected String simpleBooleanPanel = new String("roboforge.ui.ai.BSimpleBooleanPanel");
  protected String simpleAnglePanel = new String("roboforge.ui.ai.BSimpleAnglePanel");
  protected String multiBooleanPanel = new String("roboforge.ui.ai.BMultiBooleanPanel");
  protected String zonePanel = new String("roboforge.ui.ai.BAINodePanelLibrary$ZonePanel");
  protected String componentPanel = new String("roboforge.ui.ai.BAINodePanelLibrary$ComponentPanel");
  protected String collisionPanel = new String("roboforge.ui.ai.BAINodePanelLibrary$CollisionTimePanel");

  protected String componentRef = BBot.stateCode+  BWorldState.DELIMITER + BComponent.stateCode;


  // SimpleNumberData
  // -------------------------------------------------------------
  private String [] s1 = {"me.health", "My health", "enemy.health", "My enemy's health"};
  protected BSimpleNumberData health = new BSimpleNumberData("health", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/health_30.gif"), s1, 0, 100, "%");

  private String [] s2 = {"me.energy", "My energy", "enemy.energy", "My enemy's energy"};
  protected BSimpleNumberData energy = new BSimpleNumberData("energy", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/energy_30.gif"), s2, 0, 100, "%");

  private String [] s3 = {  "me.distanceToEnemy", "The distance to my enemy",
                            "me.distanceToArenaEdge", "The distance to the arena edge",
                            "me.distanceToArenaCenter", "The distance to the arena center",
                            "enemy.height", "The height of the enemy",
                            "enemy.width", "The width of the enemy (from center)",
                            "enemy.depth", "The depth of the enemy (from center)"
                          };
  protected BSimpleNumberData distance = new BSimpleNumberData("distance", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/distance_30.gif"), s3, 0, 40, "m");

  private String [] s4 = {"me.cost", "My cost", "enemy.cost", "My enemy's cost"};
  protected BSimpleNumberData cost = new BSimpleNumberData("cost", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/cost_30.gif"), s4, 20000, 35000, "cred");

  private String [] s5 = {"me.timeSinceCollision", "Time elapsed since my last collision"};
  protected BSimpleNumberData collision = new BSimpleNumberData("collision time", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/collision_30.gif"), s5, 0, 100, "s");

  private String [] s6 = {"me.weight", "My weight", "enemy.weight", "My enemy's weight"};
  protected BSimpleNumberData weight = new BSimpleNumberData("weight", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/weight_30.gif"), s6, 0, 100, "kg");

  private String [] s7 = {"me.reach", "My reach", "enemy.reach", "My enemy's reach"};
  protected BSimpleNumberData reach = new BSimpleNumberData("reach distance", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/reach_30.gif"), s7, 0, 40, "m");

  private String [] s8 = {  "timeElapsed", "The time elapsed",
                            "timeRemaining", "The time remaining",
                            "timeSinceDeadlock", "The time elasped since a deadlock"
                          };
  protected BSimpleNumberData time = new BSimpleNumberData("time", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/time_30.gif"), s8, 0, 180, "s");

  private String [] s9 = {"enemy.velocityTowardsMe", "The velocity of my enemy towards me"};
  protected BSimpleNumberData velocity = new BSimpleNumberData("velocity", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/block_30.gif"), s9, 0, 100, "m/s");

  private String [] s10 = {"me.isBlind", "Am I blind?", "enemy.isBlind", "Is my enemy blind?"};
  protected BSimpleDecisionData blind = new BSimpleDecisionData("blind", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/isblind_30.gif"), s10);

  private String [] s11 = {"enemy.chassis.isHover", "Does my enemy's chassis hover?", "enemy.chassis.isLegged", "Does my enemy's chassis have legs?", "enemy.chassis.isWheeled", "Does my enemy's chassis have wheels?"};
  protected BSimpleDecisionData enemyChassisType = new BSimpleDecisionData("enemy chassis type", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/block_30.gif"), s11);

  private String [] s12 = {"enemy.isDetected", "Have I detected my enemy?"};
  protected BSimpleDecisionData enemyDetected = new BSimpleDecisionData("enemy detected", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/detected_30.gif"), s12);

  private String [] s13 = {"me.angleToArenaCenter", "My angle to the arena center", "me.angleToEnemy", "My angle to my enemy", "enemy.angleToMe", "My enemy's angle to me", "enemy.velocityAngleToMe", "The angle of my enemy's velocity to me"};
  protected BSimpleNumberData angle = new BSimpleNumberData("angle", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/angle_30.gif"), s13, 0, 360, "");

  private String [] s14 = {".isActive", "Is active", ".detectsChassis", "Detect a chassis", ".detectsController", "Detect a controller", ".detectsEnergy", "Detect an energy generator", ".detectsSensor", "Detect a sensor", ".detectsShielding", "Detect a shield",  ".detectsWeapon", "Detect a weapon", ".detectsJoint", "Detect a joint"};
  private BSimpleDecisionData zones = new BSimpleDecisionData("zones", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/zone_30.gif"), s14);

  private String [] s15 = {componentRef, "My components"};
  private BSimpleDecisionData components = new BSimpleNumberData("component health", new HSBImageIcon (roboforge.BGlobal.IMAGEPATH + "ui/ai/component_30.gif"), s15, 0, 100, "%");

  // Constructor.
  // -------------------------------------------------------------
  public BAINodePanelLibrary()
    {
      initLibrary();
      initRefLibrary();
      initDataLibrary();
    }

  // Initialization functions...
  // -------------------------------------------------------------

  protected void initLibrary()
  {
    library.put(
      "roboforge.ai.decisions.BRootNode",
      "roboforge.ui.ai.BRootNodePanel");

    library.put(
      "roboforge.ai.decisions.BGroupNode",
      "roboforge.ui.ai.BGroupNodePanel");

     library.put(
      "roboforge.ai.decisions.BBlockNode",
      "roboforge.ui.ai.BGroupNodePanel");

    library.put(
      "roboforge.ai.decisions.BZoneGroupNode",
      "roboforge.ui.ai.BGroupNodePanel"); 

    library.put(
      "roboforge.ai.decisions.BChassisActionNode",
      "roboforge.ui.ai.BChassisActionNodePanel");

    library.put(
      "roboforge.ai.decisions.BMoveActionNode",
      "roboforge.ui.ai.BMoveActionNodePanel");

    library.put(
      "roboforge.ai.decisions.BOrientActionNode",
      "roboforge.ui.ai.BOrientActionNodePanel");

    library.put(
      "roboforge.ai.decisions.BAssignmentNode",
      "roboforge.ui.ai.BAssignmentNodePanel");

    library.put(
      "roboforge.ai.decisions.BDecisionNode",
      "roboforge.ui.ai.BDecisionNodePanel");
  }

  protected void initRefLibrary()
  {
    refLibrary.put( "me.health", simpleNumberPanel );
    refLibrary.put( "enemy.health", simpleNumberPanel );
    refLibrary.put( "me.energy", simpleNumberPanel );
    refLibrary.put( "enemy.energy", simpleNumberPanel );
    refLibrary.put( "me.distanceToEnemy", simpleNumberPanel );
    refLibrary.put( "me.distanceToArenaEdge", simpleNumberPanel );
    refLibrary.put( "me.distanceToArenaCenter", simpleNumberPanel );

    refLibrary.put( "enemy.height", simpleNumberPanel );
    refLibrary.put( "enemy.width", simpleNumberPanel );
    refLibrary.put( "enemy.depth", simpleNumberPanel );


    refLibrary.put( "me.cost", simpleNumberPanel );
    refLibrary.put( "enemy.cost", simpleNumberPanel );


    //refLibrary.put( "me.lastCollisionTime", collisionPanel );
    refLibrary.put( "me.timeSinceCollision", collisionPanel );

    refLibrary.put( "me.weight", simpleNumberPanel );
    refLibrary.put( "enemy.weight", simpleNumberPanel );
    refLibrary.put( "me.reach", simpleNumberPanel );
    refLibrary.put( "enemy.reach", simpleNumberPanel );
    refLibrary.put( "enemy.velocityTowardsMe", simpleNumberPanel );
    refLibrary.put( "timeElapsed", simpleNumberPanel );
    refLibrary.put( "timeRemaining", simpleNumberPanel );
    refLibrary.put( "timeSinceDeadlock", simpleNumberPanel );



    refLibrary.put( "me.isBlind", simpleBooleanPanel );
    refLibrary.put( "enemy.isBlind", simpleBooleanPanel );
    refLibrary.put( "enemy.chassis.isHover", simpleBooleanPanel );
    refLibrary.put( "enemy.chassis.isLegged", simpleBooleanPanel );
    refLibrary.put( "enemy.chassis.isWheeled", simpleBooleanPanel );
    refLibrary.put( "enemy.isDetected", simpleBooleanPanel );

    refLibrary.put( "me.angleToArenaCenter", simpleAnglePanel );
    refLibrary.put( "me.angleToEnemy", simpleAnglePanel );
    refLibrary.put( "enemy.angleToMe", simpleAnglePanel );
    refLibrary.put( "enemy.velocityAngleToMe", simpleAnglePanel );

    refLibrary.put( ".isActive", zonePanel );
    refLibrary.put( ".detectsChassis", zonePanel );
    refLibrary.put( ".detectsController", zonePanel );
    refLibrary.put( ".detectsEnergy", zonePanel );
    refLibrary.put( ".detectsSensor", zonePanel );
    refLibrary.put( ".detectsShielding", zonePanel );
    refLibrary.put( ".detectsWeapon", zonePanel );
    refLibrary.put( ".detectsJoint", zonePanel );

    refLibrary.put( componentRef, componentPanel );



  }

  protected void initDataLibrary()
  {
    dataLibrary.put( "me.health", health );
    dataLibrary.put( "enemy.health", health );
    dataLibrary.put( "me.energy", energy );
    dataLibrary.put( "enemy.energy", energy );
    dataLibrary.put( "me.distanceToEnemy", distance );
    dataLibrary.put( "me.distanceToArenaEdge", distance );
    dataLibrary.put( "me.distanceToArenaCenter", distance );

    dataLibrary.put( "enemy.height", distance );
    dataLibrary.put( "enemy.width", distance );
    dataLibrary.put( "enemy.depth", distance );

    dataLibrary.put( "me.cost", cost );
    dataLibrary.put( "enemy.cost", cost );
    dataLibrary.put( "me.timeSinceCollision", collision );
    dataLibrary.put( "me.weight", weight );
    dataLibrary.put( "enemy.weight", weight );
    dataLibrary.put( "me.reach", reach );
    dataLibrary.put( "enemy.reach", reach );
    dataLibrary.put( "enemy.velocityTowardsMe", velocity );

    dataLibrary.put( "timeElapsed", time );
    dataLibrary.put( "timeRemaining", time );
    dataLibrary.put( "timeSinceDeadlock", time );



    dataLibrary.put( "me.isBlind", blind );
    dataLibrary.put( "enemy.isBlind", blind );
    dataLibrary.put( "enemy.chassis.isHover", enemyChassisType );
    dataLibrary.put( "enemy.chassis.isLegged", enemyChassisType );
    dataLibrary.put( "enemy.chassis.isWheeled", enemyChassisType );
    dataLibrary.put( "enemy.isDetected", enemyDetected );

    dataLibrary.put( "me.angleToArenaCenter", angle );
    dataLibrary.put( "me.angleToEnemy", angle );
    dataLibrary.put( "enemy.angleToMe", angle );
    dataLibrary.put( "enemy.velocityAngleToMe", angle );

    dataLibrary.put( ".isActive", zones );
    dataLibrary.put( ".detectsChassis", zones );
    dataLibrary.put( ".detectsController", zones );
    dataLibrary.put( ".detectsEnergy", zones );
    dataLibrary.put( ".detectsSensor", zones );
    dataLibrary.put( ".detectsShielding", zones );
    dataLibrary.put( ".detectsWeapon", zones );
    dataLibrary.put( ".detectsJoint", zones );

    dataLibrary.put( componentRef, components );
    
  }

  public void onClose()
  {
    BRootNodePanel.clearInstance();
    BGroupNodePanel.clearInstance();
    BChassisActionNodePanel.clearInstance();
    BMoveActionNodePanel.clearInstance();
    BOrientActionNodePanel.clearInstance();
    BAssignmentNodePanel.clearInstance();
    BDecisionNodePanel.clearInstance();

    BSimpleNumberPanel.clearInstance();
    BSimpleBooleanPanel.clearInstance();
    BSimpleAnglePanel.clearInstance();
    BMultiBooleanPanel.clearInstance();

    // internal static classes
    ZonePanel.clearInstance();
    ComponentPanel.clearInstance();
    CollisionTimePanel.clearInstance();

  }

  protected String getWorldRef( BSimpleDecisionNode n)
//  protected String getWorldRef( BDecisionTreeNode n, String className)
  {
      // transpost to me.components for component world items
    String ref = n.getWorldItemRef();

    BDebug.print("BAINodePanelLibrary - getWorldRef = " + ref);
    /*
    if (className.equals("roboforge.ai.decisions.BSimpleDecisionNode"))
    {
      ref = ((BSimpleDecisionNode)n).getWorldItemRef();
    }
    else if (className.equals("roboforge.ai.decsisions.BSimpleAngleNode"))
    {
      ref = ((BSimpleAngleNode)n).getWorldItemRef();
    }
*/
    if (ref.indexOf(componentRef) == 0 )
      ref = componentRef;

    return ref;

  }


  // gets the class name of a decision tree node
  public String getPanelClassName(BDecisionTreeNode n)
  {
    if (n == null)
      return "";

    String panelClassName = null;

    // Find name of class
    String className =
      n.getClass().getName();

    //BDebug.print("BAINodePanelLibrary - className = " + className);

    if (className.equals("roboforge.ai.decisions.BSimpleDecisionNode"))
    {
      panelClassName = (String) refLibrary.get(getWorldRef((BSimpleDecisionNode)n));
    }
    else if (className.equals("roboforge.ai.decisions.BSimpleAngleNode"))
    {
      panelClassName = (String) refLibrary.get(getWorldRef((BSimpleAngleNode)n));
    }
    else
      panelClassName = (String) library.get(className);

    if(panelClassName == null)
      return "";

    return panelClassName;
  }

  // Accessor functions
  // -------------------------------------------------------------
  public BAINodePanel getPanelForNode(BDecisionTreeNode n)
  {
    //BDebug.print ("BAINodePanelLibrary.getPanelForNode " + n );

    if (n == null)
      return BAINodePanel.getInstance();

    // the name of the panel class to be used
    String panelClassName;

    // the unique identifier of the world item
    String worldItemRef = "";


    // if it is a simple decision node, see what sort it is and set
    // the panel class name accordingly
    panelClassName = getPanelClassName(n);

    if (panelClassName == null)
      return BAINodePanel.getInstance();

    try
    {

      //BDebug.print("BAINodePanelLibrary.panelName "+ panelClass);
      
       Class panelClass = Class.forName(panelClassName);

       Method getInstance = panelClass.getMethod("getInstance", null);

       BAINodePanel panel = (BAINodePanel)
                              getInstance.invoke(null, null);


       if (panel instanceof BSimpleDecisionPanel)
       {

          BSimpleDecisionPanel sPanel = (BSimpleDecisionPanel) panel;

          sPanel.setData((BSimpleDecisionData)dataLibrary.get(getWorldRef((BSimpleDecisionNode)n)));

       }

       return panel;
    //  }
    }

    catch (IllegalAccessException ex)
      { return BAINodePanel.getInstance(); }
    catch (ClassNotFoundException ex)
      { return BAINodePanel.getInstance(); }
    catch (NoSuchMethodException ex)
      { return BAINodePanel.getInstance(); }
    catch (InvocationTargetException ex)
      { return BAINodePanel.getInstance(); }
  }




  // inner Classes
  protected static class ZonePanel extends BMultiBooleanPanel
  {

    protected Hashtable zoneTable = new Hashtable(20, 0.75f);
    private static  ZonePanel instance;


    public ZonePanel()
    {
      super();
    }


    public static BAINodePanel getInstance()
    {
      if (instance == null)
        instance = new ZonePanel();

      return instance;
    }

    public static void clearInstance()
    {
      instance = null;
    }

    public void refreshCombo()
    {
      BZones zones = getAI().getBot().getZones();
      optionCombo.setModel(new DefaultComboBoxModel(zones.getZones()) );

      // refresh the zone hash table
      zoneTable.clear();

      for (int i = 0; i < zones.getZones().size(); i++)
      {
        //BDebug.print ("BZonePanel.addingToTable " + zones.getZones().elementAt(i).toString() );
        zoneTable.put(zones.getZones().elementAt(i).toString(), zones.getZoneAt(i));
      }
    }

    protected void updateInfo()
    {
      if(optionCombo.getSelectedIndex() > -1)
      {
        if (optionString2.equals("Is active"))
          infoLabel.setText("Is zone \"" + optionString + "\" active ?");
        else
          infoLabel.setText("Does zone \"" + optionString + "\" " + optionString2.toLowerCase() + " ?");
      }
      else
        infoLabel.setText("No zone selected");

    }

    protected void setPanelFromNode(BDecisionTreeNode n)
    {
      super.setPanelFromNode(n);
      if(initialized)
      {
       // BDebug.print("BZonePanel looking up " +  ((BString)node.getValueRef()).getValue() );
        optionCombo.setSelectedItem(zoneTable.get(((BString)node.getValueRef()).getValue()));

        if (n.getParent() instanceof BZoneGroupNode)
          optionCombo.setEnabled(false);
        else
          optionCombo.setEnabled(true);

      }
    }

    protected void setNodeFromPanel()
    {
      //super.setNodeFromPanel();

      if(node != null)
      {
        if (!(node.getParent() instanceof BZoneGroupNode))
          node.setValueRef(new BString(optionString));

        node.setWorldItemRef((String)optionTable.get(optionString2));
        String exp = "[" + BZones.FULL_WORLDSTATE_CODE + ((BString)node.getValueRef()).getValue()+ optionTable.get(optionString2) + "]";
        //BDebug.print ("BZoneNodeGroupPanel exp " + exp);
        updateNodeExpression(exp);

        if(optionCombo.getSelectedIndex() > -1)
          node.setName(optionString + " " + optionString2.toLowerCase() + "?");
        else
          node.setName("No zone selected");

      }
    }

    /*public void onActivate()
    {
      super.onActivate();
      refreshCombo();
    } */



  }



  protected static class CollisionTimePanel extends BSimpleNumberPanel
  {
    private static CollisionTimePanel instance;

    public CollisionTimePanel()
    {
      super();
    }

    public static void clearInstance()
    {
      instance = null;
    }

     public static BAINodePanel getInstance()
    {
      if (instance == null)
        instance = new CollisionTimePanel();

      return instance;
    }

     protected void setNodeFromPanel()
    {
        BDebug.print("BAINodePanelLibrary$collisionPanel - value " + valueSlider.getValue());

        super.setNodeFromPanel();

        if(node != null)
        {
          String op;
          if(operatorString.equals("less than"))
            op = "<";
          else if(operatorString.equals("equal to"))
            op = "=";
          else
            op = ">";

          String exp =  "[" + optionTable.get(optionString) + "] " + op + " " + valueSlider.getValue() ;
          updateNodeExpression(exp);
        } 

      }


  }


  // COMPONENT PANEL CLASS
  protected static class ComponentPanel extends BSimpleNumberPanel
  {

    private static ComponentPanel instance;

    public ComponentPanel()
    {
      super();
    }


    public static BAINodePanel getInstance()
    {
      if (instance == null)
        instance = new ComponentPanel();

      return instance;
    }

    public static void clearInstance()
    {
      instance = null;
    }

    public void onActivate()
    {
      super.onActivate();
      refreshCombo();
    }

    protected void refreshCombo()
    {
          //BDebug.print ("BComponentPanel.refreshCombo() called ");

          String lastSelected = "";

          if ( optionCombo.getSelectedItem() != null);
            lastSelected = (String)optionCombo.getSelectedItem();

          optionCombo.removeAllItems();
          optionTable.clear();

          BComponent[] components = getAI().getBot().getBreathComponents();

          for (int i = components.length-1; i >=0; i--)
            if (!components[i].getChassisLock())
            {
              String code = components[i].getWorldStateCode() + BWorldState.DELIMITER + "health";
              String name = components[i].getName() + "'s health";
              optionTable.put(code, name) ;
              optionTable.put(name, code) ;
              optionCombo.addItem( name );
            }

          if (lastSelected != null)
            if (!lastSelected.equals("") )
              optionCombo.setSelectedItem(lastSelected);

    }



    protected void setPanelFromNode(BDecisionTreeNode n)
    {

      if(initialized)
        refreshCombo();

      super.setPanelFromNode(n);

     }




  }




} // library
