package roboforge.ui.ai;

import roboforge.BGlobal;
import roboforge.BDebug;

import roboforge.ai.decisions.*;
import roboforge.ui.components.*;
import roboforge.ui.components.BCompoundIcon;
import roboforge.ui.components.BUIResources;

import roboforge.util.graphics.*;

import java.awt.Color;
import java.awt.Component;

import javax.swing.Icon;
import javax.swing.JTree;
import javax.swing.tree.*;

import java.awt.*;

public class BDecisionTreeIcon extends BBorderedIcon
{


    Icon closedChildrenIcon = BIconCache.getHSB("tree_expanded_icon.gif");
    boolean closed;

    public BDecisionTreeIcon(Color borderColor, Icon innerIcon, int borderGap, boolean drawBackground)
    {
      super(borderColor, innerIcon, borderGap, drawBackground);
    }

    static final int CLOSED_BOX_SIZE = 9;
    static final int CLOSED_BOX_BORDER = 2;


    public void paintIcon(Component c, Graphics g, int x, int y)
    {
      super.paintIcon(c,g,x,y);

      if (closed)
      //  paintClosed(g,( x + this.getIconWidth() ) - CLOSED_BOX_SIZE - 2,(y + this.getIconHeight()) - CLOSED_BOX_SIZE -2 );
        closedChildrenIcon.paintIcon(c, g, ( x + this.getIconWidth() ) - closedChildrenIcon.getIconWidth() - 2, (y + this.getIconHeight()) - closedChildrenIcon.getIconHeight() -2 );
    }

  /*  private void paintClosed( Graphics g, int x, int y )
    {
      g.drawLine( x + (CLOSED_BOX_SIZE / 2) + 1, y + CLOSED_BOX_BORDER, x + (CLOSED_BOX_SIZE / 2) + 1, y + CLOSED_BOX_SIZE - CLOSED_BOX_BORDER);
      g.drawLine( x + CLOSED_BOX_BORDER, y + (CLOSED_BOX_SIZE / 2) + 1, x + CLOSED_BOX_SIZE - CLOSED_BOX_BORDER + 1, y + (CLOSED_BOX_SIZE / 2) + 1);

    } */

    public void setClosed(boolean b)
    {
      closed = b;
    }





} 