package roboforge.ui.ai;

import roboforge.ai.BDecisionTreeAI;
import roboforge.ai.decisions.*;

import roboforge.ui.components.*;

import java.awt.event.*;

public class BGroupNodePanel extends BAINodePanel
{

  // Class variables...
  // -------------------------------------------------------------

  protected static BAINodePanel instance = null;
    // A single instance of this panel type.
    // Returned by getInstance().


  // Member variables...
  // -------------------------------------------------------------

  protected BGroupNode node;


  // Visual elements...
  // -------------------------------------------------------------

  protected BTextField name = new BTextField();
  protected BMultiLabel info = new BMultiLabel();
//  protected BCheckBox open = new BCheckBox("expand group");


  // Constructor.
  // -------------------------------------------------------------

  public BGroupNodePanel()
  {
    super("group");

    layoutPanelChildren();
    configPanelChildren();
  }

  protected void layoutPanelChildren()
  {
    addHGlued(new BLabel("Description: "));
    addTinyMargin();
    addHGlued(name);
    addMargin();
    //addHGlued(open);
    //addMargin();

    addGlued(new BLine() );
    addMargin();
    add(info);
  }

  protected void configPanelChildren()
  {
    name.addActionListener(updateListener);

    /*open.addMouseListener(
      new MouseAdapter()
      {
        public void mouseClicked(MouseEvent e)
        {
           if (model != null)
            if ( BGroupNodePanel.this.isShowing() )
            {
              setNodeFromPanel();
              model.notifyTree();
            }
        }

      }
    );   */
 }


  // Activation methods...
  // -------------------------------------------------------------

  public void onClose()
  {
    instance = null;
    super.onClose();
  }


  public static void clearInstance()
    { instance = null; }

  // Accessor methods...
  // -------------------------------------------------------------

  public BDecisionTreeNode getNode()
    { return node; }

  public static BAINodePanel getInstance()
  {
    if (instance == null)
      instance = new BGroupNodePanel();

    return instance;
  }


  // UI methods...
  // -------------------------------------------------------------

  protected void setPanelFromNode(BDecisionTreeNode n)
  {
    this.node = (BGroupNode) n;
    name.setText(node.getName());
   // open.setSelected(! node.isClosed() );

    info.setText( this.node.getDescription() );

  }

  protected void setNodeFromPanel()
  {
    if (node != null)
    {
      String trimmed = name.getText().trim();

      if (!trimmed.equals(""))
        node.setName(trimmed);
      else
        node.setName(null);

  //    node.setClosed(!open.isSelected() );
     // model.notifyTree();

    }
  }

}