package roboforge.ui.ai;

import roboforge.ui.components.HSBImageIcon;

/*
  BSimpleDecisionData
  holds the data required for a simple decision:
  the title of the panel, the image of the world item type
  and an array of strings that contains the combo box items
  as well as the actual world item references
*/

public class BSimpleDecisionData
{
  private String title;
  private HSBImageIcon image;
  private String [] options;

  // constructor
  public BSimpleDecisionData(String title, HSBImageIcon image, String [] options)
  {
    this.title = title;
    this.image = image;
    this.options = options;
  }

  // returns the title to be displayed on the panel
  protected String getTitle()
  {
    return title;
  }

  // returns the icon to be displayed on the panel
  protected HSBImageIcon getIcon()
  {
    return image;
  }

  // returns the array of option strings
  protected String [] getOptions()
  {
    return options;
  }
}
