package roboforge.ui.components;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;

import javax.swing.*;


public class BAnimatedTextLabel extends BAnimatedLabel
{

  // Member variables...
  // -------------------------------------------------------------

  protected Color light;
  protected Color dark;

  protected int cycle;

  protected double r,  g,  b;
  protected double dr, dg, db;



  // Constructors...
  // -------------------------------------------------------------

  public BAnimatedTextLabel()
    { super(); }

  public BAnimatedTextLabel(BUIResources res, String key)
    { super(res, key); }


  public void initializeUI(BUIResources res, String key)
  {
    super.initializeUI(res, key);

    if (frames == LOOP)
      frames = 10;

    if (res != null)
    {
      cycle = res.getInt(key+ ".cycle");
      if (cycle == 0)
        cycle = 10;

      light = res.getColor(key+ ".light");
      if (light == null)
        light = Color.white;

      dark  = res.getColor(key+ ".dark");
      if (dark == null)
        dark = Color.black;
    }
  }


  // Animation method...
  // -------------------------------------------------------------

  public void animationStart()
  {
    double n = (cycle / 2.0);

    r = dark.getRed();
    g = dark.getGreen();
    b = dark.getBlue();

    dr = (light.getRed()   - r) / n;
    dg = (light.getGreen() - g) / n;
    db = (light.getBlue()  - b) / n;

  }

  public void animation()
  {
    if (current < (cycle >> 1))
      { r += dr; g += dg; b += db; }
    else
      { r -= dr; g -= dg; b -= db; }

    Color c = new Color((int) r, (int) g, (int) b);
    setForeground(c);
  }


}