package roboforge.ui.components;

import java.awt.Component;
import java.awt.Graphics;

import javax.swing.Icon;

public class BCompoundIcon implements Icon
{

  // Class variables...
  // -------------------------------------------------------------

  protected static final int GAP = 4;


  // Member variables...
  // -------------------------------------------------------------

  protected Icon a, b;


  // Constructors...
  // -------------------------------------------------------------

  public BCompoundIcon()
    { }

  public BCompoundIcon(Icon a, Icon b)
  {
    this.a = a;
    this.b = b;
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public void paintIcon(Component c, Graphics g, int x, int y)
  {
    int offset = x + GAP;

    if (a != null)
    {
      int yOffset = 0;

      // align the height of the icons
      if (b != null)
      {
        if (b.getIconHeight() > a.getIconHeight() )
          yOffset = ( b.getIconHeight() - a.getIconHeight() ) / 2;
      }

      a.paintIcon(c, g, x, y + yOffset);
      offset += a.getIconWidth();
    }

    if (b != null)
      b.paintIcon(c, g, offset, y);
  }

  public int getIconWidth()
  {
    int aw = (a != null) ? a.getIconWidth() : 0;
    int bw = (b != null) ? b.getIconWidth() : 0;

    return aw+ GAP+ bw;
  }

  public int getIconHeight()
  {
    int ah = (a != null) ? a.getIconHeight() : 0;
    int bh = (b != null) ? b.getIconHeight() : 0;

    return Math.max(ah, bh);
  }


  public void setFirstIcon(Icon a)
    { this.a = a; }

  public void setSecondIcon(Icon b)
    { this.b = b; }

  public Icon getFirstIcon()
    { return a; }

  public Icon getSecondIcon()
    { return b; }

}