package roboforge.ui.components;

import roboforge.BDebug;
import roboforge.BGlobal;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.*;

import javax.swing.JPasswordField;
import javax.swing.FocusManager;



public class BPasswordField extends JPasswordField
{

  // Member variables...
  // -------------------------------------------------------------

  protected static final int PREF_HEIGHT = 19;

  protected static final Color enabledColor = 
    BGlobal.colors.getMidShade();
  
  protected static final Color disabledColor = 
    BGlobal.colors.getDarkShade();



  // Constructor.
  // -------------------------------------------------------------

  public BPasswordField(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BPasswordField()
  {
    super();
    initializeUI(null, null);
  }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {

    setMinimumSize(new Dimension(0, PREF_HEIGHT));
    setPreferredSize(new Dimension(20, PREF_HEIGHT));
    setMaximumSize(new Dimension(Short.MAX_VALUE, PREF_HEIGHT));

    if (res != null)
      res.initComponent(this, key);

    TextEntryListener listener = new TextEntryListener();
    addActionListener(listener);
  }

  protected class TextEntryListener implements ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      FocusManager.getCurrentManager()
        .focusNextComponent(BPasswordField.this);
    }
  }
  

  // Accessor methods...
  // -------------------------------------------------------------
  
  public void setEnabled(boolean e)
  {
    super.setEnabled(e);
    setForeground(e ? enabledColor : disabledColor);
  }
  
}