package roboforge.ui.components;

import java.awt.*;

import javax.swing.JLabel;
import javax.swing.UIManager;

public class BRect extends JLabel
{
  // Member variables...
  // -------------------------------------------------------------

  protected Color lineColor = Color.white;

  // Constructor.
  // -------------------------------------------------------------

  public BRect(BUIResources res, String resourceKey)
  {
    super();
    initializeUI(res, resourceKey);
  }

  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    Color fg = res.getColor(key+ ".foreground");
    if (fg != null)
      setForeground(fg);
    else
      setForeground(UIManager.getColor("Rect.foreground"));

    res.initComponent(this, key);

    // Set centered alignment, for correct BoxLayout display...
    setAlignmentX(Component.CENTER_ALIGNMENT);
    setAlignmentY(Component.CENTER_ALIGNMENT);
  }

  // Action methods...
  // -------------------------------------------------------------

  public void paint(Graphics g)
  {
    g.setColor(getForeground());

    Dimension d = getSize();
    g.drawRect(0, 0, d.width-1, d.height-1);
  }


  public Dimension getMaximumSize()
    { return new Dimension(Short.MAX_VALUE, Short.MAX_VALUE); }

}