package roboforge.ui.components;

import roboforge.BDebug;
import roboforge.BGlobal;

import java.awt.*;
import javax.swing.JTabbedPane;

public class BTabbedPane extends JTabbedPane
{

  // Constructors...
  // -------------------------------------------------------------

  public BTabbedPane(BUIResources res, String key)
  {
    super();
    initializeUI(res, key);
  }

  public BTabbedPane()
    { this(null, null); }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    setOpaque(true);

    if (res != null)
      res.initComponent(this, key);
  }


  // Accessor methods...
  // -------------------------------------------------------------

  /*
  public void setEnabled(boolean enabled)
  {
    super.setEnabled(enabled);

    synchronized (getTreeLock())
    {
      Component[] kids = getComponents();
      for (int i=0; i<kids.length; i++)
        kids[i].setEnabled(enabled);
    }
  }
  */

  public Component findComponentAt(int x, int y)
    // Workaround for DND bug #4193463...
    // Looks like the bug is to do with no visibility checking
    // of child containers in JComponent.findComponentAt(x,y).
    // Thanks sqrrrl, whoever you are.
  {
    if (!contains(x, y))
      return null;

    int n = getComponentCount();
    for (int i=0; i<n; i++)
    {
      Component c = getComponentAt(i);
      if (c != null)
      {
        if (c instanceof Container)
        {
          // Here's the major change.
      	  if(c.isVisible())
	          c = ((Container) c).
              findComponentAt(x - c.getX(), y - c.getY());
        }
        else
          { c = c.locate(x - c.getX(), y - c.getY()); }

        if (c != null && c.isVisible())
          { return c; }
      }
    }
    return this;
  }

}

