package roboforge.ui.components.border;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class BRoundedBorder implements Border
{

  // TODO: Decide which of these to expose to constructor..
  protected static Insets insets = new Insets(0, 0, 0, 0);
  protected Color enabledColor   = null;
  protected Color focusedColor   = null;
  protected Color disabledColor  = null;
  protected float roundness      = 0.25f;

  //protected static final Stroke FOCUS_STROKE =
  //  new BasicStroke(2.0f);

  protected static RenderingHints hints = new RenderingHints (
    RenderingHints.KEY_ANTIALIASING,
    RenderingHints.VALUE_ANTIALIAS_ON );

  public BRoundedBorder
  (
    Color enabledColor,
    Color focusedColor,
    Color disabledColor,
    float roundness
  )
  {
    this.enabledColor  = enabledColor;
    this.focusedColor  = focusedColor;
    this.disabledColor = disabledColor;
    this.roundness     = roundness;
  }

  public BRoundedBorder(Color c, float roundness)
  {
    this.enabledColor  = c;
    this.focusedColor  = c;
    this.disabledColor = c;
    this.roundness     = roundness;
  }

  public Insets getBorderInsets(Component c)
  {
    // TODO: Should this be cloned, or passed by reference?
    return (Insets) insets.clone();
  }

  public boolean isBorderOpaque()
    { return false; }

  public void paintBorder(Component c, Graphics g, int x, int y, int w, int h)
  {
    int arcsize = Math.round(roundness * Math.min(w, h));

    Graphics2D g2D = (Graphics2D) g;
    g2D.addRenderingHints(hints);

    //Stroke oldStroke = g2D.getStroke();

    if (c.isEnabled())
    {
      if (c.hasFocus())
      {
        //g2D.setStroke(FOCUS_STROKE);
        g2D.setColor(focusedColor);
      }
      else
        g2D.setColor(enabledColor);
    }
    else
      g2D.setColor(disabledColor);

    g2D.drawRoundRect(x, y, w-1, h-1, arcsize, arcsize);

    //if (c.hasFocus())
    //  g2D.setStroke(oldStroke);
  }
}

