package roboforge.ui.components.table;

import java.awt.Component;
import javax.swing.JTable;
import javax.swing.table.*;



public class BDelegatingCellRenderer implements TableCellRenderer
{

  // Constructors...
  // -------------------------------------------------------------

  public BDelegatingCellRenderer()
    { }


  // Accessor methods...
  // -------------------------------------------------------------

  public Component getTableCellRendererComponent
  (
    JTable table, Object value,
    boolean isSelected, boolean hasFocus,
		int row, int col
  )
  {
    if (!(value instanceof BTableCellDelegate))
      throw new IllegalArgumentException(
        "BDelegatingRenderer.getTableCellRendererComponent(): "+
        "value is not an instance of BTableCellDelegate.");

    BTableCellDelegate delegate =
      (BTableCellDelegate) value;

    TableCellRenderer renderer =
      delegate.getRenderer();

    return renderer.getTableCellRendererComponent
      (table, value, isSelected, hasFocus, row, col);
	}

  
}
