package roboforge.ui.events;

public interface BActivateable
{

  public boolean isActive();
    // Whether this object is currently 'active'.

  public boolean isClosed();
    // Whether this object is currently 'closed'.


  public void requestActivate();
    // Request that this object be activated.
    // Has no effect if object is already active.

  public void requestDeactivate();
    // Request that this object be deactivated.
    // Has no effect if object is already deactivated.

  public void requestClose();
    // Request that this object be closed.
    // Has no effect if object is already closed.


  public void onActivate();
    // When activated - that is, becomes visible.

  public void onDeactivate();
    // When de-activated - that is, hidden.

  public void onClose();
    // When closed entirely - permanently hidden.


  public void addActivationListener(BActivationListener l);
    // Allow other objects to listen to activations...

  public void removeActivationListener(BActivationListener l);
    // Allow other objects to stop listening to activations...

}
