package roboforge.ui.fusion;

import roboforge.ui.components.HSBImageIcon;

import java.awt.*;
import javax.swing.*;

import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class FusionLabelUI extends BasicLabelUI
{
  // Shared UI object
  private final static FusionLabelUI labelUI = new FusionLabelUI();

  protected static RenderingHints hints = new RenderingHints (
    RenderingHints.KEY_ANTIALIASING,
    RenderingHints.VALUE_ANTIALIAS_ON );

  // TODO: Use b.disabledColor();
  protected Color disabledColor = Color.white;
  // protected Color iconColor = Color.white;

  public FusionLabelUI()
  {
    super();
  }

  public static ComponentUI createUI(JComponent c) {
    return labelUI;
  }

  protected void installDefaults(JLabel c)
  {
    super.installDefaults(c);

    String pp = "Label.";

    disabledColor = UIManager.getColor(pp+ "disabledColor");
    // iconColor     = c.getForeground();
  }

  public void paint(Graphics g, JComponent c)
  {
    JLabel l = (JLabel) c;
    if (l.getIcon() instanceof HSBImageIcon)
    {
      HSBImageIcon icon = (HSBImageIcon) l.getIcon();
      icon.setDisabledColor(disabledColor);
    }

    // Graphics2D g2D = (Graphics2D) g;
    // g2D.addRenderingHints(hints);

    super.paint(g, c);
  }

  protected void paintDisabledText(JLabel l, Graphics g, String s, int textX, int textY)
  {
    int accChar = l.getDisplayedMnemonic();
    g.setColor(disabledColor);
    BasicGraphicsUtils.drawString(g, s, accChar, textX, textY);
  }

}
