package roboforge.ui.fusion;

import roboforge.sound.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;


public class FusionListUI extends BasicListUI
{

  protected BSound selectSound;
  
  public static ComponentUI createUI(JComponent list)
    { return new FusionListUI(); }

  
  protected void installDefaults()
  {
    super.installDefaults();
    
    String pp = "List.";
    selectSound = (BSound) UIManager.get(pp + "selectSound");
  }
  
  
  protected MouseInputListener createMouseInputListener()
    { return new FusionMouseInputHandler(); }

  // protected ListSelectionListener createListSelectionListener()
  //  { return new FusionListSelectionHandler(); }
  
  
  public class FusionMouseInputHandler extends MouseInputHandler
  {
    public void mousePressed(MouseEvent e)
    { 
      super.mousePressed(e);
      if (selectSound != null)
        selectSound.play();              
    }

    public void mouseDragged(MouseEvent e)
      { /* Do nothing. This avoids drag n' drop hassles. */ }
  }

  /*
  public class FusionListSelectionHandler extends ListSelectionHandler
  {
    public void valueChanged(ListSelectionEvent e)
    { 
      super.valueChanged(e);

      if (list.isVisible())
        if (!e.getValueIsAdjusting())
          if (selectSound != null)
            selectSound.play();        
      
    }
  }
  */
  
}
