package roboforge.ui.fusion;

import java.awt.*;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.border.*;

public class FusionScrollBarUI extends BasicScrollBarUI
{
  protected Color buttonBackground = null;
  protected Color buttonForeground = null;
  protected Color buttonHighlight  = null;
  protected Border buttonBorder    = null;

  public static ComponentUI createUI(JComponent b)
    { return new FusionScrollBarUI(); }

  protected static String pp = "ScrollBar.";

  protected void installDefaults()
  {
    // Ensures inc/dec buttons get the proper colors in constructor.
    configureScrollBarColors();

    buttonBackground  = UIManager.getColor(pp+ "buttonBackground");
    buttonForeground  = UIManager.getColor(pp+ "buttonForeground");
    buttonHighlight   = UIManager.getColor(pp+ "buttonHighlight");
    buttonBorder      = UIManager.getBorder(pp+ "buttonBorder");

    super.installDefaults();

    incrButton.setBorder(buttonBorder);
    decrButton.setBorder(buttonBorder);
  }


  protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)
  {
  	if(thumbBounds.isEmpty() || !scrollbar.isEnabled())
      { return; }

    int w = thumbBounds.width;
    int h = thumbBounds.height;

	  g.translate(thumbBounds.x, thumbBounds.y);

	  g.setColor(thumbColor);
	  g.fillRect(0, 0, w-1, h-1);

    g.setColor(thumbHighlightColor);
	  g.drawRect(0, 0, w-1, h-1);

	  g.translate(-thumbBounds.x, -thumbBounds.y);
  }

  protected void paintDecreaseHighlight(Graphics g)
    { }

  protected void paintIncreaseHighlight(Graphics g)
    { }

  protected JButton createDecreaseButton(int orientation)
  {
    return new FusionArrowButton(
      orientation, buttonBackground, buttonForeground, buttonHighlight);
  }

  protected JButton createIncreaseButton(int orientation)
  {
    return new FusionArrowButton(
      orientation, buttonBackground, buttonForeground, buttonHighlight);
  }
}
