package roboforge.ui.fusion;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.tree.*;



public class FusionSliderUI extends BasicSliderUI
{

  public FusionSliderUI(JSlider slider)
    { super(slider); }


  public static ComponentUI createUI(JComponent c)
    { return new FusionSliderUI((JSlider) c); }


    protected void paintMinorTickForHorizSlider(Graphics g, Rectangle bounds, int x)
    {
      g.setColor(getHighlightColor());
      g.drawLine(x, 0, x, bounds.height / 2 - 1);
    }

    protected void paintMajorTickForHorizSlider(Graphics g, Rectangle bounds, int x)
    {
      g.setColor(getHighlightColor());
      g.drawLine(x, 0, x, bounds.height - 2);
    }

    protected void paintMinorTickForVertSlider(Graphics g, Rectangle bounds, int y)
    {
      g.setColor(getHighlightColor());
      g.drawLine(0, y, bounds.width / 2 - 1, y);
    }

    protected void paintMajorTickForVertSlider(Graphics g, Rectangle bounds, int y)
    {
      g.setColor(getHighlightColor());
      g.drawLine( 0, y,  bounds.width - 2, y);
    }

    public void paintFocus(Graphics g)
    {
      /* Do nothing. */ 
    }


}