package roboforge.ui.fusion;

import roboforge.BDebug;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import javax.swing.plaf.*;
import javax.swing.plaf.basic.BasicTextFieldUI;
import javax.swing.plaf.basic.BasicGraphicsUtils;


public class FusionTextFieldUI extends BasicTextFieldUI
{
  
    protected FocusListener focusListener
      = new FocusListener();
    
    
    public ComponentUI createUI()
      { return new FusionTextFieldUI(); }
    
    
    protected void installListeners() 
    { 
      super.installListeners();
      getComponent().addFocusListener(focusListener); 
    }

    protected void uninstallListeners() 
    { 
      super.uninstallListeners();
      getComponent().removeFocusListener(focusListener); 
    }
    
    
    protected class FocusListener extends FocusAdapter
    {
      public void focusGained(FocusEvent e)
        { getComponent().repaint(); }

      public void focusLost(FocusEvent e)
        { getComponent().repaint(); }
    }
  
}
