package roboforge.ui.modes;

import roboforge.BDebug;
import roboforge.BNameable;
import roboforge.ui.BIconic;
import roboforge.ui.events.*;

import javax.swing.Icon;

public abstract class BMode
  implements BActivateable, BNameable, BIconic
{

  // Internal variables...
  // -------------------------------------------------------------

  protected String name;
  protected Icon icon;

  // Support class for handling activation listeners...
  protected BActivationSupport activationSupport
    = new BActivationSupport(this);


  // Activation methods...
  // -------------------------------------------------------------

  public boolean isActive()
    { return activationSupport.isActive(); }

  public boolean isClosed()
    { return activationSupport.isClosed(); }


  public void requestActivate()
    { activationSupport.requestActivate(); }

  public void requestDeactivate()
    { activationSupport.requestDeactivate(); }

  public void requestClose()
    { activationSupport.requestClose(); }


  public void onActivate()
    { activationSupport.fireActivate(); }

  public void onDeactivate()
    { activationSupport.fireDeactivate(); }

  public void onClose()
    { activationSupport.fireClose(); }

    
  public void addActivationListener(BActivationListener l)
    { activationSupport.addActivationListener(l); }

  public void removeActivationListener(BActivationListener l)
    { activationSupport.addActivationListener(l); }



  // Accessor methods...
  // -------------------------------------------------------------

  public String getName()
    { return name; }

  public void setName(String name)
    { this.name = name; }

  public Icon getIcon()
    { return icon; }

  public void setIcon(Icon icon)
    { this.icon = icon; }

}
