package roboforge.ui.modes;

import roboforge.BComponent;
import roboforge.BGlobal;
import roboforge.BPaintable;

import roboforge.ui.*;
import roboforge.ui.components.BUIResources;
import roboforge.util.graphics.*;

import java.awt.Cursor;
import java.awt.event.MouseEvent;


public class BModeAppearancePaint extends BModePick
{


  // Class variables...
  // -------------------------------------------------------------

  private static final Cursor CURSOR =
    BGraphics.getCursor("paintbucket_cursor.gif", 25, 20);


  // Internal Variables.
  // -------------------------------------------------------------

  protected BPaintable source;

  
  // Constructor.
  // -------------------------------------------------------------

  public BModeAppearancePaint(B3DCanvas canvas, BPaintable source)
  {
    super(canvas);

    cursor = CURSOR;
    this.source = source;
  }


  // Picking methods.
  // -------------------------------------------------------------

  protected void onPickComponent(BComponent c, MouseEvent e)
  {
    // Paint component with source appearance.
    // The boolean argument indicates whether to apply alpha.
    c.setAppearance(source.getAppearance(), false);
  }
}