package roboforge.ui.modes;

import roboforge.util.timing.*;
import java.awt.event.*;



public abstract class BModeArena extends BModeMouse
{

	protected double rate;
  	// Animation rate ratio.

  protected double last;
  	// Last animation time stamp.



  public BModeArena()
  {
  	super();

    // Default rate...
    this.rate = 1;
  }


  
  public void onActivate()
  {
    super.onActivate();

    // Timing stuff...
    last = BClock.time();
  }


  public final void animate()
  {
    double t  = BClock.time();
    double dt = (t - last) * rate;
    last			= t;

    if (isKeysActive || isMouseActive)
      return;

    animationStep(t, dt);
  }

  protected abstract void animationStep(double t, double dt);
    // Steps the mode animation.


  public void setRate(double rate)
  	{ this.rate = rate; }

  public double getRate()
  	{ return rate; }

    

  public final void keyPressed(KeyEvent e)
  {
    super.keyPressed(e);

    switch (e.getKeyCode())
    {
      case KeyEvent.VK_UP:
        keyUpPressed(e); break;

      case KeyEvent.VK_DOWN:
        keyDownPressed(e); break;

      case KeyEvent.VK_LEFT:
        keyLeftPressed(e); break;

      case KeyEvent.VK_RIGHT:
        keyRightPressed(e); break;
    }
  }

  protected boolean isValidKey(KeyEvent e)
  {
    int k = e.getKeyCode();

    return
      (k == KeyEvent.VK_UP)   ||
      (k == KeyEvent.VK_DOWN) ||
      (k == KeyEvent.VK_LEFT) ||
      (k == KeyEvent.VK_RIGHT);
  }



  public void keyUpPressed(KeyEvent e)
    { }

  public void keyDownPressed(KeyEvent e)
    { }

  public void keyLeftPressed(KeyEvent e)
    { }

  public void keyRightPressed(KeyEvent e)
    { }

}
