package roboforge.ui.modes;

import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.lang.Math.*;

import roboforge.*;
import roboforge.ui.*;

public class BModeArenaLookAt extends BModeMouse
{

  private BArenaCanvas canvas;
  private TransformGroup tg;
  private double arenaSize;
  private double minY, maxY;



  // working variables
  private Transform3D  workingTran = new Transform3D();
  private Transform3D tranXZ = new Transform3D();
  private Vector3d translation  = new Vector3d();
  private Vector3d oldTran  = new Vector3d();
  private Vector3d zeroTranslation  = new Vector3d(0,0,0);

  double x_factor = 0.7;
  double y_factor = 0.7;


  int deltaCap = 30;


  public BModeArenaLookAt(BArenaCanvas canvas, TransformGroup tg, double arenaSize, double minY, double maxY)
  {
    this.canvas = canvas;
    this.tg = tg;
    this.arenaSize = arenaSize /2.0;
    this.minY = minY;
    this.maxY = maxY;

  }



 private  static Transform3D rotXTran = new Transform3D();
 private static Point3d relativeVec = new Point3d();
 private static Vector3d v = new  Vector3d();
 private static Vector3d v2 = new  Vector3d();
 private static Vector3d cross = new Vector3d();



  public void mouseDragged(MouseEvent e)
  {
    super.mouseDragged(e);

    if (isMouseActive)
    {
      tg.getTransform(workingTran);

      //set translation
      translation.x = dx * x_factor;
      translation.y = 0;
      translation.z = dy * y_factor;


      // calculating translation
      tranXZ.set(translation);
      workingTran.mul(workingTran, tranXZ);

      // capping new position
      workingTran.get(translation);

      if (translation.length() * BGlobal.CANVAS_TO_WORLD_SCALE < arenaSize)
      {
        translation.y = java.lang.Math.max(translation.y, minY);
        translation.y = java.lang.Math.min(translation.y, maxY);
        workingTran.setTranslation(translation);

        tg.setTransform(workingTran );

        canvas.lookAt(false);

      }
    }


  }







}




