package roboforge.ui.modes;

import roboforge.util.graphics.*;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.event.KeyEvent;



public class BModeMouse extends BMode
{

  // Class variables...
  // -------------------------------------------------------------

  private static final Cursor CURSOR =
    BGraphics.getCursor();


  // Member variables...
  // -------------------------------------------------------------

  protected Cursor  cursor;
  protected boolean isSubMode = false;

  protected int x  = 0;
  protected int y  = 0;
  protected int dx = 0;
  protected int dy = 0;


  protected boolean isKeysActive;
    // Whether keys are currently active.

  protected boolean isMouseActive;
    // Whether mouse is currently active.


  // Constructor...
  // -------------------------------------------------------------

  public BModeMouse()
  {
    this.cursor        = CURSOR;
    this.isKeysActive  = false;
    this.isMouseActive = false;
  }


  // Mouse methods...
  // -------------------------------------------------------------

  public void mousePressed(MouseEvent e)
  {
    isMouseActive = true;

    dx = 0;
    dy = 0;

    x = e.getX();
    y = e.getY();
  }

  public void mouseDragged(MouseEvent e)
  {
    dx = e.getX() - x;
    dy = e.getY() - y;

    x  = e.getX();
    y  = e.getY();
  }

  public void mouseReleased(MouseEvent e)
  {
    isMouseActive = false;

    dx = e.getX() - x;
    dy = e.getY() - y;

    x  = e.getX();
    y  = e.getY();
  }


  public void keyPressed(KeyEvent e)
  {
    if (isValidKey(e))
      isKeysActive = true;
  }

  public void keyReleased(KeyEvent e)
    { isKeysActive = false; }

  protected boolean isValidKey(KeyEvent e)
    { return true; }



  // Accessor methods...
  // -------------------------------------------------------------

  public void setSubMode(boolean b)
    { this.isSubMode = b; }

  public boolean isSubMode()
    { return this.isSubMode; }

  public Cursor getCursor()
    { return cursor; }

  public void setCursor(Cursor cursor)
    { this.cursor = cursor; }

  public boolean isKeysActive()
    { return isKeysActive; }

  public boolean isMouseActive()
    { return isMouseActive; }


  public String getToolTipText(int x, int y)
    { return null; }
    
    
}
