package roboforge.ui.modes;

import roboforge.BDebug;
import roboforge.BPhysics;

import roboforge.math.*;
import roboforge.ui.*;

import java.awt.event.MouseEvent;

import javax.media.j3d.*;
import javax.vecmath.*;

import com.sun.j3d.utils.picking.*;
// import com.sun.j3d.utils.behaviors.picking.*;


public class BModePlaneDrag extends BModeCanvas
{

  // Internal variables.
  // -------------------------------------------------------------

  protected BPlane3d plane;
    // Plane for finding drag intersections...

  protected Point3d intersection = new Point3d();
    // Current intersection of ray and plane.

  protected Point3d last = new Point3d();
    // Last intersection of ray and plane.

  protected Vector3d delta = new Vector3d();
    // Change in intersection point.

  protected double distance;
    // Distance from ray origin to intersection pt.

  protected PickCanvas pickCanvas;
    // protected PickObject pickObject;
    // Object used to do picking within the scene.

  protected PickRay pickRay;
    // The current pickray from mouse cursor.


  // Constructors...
  // -------------------------------------------------------------

  public BModePlaneDrag(B3DCanvas canvas)
    { this(canvas, new BPlane3d()); }

  public BModePlaneDrag(B3DCanvas canvas, BPlane3d plane)
  {
    super(canvas);
    this.plane = plane;

    pickCanvas = new PickCanvas(canvas, canvas.getPickGroup());
    pickCanvas.setMode(PickCanvas.GEOMETRY);
    pickCanvas.setTolerance(0f);

    // pickObject = new PickObject(canvas, canvas.getPickGroup());
  }

  // Accessor methods.
  // -------------------------------------------------------------



  // Mouse-event methods.
  // -------------------------------------------------------------

  public void mousePressed(MouseEvent e)
  {
    super.mousePressed(e);

    pickCanvas.setShapeLocation(e);
    pickRay = (PickRay) pickCanvas.getPickShape();
      // pickObject.generatePickRay(x, y);

    plane.intersects(pickRay, distance, intersection);
    delta.set(0,0,0);

    last.set(intersection);
  }

  public void mouseDragged(MouseEvent e)
  {
    super.mouseDragged(e);

    pickCanvas.setShapeLocation(e);
    pickRay = (PickRay) pickCanvas.getPickShape();
    // pickRay = (PickRay) pickObject.generatePickRay(x, y);

    plane.intersects(pickRay, distance, intersection);

    delta.sub(intersection, last);
    last.set(intersection);
  }

}
