package roboforge.ui.net;

import roboforge.ui.*;
import roboforge.ui.action.*;
import roboforge.ui.components.*;
import roboforge.util.graphics.*;
import roboforge.net.client.*;
import roboforge.BDebug;
import roboforge.BGlobal;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import java.io.RandomAccessFile;

import javax.media.j3d.VirtualUniverse;



public class BLicenceAgreementScreen extends BBasicScreen
{

   protected BClientStack server ;

   protected BUIResources res = new BUIResources( new Object[]
  {
    "cancel.bounds",          new Rectangle(405, 325, 195, 30),

    "cancel.name",            "Cancel",
    "cancel.tooltip",         "I do not agree to these terms.",
    "cancelAction.name",      "No, I do NOT agree.",

    "accept.bounds",          new Rectangle(200, 325, 195, 30),

    "accept.name",            "Accept",
    "accept.tooltip",         "I agree to these terms.",
    "acceptAction.name",      "I accept these terms." ,

  //  "agreement.bounds", new Rectangle(200, 0, 400, 200),
    "agreementScroller.bounds", new Rectangle(200, 80, 400, 230),

    "agreementText.border",    new EmptyBorder(10, 10, 10, 10),


  });

  protected BButton cancel    = new BButton(res, "cancel");
  protected BButton accept    = new BButton(res, "accept");

  protected BTextArea agreementText   = new BMultiLabel(res, "agreementText");
  protected BScrollPane agreementScroller = new BScrollPane(res,"agreementScroller" );

  public BLicenceAgreementScreen(BClientStack stack)
  {
    super();

    VirtualUniverse.setJ3DThreadPriority(Thread.MIN_PRIORITY );

    server = stack;


    layoutChildren();
    configChildren();

  }

   protected void layoutChildren()
  {
    body.setLayout(null);
    body.addOnTop(cancel);
    body.addOnTop(accept);

    body.addOnTop(agreementScroller);
    //agreementScroller.setViewportView(agreementText);

    //JViewport viewP = new JViewport();
    //viewP.setView(agreementText);
    agreementScroller.getViewport().setView(agreementText) ;

  }

   protected void configChildren()
  {
    cancel.setAction(new CancelAction(res, "cancelAction") );
    accept.setAction(new AcceptAction(res, "acceptAction") );

    fillAgreement();
   /* BDebug.print (  agreementScroller.getViewport().getViewPosition());

    agreementScroller.getViewport().setViewPosition(  agreementScroller.getViewport().toViewCoordinates(new Point(0,0))     ) ;
    */

  }

  protected void fillAgreement()
  {
    try
    {
      String totalText = "";
      RandomAccessFile inFile = new RandomAccessFile(BGlobal.SYSTEMPATH + "terms.txt", "r" );
      String line = inFile.readLine();

      while (line != null)
      {
        totalText = totalText + "\n" + line;
        line = inFile.readLine();
      }

      agreementText.setText(totalText);

    }
    catch(Exception e) {}
  }



  protected class CancelAction extends BAction
  {
    public CancelAction(BUIResources res, String key)
      { super(res, key); }

    public void actionPerformed(ActionEvent e)
      { BApplication.closeScreen(); }
  }

   protected class AcceptAction extends BAction
  {
    public AcceptAction(BUIResources res, String key)
      { super(res, key); }

    public void actionPerformed(ActionEvent e)
    {
      /*    BTournamentScreen tournaments =
      new BTournamentScreen(server);

      BApplication.openScreen(tournaments);
      BApplication.closeScreen(BLicenceAgreementScreen.this);
      */

          BPatchScreen patch =
      new BPatchScreen(server);

      BApplication.openScreen(patch);
      BApplication.closeScreen(BLicenceAgreementScreen.this);



    }
  }

  boolean isFirstPaint = true;
  public void paint(Graphics g)
  {
      if (isFirstPaint)
      {
        isFirstPaint = false;
        agreementScroller.getViewport().setViewPosition(  new Point(0,0)     ) ;
      }

      super.paint(g);

  }



}
