package roboforge.util.graphics;

import roboforge.math.BMath3D;

import java.awt.Color;
import javax.vecmath.Color3f;
import javax.vecmath.Color4f;



public class BColors
{

  protected static float[] ra = new float[4];
    // Working space for conversion routines..

  protected static float[] rb = new float[4];
    // Working space for conversion routines..

  protected static float[] ha = new float[4];
    // Working space for conversion routines..

  protected static float[] hb = new float[4];
    // Working space for conversion routines..



  public static Color blendRGB(Color a, Color b, float t)
  {
    a.getRGBComponents(ra);
    b.getRGBComponents(rb);

    float rt = 1 - t;

    ra[0] = (rt * ra[0]) + (t * rb[0]);
    ra[1] = (rt * ra[1]) + (t * rb[1]);
    ra[2] = (rt * ra[2]) + (t * rb[2]);
    ra[3] = (rt * ra[3]) + (t * rb[3]);

    return new Color(ra[0], ra[1], ra[2], ra[3]);
  }


  public static Color blendHSB(Color a, Color b, float t)
  {
    int r1 = a.getRed();
    int g1 = a.getGreen();
    int b1 = a.getBlue();
    int a1 = a.getAlpha();

    int r2 = b.getRed();
    int g2 = b.getGreen();
    int b2 = b.getBlue();
    int a2 = a.getAlpha();

    Color.RGBtoHSB(r1, g1, b1, ha);
    Color.RGBtoHSB(r2, g2, b2, hb);

    float rt = 1 - t;

    ha[0] = (rt * ha[0]) + (t * hb[0]);
    ha[1] = (rt * ha[1]) + (t * hb[1]);
    ha[2] = (rt * ha[2]) + (t * hb[2]);

    int c = Color.HSBtoRGB(ha[0], ha[1], ha[2]);

    int alpha = Math.round(rt*a1 + t*a2);
    c = c | (alpha << 24);

    return new Color(c, true);
  }


  public static Color3f convert(Color c)
    { return new Color3f(c); }

  public static Color convert(Color3f c)
    { return new Color(c.x, c.y, c.z); }

  public static Color convert(Color4f c)
    { return new Color(c.x, c.y, c.z); }


  public static void randomHSB(Color4f base, Color4f vary, Color4f result)
  {
    BMath3D.randomize(base, vary, result);
    Color c = Color.getHSBColor(result.x, result.y, result.z);

    result.x = (float) c.getRed()   / 255f;
    result.y = (float) c.getGreen() / 255f;
    result.z = (float) c.getBlue()  / 255f;
  }


  public static void randomHSB(Color3f base, Color3f vary, Color3f result)
  {
    BMath3D.randomize(base, vary, result);
    Color c = Color.getHSBColor(result.x, result.y, result.z);

    result.x = (float) c.getRed()   / 255f;
    result.y = (float) c.getGreen() / 255f;
    result.z = (float) c.getBlue()  / 255f;
  }

}
