package roboforge.util.io;

import java.io.*;
public class BCountInputStream extends FilterInputStream
{

  private long count;

  public BCountInputStream(InputStream in)
  {
    super(in);
    this.count = 0;
  }

  public int read() throws IOException
  {
    int n = in.read();
    if (n != -1) count++;
    return n;
  }

  public int read(byte b[], int off, int len) throws IOException
  {
    int n = in.read(b, off, len);
    if (n > 0) count += n;
    return n;
  }

  public long getCount()
    { return count; }

  public void resetCount()
    { count = 0; }
}
